proc calendar {} {
    global VS CALENDAR
    
    set w .calendar
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +150+55
    wm geometry $w =0x0
    wm title $w ""
    set CALENDAR(1)  31
    set CALENDAR(2)  28
    set CALENDAR(3)  31
    set CALENDAR(4)  30
    set CALENDAR(5)  31
    set CALENDAR(6)  30
    set CALENDAR(7)  31
    set CALENDAR(8)  31
    set CALENDAR(9)  30
    set CALENDAR(10) 31
    set CALENDAR(11) 30
    set CALENDAR(12) 31
    
    foreach { i j } { 0  1  2  3  4  5  6  } {
        set CALENDAR($i,-1) $j
    }
    frame $w.buttons -relief sunken -bd 1 
    frame $w.tit 
    label $w.tit.l1 -text "  " -font $VS(fontn) -bd 2 -relief raised
    label $w.tit.l2 -textvar VS(monthword) -font $VS(fontn) -padx 5 -pady 5 -fg blue
    label $w.tit.l3 -textvar VS(year) -font $VS(fontn) -padx 5 -pady 5 -fg blue
    label $w.tit.l4 -text "" -font $VS(fontn) -pady 5 -fg blue
    frame $w.set -relief raised -bd 1
    foreach i { d m y } {
        frame $w.set.$i
    }
    button $w.buttons.exit -text "" -command "destroy $w"
    label $w.buttons.lm -textvar VS(alldate) -relief sunken -anchor center -padx 3 -width 35
    button $w.buttons.help -text ""
    pack $w.buttons -side bottom
    pack $w.tit -side top -padx 5 -pady 5
    pack $w.tit.l1
    pack $w.tit.l2 $w.tit.l3 $w.tit.l4 -side left
    pack $w.buttons.exit $w.buttons.lm $w.buttons.help -side left -padx 5
    
    table $w.tbl -width 7 -height 7 -cols 7 -rows 7 \
        -cursor arrow \
        -variable CALENDAR \
        -titlecols 1 \
        -colorigin -1\
        -flashmode off \
        -selectmode browse \
        -wrap on \
        -state disabled
    
    $w.tbl tag config title -fg yellow
    $w.tbl tag config sel -fg blue
    tktableinittag $w.tbl
    $w.tbl tag row RaisedBgRed1 6
    $w.tbl tag row RaisedBgRed2 5
    $w.tbl tag row RaisedBgGreen 0 1 2 3 4
    $w.tbl width -1 4 0 4 1 4 2 4 3 4 4 4 5 4
    #$w.tbl selection set $CALENDAR(rowcol) $CALENDAR(rowcol)
   
    bind $w.tbl <ButtonRelease-1> {
        set idx [%W index @%x,%y]
        if { $CALENDAR($idx) != "" } {
            setdate "$VS(month)/$CALENDAR($idx)/$VS(year)"
        }
    }
   
    foreach { i j } { ControlUp d.bu ControlDown d.bd ControlUp m.bu ControlDown m.bd ControlUp y.bu ControlDown y.bd } {
        button $w.set.$j -takefocus 0 -bitmap @$VS(dir)$i.xbm
    }
    $w.set.d.bd configure -command "incrdate - day"
    $w.set.d.bu configure -command "incrdate + day"
    $w.set.m.bd configure -command "incrdate - month"
    $w.set.m.bu configure -command "incrdate + month"
    $w.set.y.bd configure -command "incrdate - year"
    $w.set.y.bu configure -command "incrdate + year"
    
    label $w.set.ltit -text "                        "
    entry $w.set.d.e -textvar VS(day) -fg blue -state disabled -width 4 -justify center
    label $w.set.lf1 -text "     "
    entry $w.set.m.e -textvar VS(monthword) -fg blue -state disabled -width 10 -justify center
    label $w.set.lf2 -text "     "
    entry $w.set.y.e -textvar VS(year) -fg blue -state disabled -width 6 -justify center
    pack $w.tbl
    pack $w.set -padx 5 -pady 5
    pack $w.set.ltit -anchor w
    foreach i { d lf1 m lf2 y d.e m.e y.e } {
        pack $w.set.$i -side left
    }
    foreach i { d.bu d.bd m.bu m.bd y.bu y.bd } {
        pack $w.set.$i -fill y -padx 0 -pady 0
    }
    wm geometry $w [centerwindow $w]
    calendar:read
}

proc translatedate { str } {
    foreach { i j } { Jan  Feb  Mar  Apr  May  \
                      Jun  Jul  Aug  Sep  \
                      Oct  Nov  Dec  \
                      Sun  Mon  Tue  \
                      Wed  Thu  Fri  Sat  } {
        regsub $i $str $j str
    }
    return $str
}

proc setdate { date } {
    global VS NAKLPLIST
    
    set VS(day)         [clock format [clock scan $date] -format %d]
    set VS(dayweek)     [translatedate [clock format [clock scan $date] -format %a]]
    set VS(month)       [clock format [clock scan $date] -format %m]
    set VS(monthword)   [translatedate [clock format [clock scan $date] -format %b]]
    set VS(year)        [clock format [clock scan $date] -format %Y]
    set VS(date)        $VS(month)/$VS(day)/$VS(year)
    set VS(alldate)     "$VS(dayweek) $VS(day) $VS(monthword) $VS(year) " 
    set VS(clock)       [clock scan $date]
    
    set NAKLPLIST(find) ""
}

proc incrdate { k l } {
    global VS
    setdate [clock format [clock scan "${k}1 $l" -base [clock scan $VS(date)]] -format %m/%d/%Y]
    calendar:read
}

proc calendar:read {} {
    global VS CALENDAR
    
    set w .calendar
    set pop 0
    regsub "^0" $VS(month) "" month
    regsub "^0" $VS(day) "" day
    if { [expr $VS(year) % 4] == 0 && $month == 2 } {
        set pop 1
    }
    set br [clock format [clock scan $VS(month)/01/$VS(year)] -format %a]
    switch $br {
        Mon { set br 0 }
        Tue { set br 1 }
        Wed { set br 2 }
        Thu { set br 3 }
        Fri { set br 4 }
        Sat { set br 5 }
        Sun { set br 6 }
    }
    set row 0
    set col 0
    for { set i 1 } { $i <= 42 } { incr i } {
        set CALENDAR($row,$col) ""
        incr row
        if { $row > 6 } { 
            set row 0 
            incr col
        }
    }
    set row $br
    set col 0
    for { set i [expr 1 + $br] } { $i <= [expr $CALENDAR($month) + $pop + $br] } { incr i } {
        set CALENDAR($row,$col) [expr $i - $br]
        if { $CALENDAR($row,$col) == $day } {
            set CALENDAR(rowcol) ${row},${col}
        }
        incr row
        if { $row > 6 } { 
            set row 0 
            incr col
        }
    }
    $w.tbl selection clear all
    $w.tbl selection set $CALENDAR(rowcol) $CALENDAR(rowcol)
}
