proc allcfg {} {
    global VS ALLCFG

    set w .allcfg
    set ALLCFG(ListWindowBut) { printer myorg sostavms pn nds }
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w +59+55
    wm title $w ""
    
    frame $w.but
    foreach { i j } { printer   "" \
                      myorg     "  " \
                      sostavms  "  " \
                      pn        " " \
                      nds       " " \
                    } {
        label $w.but.$i -padx 10 -relief sunken -wraplength 165 \
              -height 3 -bd 3 -text $j 
    }
    $w.but.printer configure -relief flat -bg #00c0c0
    pack $w.but -side top -anchor w
    foreach { i } "$ALLCFG(ListWindowBut)" {
        pack $w.but.$i -side left
        bind $w.but.$i <Button-1> { allcfg:initbut %W }
    }
    cfgprinter
}

proc allcfg:initbut { W } {
    global ALLCFG
    
    catch [ destroy .allcfg.dat]
    set w .allcfg.but
    foreach { i } "$ALLCFG(ListWindowBut)" {
        $w.$i configure -relief sunken -fg black -bg grey85
    }
    $W configure -relief flat -bg #00c0c0
    switch -regexp $W {
        [\.]printer   { cfgprinter }
        [\.]myorg     { myorg }
        [\.]sostavms  { sostavms }
        [\.]pn        { stt }
        [\.]nds       { nds }
    }
}

proc readcfg {} {
    global VS
    
    set f [open $VS(cfgfile)]
    while { ![eof $f] } {
        dependcfg [gets $f]
    }
    close $f
    writecfg
}

proc writecfg {} {
    global VS

    set f [open $VS(cfgfile) "w"]
    puts $f "Server=$VS(server)"
    puts $f "Port=$VS(port)"
    puts $f "Login=$VS(login)"
    puts $f "PrintServer=$VS(PrintServer)"
    puts $f "PrintProgram=$VS(PrintProgram)"
    puts $f "Printer=$VS(Printer)"
    puts $f "PrintConveer=$VS(PrintConveer)"
    
    close $f
}

proc dependcfg {str} {
    global VS
    
    set envid {}
    set envvar {}
    scan $str "%\[^=]%*c%\[^\n]" envid envvar
    
    switch $envid {
        Server          {set VS(server)             $envvar}
        Port            {set VS(port)               $envvar}
        Login           {set VS(login)              $envvar}
        PrintServer     {set VS(PrintServer)        $envvar}
        PrintProgram    {set VS(PrintProgram)       $envvar}
        Printer         {set VS(Printer)            $envvar}
        PrintConveer    {set VS(PrintConveer)       $envvar}
    }
}
