proc cfgprinter {} {
    global VS
    
    readcfg
    initprinter
    set w .allcfg.dat
    catch [destroy $w]
    frame $w
    frame $w.title -bd 5
    label $w.title.l -font $VS(fontn) -text " " -relief raised -anchor center -bd 1 -padx 3 -width 26
    frame $w.prg -bd 5
    label $w.prg.l -text " "
    frame $w.prg.rb -relief sunken -bd 2
    radiobutton $w.prg.rb.1 -text lpr -variable VS(PrintProgram) -value lpr -command "set VS(PrintServer) {}; set VS(Printer) {}; set VS(PrintConveer) {}"
    radiobutton $w.prg.rb.2 -text smbprint -variable VS(PrintProgram) -value smbprint -command "set VS(PrintServer) {}; set VS(Printer) {}; set VS(PrintConveer) {}"
    
    pack $w -padx 5 -pady 5
    pack $w.title $w.title.l -fill x
    pack $w.prg
    pack $w.prg.rb $w.prg.l -side right
    pack $w.prg.rb.1 $w.prg.rb.2 -side left
    cfgprinter:shadow
    
    bind $w.prg.rb.1 <B1-ButtonRelease> { %W invoke; cfgprinter:shadow }
    bind $w.prg.rb.2 <B1-ButtonRelease> { %W invoke; cfgprinter:shadow }
    bind $w <Key-Escape>                { .allcfg.dat.buttons.exit invoke }
}

proc cfgprinter:shadow {} {
    global VS
    
    set flg 0
    set w .allcfg.dat
    catch [destroy $w.prn; destroy $w.ps; destroy $w.pc; destroy $w.buttons]
    if { $VS(PrintProgram) == "smbprint" } {
        frame $w.ps -bd 5
        label $w.ps.l -text ""
        entry $w.ps.e -textvariable VS(PrintServer) -width 35
        button $w.ps.b -takefocus 0 -bitmap @$VS(dir)ComboBox.xbm -command cfgprinter:ps
        
        pack $w.ps -fill x
        pack $w.ps.b $w.ps.e $w.ps.l -side right
        focus $w.ps.e
        set flg 1
    }
    frame $w.prn -bd 5
    label $w.prn.l -text ""
    entry $w.prn.e -textvariable VS(Printer) -width 35
    button $w.prn.b -takefocus 0 -bitmap @$VS(dir)ComboBox.xbm -command cfgprinter:prn
    frame $w.pc -bd 5
    label $w.pc.l -text ""
    entry $w.pc.e -textvariable VS(PrintConveer) -width 38
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "writecfg; initprinter;"
    button $w.buttons.clear -text "" -command "set VS(PrintServer) {}; set VS(Printer) {}; set VS(PrintConveer) {}"
    button $w.buttons.exit -text "" -command "destroy .cfgprinterps; destroy .cfgprinterprn; destroy .allcfg;"
    if { $flg == 0 } { focus $w.prn.e }
    
    pack $w.prn $w.pc -fill x
    pack $w.buttons -padx 5 -pady 5
    pack $w.prn.b $w.prn.e $w.prn.l $w.pc.e $w.pc.l -side right
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 10
}

proc cfgprinter:ps {} {
    global  VS

    set w .cfgprinterps
    set x [winfo rootx .allcfg.dat.ps.e]
    set y [winfo rooty .allcfg.dat.ps.e]
    
    catch [destroy $w]
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -setgrid 1 -height 5 -width 36
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    waiting "  ..." blue
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "cat /etc/hosts"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            if { [regexp "^#" $str] != 1 } {
                if { [scan $str "%s%s" ip name] == 2 } {
                    $w.lb insert end $name
                }
            }
        }
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    - !    ."
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }    
    
    $w.lb insert end ""
    destroy .waiting
    $w.lb selection set 0 0
        
    bind $w.lb <B1-ButtonRelease> {
        set VS(PrintServer) [ %W get [ %W curselection ] ]
    }
    tkwait variable VS(PrintServer)
    destroy $w
}


proc cfgprinter:prn {} {
    global VS
    
    set w .cfgprinterprn
    set x [winfo rootx .allcfg.dat.prn.e]
    set y [winfo rooty .allcfg.dat.prn.e]
    
    catch [destroy $w]
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -setgrid 1 -height 5 -width 36
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        if { $VS(PrintProgram) == "smbprint" } {
            puts $socks "smbclient -L $VS(PrintServer) -N -U%"
            flush $socks
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                scan $str "%s%s" s1 s2
                if { $s2 == "Printer" } { 
                    $w.lb insert end $s1 
                }
            }    
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    - !    ."
            }
        }
        if { $VS(PrintProgram) == "lpr" } {
            puts $socks "lpc status"
            flush $socks
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                if { [regexp ":$" $str] == 1 } { 
                    scan $str "%\[^:]" s1
                    $w.lb insert end $s1 
                }
            }    
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    - !    ."
            }
        }
        
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    $w.lb insert end "" 
    destroy .waiting
    $w.lb selection set 0 0
        
    bind $w.lb <B1-ButtonRelease> {
        set VS(Printer) [ %W get [ %W curselection ] ]
    }
    tkwait variable VS(Printer)
    destroy $w
}

proc initprinter {} {
    global VS
    if { $VS(PrintProgram) == "lpr" } {
        if { $VS(PrintConveer) == "" } {
            set VS(lp) "lpr -P $VS(Printer)"
        } else {
            set VS(lp) "$VS(PrintConveer) | lpr -P $VS(Printer)"
        }
    }
    if { $VS(PrintProgram) == "smbprint" } {
        if { $VS(PrintConveer) == "" } {
            set VS(lp) "smbprint \\\\\\\\\\\\\\$VS(PrintServer)\\\\\\\\$VS(Printer) -N -P -U%"
        } else {
            set VS(lp) "$VS(PrintConveer) | smbprint \\\\\\\\\\\\\\$VS(PrintServer)\\\\\\\\$VS(Printer) -N -P -U%"
        }
    }
}
