#################################################################################### 
# COMBOBOXD widget
####################################################################################

proc comboboxd { win args } {
    global COMBOBOXD_E_FLAG:$win VS
    
    catch [unset COMBOBOXD_E_FLAG:$win]
    regsub -all "\\." $win ":" fw

    #    
    set optf "-Fbd 1 -Frelief sunken"
    set opte "-Ebd 1 -Erelief sunken -Eselectbackground cyan3"
    set optb "-Bbd 1 -Bactivebackground cyan3"
    set optl "-LTbd 1 -LTrelief sunken -LLbg seashell2 -LLfg blue4 -LLbd 0 -LSXbd 1 -LSXtakefocus 0 -LSXactivebackground cyan3 -LSYbd 1 -LSYtakefocus 0 -LSYactivebackground cyan3 -LLselectbackground cyan3 -LSYbg seashell2 -LSXbg seashell2 -LSXtroughcolor seashell3 -LSYtroughcolor seashell3 -LSXwidth 10 -LSYwidth 10"
    
    #    : frame, entry, button, listbox
    foreach { i j } $args {
        switch -regexp -- $i {
            ^-F { append optf " $i \"$j\"" }
            ^-E { append opte " $i \"$j\"" }
            ^-B { append optb " $i \"$j\"" }
            ^-L { append optl " $i \"$j\"" }
        }
    }
    foreach { i j } { optf F opte E optb B optl L } {
        regsub -all -- "-$j" [subst $$i] "-" $i
    }
    if ![regexp -- "-command" $optb] {
        append optb " -command \"comboboxd:lb$fw $win $fw $optl\""
    }
    
    eval frame $win $optf
    rename $win $win.frame
    eval entry $win.e $opte
    eval button $win.b -bitmap @$VS(dir)/comboboxd.xbm $optb
    pack $win.e $win.b -side left -padx 0 -pady 0 -fill y
    bind $win   <FocusIn>           { focus %W.e }
    bind $win.b <KeyPress-Return>   { %W invoke }
    bind $win.e <Control-Return>    [list $win.b invoke ]
    
    
    #            
    # 
    listbox $win.l
    #  listbox  comboboxd    -command
    proc comboboxd:lb$fw { win fw args } {
        set oldefg [lindex [$win.e configure -fg] 4]
        $win.e configure -fg blue4
        #    : toplevel, listbox, scrollbarX scrollbarY
        foreach { i j } $args {
            switch -regexp -- $i {
                ^-T  { append optt  " $i $j" }
                ^-L  { append optl  " $i $j" }
                ^-SX { append optsx " $i $j" }
                ^-SY { append optsy " $i $j" }
            }
        }
        foreach { i j } { optt T optl L optsx SX optsy SY } {
            regsub -all -- "-$j" [subst $$i] "-" $i
        }
        #    entry
        set varentry [lindex [$win.e configure -textvar] 4]
        global $varentry
        
        set w $win.lb
        catch [destroy $w]
        eval toplevel $w $optt
        wm overrideredirect $w 1
        wm geometry $w +[winfo rootx $win.e]+[expr [winfo rooty $win.e] + [winfo height $win.e]]
        eval scrollbar $w.sx -command [subst {"$w.l xview"}] -orient h $optsx
        eval scrollbar $w.sy -command [subst {"$w.l yview"}] $optsy
        eval listbox $w.l -yscroll [subst {"$w.sy set"}] -xscroll [subst {"$w.sx set"}] -bd 0 $optl -width [lindex [$win.e configure -width] 4]
        pack $w.sy -side right -fill y
        pack $w.sx -side bottom -fill x
        pack $w.l -side left
        focus $w.l
        bind $w   <Key-Escape>       "destroy $w"
        bind $w   <B3-ButtonRelease> "destroy $w"
        bind $w.l <KeyPress-Return>  "comboboxd:lb:ret$fw $w %W $varentry"
        bind $w.l <B1-ButtonRelease> "comboboxd:lb:ret$fw $w %W $varentry"
        bind $w.l <Motion> { 
            %W selection clear 0 end
            %W selection set [%W nearest %y] 
        }
        for { set i 0 } { $i < [$win.l index end] } { incr i } {
            $w.l insert end [$win.l get $i $i]
        }
        $w.l selection set 0 0
        set oldebg [$win.e cget -bg]
        set oldbbg [$win.b cget -bg]
        set lbg [$w.l cget -bg]
        $win.e configure -bg $lbg
        $win.b configure -bg $lbg
        bindtags $w.l [list Listbox $w.l $w all ]
        grab $w
        tkwait window $w
        $win.e configure -fg $oldefg -bg $oldebg
        $win.b configure -bg $oldbbg
        focus -force $win
    }
    
    #    Entry  Listbox
    set varentry [lindex [$win.e configure -textvar] 4]
    global $varentry
    trace variable $varentry w "comboboxd:e:ret$fw $win"
    proc comboboxd:e:ret$fw { w name1 name2 op } {
        global $name1 COMBOBOXD_E_FLAG:$w
        if ![info exists COMBOBOXD_E_FLAG:$w] {
            set flg 0
            foreach i [$w.l get 0 end] {
                if { $i == [subst $$name1] } { set flg 1 }
            }
            if { $flg == 0 } { 
                if { [subst $$name1] != "" } { $w.l insert end [subst $$name1] }
            }
        }
    }
    bind $win.e <FocusIn>           "comboboxd:win:e:focusin $win"
    proc comboboxd:win:e:focusin { win } {
        global COMBOBOXD_E_FLAG:$win
        set COMBOBOXD_E_FLAG:$win 0
    }
    bind $win.e <FocusOut>          "comboboxd:win:e:focusout $win"
    proc comboboxd:win:e:focusout { win } {
        global COMBOBOXD_E_FLAG:$win
        catch [unset COMBOBOXD_E_FLAG:$win]
        set varentry [lindex [$win.e configure -textvar] 4]
        global $varentry
        set $varentry [subst $$varentry]
    }
    
    proc comboboxd:lb:ret$fw { w wb varentry } {
        global $varentry
        catch [set $varentry [$wb get [$wb curselection]]]
        destroy $w
    }
    
    #     [ win insert var end ]
    proc $win { args } "eval $win:second $win \$args"
    proc $win:second { win args } {
        switch -regexp $args {
            ^insert     { eval $win.l $args }
            ^configure  { 
                eval $win.e $args
                eval $win.b $args
             }
        }
    }
}

