proc docopl:varold { i } {
    global DOCOPL_DATA

    catch [set DOCOPL_DATA($i,old_0) $DOCOPL_DATA($i,0)]
    catch [set DOCOPL_DATA($i,old_1) $DOCOPL_DATA($i,1)]
    catch [set DOCOPL_DATA($i,old_2) $DOCOPL_DATA($i,2)]
}

proc docopl:clear {} {
    global VS DOCOPL_DATA DOCOPL
    
    catch [unset DOCOPL_DATA]
    if { $DOCOPL(tip) == "s" } {
        set DOCOPL_DATA(-1,0) "N "
        set DOCOPL_DATA(-1,1) ""
        set DOCOPL_DATA(-1,2) ""
    } else {
        set DOCOPL_DATA(-1,0) ""
        set DOCOPL_DATA(-1,1) ""
        set DOCOPL_DATA(-1,2) ""
    }

}

proc docopl:read {} {
    global VS DOCOPL_DATA DOCOPL
    
    docopl:clear
    set w $DOCOPL(inwin).docopl.dat.tbl
    waiting "  ..." blue
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "docopl_sel $DOCOPL(tip) $DOCOPL(cod)"
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach { j } { cod nnaklcod 0 1 2 } { set DOCOPL_DATA($i,$j) "" }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                DOCOPL_DATA($i,cod)       DOCOPL_DATA($i,nnaklcod) \
                DOCOPL_DATA($i,0)         DOCOPL_DATA($i,1) \
                DOCOPL_DATA($i,2)
            docopl:varold $i
        }
        if [info exists DOCOPL(ActiveRow)] { 
            if { $i < $DOCOPL(ActiveRow) && $i >= 0 } { set DOCOPL(ActiveRow) $i }
            $w see $DOCOPL(ActiveRow),0
            $w activate $DOCOPL(ActiveRow),$DOCOPL(ActiveCol)
        }
        
        set DOCOPL(rows) [expr $i + 2]
        if { $DOCOPL(rows) < 11 } { set DOCOPL(rows) 11 }
        $w configure -rows $DOCOPL(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    docopl:summa
    waiting "" ""
}

proc docopl:delete {} {
    global VS DOCOPL DOCOPL_DATA
    
    set w $DOCOPL(inwin).docopl.dat.tbl
    if [info exists DOCOPL(ActiveRow)] {
        if [info exists DOCOPL_DATA($DOCOPL(ActiveRow),cod)] {
            set DOCOPL_DATA(active) ""
            $w tag row UnSelectRow $DOCOPL(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $DOCOPL(ActiveRow)
                waiting "  ..." red
                puts $socks "docopl_del $DOCOPL(tip) $DOCOPL_DATA($DOCOPL(ActiveRow),cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $DOCOPL(ActiveRow)
                waiting "" ""
                docopl:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc docopl:insert { row } {
    global VS DOCOPL_DATA DOCOPL
    
    set w $DOCOPL(inwin).docopl.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        if ![info exists DOCOPL_DATA($row,0)] { set DOCOPL_DATA($row,0) "" }
        if ![info exists DOCOPL_DATA($row,1)] { set DOCOPL_DATA($row,1) 0 }
        if ![info exists DOCOPL_DATA($row,2)] { set DOCOPL_DATA($row,2) 0 }
        puts $socks "docopl_ins $DOCOPL(tip) $DOCOPL(cod) \
                                \"$DOCOPL_DATA($row,0)\" \
                                \"$DOCOPL_DATA($row,1)\" \
                                \"$DOCOPL_DATA($row,2)\" "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set DOCOPL_DATA($row,cod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            docopl:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc docopl:update { row } {
    global VS DOCOPL_DATA DOCOPL
    
    set w $DOCOPL(inwin).docopl.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        if ![info exists DOCOPL_DATA($row,0)] { set DOCOPL_DATA($row,0) "" }
        if ![info exists DOCOPL_DATA($row,1)] { set DOCOPL_DATA($row,1) 0 }
        if ![info exists DOCOPL_DATA($row,2)] { set DOCOPL_DATA($row,2) 0 }
        puts $socks "docopl_upd $DOCOPL(tip) $DOCOPL_DATA($row,cod) \
                                \"$DOCOPL_DATA($row,0)\" \
                                \"$DOCOPL_DATA($row,1)\" \
                                \"$DOCOPL_DATA($row,2)\" "
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg  $socks "    !"
        } else { 
            $w tag row Normal $row 
            docopl:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc docopl:print {} {
    global VS DOCOPL

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "docopl_rep $DOCOPL(tip) $DOCOPL(cod) \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
