#################################################################################### 
# FRAMED widget
#  framed .f opts
#     master   slave,     
# : 
# :
# ______
#     :
#   "{{ }} proc arg1 arg2 arg3 ..."
#        -  slave_
####################################################################################

proc framed { win args } {
    global FRAMED
    #   
    set optf "-bd 1 -relief sunken"
    set optb "-bd 0 -relief groove -padx 0 -pady 1"
    set optl "-bd 0 -relief groove -bg grey80"

    # /      / button
    proc framed:operviawin$win { win flg } {
        global FRAMED
        if { $flg == 1 } {
            foreach i [winfo children $win] {
                if ![regexp "framed:button" $i] {
                    pack forget $i
                }
            }
            pack $win.framed:button2 -side left
            pack $win.framed:button1 -fill both
        } else {
            foreach i [winfo children $win] {
                if ![regexp framed:button $i] {
                    eval pack $i $FRAMED($i)
                }
            }
            pack forget $win.framed:button2 $win.framed:button1
        }
    }
    
    proc framed:b$win { win df } {
        global FRAMED
        for { set i 1 } { $i <= $FRAMED(df) } { incr i } {
            if { $i == $df } {
                framed:operviawin$win $win.$i 0
            } else {
                framed:operviawin$win $win.$i 1
            }
        }
    }
    
    frame $win
    rename $win $win.frame
    set df -1
    foreach i $args {
        incr df
        eval frame $win.$df $optf
        eval [lindex $i 1] $win.$df [lrange $i 2 end]
        pack $win.$df -fill x
        if { $df != 0 } {
            foreach j [winfo children $win.$df] {
                set FRAMED($j) [pack info $j]
            }
            eval button $win.$df.framed:button1 -text [lindex $i 0] $optb -command {"framed:b$win $win $df"}
            eval label $win.$df.framed:button2 -bitmap @framed.xbm $optl
            framed:operviawin$win $win.$df 1
            bind $win.$df.framed:button2 <1> "$win.$df.framed:button1 invoke"
        }
        
    }
    set FRAMED(df) $df    
    
    
}

