proc gorod:read {} {
    global VS GOROD GOROD_DATA
    
    set w .gorod.lb.listbox
    event generate .gorod.lb.listbox <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset GOROD_DATA]
    if { $GOROD(sortstr) == "" }    { set GOROD(sortstr) "nam" } 
    if { $GOROD(sortdesc) == "" }   { set GOROD(sortdesc) " "  }
    if { $GOROD(find) == "" } {
        set GOROD(find) "1=1"
        lappend GOROD(find,listbox) $GOROD(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "gorod_sel \"$GOROD(find)\" \"$GOROD(sortstr) $GOROD(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set GOROD_DATA(cod,$i) {}; set GOROD_DATA(nam,$i) {}; set GOROD_DATA(phone_cod,$i) {}
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" GOROD_DATA(cod,$i) GOROD_DATA(nam,$i) GOROD_DATA(phone_cod,$i)
            if { [clipped $GOROD(entry,nam)] == [clipped $GOROD_DATA(nam,$i)] } {
                set GOROD(listbox,curselection) $i
            }
            $w insert end [format " %-30s  %-12s " $GOROD_DATA(nam,$i) $GOROD_DATA(phone_cod,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set GOROD(statusline) " $i ."
        }
        set GOROD(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc gorod:find {} {
    global VS GOROD
    
    gorod:entry find
    if { $GOROD(entrystatus) == 1 } {
        set GOROD(find) "1=1"
        foreach {i j} "\"$GOROD(entry,nam)\" nam \"$GOROD(entry,phone_cod)\" phone_cod" {
            if { $i != "" } {
                set GOROD(find) "$GOROD(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $GOROD(find,listbox) $GOROD(find)] == -1} {
            lappend GOROD(find,listbox) $GOROD(find)
        }
        gorod:read
    }
    set GOROD(entrystatus) 0
}

proc gorod:delete {} {
    global VS GOROD GOROD_DATA
    
    set w .gorod.lb.listbox
    if { $GOROD(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $GOROD(listbox,curselection)
            puts $socks "gorod_del $GOROD_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            gorod:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $GOROD(listbox,count)} {
            set id $GOROD(listbox,count)
            set GOROD(listbox,curselection) $GOROD(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set GOROD(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set GOROD(deletestatus) 0
}

proc gorod:insert {} {
    global VS GOROD
    
    set w .gorod.lb.listbox
    gorod:entry insert
    if { $GOROD(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "gorod_ins \"$GOROD(entry,nam)\" \"$GOROD(entry,phone_cod)\""
            flush $socks
    
            while { [ set gorodcod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            gorod:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $GOROD(listbox,curselection)]
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set GOROD(entrystatus) 0
}

proc gorod:update {} {
    global VS GOROD GOROD_DATA

    set w .gorod.lb.listbox
    set GOROD(entry,nam) [clipped $GOROD_DATA(nam,$GOROD(listbox,curselection))]
    set GOROD(entry,phone_cod) [clipped $GOROD_DATA(phone_cod,$GOROD(listbox,curselection))]
    gorod:entry update
    if { $GOROD(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "gorod_upd $GOROD_DATA(cod,$GOROD(listbox,curselection)) \"$GOROD(entry,nam)\" \"$GOROD(entry,phone_cod)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            gorod:read
        } else {
            errormsg nosocks "  !"
        }
    }
    
    $w see [set id $GOROD(listbox,curselection)]
    $w selection set $id $id
    $w activate $id
    event generate $w <<iconmenu-enabled>>
    set GOROD(entrystatus) 0
}

proc gorod:view {} {
    global VS GOROD GOROD_DATA
    
    set GOROD(entry,nam) $GOROD_DATA(nam,$GOROD(listbox,curselection))
    set GOROD(entry,phone_cod) $GOROD_DATA(phone_cod,$GOROD(listbox,curselection))
    gorod:entry view
    catch [event generate .gorod.lb.listbox <<iconmenu-enabled>>]
}

proc gorod:print {} {
    global VS GOROD    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "gorod_rep \"$GOROD(find)\" \"$GOROD(sortstr) $GOROD(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
