proc lgota:read {} {
    global VS LGOTA LGOTA_DATA
    
    set w .lgota.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    catch [unset LGOTA_DATA]
    if { $LGOTA(sortstr) == "" }    { set LGOTA(sortstr) "nam" } 
    if { $LGOTA(sortdesc) == "" }   { set LGOTA(sortdesc) " "  }
    if { $LGOTA(find) == "" } {
        set LGOTA(find) "1=1"
        lappend LGOTA(find,listbox) $LGOTA(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "lgota_sel \"$LGOTA(find)\" \"$LGOTA(sortstr) $LGOTA(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set LGOTA_DATA(cod,$i) {}; set LGOTA_DATA(nam,$i) {}; set LGOTA_DATA(proc,$i) {}
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\n]" LGOTA_DATA(cod,$i) LGOTA_DATA(nam,$i) LGOTA_DATA(proc,$i)
            if { [clipped $LGOTA(entry,nam)] == [clipped $LGOTA_DATA(nam,$i)] } {
                set LGOTA(listbox,curselection) $i
            }
            $w insert end [format " %-30s  %-14s " $LGOTA_DATA(nam,$i) $LGOTA_DATA(proc,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set LGOTA(statusline) " $i ."
        }
        set LGOTA(listbox,count) [expr $i - 1]
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc lgota:find {} {
    global VS LGOTA
    
    lgota:entry find
    if { $LGOTA(entrystatus) == 1 } {
        set LGOTA(find) "1=1"
        foreach {i j} "\"$LGOTA(entry,nam)\" nam \"$LGOTA(entry,proc)\" proc" {
            if { $i != "" } {
                set LGOTA(find) "$LGOTA(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $LGOTA(find,listbox) $LGOTA(find)] == -1} {
            lappend LGOTA(find,listbox) $LGOTA(find)
        }
        lgota:read
    }
    set LGOTA(entrystatus) 0
}

proc lgota:delete {} {
    global VS LGOTA LGOTA_DATA
    
    set w .lgota.lb.listbox
    if { $LGOTA(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $LGOTA(listbox,curselection)
            puts $socks "lgota_del $LGOTA_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            lgota:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $LGOTA(listbox,count)} {
            set id $LGOTA(listbox,count)
            set LGOTA(listbox,curselection) $LGOTA(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set LGOTA(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set LGOTA(deletestatus) 0
}

proc lgota:insert {} {
    global VS LGOTA
    
    set w .lgota.lb.listbox
    lgota:entry insert
    if { $LGOTA(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "lgota_ins \"$LGOTA(entry,nam)\" \"$LGOTA(entry,proc)\""
            flush $socks
    
            while { [ set lgotacod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            lgota:read
        } else {
            errormsg nosocks "  !"
        }

        set id $LGOTA(listbox,curselection)
        $w see $id
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set LGOTA(entrystatus) 0
}

proc lgota:update {} {
    global VS LGOTA LGOTA_DATA

    set w .lgota.lb.listbox
    set LGOTA(entry,nam) [clipped $LGOTA_DATA(nam,$LGOTA(listbox,curselection))]
    set LGOTA(entry,proc) [clipped $LGOTA_DATA(proc,$LGOTA(listbox,curselection))]
    lgota:entry update
    if { $LGOTA(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "lgota_upd $LGOTA_DATA(cod,$LGOTA(listbox,curselection)) \"$LGOTA(entry,nam)\" \"$LGOTA(entry,proc)\""
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            lgota:read
        } else {
            errormsg nosocks "  !"
        }

        $w see [set id $LGOTA(listbox,curselection)]
        $w selection set $id $id
        $w activate $id
        event generate $w <<iconmenu-enabled>>
    }
    set LGOTA(entrystatus) 0
}

proc lgota:view {} {
    global VS LGOTA LGOTA_DATA
    
    set LGOTA(entry,nam) $LGOTA_DATA(nam,$LGOTA(listbox,curselection))
    set LGOTA(entry,proc) $LGOTA_DATA(proc,$LGOTA(listbox,curselection))
    lgota:entry view
    catch [event generate .lgota.lb.listbox <<iconmenu-enabled>>]
}

proc lgota:print {} {
    global VS LGOTA    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "lgota_rep \"$LGOTA(find)\" \"$LGOTA(sortstr) $LGOTA(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
