proc init {} {
    global VS tcl_platform env
    
    encoding system cp1251
  
    set VS(sepdata) "\001\002\003\004\005\006\007"
    set VS(dir) $env(VSDIR)
    set VS(cfgfile) $env(VSCFGFILE)
    
    package require -exact Tktable 2.5
    package require BWidget
    
    switch $tcl_platform(platform) {
        "unix" {
            set VS(font)    "-*-fixed-*-*-*-*-13-*-*-*-*-*-windows-*"
            set VS(fontm)   "-*-fixed-*-*-*-*-10-*-*-*-*-*-windows-1251"
            set VS(fontn)   "-*-courier-*-*-*-*-11-*-*-*-*-*-windows-1251"
            set VS(fonth20) "-*-courier-*-*-*-*-15-*-*-*-*-*-windows-1251"
            option add *Scrollbar.Width 10
        }
        "windows" {
            set VS(font)    "-*-courier-*-*-*-*-12-*-*-*-*-*-*"
            set VS(fontm)    "-*-courier-*-*-*-*-10-*-*-*-*-*-*"
            set VS(fontn)   "-*-times-bold-i-*-*-16-*-*-*-*-*-*"
            set VS(fonth20) "-*-times-bold-i-*-*-26-*-*-*-*-*-*"
            option add *Button.padY 0
        }
    }
    
    option add *Menu.TearOff 0
    option add *Table.DrawMode fast
    option add *Label.Foreground blue4
    foreach { i } { Scale Table Message Button Radiobutton Checkbutton Entry \
                    Label Menu Menubutton Text Listbox Scrollbar } {
        option add *$i.Font $VS(font)
        option add *$i.selectBackground #00c0c0
        option add *$i.selectForeground black
        option add *$i.activeBackground #00c0c0
        option add *$i.HighlightColor #008f8f
        option add *$i.BorderWidth 1 
        
        bind $i <Key> [ list + YesNoUpdateKey %W %N ]
    }
    foreach { i } { Table Radiobutton Checkbutton Entry Text } {
        bind $i <Map>       [ list + YesNoUpdateVis %W ]
        #bind $i <Control-k>
        #bind $i <Control-k> {
        #    puts ok
        #}
    }
    option add *$i.Font $VS(fontm)

    set LIB "findbox            tktable             bind     login   checkpasswd\
	         mainfun            mainmenu 	        gorod    gorod_math\
	         yesnoupdate        construct 	        cfg	     cfgprinter\
	         operacia           operacia_math       lgota    framed \
	         lgota_math         ei                  ei_math\
	         tovargtt           tovargroup          tovargroup_math\
	         tovartip           tovartip_math       tovar\
	         tovar_math         he                  sot\
	         sot_math           postpol             postpol_math \
	         sotss              sklad               sklad_math \
	         myorg              myorg_math          sostavms \
	         sostavm            sostavm_math        sostavs \
	         sostavs_math       stt                 stt_math \
	         schetfnr           schet               finnaklr \
	         schettov           schet_math          finnaklr_math \
	         schettov_math      docopl              docopl_math \
	         schettovt          schettovt_math      calendar \
	         schetnnakl         schetnnakl_math     nnakl \
	         nnaklhead          nnaklhead_math      nnakltov \
	         nnakltov_math      naklplist           naklplist_math \
	         naklp              naklphead           naklphead_math \
	         naklptov           naklptov_math       nds \
	         nds_math           snnno               snnno_math \
	         vplist             vplist_math         vp \
	         vphead             vphead_math         vptov \
	         vptov_math         sernum              sernumhead \
	         sernum_math        spisanie            spisaniehead \
	         spisanie_math      spisanietov_math    nnakllist \
	         nnakllist_math     tovcard             tovcardhead \
	         tovcard_math       tovcardtov_math     oplnototg \
	         oplnototg_math     otgnotopl           otgnotopl_math \
	         jurnal             jurnal_math         prodaga \
	         prodaga_math       skladost            skladosthead \
	         skladosttov_math   whomathtov          whomathtov_math \
	         tovinrez           tovinrezhead        tovinrez_math \
	         garanttalon_math   controlu            noo \
	         noo_math           globalperenos       globalperenos_math \
	         prodagamat         prodagamat_math     prikid \
	         prikid_math        valuta              valuta_math \
	         tovdolg            tovdolg_math        tovdolghead \
	         whorezdoc          whorezdoc_math      prodmattov \
	         prodmattov_math    tovarwww            zaimtov \
	         zaimtov_math       zaimopl             zaimopl_math \
	         zaimlist           zaimlist_math       zaimlisthead \
	         price              price_math          pricepost   pricepost_math \
	         comboboxd"
    
    foreach i $LIB {
        uplevel #0 [ list source "$VS(dir)$i.tcl" ]
    }
    readcfg
    initprinter
    setdate [clock format [clock seconds] -format %m/%d/%Y]
    tktableinit
    
    foreach i { controlu find insert print printkwit sort view update delete exit  \
                nalnakl tovt whomathtov schet waiting answer tovnakl } {
        image create photo img_$i -file "$VS(dir)$i.gif"
    }
    foreach i { find insert view update } {
        image create photo logo_$i -file "$VS(dir)$i.gif"
    }
    image create photo errormsgimg -file "$VS(dir)stop1.gif" 
    bind Button <KeyPress-Return> {
        %W invoke
    }
    bind Entry <KeyPress-Return> {
        event generate %W <Key-Tab>
    }
}

init
login first
