proc errormsg { socks str } {
    global VS
    
    set strerr {}
    if { $socks != "nosocks" } {
        set strerr [gets $socks]
    }
    
    set strerr1 ""
    set strerr2 ""
    set strerr3 ""
    scan $strerr "%\[^\t]%*c%\[^\t]%*c%\[^\n]" strerr1 strerr2 strerr3
    set bg gray82
    set VS(ErrormsgStatus) 0
    set w .errormsg
    catch [ destroy $w ]
    toplevel $w -bd 5 -relief raised -cursor arrow -bg $bg
    wm overrideredirect $w 1
    wm resizable $w 0 0
    #wm geometry $w +260+260
    wm geometry $w =0x0
    wm title $w " !"
    grab set $w
    frame $w.fmsg -bd 2 -relief groove -bg $bg
    label $w.fmsg.labelimage -image errormsgimg -bd 3 -bg $bg
    frame $w.fmsg.sep0 -bd 1 -width 2 -relief sunken
    frame $w.fmsg.sep1 -bd 1 -height 2 -relief sunken
    frame $w.fmsg.sep2 -bd 1 -height 2 -relief sunken
    frame $w.fmsg.sep3 -bd 1 -height 2 -relief sunken
    message $w.fmsg.msg  -font $VS(fontn) -text $str -width 400 -bg $bg -justify center -fg red1
    message $w.fmsg.msg1 -text $strerr1 -width 400 -bg $bg -justify center -fg red2
    message $w.fmsg.msg2 -text $strerr2 -width 400 -bg $bg -justify center -fg red3
    message $w.fmsg.msg3 -text $strerr3 -width 400 -bg $bg -justify center -fg red4
    frame $w.buttons -bd 2 -bg $bg
    button $w.buttons.ok -text "  " -command "set VS(ErrormsgStatus) 1" -bg $bg
    
    pack $w.fmsg $w.buttons $w.buttons.ok
    pack $w.fmsg.labelimage $w.fmsg.sep0 -side left -fill both
    foreach i { msg sep1 msg1 sep2 msg2 sep3 msg3 } {
        pack $w.fmsg.$i -fill both
    }
    focus $w.buttons.ok
    
    wm geometry $w [centerwindow $w]
    
    tkwait variable VS(ErrormsgStatus)
    grab release $w
    destroy $w
    catch [destroy .waiting]
    focus -force [focus -lastfor [topstackwindow .]]
}

proc waiting { str col } {
    global VS
    
    set w .waiting
    catch [ destroy $w ]
    update
    if { $col == "cyan" } { set col cyan4 }
    if { $col == "green" } { set col green4 }
    if { $str != "" } {
        toplevel $w -cursor clock
        wm overrideredirect $w 1
        wm geometry $w =0x0
        #grab set $w
        frame $w.fmsg -bd 5 -relief raised 
        label $w.fmsg.labelimage -image img_waiting -bd 5 
        message $w.fmsg.msg -text $str -bd 5 -width 200 -fg $col -justify center
        pack $w.fmsg
        pack $w.fmsg.labelimage -side left 
        pack $w.fmsg.msg -side right 
        wm geometry $w [centerwindow $w]
    }
    update
}

proc whatdoing { str win } {
    global VS
    
    set VS(WhatdoingStatus) 0
    set w .whatdoing
    catch [ destroy $w ]
    toplevel $w -bd 5 -relief raised
    wm overrideredirect $w 1
    wm resizable $w 0 0
    #wm geometry $w +260+260
    wm geometry $w =0x0
    wm title $w $str
    grab set $w
    frame $w.fmsg -relief groove -bd 2
    label $w.fmsg.labelimage -image img_answer -bd 5 
    message $w.fmsg.msg -font $VS(font) -text $str -bd 5 -width 300 -justify center
    frame $w.buttons -relief sunken
    button $w.buttons.ok -bd 3 -relief groove -text "  " -command "set VS(WhatdoingStatus) 1"
    button $w.buttons.no -text "  " -command "set VS(WhatdoingStatus) 0"
    
    pack $w.fmsg $w.buttons 
    pack $w.buttons.ok $w.buttons.no -side left -padx 10 -pady 1
    pack $w.fmsg.labelimage -side left 
    pack $w.fmsg.msg -side right 
    focus $w.buttons.ok
    
    wm geometry $w [centerwindow $w]
    tkwait variable VS(WhatdoingStatus)
    grab release $w
    destroy .whatdoing
    focus -force [focus -lastfor $win]
    return $VS(WhatdoingStatus)
}

#proc bgerror { a } {
#    global errorCode errorInfo
#    
#    catch [destroy .waiting]
#    puts "Code=$errorCode\n$errorInfo"
#    focus -force [focus -lastfor [topstackwindow .]]
#}

proc centerwindow { win } {
    #     toplevel    
    # wm geometry =0x0
    update idletasks
    set w [winfo reqwidth $win]
    set h [winfo reqheight $win]
    set x [expr [winfo screenwidth $win] / 2 - $w / 2 ]
    set y [expr [winfo screenheight $win] / 2 - $h / 2 ]
    return "=${w}x$h+$x+$y"
}

proc topstackwindow { win } {
    set lwin [winfo children $win]
    return [winfo containing [expr [winfo screenwidth $win] / 2] [expr [winfo screenheight $win] / 2]]
    #return [lindex $lwin [expr [llength $lwin] - 1]]
}
