proc naklphead:clear {} {
    global NAKLP
    
    foreach i { cod num dat datdolga skladcod skladnam operaciacod operacianam \
                klientcod klientnam lgotanam proc lgotaproc kurs prim1 } {
        set NAKLP($i) ""
    }
}

proc naklphead:old {} {
    global NAKLP
    
    foreach i { num dat datdolga skladcod skladnam operaciacod operacianam \
                klientcod klientnam lgotanam proc lgotaproc kurs prim1 } {
        set NAKLP(old_$i)   $NAKLP($i)
    }
}

proc naklphead:update {} {
    global VS NAKLP 

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ... " green
        puts $socks "naklp_upd \"$NAKLP(pr)\" \
                               $NAKLP(cod) \
                               \"$NAKLP(num)\" \
                               \"$NAKLP(dat)\" \
                               \"$NAKLP(skladcod)\" \
                               \"$NAKLP(operaciacod)\" \
                               \"$NAKLP(klientcod)\" \
                               \"$NAKLP(kurs)\" \
                               \"$NAKLP(lgotaproc)\" \
                               \"$NAKLP(prim1)\" \
                               \"$NAKLP(datdolga)\" "
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        } else {
            naklphead:old
        }

        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc naklphead:read {} {
    global VS NAKLP
    
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "naklpone_sel \"$NAKLP(pr)\" $NAKLP(cod)"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      NAKLP(num) \
                      NAKLP(dat) \
                      NAKLP(skladcod) \
                      NAKLP(skladnam) \
                      NAKLP(operaciacod) \
                      NAKLP(operacianam) \
                      NAKLP(klientcod) \
                      NAKLP(klientnam) \
                      NAKLP(kurs) \
                      NAKLP(lgotanam) \
                      NAKLP(proc) \
                      NAKLP(lgotaproc) \
                      NAKLP(prim1) \
                      NAKLP(datdolga)
        }
        if { $NAKLP(pr) == "r" } {
            set NAKLP(num)  [format "%5.0f" $NAKLP(num)]
        } else {
            set NAKLP(num)  [clipped $NAKLP(num)]
        }
        set NAKLP(skladnam)    [clipped $NAKLP(skladnam)]
        set NAKLP(operacianam) [clipped $NAKLP(operacianam)]
        set NAKLP(klientnam)   [clipped $NAKLP(klientnam)]
        set NAKLP(lgotaproc)   [clipped $NAKLP(lgotaproc)]
        set NAKLP(prim1)       [clipped $NAKLP(prim1)]
        set NAKLP(kurs)        [clipped $NAKLP(kurs)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    naklphead:old
    waiting "" ""
}

proc naklphead:insert {} {
    global VS NAKLP
    
    if { $NAKLP(skladcod) > 0 && \
         $NAKLP(klientcod) > 0 && \
         $NAKLP(operaciacod) > 0 && \
         [string length [clipped $NAKLP(dat)]] > 0 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "naklp_ins \"$NAKLP(pr)\" \
                                   \"$NAKLP(tip)\" \
                                   \"$NAKLP(num)\" \
                                   \"$NAKLP(dat)\" \
                                   \"$NAKLP(skladcod)\" \
                                   \"$NAKLP(operaciacod)\" \
                                   \"$NAKLP(klientcod)\" \
                                   \"$NAKLP(kurs)\" \
                                   \"$NAKLP(lgotaproc)\" \
                                   \"$NAKLP(prim1)\" \
                                   \"$NAKLP(datdolga)\""
            flush $socks
    
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set NAKLP(cod) "" 
                if { $NAKLP(pr) == "r" } { 
                    set NAKLP(num) ""
                    scan $str "%\[^\t]%*c%\[^\n]" NAKLP(cod) NAKLP(num)
                    set NAKLP(num)  [format "%5.0f" $NAKLP(num)]
                } else {
                    scan $str "%\[^\t]%*c%\[^\n]" NAKLP(cod) fuf
                }
            }
       
            if { [ gets $socks ] != "0" } {
                errormsg $socks "     !"
            }
            close $socks
            waiting "" ""
        } else {
            errormsg nosocks "  !"
        }
        naklphead:old
    }
}

proc naklphead:print {} {
    global VS NAKLP NAKLPTOV

    if { $NAKLPTOV(sortstr) == "" }    { set NAKLPTOV(sortstr) "tnam" } 
    if { $NAKLPTOV(sortdesc) == "" }   { set NAKLPTOV(sortdesc) " "  }
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "naklphead_rep \"$NAKLP(pr)\" \"$NAKLP(tip)\" $NAKLP(cod) \"$NAKLPTOV(sortstr) $NAKLPTOV(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc naklphead:heoperacianam { tip win } {
    global NAKLP HE
    
    set w $NAKLP(inwin).naklp.head.num.operacianam
    set HE(tit) "   "
    set prgnam "operaciap"
    if { $NAKLP(pr) == "r" } {
        set HE(tit) "   "
        set prgnam "operaciar"
    }
    set namstr "*"
    if { $tip == "u" } { set namstr "$NAKLP(operacianam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 $prgnam $namstr $tip $win
    set NAKLP(operaciacod)      $HE(cod)
    set NAKLP(operacianam)      [clipped $HE(nam)]
    set NAKLP(old_operacianam)  $NAKLP(operacianam)
    set NAKLP(hebutton) 0
}

proc naklphead:heklientnam { tip win } {
    global NAKLP HE
    
    set w $NAKLP(inwin).naklp.head.klient.klientnam
    set HE(tit) " "
    #set hefun postavschik
    set hefun klientlg
    if { $NAKLP(pr) == "r" } { 
        set HE(tit) " "
        set hefun klientlg
    }
    set namstr "*"
    if { $tip == "u" } { set namstr "$NAKLP(klientnam)" }
    
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 $hefun $namstr $tip $win
    set NAKLP(klientcod) $HE(cod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" NAKLP(klientnam) NAKLP(lgotacod) NAKLP(lgotanam) NAKLP(proc)
    set NAKLP(klientnam)     [clipped $NAKLP(klientnam)]
    set NAKLP(lgotanam)      [clipped $NAKLP(lgotanam)]
    set NAKLP(old_klientnam) $NAKLP(klientnam)
    set NAKLP(lgotaproc)     $NAKLP(proc)
    set NAKLP(old_lgotaproc) $NAKLP(lgotaproc)
    set NAKLP(hebutton) 0
}

proc naklphead:heskladnam { tip win } {
    global NAKLP HE
    
    set w $NAKLP(inwin).naklp.head.sklad.skladnam
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$NAKLP(skladnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 30 sklad $namstr $tip $win
    set NAKLP(skladcod)     $HE(cod)
    set NAKLP(skladnam)     [clipped $HE(nam)]
    set NAKLP(old_skladnam) $NAKLP(skladnam)
    set NAKLP(hebutton) 0
}

proc naklphead:kurs {} {
    global NAKLP NAKLPTOV_DATA
    
    if [whatdoing "         : 1  2.    ?" $NAKLP(inwin).naklp.head] {
        set i 0
        while 1 {
            if [ info exists NAKLPTOV_DATA($i,0) ] {
                if { $NAKLPTOV_DATA($i,4) > 0 } {
                    set NAKLPTOV_DATA($i,5) [format "%.2f" [expr $NAKLPTOV_DATA($i,4) / $NAKLP(kurs)]]
                } else {
                    set NAKLPTOV_DATA($i,4) [format "%.2f" [expr $NAKLPTOV_DATA($i,5) * $NAKLP(kurs)]]
                }
            } else break
            incr i
        }
    }
}

proc naklp:lgotaproc {} {
    global NAKLP NAKLPTOV_DATA
    
    if { $NAKLP(lgotaproc) != $NAKLP(old_lgotaproc) && [string length $NAKLP(lgotaproc)] > 0 } {
        set i 0
        waiting "     ..." cyan4
        for { set j 0 } { $j < 50000 } { incr j } {set a 0}
        while 1 {
            if [ info exists NAKLPTOV_DATA($i,3) ] {
                set NAKLPTOV_DATA($i,3) [expr $NAKLPTOV_DATA($i,tovarcena) - $NAKLPTOV_DATA($i,3) * $NAKLP(lgotaproc) / 100 ]
            } else break
            incr i
        }
        waiting "" ""
    }
}
