proc naklptov:varold { i } {
    global NAKLPTOV_DATA NAKLP

    set NAKLPTOV_DATA($i,old_tovarcod) $NAKLPTOV_DATA($i,tovarcod)
    set NAKLPTOV_DATA($i,old_0)        $NAKLPTOV_DATA($i,0)
    set NAKLPTOV_DATA($i,old_1)        $NAKLPTOV_DATA($i,1)
    set NAKLPTOV_DATA($i,old_2)        $NAKLPTOV_DATA($i,2)
    set NAKLPTOV_DATA($i,old_3)        $NAKLPTOV_DATA($i,3)
    set NAKLPTOV_DATA($i,old_4)        $NAKLPTOV_DATA($i,4)
    if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } {
        set NAKLPTOV_DATA($i,old_5)        $NAKLPTOV_DATA($i,5)
    }
}


proc naklptov:clear {} {
    global NAKLPTOV_DATA NAKLPTOV NAKLP
    
    catch [unset NAKLPTOV_DATA]
    if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } {
        set NAKLPTOV_DATA(-1,0) " "
        set NAKLPTOV_DATA(-1,1) ". "
        set NAKLPTOV_DATA(-1,2) "."
        set NAKLPTOV_DATA(-1,3) ". ."
        set NAKLPTOV_DATA(-1,4) ""
        set NAKLPTOV_DATA(-1,5) ""
    } else {
        set NAKLPTOV_DATA(-1,0) " "
        set NAKLPTOV_DATA(-1,1) "."
        set NAKLPTOV_DATA(-1,2) ". ."
        set NAKLPTOV_DATA(-1,3) ""
        set NAKLPTOV_DATA(-1,4) ""
    }
}

proc naklptov:read {} {
    global VS NAKLPTOV_DATA NAKLPTOV NAKLP
    
    naklptov:clear
    set w $NAKLP(inwin).naklp.tov.tbl
    waiting "  ..." blue
    if { $NAKLPTOV(sortstr) == "" }    { set NAKLPTOV(sortstr) "tnam" } 
    if { $NAKLPTOV(sortdesc) == "" }   { set NAKLPTOV(sortdesc) " "  }
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "naklptov_sel $NAKLP(pr) $NAKLP(tip) $NAKLP(cod) \"$NAKLPTOV(sortstr) $NAKLPTOV(sortdesc)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach { j } { finoperpcod matoperpcod tovarcod tovarcena 0 1 2 3 4 5 issernum } {
                set NAKLPTOV_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                NAKLPTOV_DATA($i,finoperpcod)       NAKLPTOV_DATA($i,matoperpcod) \
                NAKLPTOV_DATA($i,tovarcod)          NAKLPTOV_DATA($i,tovarcena) \
                NAKLPTOV_DATA($i,0) \
                NAKLPTOV_DATA($i,1)                 NAKLPTOV_DATA($i,2) \
                NAKLPTOV_DATA($i,3)                 NAKLPTOV_DATA($i,4) \
                NAKLPTOV_DATA($i,5)                 NAKLPTOV_DATA($i,issernum)
            
            set NAKLPTOV_DATA($i,0) [clipped   $NAKLPTOV_DATA($i,0)]
            set kol 1
            if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } { 
                set kol 2 
                set NAKLPTOV_DATA($i,1) [clipped $NAKLPTOV_DATA($i,1)]
            }
            catch [set NAKLPTOV_DATA($i,$kol)            [format "%7.2f" $NAKLPTOV_DATA($i,$kol)]]
            catch [set NAKLPTOV_DATA($i,[expr 2 + $kol]) [format "%9.2f" $NAKLPTOV_DATA($i,[expr 2 + $kol])]]
            catch [set NAKLPTOV_DATA($i,[expr 3 + $kol]) [format "%9.2f" $NAKLPTOV_DATA($i,[expr 3 + $kol])]]
            naklptov:varold $i
        }
        if [info exists NAKLPTOV(ActiveRow)] { 
            if { $i < $NAKLPTOV(ActiveRow) && $i >= 0 } { set NAKLPTOV(ActiveRow) $i }
            $w see $NAKLPTOV(ActiveRow),0
            $w activate $NAKLPTOV(ActiveRow),$NAKLPTOV(ActiveCol)
        }
        
        set NAKLPTOV(rows) [expr $i + 2]
        if { $NAKLPTOV(rows) < 9 } { set NAKLPTOV(rows) 9 }
        $w configure -rows $NAKLPTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    naklptov:summa 1
    waiting "" ""
}

proc naklptov:delete {} {
    global VS NAKLPTOV NAKLPTOV_DATA NAKLP
    
    set w $NAKLP(inwin).naklp.tov.tbl
    if [info exists NAKLPTOV(ActiveRow)] {
        if { [info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),finoperpcod)] ||
             [info exists NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod)] } {
            set NAKLPTOV_DATA(active) ""
            $w tag row UnSelectRow $NAKLPTOV(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $NAKLPTOV(ActiveRow)
                waiting "  ..." red
                puts $socks "naklptov_del $NAKLP(pr) $NAKLP(tip) \
                                          $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),finoperpcod) \
                                          $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),matoperpcod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $NAKLPTOV(ActiveRow)
                waiting "" ""
                naklptov:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc naklptov:insert { row } {
    global VS NAKLPTOV_DATA NAKLPTOV NAKLP
    
    set w $NAKLP(inwin).naklp.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        set kol 1
        if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } { set kol 2 }
        if ![info exists NAKLPTOV_DATA($row,[expr 3 + $kol])] {
            set NAKLPTOV_DATA($row,[expr 3 + $kol]) "0.00"
        }
        if ![info exists NAKLPTOV_DATA($row,1)] { set NAKLPTOV_DATA($row,1) {} }
        puts $socks "naklptov_ins $NAKLP(pr)    $NAKLP(tip) \
                                  $NAKLP(cod) \
                                  \"$NAKLP(dat)\" \
                                  $NAKLP(skladcod) \
                                  $NAKLPTOV_DATA($row,tovarcod) \
                                  \"$NAKLPTOV_DATA($row,1)\" \
                                  $NAKLPTOV_DATA($row,$kol) \
                                  $NAKLPTOV_DATA($row,[expr 2 + $kol]) \
                                  $NAKLPTOV_DATA($row,[expr 3 + $kol])"
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\n]" NAKLPTOV_DATA($row,finoperpcod) \
                                          NAKLPTOV_DATA($row,matoperpcod)
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            naklptov:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc naklptov:update { row } {
    global VS NAKLPTOV_DATA NAKLPTOV NAKLP
    
    set w $NAKLP(inwin).naklp.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        set kol 1
        if { $NAKLP(pr) == "p" && $NAKLP(tip) == "m" } { set kol 2 }
        if ![info exists NAKLPTOV_DATA($row,[expr 3 + $kol])] {
            set NAKLPTOV_DATA($row,[expr 3 + $kol]) "0.00"
        }
        if ![info exists NAKLPTOV_DATA($row,1)] { set NAKLPTOV_DATA($row,1) {} }
        puts $socks "naklptov_upd $NAKLP(pr)    $NAKLP(tip) \
                                  $NAKLPTOV_DATA($row,finoperpcod) \
                                  $NAKLPTOV_DATA($row,matoperpcod) \
                                  $NAKLPTOV_DATA($row,tovarcod) \
                                  \"$NAKLPTOV_DATA($row,1)\" \
                                  $NAKLPTOV_DATA($row,$kol) \
                                  $NAKLPTOV_DATA($row,[expr 2 + $kol]) \
                                  $NAKLPTOV_DATA($row,[expr 3 + $kol])"
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            naklptov:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc naklptov:hetovarnam { tip win } {
    global VS NAKLPTOV_DATA HE NAKLPTOV NAKLP
    
    set w $NAKLP(inwin).naklp.tov.curfldval
    if { $NAKLP(pr) == "p" } {
        set kol 1
        if { $NAKLP(tip) == "m" } { set kol 2 }
        set HE(tit) "                                 ..   SN"
        he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 8 64 tovarp "$NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)" $tip $win
        scan $HE(cod) "%\[^\003]%*c%s" \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod) \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),eicod)
        scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%s" \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),[expr 1 + $kol]) \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),issernum)
        set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) [clipped $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)]
    }
    if { $NAKLP(pr) == "r" } {
        set sep \003
        #set HE(tit) "                                    .              . ..                "
        #he [expr [winfo rootx $w] - 30 ] [expr [winfo rooty $w] + [winfo height $w]] 13 93 tovarostatok "$NAKLP(tip)$sep$NAKLP(skladcod)$sep$NAKLP(dat)$sep$NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)" $tip $win
        #scan $HE(cod) "%\[^\003]%*c%\[^\003]%*c%s" \
        #    fuf \
        #    NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod) \
        #    fuf
        #scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
        #    fuf \
        #    NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) \
        #    fuf \
        #    NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1) \
        #    NAKLPTOV_DATA($NAKLPTOV(ActiveRow),2) \
        #    NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3) \
        #    NAKLPTOV_DATA($NAKLPTOV(ActiveRow),4) \
        #    fuf
        set HE(tit) "                                 ..               "
        he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 6 75 tovar "$NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)" $tip $win
        scan $HE(cod) "%\[^\003]%*c%s" \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcod) \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),eicod)
        scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0) \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),2) \
            NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3) \
            fuf
        catch [set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),tovarcena) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3)]
        if { $NAKLP(lgotaproc) >= 0 } {
            catch [set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3) [expr $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3) - $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3) * $NAKLP(lgotaproc) / 100 ]]
        }
        catch [set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)   [clipped $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),0)]]
        catch [set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),kol) $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),1)]
        catch [set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3)   [format "%9.2f" $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),3)]]
        catch [set NAKLPTOV_DATA($NAKLPTOV(ActiveRow),4)   [format "%9.2f" $NAKLPTOV_DATA($NAKLPTOV(ActiveRow),4)]]
    }
}

