proc nds:browsecommand { rowcol } {
    global NDS NDS_DATA
    
    set w .allcfg.dat.dat.tbl
    if { [info exists NDS(ActiveRow)] && \
         $NDS(ActiveRow) >= 0 } {
        $w tag row UnSelectRow $NDS(ActiveRow)
    }
    set NDS(ActiveRowCol) $rowcol 
    scan $NDS(ActiveRowCol) "%\[^,]%*c%s" NDS(ActiveRow) NDS(ActiveCol)
    if { $NDS(ActiveRow) >= 0 } {
        $w tag row SelectRow $NDS(ActiveRow)
    }
}

proc nds {} {
    global VS NDS NDS_DATA
    
    set NDS(rows) 11
    
    set w .allcfg.dat
    set w1 ${w}.menu
    catch [destroy $w]
    
    frame $w
    pack $w
    label $w.tut -font $VS(fontn) -text "                   " -relief raised -bd 1
    pack $w.tut -pady 5
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -command nds:addrow
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command nds:delete
    $w1.1 add separator
    $w1.1 add command -label ""
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command nds:ok
    button $w.buttons.clear -text "" -command nds:clear
    button $w.buttons.exit -text "" -command "destroy .allcfg"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 10
    
    frame $w.butimg -bd 0 
    pack $w.butimg -side top -fill x 
        
    foreach {i j} { insert "" delete "" exit ""} {
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { 
            $w.butimg.$i configure -command "destroy .balloon; $w.buttons.exit invoke"
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.delete <Button-1> {
        .allcfg.dat.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind .allcfg.dat <Button-3> { 
        set win .allcfg.dat.dat.tbl
        .allcfg.dat.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    
    entry $w.curfldval -width 32 -textvar NDS_DATA(active) -fg red -bg #fffff0
    
    pack $w.curfldval
    foreach i { dat itogoo itogod } {
        frame $w.$i
        pack $w.$i
    }
    scrollbar $w.dat.sby -takefocus 0 -command " $w.dat.tbl yview "
    table $w.dat.tbl -width 2 -height 11 -cols 2 -rows $NDS(rows) \
        -yscrollcommand " $w.dat.sby set " \
        -cursor arrow \
        -variable NDS_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { nds:browsecommand %S } \
        -wrap on
        
    tktableinittag $w.dat.tbl
    $w.dat.tbl tag col AnchorCenter 2 
    $w.dat.tbl tag col AnchorE 1 2
    $w.dat.tbl tag row AnchorCenter -1
    $w.dat.tbl width 0 11 1 7
    
    pack $w.dat.tbl -side left
    pack $w.dat.sby -side right -fill y
    
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    nds:read
}

proc nds:ok {} {
    global NDS NDS_DATA

    #  
    set i 0
    while 1 {
        if [info exists NDS_DATA($i,1)] {
            if ![info exists NDS_DATA($i,cod)] {
                nds:insert $i
            } else { 
                if { $NDS_DATA($i,cod) <= 0 } {
                    nds:insert $i
                }
                if { $NDS_DATA($i,cod) > 0 } {
                    if { $NDS_DATA($i,old_0) != $NDS_DATA($i,0) || \
                         $NDS_DATA($i,old_1) != $NDS_DATA($i,1) } {
                        nds:update $i
                    }
                }
            }
        } else break
        incr i
    }
}

proc nds:addrow {} {
    global NDS

    .allcfg.dat.dat.tbl configure -rows [incr NDS(rows)]
}
