proc nnakltov:clear {} {
    global NNAKLTOV_DATA NNAKLTOV NNAKL
    
    catch [unset NNAKLTOV_DATA]
    set NNAKLTOV_DATA(-2,0) " "
    set NNAKLTOV_DATA(-2,1) "-"
    set NNAKLTOV_DATA(-2,2) ""
    set NNAKLTOV_DATA(-2,3) ""
    set NNAKLTOV_DATA(-2,4) ""
    set NNAKLTOV_DATA(-2,5) ""
    set NNAKLTOV_DATA(-2,6) ""
    set NNAKLTOV_DATA(-1,1) ""
    set NNAKLTOV_DATA(-1,2) ""
    set NNAKLTOV_DATA(-1,4) ""
    set NNAKLTOV_DATA(-1,5) ""
    set NNAKLTOV_DATA(-1,6) ""
}

proc nnakltov:read {} {
    global VS NNAKLTOV_DATA NNAKLTOV NNAKL SCHET
    
    nnakltov:clear
    set w $NNAKL(inwin).nnakl.tov.tbl
    waiting "  ..." blue
    if { $NNAKLTOV(sortstr) == "" }    { set NNAKLTOV(sortstr) "tnam" } 
    if { $NNAKLTOV(sortdesc) == "" }   { set NNAKLTOV(sortdesc) " "  }
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "nnakltov_sel $SCHET(cod) $NNAKL(cod) \"$NNAKLTOV(sortstr) $NNAKLTOV(sortdesc)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            set NNAKLTOV_DATA($i,cod) "";   set NNAKLTOV_DATA($i,schfnrtovcod) ""
            set NNAKLTOV_DATA($i,0) "";     set NNAKLTOV_DATA($i,1) ""
            set NNAKLTOV_DATA($i,2) "";     set NNAKLTOV_DATA($i,3) ""
            set NNAKLTOV_DATA($i,4) "";     set NNAKLTOV_DATA($i,5) ""
            set NNAKLTOV_DATA($i,6) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                NNAKLTOV_DATA($i,cod)       NNAKLTOV_DATA($i,schfnrtovcod) \
                NNAKLTOV_DATA($i,0)         NNAKLTOV_DATA($i,1) \
                NNAKLTOV_DATA($i,2)         NNAKLTOV_DATA($i,3) \
                NNAKLTOV_DATA($i,4)         NNAKLTOV_DATA($i,5) \
                NNAKLTOV_DATA($i,6)
            
            set NNAKLTOV_DATA($i,6)     [clipped $NNAKLTOV_DATA($i,6)]
            set NNAKLTOV_DATA($i,old_6) $NNAKLTOV_DATA($i,6)
        }
        if [info exists NNAKLTOV(ActiveRow)] { 
            if { $i < $NNAKLTOV(ActiveRow) && $i >= 0 } { set NNAKLTOV(ActiveRow) $i }
            $w see $NNAKLTOV(ActiveRow),0
            $w activate $NNAKLTOV(ActiveRow),$NNAKLTOV(ActiveCol)
        }
        
        set NNAKLTOV(rows) [expr $i + 3]
        if { $NNAKLTOV(rows) < 9 } { set NNAKLTOV(rows) 9 }
        $w configure -rows $NNAKLTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    nnakltov:summa
    waiting "" ""
}

proc nnakltov:delete {} {
    global VS NNAKLTOV NNAKLTOV_DATA NNAKL
    
    set w $NNAKL(inwin).nnakl.tov.tbl
    if [info exists NNAKLTOV(ActiveRow)] {
        if [info exists NNAKLTOV_DATA($NNAKLTOV(ActiveRow),cod)] {
            set NNAKLTOV_DATA(active) ""
            $w tag row UnSelectRow $NNAKLTOV(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $NNAKLTOV(ActiveRow)
                waiting "  ..." red
                puts $socks "nnakltov_del $NNAKLTOV_DATA($NNAKLTOV(ActiveRow),cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $NNAKLTOV(ActiveRow)
                waiting "" ""
                nnakltov:read
                if { $NNAKL(inwin) == ".schetfnr.schetnnakl" } schetnnakl:cor
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc nnakltov:insert { row } {
    global VS NNAKLTOV_DATA NNAKLTOV NNAKL
    
    set w $NNAKL(inwin).nnakl.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "nnakltov_ins $NNAKL(cod) \
                                  $NNAKLTOV_DATA($row,schfnrtovcod) \
                                  $NNAKLTOV_DATA($row,6) "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set NNAKLTOV_DATA($row,cod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            set NNAKLTOV_DATA($row,old_6)        $NNAKLTOV_DATA($row,6)
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc nnakltov:update { row } {
    global VS NNAKLTOV_DATA NNAKLTOV NNAKL
    
    set w $NNAKL(inwin).nnakl.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        puts $socks "nnakltov_upd $NNAKLTOV_DATA($row,cod) \
                                  $NNAKLTOV_DATA($row,6) "
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            set NNAKLTOV_DATA($row,old_6)        $NNAKLTOV_DATA($row,6)
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

