proc price {} {
    set w .price
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm title $w ""
    wm withdraw $w
    
    NoteBook $w.nb
    $w.nb insert end pricetov -text 
    pricetov $w [$w.nb getframe pricetov]
    $w.nb insert end pricepost -text 
    pricepost $w [$w.nb getframe pricepost]
    $w.nb raise pricetov
    $w.nb compute_size
    pack $w.nb
    BWidget::place $w 0 0 center
    wm deiconify $w
}


proc pricetov { we w } {
    global VS PRICETOV PRICETOV_DATA

    catch [unset PRICETOV]
    pricetov:clear
    set w1 $w.menu
    menu $w1
    menu $w1.1
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -command "price:print"
    $w1.1 add separator
    $w1.1 add command  -accelerator "<Esc>" -label "" -command "destroy .$w1.1"
    
    frame $w.buttons -relief sunken -bd 1
    button $w.buttons.ok -bd 3 -relief groove -text "" -command pricetov:write
    button $w.buttons.exit -text "" -command "destroy $we"
    pack $w.buttons -side bottom -pady 2
    pack $w.buttons.ok $w.buttons.exit -side left -padx 5
    if { $VS(login) != "julia" && $VS(login) != "slon2" && $VS(login) != "vlad" && $VS(login) != "olga" } {
        $w.buttons.ok configure -state disabled
    }
    
    frame $w.butimg -relief raised -bd 1
    pack $w.butimg -side top -fill x 
    foreach { i j } { print  exit  } {
        button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        if { $j == ""} { $w.butimg.$i configure -command "destroy .balloon; destroy .price" }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    bind $w <Key-Escape> [list $w.buttons.exit invoke ]
    
    #    ###################################################################
    
    set PRICETOV(rows) 18
    frame $w.tov
    pack $w.tov
    entry $w.tov.curfldval -textvar PRICETOV_DATA(active) -fg red \
        -bg #fffff0 -width 50
    scrollbar $w.tov.sby -takefocus 0 -command " $w.tov.tbl yview "
    scrollbar $w.tov.sbx -takefocus 0 -command " $w.tov.tbl xview " -orient horizontal
    table $w.tov.tbl -width 8 -height 18 -cols 8 -rows $PRICETOV(rows) -relief solid\
        -yscrollcommand " $w.tov.sby set " \
        -xscrollcommand " $w.tov.sbx set " \
        -cursor arrow \
        -variable PRICETOV_DATA \
        -titlerows 2 \
        -roworigin -2 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -drawmode fast \
        -browsecommand { pricetov:browsecommand %W %S } \
        -wrap off
        
    $w.tov.tbl tag config title -fg yellow
    $w.tov.tbl tag config sel -bg grey85
    $w.tov.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.tov.tbl
    $w.tov.tbl tag row AnchorCenter -2 -1
    $w.tov.tbl tag col AnchorE 2 3 4 5 6 
    $w.tov.tbl tag col Disabled 0 1 4 5 6
    $w.tov.tbl width 0 42  1 5  2 9  3 8  4 7  5 9  6 10  7 2
    $w.tov.tbl span -2,6 -2,7 -1,6 -1,7

    pack $w.tov.curfldval -anchor w
    pack $w.tov.sbx -side bottom -fill x
    pack $w.tov.tbl -side left
    pack $w.tov.sby -side right -fill y
            
    bind $w.tov.curfldval <Return> [list tkTableMoveCell $w.tov.tbl 0 1]
    bind $w.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        .price.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    focus $w.tov.tbl
    pricetov:read $w
}

proc pricetov:he { idx win } {
    global PRICETOVHE PRICETOV_DATA
    
    set y [winfo pointery $win]
    set x [winfo pointerx $win]
    
    set w .pricetovhe    
    catch [destroy $w]
    toplevel $w -cursor top_left_arrow
    wm overrideredirect $w 1
    wm withdraw $w
    frame $w.f -bd 2 -bg blue4
    pack $w.f
    scrollbar $w.f.sby -command "$w.f.lb yview" -takefocus 0
    listbox $w.f.lb -yscroll "$w.f.sby set" -width 50 -listvar PRICETOVHE(nam) -bg grey82
    pack $w.f.lb $w.f.sby -side left -fill y
    bind $w.f.lb <Double-ButtonRelease-1> [list pricetov:he:bind $idx %W]
    if { $y > 350 } { set y [expr $y - [winfo reqheight $w] + 20] }
    wm deiconify $w
    wm geometry $w +[expr $x - 2 * [winfo reqwidth $w]]+$y
    grab $w.f
    tkwait variable PRICETOV_DATA($idx,post_cod)
    destroy .pricetovhe
}

proc pricetov:he:bind { idxtov w } {
    global PRICETOV_DATA PRICETOVHE
    set idxpost [$w curselection]
    set PRICETOV_DATA($idxtov,6)        [$w get $idxpost]
    set PRICETOV_DATA($idxtov,post_cod) [lindex $PRICETOVHE(cod) $idxpost]
    pricetov:raschet $idxtov
}

proc pricetov:browsecommand { w rowcol } {
    global PRICETOV PRICETOV_DATA
    
    if { [info exists PRICETOV(ActiveRow)] && $PRICETOV(ActiveRow) >= 0 && \
         $PRICETOV_DATA($PRICETOV(ActiveRow),cod) != -1 } {
        $w tag row UnSelectRow $PRICETOV(ActiveRow)
    }
    
    # AFTER ######################################
    #after  
    if { [ info exists PRICETOV(ActiveRow) ] && $PRICETOV(ActiveRow) >= 0 } {
        if { [ info exists PRICETOV(ActiveCol) ] && $PRICETOV(ActiveCol) == 2 } {
            if { $PRICETOV_DATA($PRICETOV(ActiveRow),old_2) != $PRICETOV_DATA($PRICETOV(ActiveRow),2) } {
                pricetov:raschet $PRICETOV(ActiveRow)
            }
        }
    }
    
    #after 
    if { [ info exists PRICETOV(ActiveRow) ] && $PRICETOV(ActiveRow) >= 0 } {
        if { [ info exists PRICETOV(ActiveCol) ] && $PRICETOV(ActiveCol) == 3 } {
            if { $PRICETOV_DATA($PRICETOV(ActiveRow),old_3) != $PRICETOV_DATA($PRICETOV(ActiveRow),3) } {
                pricetov:raschet $PRICETOV(ActiveRow)
            }
        }
    }
    
    set PRICETOV(ActiveRowCol) $rowcol 
    scan $PRICETOV(ActiveRowCol) "%\[^,]%*c%s" PRICETOV(ActiveRow) PRICETOV(ActiveCol)
    
    # BEFORE #####################################
    # before  
    if { $PRICETOV(ActiveCol) == 2 } {
        if [info exists PRICETOV_DATA($PRICETOV(ActiveRow),2)] {
            set PRICETOV_DATA($PRICETOV(ActiveRow),old_2) $PRICETOV_DATA($PRICETOV(ActiveRow),2)
        } 
    }
    # before 
    if { $PRICETOV(ActiveCol) == 3 } {
        if [info exists PRICETOV_DATA($PRICETOV(ActiveRow),3)] {
            set PRICETOV_DATA($PRICETOV(ActiveRow),old_3) $PRICETOV_DATA($PRICETOV(ActiveRow),3)
        } 
    }
    
    if { $PRICETOV(ActiveRow) >= 0 && $PRICETOV_DATA($PRICETOV(ActiveRow),cod) != -1 } {
        $w tag row SelectRow $PRICETOV(ActiveRow)
    }
}

proc pricetov:raschet { row } {
    global PRICETOV PRICETOV_DATA PRICEPOST_DATA PRICEPOST

    set kurs 0
    if { $PRICETOV_DATA($row,2) > 0 && \
         $PRICETOV_DATA($row,3) > 0 && \
         $PRICETOV_DATA($row,post_cod) > 0 } {
        for { set i 0 } { $i < [expr $PRICEPOST(rows) - 2] } { incr i } {
            if { $PRICEPOST_DATA($i,cod) == $PRICETOV_DATA($row,post_cod) } {
                set kurs $PRICEPOST_DATA($i,1)
                if { [string trim $kurs] == "" } { set kurs 0.01 }
                break
            }
        }
        if { $kurs != 0 } {
            set PRICETOV_DATA($row,4) [format "%6.2f" [expr $PRICETOV_DATA($row,3) * 100.00 / $PRICETOV_DATA($row,2) ]]
            set PRICETOV_DATA($row,5) [format "%8.2f" [expr ($PRICETOV_DATA($row,2) + $PRICETOV_DATA($row,3)) * $kurs ]]
        }
    }
}
