proc pricetov:clear {} {
    global PRICETOV_DATA
    
    catch [unset PRICETOV_DATA]
    set PRICETOV_DATA(-2,0) ""
    set PRICETOV_DATA(-1,0) ""
    set PRICETOV_DATA(-2,1) "."
    set PRICETOV_DATA(-1,1) "."
    set PRICETOV_DATA(-2,2) ""
    set PRICETOV_DATA(-1,2) ""
    set PRICETOV_DATA(-2,3) ""
    set PRICETOV_DATA(-1,3) "()"
    set PRICETOV_DATA(-2,4) "."
    set PRICETOV_DATA(-1,4) "%"
    set PRICETOV_DATA(-2,5) " "
    set PRICETOV_DATA(-1,5) ""
    set PRICETOV_DATA(-2,6) ""
    set PRICETOV_DATA(-1,6) ""
}

proc pricetov:read { w } {
    global VS PRICETOV_DATA PRICETOV
    
    pricetov:clear
    set w $w.tov.tbl
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "pricetov_sel"
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set PRICETOV_DATA($i,0) "";   set PRICETOV_DATA($i,1) "" 
            set PRICETOV_DATA($i,2) "";   set PRICETOV_DATA($i,3) "" 
            set PRICETOV_DATA($i,4) "";   set PRICETOV_DATA($i,5) "" 
            set PRICETOV_DATA($i,6) "";   set PRICETOV_DATA($i,cod) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                PRICETOV_DATA($i,cod) PRICETOV_DATA($i,post_cod) PRICETOV_DATA($i,0) \
                PRICETOV_DATA($i,1)   PRICETOV_DATA($i,2)        PRICETOV_DATA($i,3) \
                PRICETOV_DATA($i,4)   PRICETOV_DATA($i,5)        PRICETOV_DATA($i,6)
                set PRICETOV_DATA($i,old_2) $PRICETOV_DATA($i,2)
                set PRICETOV_DATA($i,old_3) $PRICETOV_DATA($i,3)
                set PRICETOV_DATA($i,old_6) $PRICETOV_DATA($i,6)
            set PRICETOV(rows) [expr $i + 3]
            $w configure -rows $PRICETOV(rows)
            if { $PRICETOV_DATA($i,cod) == -1 } {
                $w tag row TovTip $i
            } else {
                button $w.cb$i -bitmap @$VS(dir)ComboBoxT.xbm -cursor top_left_arrow -command "pricetov:he $i $w.cb$i"
                $w window configure $i,7 -window $w.cb$i -sticky wens
            }
            incr i
        }
        if [info exists PRICETOV(ActiveRow)] { 
            if { $i < $PRICETOV(ActiveRow) && $i >= 0 } { set PRICETOV(ActiveRow) $i }
            $w see $PRICETOV(ActiveRow),0
            $w activate $PRICETOV(ActiveRow),$PRICETOV(ActiveCol)
        }
        
        set PRICETOV(rows) [expr $i + 2]
        if { $PRICETOV(rows) < 18 } { set PRICETOV(rows) 18 }
        $w configure -rows $PRICETOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc pricetov:write {} {
    global VS PRICETOV_DATA PRICETOV
    
    waiting "  ..." red
    for { set i 0 } { $i < [expr $PRICETOV(rows) - 2 ] } { incr i } {
        if { ($PRICETOV_DATA($i,old_2) != $PRICETOV_DATA($i,2) || \
             $PRICETOV_DATA($i,old_3) != $PRICETOV_DATA($i,3) || \
             $PRICETOV_DATA($i,old_6) != $PRICETOV_DATA($i,6)) && \
             $PRICETOV_DATA($i,2) > 0 && \
             $PRICETOV_DATA($i,3) > 0 && \
             $PRICETOV_DATA($i,5) > 0 && \
             $PRICETOV_DATA($i,post_cod) > 0 } {
            if { [ set socks [checkpasswd] ] != -1 } {
                puts $socks "pricetov_write $PRICETOV_DATA($i,cod) $PRICETOV_DATA($i,2) $PRICETOV_DATA($i,3) $PRICETOV_DATA($i,5) $PRICETOV_DATA($i,post_cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                set PRICETOV_DATA($i,old_2) $PRICETOV_DATA($i,2)
                set PRICETOV_DATA($i,old_3) $PRICETOV_DATA($i,3)
                set PRICETOV_DATA($i,old_6) $PRICETOV_DATA($i,6)
            } else {
                errormsg nosocks "  !"
            }
        }
    }
    waiting "" ""
}

proc price:print {} {
    global PRICETOV_DATA PRICETOV tcl_platform
    set fname "PRICE-[clock format [clock second] -format "%d%m%Y-%H%M"]"
    if { $tcl_platform(platform) == "windows" } {
        set fname "C:\\$fname"
    }
    waiting "    $fname ..." green
    after 2000
    set fd [open $fname "w"]
    for { set i 0 } { $i < [expr $PRICETOV(rows) - 2 ] } { incr i } {
        if { $PRICETOV_DATA($i,cod) == -1 } {
            puts $fd [string trimright $PRICETOV_DATA($i,0)]
        } else {
            if { $PRICETOV_DATA($i,5) > 0 } {
                puts $fd "[string trimright $PRICETOV_DATA($i,0)]\t[string trim $PRICETOV_DATA($i,5)]"
            }
        }
    }
    close $fd
    waiting "" ""
}