proc schet:clear {} {
    global SCHET
    
    set SCHET(cod) 0
    set SCHET(num) ""
    set SCHET(dat) ""
    set SCHET(datdolga) ""
    set SCHET(operaciacod) ""
    set SCHET(operacianam) ""
    set SCHET(klientcod) ""
    set SCHET(klientnam) ""
    set SCHET(lgotanam) ""
    set SCHET(proc) ""
    set SCHET(lgotaproc) ""
    set SCHET(prim1) ""
    set SCHET(prim2) ""
    schet:old
}

proc schet:old {} {
    global SCHET
    
    set SCHET(old_num)         $SCHET(num)
    set SCHET(old_dat)         $SCHET(dat)
    set SCHET(old_datdolga)    $SCHET(datdolga)
    set SCHET(old_operaciacod) $SCHET(operaciacod)
    set SCHET(old_operacianam) $SCHET(operacianam)
    set SCHET(old_klientcod)   $SCHET(klientcod)
    set SCHET(old_klientnam)   $SCHET(klientnam)
    set SCHET(old_lgotanam)    $SCHET(lgotanam)
    set SCHET(old_proc)        $SCHET(proc)
    set SCHET(old_lgotaproc)   $SCHET(lgotaproc)
    set SCHET(old_prim1)       $SCHET(prim1)
    set SCHET(old_prim2)       $SCHET(prim2)
}

proc schet:delete { schetcod } {
    global VS
    
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        puts $socks "schet_del $schetcod"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } { }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
            return -1
        } else {
            schet:clear
            finnaklr:clear
            schettov:clear
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !" .schetfnr
        return -1
    }
}

proc schet:update {} {
    global VS SCHET

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ... " green
        puts $socks "schet_upd $SCHET(cod) \
                               \"$SCHET(num)\" \
                               \"$SCHET(dat)\" \
                               \"$SCHET(operaciacod)\" \
                               \"$SCHET(klientcod)\" \
                               \"$SCHET(lgotaproc)\" \
                               \"$SCHET(prim1)\" \
                               \"$SCHET(prim2)\" \
                               \"$SCHET(datdolga)\" "
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {}

        if { [ gets $socks ] != "0" } {
            errormsg $socks "     !"
        } else {
            schet:old
        }

        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc schet:read {} {
    global VS SCHET
    
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "schetone_sel $SCHET(cod)"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                      SCHET(num) \
                      SCHET(dat) \
                      SCHET(operaciacod) \
                      SCHET(operacianam) \
                      SCHET(klientcod) \
                      SCHET(klientnam) \
                      SCHET(lgotacod) \
                      SCHET(lgotanam) \
                      SCHET(proc) \
                      SCHET(lgotaproc) \
                      SCHET(prim1) \
                      SCHET(prim2) \
                      SCHET(datdolga)
        }
        set SCHET(operacianam) [clipped $SCHET(operacianam)]
        set SCHET(klientnam)   [clipped $SCHET(klientnam)]
        set SCHET(lgotaproc) [clipped $SCHET(lgotaproc)]
        set SCHET(prim1)       [clipped $SCHET(prim1)]
        set SCHET(prim2)       [clipped $SCHET(prim2)]
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    schet:old
    waiting "" ""
}

proc schet:insert {} {
    global VS SCHET
    
    if { $SCHET(klientcod) > 0 && \
         $SCHET(operaciacod) > 0 && \
         [string length [clipped $SCHET(dat)]] > 0 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "schet_ins \"$SCHET(dat)\" \
                                   \"$SCHET(operaciacod)\" \
                                   \"$SCHET(klientcod)\" \
                                   \"$SCHET(lgotaproc)\" \
                                   \"$SCHET(prim1)\" \
                                   \"$SCHET(prim2)\" \
                                   \"$SCHET(datdolga)\""
            flush $socks
    
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set SCHET(cod) ""; set SCHET(num) "";
                scan $str "%\[^\t]%*c%\[^\n]" SCHET(cod) SCHET(num)
            }
       
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
        } else {
            errormsg nosocks "  !"
        }
        schet:old
    }
}

proc schet:print {} {
    global VS SCHET SCHETTOV

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "schet_rep \"$SCHET(cod)\" \"$SCHETTOV(sortstr) $SCHETTOV(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc schet:printkwit {} {
    global VS SCHET    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "schetkwit_rep \"$SCHET(cod)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc schet:objava { flg } {
    global VS SCHET    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "schetobjava_rep $flg \"$SCHET(cod)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc schet:heoperacianam { tip win } {
    global SCHET HE
    
    set w .schetfnr.top.head.schet.num.operacianam
    set HE(tit) "   "
    set namstr "*"
    if { $tip == "u" } { set namstr "$SCHET(operacianam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 operaciar $namstr $tip $win
    set SCHET(operaciacod) $HE(cod)
    set SCHET(operacianam) [clipped $HE(nam)]
    set SCHET(old_operacianam) $SCHET(operacianam)
    set SCHET(hebutton) 0
}

proc schet:heklientnam { tip win } {
    global SCHET HE
    
    set w .schetfnr.top.head.schet.klientnam.klientnam
    set HE(tit) " "
    set namstr "*"
    if { $tip == "u" } { set namstr "$SCHET(klientnam)" }
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 klientlg $namstr $tip $win
    set SCHET(klientcod) $HE(cod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" SCHET(klientnam) SCHET(lgotacod) SCHET(lgotanam) SCHET(proc)
    set SCHET(klientnam)     [clipped $SCHET(klientnam)]
    set SCHET(lgotanam)      [clipped $SCHET(lgotanam)]
    set SCHET(old_klientnam) $SCHET(klientnam)
    set SCHET(lgotaproc)     $SCHET(proc)
    set SCHET(old_lgotaproc) $SCHET(lgotaproc)
    set SCHET(hebutton) 0
}

proc schet:lgotaproc {} {
    global SCHET SCHETTOV_DATA
    
    if { $SCHET(lgotaproc) != $SCHET(old_lgotaproc) && [string length $SCHET(lgotaproc)] > 0 } {
        set i 0
        waiting "     ..." cyan4
        for { set j 0 } { $j < 50000 } { incr j } {set a 0}
        while 1 {
            if [ info exists SCHETTOV_DATA($i,3) ] {
                set SCHETTOV_DATA($i,3) [expr $SCHETTOV_DATA($i,tovarcena) - $SCHETTOV_DATA($i,3) * $SCHET(lgotaproc) / 100 ]
            } else break
            incr i
        }
        waiting "" ""
    }
}

proc schet:08 {} {
    global SCHET SCHETTOV_DATA
    
    if [whatdoing " 0.8%      ?" .schetfnr] {
        set i 0
        waiting "     ..." cyan4
        for { set j 0 } { $j < 50000 } { incr j } {set a 0}
        while 1 {
            if [ info exists SCHETTOV_DATA($i,3) ] {
                set SCHETTOV_DATA($i,3) [expr $SCHETTOV_DATA($i,3) + $SCHETTOV_DATA($i,3) * 0.008 ]
            } else break
            incr i
        }
        waiting "" ""
    }
}
