proc schetopl:summa {} {
    global SCHETOPL SCHETOPL_DATA SCHETTOV
    
    set w $SCHETOPL(inwin).schetopl
    set i 0
    set SCHETOPL(sopl) 0
    set SCHETOPL(sdolg) 0
    while { [info exists SCHETOPL_DATA($i,1)] && [info exists SCHETOPL_DATA($i,2)]} {
        catch [set SCHETOPL(sopl) [expr $SCHETOPL(sopl) + $SCHETOPL_DATA($i,2)]]
        incr i
    }
    catch [set SCHETOPL(sdolg) [expr $SCHETTOV(scena) - $SCHETOPL(sopl)]]
    if { $SCHETOPL(sdolg) == 0 } { set color green }
    if { $SCHETOPL(sdolg) > 0 } { set color red }
    if { $SCHETOPL(sdolg) < 0 } { set color magenta }
    $w.itogod.sdolg configure -bg $color
}

proc schetopl:browsecommand { rowcol } {
    global SCHETOPL SCHETOPL_DATA
    
    set w $SCHETOPL(inwin).schetopl.dat.tbl
    if { [info exists SCHETOPL(ActiveRow)] && \
         $SCHETOPL(ActiveRow) >= 0 } {
        $w tag row UnSelectRow $SCHETOPL(ActiveRow)
    }
    set SCHETOPL(ActiveRowCol) $rowcol 
    scan $SCHETOPL(ActiveRowCol) "%\[^,]%*c%s" SCHETOPL(ActiveRow) SCHETOPL(ActiveCol)
    schetopl:summa
    if { $SCHETOPL(ActiveRow) >= 0 } {
        $w tag row SelectRow $SCHETOPL(ActiveRow)
    }
}

proc schetopl { inwin } {
    global SCHET
    
    if { $SCHET(cod) > 0 } {
        schetopl2 $inwin
    }
}

proc schetopl2 { inwin } {
    global VS SCHETOPL SCHETOPL_DATA
    
    set SCHETOPL(rows) 11
    set SCHETOPL(sopl) 0
    set SCHETOPL(sdolg) 0
    
    set SCHETOPL(inwin) $inwin
    set w $SCHETOPL(inwin).schetopl
    set w1 ${w}.menu
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +250+70
    wm geometry $w =0x0
    #wm overrideredirect $w 1
    wm title $w "  "
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -accelerator "<Ins>" -command schetopl:addrow
    $w1.1 add command -label "" -command schetopl:print
    $w1.1 add separator
    $w1.1 add cascade -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -activebackground red \
                                 -activeforeground yellow \
                                 -command schetopl:delete
    $w1.1 add separator
    $w1.1 add command -label " " -command schetopl:nnakl
    $w1.1 add separator
    $w1.1 add command -label ""  -accelerator "<Esc>"
#    $w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.ok -bd 3 -relief groove -text "" -command schetopl:ok
    button $w.buttons.clear -text "" -command schetopl:clear
    button $w.buttons.exit -text "" -command "destroya $w"
    pack $w.buttons -side bottom -padx 5 -pady 5
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -side left -padx 5 
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
        
    foreach {i j} { insert "" print "" delete "" nalnakl " " exit ""} {
        if { $j != "" } {
            button $w.butimg.$i -takefocus 0 -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -takefocus 0 -image img_$i}
        if { $j == ""} { 
            $w.butimg.$i configure -command "destroy .balloon; $w.buttons.exit invoke"
        }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.delete <Button-1> {
        $SCHETOPL(inwin).schetopl.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $SCHETOPL(inwin).schetopl <Button-3> { 
        set win $SCHETOPL(inwin).schetopl.dat.tbl
        $SCHETOPL(inwin).schetopl.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    
    entry $w.curfldval -width 32 -textvar SCHETOPL_DATA(active) -fg red -bg #fffff0
    label $w.tut -font $VS(fontn) -text "    " -relief raised -bd 1
    pack $w.tut 
    pack $w.curfldval
    foreach i { dat itogoo itogod } {
        frame $w.$i
        pack $w.$i
    }
    scrollbar $w.dat.sby -takefocus 0 -command " $w.dat.tbl yview "
    table $w.dat.tbl -width 3 -height 11 -cols 3 -rows $SCHETOPL(rows) \
        -yscrollcommand " $w.dat.sby set " \
        -cursor arrow \
        -variable SCHETOPL_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { schetopl:browsecommand %S } \
        -wrap on
        
    $w.dat.tbl tag config title -fg yellow
    $w.dat.tbl tag config sel -bg grey85
    $w.dat.tbl tag config active -bd 1 -relief solid
    tktableinittag $w.dat.tbl
    $w.dat.tbl tag col AnchorCenter 2 
    $w.dat.tbl tag col Disabled 0
    $w.dat.tbl tag col AnchorE 1 2
    $w.dat.tbl tag row AnchorCenter -1
    $w.dat.tbl width 0 11 1 11 2 11
    
    pack $w.dat.tbl -side left
    pack $w.dat.sby -side right -fill y
    
    label $w.itogoo.l1 -text "  : "
    label $w.itogoo.sopl -textvar SCHETOPL(sopl) -bd 1 -relief sunken -anchor e -width 11 -bg gray40 -fg cyan
    label $w.itogod.l2 -text "             "
    label $w.itogod.sdolg -textvar SCHETOPL(sdolg) -bd 1 -relief sunken -anchor e -width 11
    foreach i { itogoo.l1 itogoo.sopl itogod.l2 itogod.sdolg } {
        pack $w.$i -side left
    }
        
    bind $w.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind $w.dat.tbl <KeyPress-F2> {
        if { $SCHETOPL(ActiveRow) >= 0 && $SCHETOPL(ActiveCol) == 1 } {
            set SCHETOPL_DATA($SCHETOPL(ActiveRow),1) "$VS(day).$VS(month).$VS(year)"
        }
        if { $SCHETOPL(ActiveRow) >= 0 && $SCHETOPL(ActiveCol) == 2 } {
            set SCHETOPL_DATA($SCHETOPL(ActiveRow),2) $SCHETOPL(sdolg)
        }
    }
    bind $w <Key-Escape> {
        $SCHETOPL(inwin).schetopl.buttons.exit invoke
    }
    bind $w.dat.tbl <Key-Insert> { %W configure -rows [incr SCHETOPL(rows)] }
    wm geometry $w [centerwindow $w]
    schetopl:read
    focus $w.dat.tbl
}

proc schetopl:ok {} {
    global SCHETOPL SCHETOPL_DATA VS

    #     
    set i 0
    while 1 {
        if [info exists SCHETOPL_DATA($i,1)] {
            if ![info exists SCHETOPL_DATA($i,cod)] {
                schetopl:insert $i
            } else { 
                if { $SCHETOPL_DATA($i,cod) <= 0 } {
                    schetopl:insert $i
                }
                if { $SCHETOPL_DATA($i,cod) > 0 } {
                    if { $SCHETOPL_DATA($i,old_1) != $SCHETOPL_DATA($i,1) || \
                         $SCHETOPL_DATA($i,old_2) != $SCHETOPL_DATA($i,2) } {
                        schetopl:update $i
                    }
                }
            }
        } else break
        incr i
    }
    set VS($SCHETOPL(inwin).schetopl_update) 0
}

proc schetopl:addrow {} {
    global SCHETOPL

    $SCHETOPL(inwin).schetopl.dat.tbl configure -rows [incr SCHETOPL(rows)]
}

proc schetopl:nnakl {} {
    global SCHETOPL SCHETOPL_DATA
    
    if [info exists SCHETOPL_DATA($SCHETOPL(ActiveRow),cod)] {
        nnakl:ident schetopl
        schetopl:read
    }
}
