proc schetopl:varold { i } {
    global SCHETOPL_DATA

    set SCHETOPL_DATA($i,old_1) $SCHETOPL_DATA($i,1)
    set SCHETOPL_DATA($i,old_2) $SCHETOPL_DATA($i,2)
}

proc schetopl:clear {} {
    global VS SCHETOPL_DATA SCHETOPL SCHET
    
    catch [unset SCHETOPL_DATA]
    set SCHETOPL_DATA(-1,0) "N "
    set SCHETOPL_DATA(-1,1) ""
    set SCHETOPL_DATA(-1,2) ""

}

proc schetopl:read {} {
    global VS SCHETOPL_DATA SCHETOPL SCHET
    
    schetopl:clear
    set w $SCHETOPL(inwin).schetopl.dat.tbl
    waiting "  ..." blue
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "schetopl_sel \"$SCHET(cod)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            set SCHETOPL_DATA($i,cod) "";   set SCHETOPL_DATA($i,nnaklcod) "" 
            set SCHETOPL_DATA($i,0) "";     set SCHETOPL_DATA($i,1) ""
            set SCHETOPL_DATA($i,2) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                SCHETOPL_DATA($i,cod)       SCHETOPL_DATA($i,nnaklcod) \
                SCHETOPL_DATA($i,0)         SCHETOPL_DATA($i,1) \
                SCHETOPL_DATA($i,2)
            schetopl:varold $i
        }
        if [info exists SCHETOPL(ActiveRow)] { 
            if { $i < $SCHETOPL(ActiveRow) && $i >= 0 } { set SCHETOPL(ActiveRow) $i }
            $w see $SCHETOPL(ActiveRow),0
            $w activate $SCHETOPL(ActiveRow),$SCHETOPL(ActiveCol)
        }
        
        set SCHETOPL(rows) [expr $i + 2]
        if { $SCHETOPL(rows) < 11 } { set SCHETOPL(rows) 11 }
        $w configure -rows $SCHETOPL(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    schetopl:summa
    waiting "" ""
}

proc schetopl:delete {} {
    global VS SCHETOPL SCHETOPL_DATA
    
    set w $SCHETOPL(inwin).schetopl.dat.tbl
    if [info exists SCHETOPL(ActiveRow)] {
        if [info exists SCHETOPL_DATA($SCHETOPL(ActiveRow),cod)] {
            set SCHETOPL_DATA(active) ""
            $w tag row UnSelectRow $SCHETOPL(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $SCHETOPL(ActiveRow)
                waiting "  ..." red
                puts $socks "schetopl_del $SCHETOPL_DATA($SCHETOPL(ActiveRow),cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $SCHETOPL(ActiveRow)
                waiting "" ""
                schetopl:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc schetopl:insert { row } {
    global VS SCHETOPL_DATA SCHETOPL SCHET
    
    set w $SCHETOPL(inwin).schetopl.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "schetopl_ins \"$SCHET(cod)\" \
                                  \"$SCHETOPL_DATA($row,1)\" \
                                  \"$SCHETOPL_DATA($row,2)\" "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SCHETOPL_DATA($row,cod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            schetopl:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc schetopl:update { row } {
    global VS SCHETOPL_DATA SCHETOPL SCHET
    
    set w $SCHETOPL(inwin).schetopl.dat.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        puts $socks "schetopl_upd \"$SCHETOPL_DATA($row,cod)\" \
                                  \"$SCHETOPL_DATA($row,1)\" \
                                  \"$SCHETOPL_DATA($row,2)\" "
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            schetopl:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc schetopl:print {} {
    global VS SCHET    

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "schetopl_rep \"$SCHET(cod)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
