proc schettov:clear {} {
    global VS SCHETTOV_DATA SCHETTOV SCHET
    
    catch [unset SCHETTOV_DATA]
    set SCHETTOV_DATA(-1,0) " "
    set SCHETTOV_DATA(-1,1) "."
    set SCHETTOV_DATA(-1,2) ". ."
    set SCHETTOV_DATA(-1,3) "   "
    set SCHETTOV_DATA(-1,4) " "

}

proc schettov:read {} {
    global VS SCHETTOV_DATA SCHETTOV SCHET
    
    schettov:clear
    set w .schetfnr.tov.tbl
    waiting "  ..." blue
    if { $SCHETTOV(sortstr) == "" }    { set SCHETTOV(sortstr) "tnam" } 
    if { $SCHETTOV(sortdesc) == "" }   { set SCHETTOV(sortdesc) " "  }
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "schettov_sel \"$SCHET(cod)\" \"$SCHETTOV(sortstr) $SCHETTOV(sortdesc)\""
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            set SCHETTOV_DATA($i,cod) "";   set SCHETTOV_DATA($i,tovarcod) "" 
            set SCHETTOV_DATA($i,tovarcena) ""
            set SCHETTOV_DATA($i,0) "";     set SCHETTOV_DATA($i,1) ""
            set SCHETTOV_DATA($i,2) "";     set SCHETTOV_DATA($i,3) ""
            set SCHETTOV_DATA($i,4) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                SCHETTOV_DATA($i,cod)       SCHETTOV_DATA($i,tovarcod) \
                SCHETTOV_DATA($i,tovarcena) \
                SCHETTOV_DATA($i,0)         SCHETTOV_DATA($i,1) \
                SCHETTOV_DATA($i,2)         SCHETTOV_DATA($i,3) \
                SCHETTOV_DATA($i,4)
            
            set SCHETTOV_DATA($i,0) [clipped   $SCHETTOV_DATA($i,0)]
            set SCHETTOV_DATA($i,4) [clipped   $SCHETTOV_DATA($i,4)]
            set SCHETTOV_DATA($i,old_tovarcod) $SCHETTOV_DATA($i,tovarcod)
            set SCHETTOV_DATA($i,old_0)        $SCHETTOV_DATA($i,0)
            set SCHETTOV_DATA($i,old_1)        $SCHETTOV_DATA($i,1)
            set SCHETTOV_DATA($i,old_3)        $SCHETTOV_DATA($i,3)
            set SCHETTOV_DATA($i,old_4)        $SCHETTOV_DATA($i,4)
        }
        if [info exists SCHETTOV(ActiveRow)] { 
            if { $i < $SCHETTOV(ActiveRow) && $i >= 0 } { set SCHETTOV(ActiveRow) $i }
            $w see $SCHETTOV(ActiveRow),0
            $w activate $SCHETTOV(ActiveRow),$SCHETTOV(ActiveCol)
        }
        
        set SCHETTOV(rows) [expr $i + 2]
        if { $SCHETTOV(rows) < 8 } { set SCHETTOV(rows) 8 }
        $w configure -rows $SCHETTOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    schettov:summa
    waiting "" ""
}

proc schettov:delete {} {
    global VS SCHETTOV SCHETTOV_DATA
    
    set w .schetfnr.tov.tbl
    if [info exists SCHETTOV(ActiveRow)] {
        if [info exists SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)] {
            set SCHETTOV_DATA(active) ""
            $w tag row UnSelectRow $SCHETTOV(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $SCHETTOV(ActiveRow)
                waiting "  ..." red
                puts $socks "schettov_del $SCHETTOV_DATA($SCHETTOV(ActiveRow),cod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $SCHETTOV(ActiveRow)
                waiting "" ""
                schettov:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc schettov:insert { row } {
    global VS SCHETTOV_DATA SCHETTOV SCHET
    
    set w .schetfnr.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "schettov_ins \"$SCHET(cod)\" \
                                  \"$SCHETTOV_DATA($row,tovarcod)\" \
                                  [clipped \"$SCHETTOV_DATA($row,4)\"] \
                                  [clipped \"$SCHETTOV_DATA($row,1)\"] \
                                  [clipped \"$SCHETTOV_DATA($row,3)\"] "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SCHETTOV_DATA($row,cod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { $w tag row Normal $row }
        close $socks
        set SCHETTOV_DATA($row,old_tovarcod) $SCHETTOV_DATA($row,tovarcod)
        set SCHETTOV_DATA($row,0)            [clipped $SCHETTOV_DATA($row,0)]
        set SCHETTOV_DATA($row,old_0)        $SCHETTOV_DATA($row,0)
        set SCHETTOV_DATA($row,old_1)        $SCHETTOV_DATA($row,1)
        set SCHETTOV_DATA($row,old_3)        $SCHETTOV_DATA($row,3)
        set SCHETTOV_DATA($row,old_4)        $SCHETTOV_DATA($row,4)
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc schettov:update { row } {
    global VS SCHETTOV_DATA SCHETTOV SCHET
    
    set w .schetfnr.tov.tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        puts $socks "schettov_upd \"$SCHETTOV_DATA($row,cod)\" \
                                  \"$SCHETTOV_DATA($row,tovarcod)\" \
                                  [clipped \"$SCHETTOV_DATA($row,4)\"] \
                                  [clipped \"$SCHETTOV_DATA($row,1)\"] \
                                  [clipped \"$SCHETTOV_DATA($row,3)\"] "
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { $w tag row Normal $row }
        close $socks
        set SCHETTOV_DATA($row,old_tovarcod) $SCHETTOV_DATA($row,tovarcod)
        set SCHETTOV_DATA($row,0)            [clipped $SCHETTOV_DATA($row,0)]
        set SCHETTOV_DATA($row,old_0)        $SCHETTOV_DATA($row,0)
        set SCHETTOV_DATA($row,old_1)        $SCHETTOV_DATA($row,1)
        set SCHETTOV_DATA($row,old_3)        $SCHETTOV_DATA($row,3)
        set SCHETTOV_DATA($row,old_4)        $SCHETTOV_DATA($row,4)
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc schettov:hetovarnam { tip win } {
    global VS SCHETTOV_DATA HE SCHETTOV SCHET
    
    set w .schetfnr.tov.curfldval
    set HE(tit) "                                 ..               "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 6 75 tovar "$SCHETTOV_DATA($SCHETTOV(ActiveRow),0)" $tip $win
    scan $HE(cod) "%\[^\003]%*c%s" \
        SCHETTOV_DATA($SCHETTOV(ActiveRow),tovarcod) \
        SCHETTOV_DATA($SCHETTOV(ActiveRow),eicod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
        SCHETTOV_DATA($SCHETTOV(ActiveRow),0) \
        SCHETTOV_DATA($SCHETTOV(ActiveRow),2) \
        SCHETTOV_DATA($SCHETTOV(ActiveRow),3) \
        fuf
    set SCHETTOV_DATA($SCHETTOV(ActiveRow),0) [clipped $SCHETTOV_DATA($SCHETTOV(ActiveRow),0)]
    catch [set SCHETTOV_DATA($SCHETTOV(ActiveRow),tovarcena) $SCHETTOV_DATA($SCHETTOV(ActiveRow),3)]
    if { $SCHET(lgotaproc) >= 0 } {
        catch [set SCHETTOV_DATA($SCHETTOV(ActiveRow),3) [expr $SCHETTOV_DATA($SCHETTOV(ActiveRow),3) - $SCHETTOV_DATA($SCHETTOV(ActiveRow),3) * $SCHET(lgotaproc) / 100 ]]
    }
    catch [set SCHETTOV_DATA($SCHETTOV(ActiveRow),4) $SCHETTOV_DATA($SCHETTOV(ActiveRow),0)]
}

proc schettov:print {} {
    global VS SCHET SCHETTOV

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "schettov_rep \"$SCHET(cod)\" \"$SCHETTOV(sortstr) $SCHETTOV(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
