proc sostavms {} {
    global VS SOSTAVMS

    set w .allcfg.dat
    catch [destroy $w]
    frame $w
    pack $w
    frame $w.title -bd 5
    label $w.title.l -font $VS(fontn) -text "  " -relief raised -anchor center -bd 1 -padx 3 -width 26
    pack $w.title $w.title.l -fill x

    set w1 ${w}.menu
    trace vdelete SOSTAVMS(window) w trace:sostavms:window
    set SOSTAVMS(window) {}
    trace variable SOSTAVMS(window) w trace:sostavms:window
    
    menu $w1 -tearoff 0 
    menu $w1.1 -tearoff 0
    menu $w1.1.sort -tearoff 0
    menu $w1.1.delete -tearoff 0
    $w1 add cascade -label "" -menu $w1.1 
    $w1.1 add command -label "" -command "sostavms:find"
    $w1.1 add command -label "" -command "sostavms:insert"
    $w1.1 add command -label "" -command "sostavms:print"
    $w1.1 add cascade -label "" -menu $w1.1.sort
    $w1.1 add separator
    $w1.1 add command -state disabled -label "" -command sostavms:view
    $w1.1 add command -state disabled -label "" -command sostavms:update
    $w1.1 add cascade -state disabled -label "" -menu $w1.1.delete
        $w1.1.delete add command -label "  "
        $w1.1.delete add command -label " !!!" -command "sostavms:delete" -activebackground red -activeforeground yellow    
    $w1.1 add separator
    $w1.1 add command -label "" -command "destroy .$w1.1"
    #$w configure -menu $w1
    
    frame $w.buttons -relief sunken -bd 1 
    button $w.buttons.exit -text "" -command "destroy .balloon; destroy .allcfg;"
    label $w.buttons.lm -textvariable SOSTAVMS(statusline) -relief sunken -anchor w -padx 3 -width 50
    button $w.buttons.help -text ""
    pack $w.buttons -side bottom 
    pack $w.buttons.exit $w.buttons.lm -side left -padx 5 
    pack $w.buttons.help -side right -padx 5
    
    frame $w.butimg -relief flat -bd 0 
    pack $w.butimg -side top -fill x 
    foreach {i j} {find "" insert "" print "" sort "" view "" update "" delete "" exit ""} {
        if { $j != "" && $j != "" } {
            button $w.butimg.$i -state disabled -image img_$i -command "$w1.1 invoke [$w1.1 index $j]"
        }
        if { $j == ""} {button $w.butimg.$i -state disabled -image img_$i}
        if { $j == ""} {button $w.butimg.$i -state disabled -image img_$i}
        if { $j == ""} { $w.butimg.$i configure -state normal -command "destroy .balloon; destroy $w"; }
        pack $w.butimg.$i -side left
        bind $w.butimg.$i <Leave> { destroy .balloon }
        bind $w.butimg.$i <Enter> { bindballoon %W }
    }
    
    bind $w.butimg.sort <Button-1> {
        .allcfg.dat.menu.1.sort post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    bind $w.butimg.delete <Button-1> {
        .allcfg.dat.menu.1.delete post [expr [winfo rootx %W] + [expr [winfo reqwidth %W] / 2]] [expr [winfo rooty %W] + [winfo reqheight %W]]
    }
    sostavs
    sostavm
}

proc sostavms:sort {} {
    global  SOSTAVMS VS SOSTAVM SOSTAVS
    
    set w .allcfg.dat.menu
    catch [$w.1.sort delete 0 20]
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavm.lb.listbox {
            $w.1.sort add radio -label " " -variable SOSTAVM(sortstr) -value "nam"\
                 -command "sostavm:read; .allcfg.dat.sostavm.lb.listbox selection set 0 0"
            $w.1.sort add radio -label "    " -variable SOSTAVM(sortstr) -value "tovargroup_cod, nam"\
                 -command "sostavm:read; .allcfg.dat.sostavm.lb.listbox selection set 0 0"
            $w.1.sort add separator
            $w.1.sort add radio -label " " -variable SOSTAVM(sortdesc) -value " "\
                 -command "sostavm:read; .allcfg.dat.sostavm.lb.listbox selection set 0 0"
            $w.1.sort add radio -label " " -variable SOSTAVM(sortdesc) -value "desc"\
                 -command "sostavm:read; .allcfg.dat.sostavm.lb.listbox selection set 0 0"
            $w.1.sort add separator
            $w.1.sort add command -label "" 
        }
        .allcfg.dat.sostavs.lb.listbox {
            $w.1.sort add radio -label " " -variable SOSTAVS(sortstr) -value "b.nam"\
                 -command "sostavs:read; .allcfg.dat.sostavs.lb.listbox selection set 0 0"
            $w.1.sort add radio -label "  " -variable SOSTAVS(sortstr) -value "a.sort_field"\
                 -command "sostavs:read; .allcfg.dat.sostavs.lb.listbox selection set 0 0"
            $w.1.sort add separator
            $w.1.sort add radio -label " " -variable SOSTAVS(sortdesc) -value " "\
                 -command "sostavs:read; .allcfg.dat.sostavs.lb.listbox selection set 0 0"
            $w.1.sort add radio -label " " -variable SOSTAVS(sortdesc) -value "desc"\
                 -command "sostavs:read; .allcfg.dat.sostavs.lb.listbox selection set 0 0"
            $w.1.sort add separator
            $w.1.sort add command -label "" 
        }
    }
}

proc sostavms:insert {} {
    global  SOSTAVMS
    
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavs.lb.listbox      { sostavs:insert }
    }
}

proc sostavms:update {} {
    global  SOSTAVMS
    
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavs.lb.listbox      { sostavs:update }
    }
}

proc sostavms:delete {} {
    global  SOSTAVMS
    
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavs.lb.listbox      { sostavs:delete }
    }
}

proc sostavms:view {} {
    global  SOSTAVMS
    
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavs.lb.listbox      { sostavs:view }
    }
}

proc sostavms:find {} {
    global  SOSTAVMS
    
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavm.lb.listbox       { sostavm:find }
        .allcfg.dat.sostavs.lb.listbox       { sostavs:find }
    }
}

proc sostavms:print {} {
    global  SOSTAVMS
    
    switch $SOSTAVMS(window) {
        .allcfg.dat.sostavs.lb.listbox     { sostavs:print }
    }
}

proc trace:sostavms:window { name1 name2 op } {
    global SOSTAVS SOSTAVS_DATA SOSTAVMS SOSTAVM SOSTAVM_DATA 

    
    .allcfg.dat.sostavm.nameform.l configure -fg black
    .allcfg.dat.sostavs.nameform.l configure -fg black
    switch -regexp $SOSTAVMS(window) {
        \.sostavm\. { .allcfg.dat.sostavm.nameform.l configure -fg blue }
        \.sostavs\. { .allcfg.dat.sostavs.nameform.l configure -fg blue }
    }
    
    sostavms:iconmenu:state disabled "find  insert  print  sort  view  update  delete "
    switch -regexp $SOSTAVMS(window) {
        \.sostavm\. {
            sostavms:iconmenu:state normal  "find "
        }
        \.sostavs\.    { 
            if { [info exists SOSTAVM_DATA(cod,$SOSTAVM(listbox,curselection))] && \
                 $SOSTAVM_DATA(cod,$SOSTAVM(listbox,curselection)) > 0 } { 
                sostavms:iconmenu:state normal  "insert " 
                if { [info exists SOSTAVS_DATA(cod,$SOSTAVS(listbox,curselection))] && \
                     $SOSTAVS_DATA(cod,$SOSTAVS(listbox,curselection)) > 0 } { 
                    sostavms:iconmenu:state normal "find  insert  print  sort  view  update  delete "
                }
            }
        }
    }   
    sostavms:sort
}

proc sostavms:iconmenu:state {s l} {
    set w .allcfg.dat
    foreach {statei statej} "$l" {
        $w.menu.1 entryconfigure [$w.menu.1 index $statej] -state $s
        $w.butimg.$statei configure -state $s
    }
}

proc sostavms:select:element { win } {
    global VS SOSTAVM_DATA SOSTAVM

    set w .allcfg.dat.se$win
    catch [destroy $w]
    if { [ .allcfg.dat.$win.lb.listbox index end ] != 0 } {
        set cursel $SOSTAVM(listbox,curselection)
        set txt $SOSTAVM_DATA(nam,$cursel)
        set x [lindex [.allcfg.dat.$win.lb.listbox bbox $cursel] 0]
        set y [lindex [.allcfg.dat.$win.lb.listbox bbox $cursel] 1]
        toplevel $w -cursor arrow
        wm overrideredirect $w 1
        wm geometry $w +[expr [winfo rootx .allcfg.dat.$win.lb.listbox] + $x - 1]+[expr [winfo rooty .allcfg.dat.$win.lb.listbox] + $y - 2]
        label $w.l -relief raised -bd 1 -anchor w -text " $txt" -padx 0 -pady 1 -width 32 -bg #00c0c0
        pack $w.l
    }
    bind $w <Button-1> {
        scan %W "%%*c%%\[^.]%%*c%%\[^.]%%*c%%\[^.]" w1 w2 w3
        set win ".${w1}.$w2.${w3}"
        catch [destroy $win]
    }
}
