proc sostavs {} {
    global VS SOSTAVS SOSTAVMS SOSTAVS_DATA SOSTAVM_DATA

    set SOSTAVS(entry,nam) ""
    set SOSTAVS(listbox,curselection) 0
    set SOSTAVS(sortdesc) ""
    set SOSTAVS(sortstr) ""
    #set SOSTAVS_DATA(cod,0) 0
    
    set w .allcfg.dat.sostavs
    catch [destroy $w]
    
    frame $w -bd 5
    pack $w -side right
    frame $w.nameform
    label $w.nameform.l -font $VS(fontn) -text "   " -relief raised -anchor center -bd 1 -padx 3
    frame $w.namefield
    label $w.namefield.p1 -text "" -relief raised -anchor center -bd 1 -padx 1 -width 35
    pack $w.nameform $w.nameform.l
    sostavs:search
    pack $w.namefield
    pack $w.namefield.p1 -side left

    frame $w.lb
    scrollbar $w.lb.scrollbar -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -yscroll "$w.lb.scrollbar set" -height 15 -width 32
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    bind $w.lb.listbox <Button-1> {
        set SOSTAVMS(window) %W
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        event generate %W <<sostavs:set:variable>>
        event generate %W <<sostavs:run:read>>
    }
    bind $w.lb.listbox <<sostavs:set:variable>> {
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set SOSTAVMS(statusline) [ %W get $id ]
        set SOSTAVS(listbox,curselection) $id
        if { [winfo exists .allcfg.dat.sesostavm] == 0 } {
            sostavms:select:element sostavm
        }
    }
    bind $w.lb.listbox <Double-Button-1> {
        if [info exists SOSTAVS_DATA(nam,$SOSTAVS(listbox,curselection))] {
            sostavs:view
        }
    }
    bind $w.lb.listbox <Button-3> {
        set SOSTAVMS(window) %W
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <<sostavs:set:variable>>
        .allcfg.dat.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
}

proc sostavs:search {} {
    global VS
    
    set w .allcfg.dat.sostavs.search
    frame $w
    label $w.lfind -relief sunken -width 31 -textvariable SOSTAVS(find) -anchor w
    button $w.lfindb -bitmap @$VS(dir)ComboBox.xbm -command sostavs:search:lb 
    pack $w
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { sostavs:search:lb }
}

proc sostavs:search:lb {} {
    global VS SOSTAVS SOSTAVMS
    
    set w .allcfg.dat.sostavs.search.lfindlb
    catch [destroy $w]
    set x [winfo rootx .allcfg.dat.sostavs.search.lfind]
    set y [winfo rooty .allcfg.dat.sostavs.search.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -height 5 -width 31
    
    foreach {i} $SOSTAVS(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $SOSTAVS(find,listbox) $SOSTAVS(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set SOSTAVS(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable SOSTAVS(find)
    destroy $w
    sostavs:read
}

proc sostavs:entry {status} {
    global VS SOSTAVS
    
    set SOSTAVS(entrystatus) ""
    set SOSTAVS(status) $status
    set w .allcfg.dat.sostavs.sostavsentry
    if { $status != "view" && $status != "update"} {
        set SOSTAVS(entry,nam) ""
    }
    set SOSTAVS(entry,old_nam) $SOSTAVS(entry,nam)
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +130+218
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set ffl "$VS(dir)find.gif";     set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set ffl "$VS(dir)insert.gif";   set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set ffl "$VS(dir)view.gif";     set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set ffl "$VS(dir)update.gif";   set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_find -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    frame $w.inf.nam
    pack $w.inf.nam -anchor w -padx 3 -pady 3
    label $w.inf.nam.l -text "  "
    entry $w.inf.nam.e -textvariable SOSTAVS(entry,nam) -width 30
    button $w.inf.nam.b -bitmap @$VS(dir)ComboBox.xbm -takefocus 0 -command { sostavs:henam r .allcfg.dat.sostavs.sostavsentry }
    
    if { $status == "view" } {
        $w.inf.nam.e configure -state disabled
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set SOSTAVS(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "set SOSTAVS(entry,nam) {} "
    button $w.buttons.exit -text "" -command "set SOSTAVS(entrystatus) 0; destroy $w"

    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf
    pack $w.msg.l -padx 5 -pady 5
    pack $w.inf.nam.l $w.inf.nam.e $w.inf.nam.b -side left
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        focus $w.inf.nam.e
    } else {
        focus $w.buttons.exit
    }
    bind $w <Key-Escape> {
        .allcfg.dat.sostavs.sostavsentry.buttons.exit invoke
    }
    bind $w.inf.nam.e <FocusOut> {
        if { $SOSTAVS(status) != "find" } {
            if { "$SOSTAVS(entry,old_nam)" != "$SOSTAVS(entry,nam)" } {
                sostavs:henam u .allcfg.dat.sostavs.sostavsentry
                set SOSTAVS(entry,old_nam) $SOSTAVS(entry,nam)
            }
        }
    }
    bind $w.inf.nam.e <Button-1> {
        catch [destroy .allcfg.dat.sostavs.sostavsentry.he]
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
