proc sostavs:read {} {
    global VS SOSTAVS SOSTAVS_DATA SOSTAVMS SOSTAVM SOSTAVM_DATA
    
    catch [unset SOSTAVS_DATA]
    catch [destroy .allcfg.dat.sostavs.search.lfindlb]
    set w .allcfg.dat.sostavs.lb.listbox
    waiting "  ..." blue
    if { $SOSTAVS(sortstr) == "" }   { set SOSTAVS(sortstr) "sort_field"  }
    if { $SOSTAVS(sortdesc) == "" }   { set SOSTAVS(sortdesc) " "  }
    if { $SOSTAVS(find) == "" } {
        set SOSTAVS(find) "1=1"
        lappend SOSTAVS(find,listbox) $SOSTAVS(find)
    } 
    
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "sostav_sel \"$SOSTAVM_DATA(cod,$SOSTAVM(listbox,curselection))\" \"$SOSTAVS(find)\" \"$SOSTAVS(sortstr) $SOSTAVS(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set SOSTAVS_DATA(cod,$i) ""; set SOSTAVS_DATA(slavecod,$i) ""; 
            set SOSTAVS_DATA(nam,$i) "";  set SOSTAVS_DATA(sortfield,$i) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" SOSTAVS_DATA(cod,$i) SOSTAVS_DATA(slavecod,$i) SOSTAVS_DATA(nam,$i) SOSTAVS_DATA(sortfield,$i)
            if { [clipped $SOSTAVS(entry,nam)] == [clipped $SOSTAVS_DATA(nam,$i)] } {
                set SOSTAVS(listbox,curselection) $i
            }
            $w insert end " $SOSTAVS_DATA(nam,$i)"
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set SOSTAVMS(statusline) " $i ."
        }
        set SOSTAVS(listbox,count) [expr $i - 1]
        if { $SOSTAVS(listbox,count) < 0 } {
            set SOSTAVS(listbox,count) 0
        }
        $w see $SOSTAVS(listbox,curselection)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc sostavs:find {} {
    global VS SOSTAVS
    
    sostavs:entry find
    if { $SOSTAVS(entrystatus) == 1 } {
        set SOSTAVS(find) "1=1"
        foreach {i j} "\"$SOSTAVS(entry,nam)\" nam" {
            if { $i != "" } {
                set SOSTAVS(find) "$SOSTAVS(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $SOSTAVS(find,listbox) $SOSTAVS(find)] == -1} {
            lappend SOSTAVS(find,listbox) $SOSTAVS(find)
        }
        sostavs:read
    }
    set SOSTAVS(entrystatus) 0
}

proc sostavs:delete {} {
    global VS SOSTAVS SOSTAVS_DATA
    
    set w .allcfg.dat.sostavs.lb.listbox
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." red
        set id [$w curselection]
        puts $socks "sostav_del $SOSTAVS_DATA(cod,$id)"
        flush $socks
        while { [ gets $socks ] != $VS(sepdata) } {
        }
    
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
        sostavs:read
    } else {
        errormsg nosocks "  !"
    }
       
    if { $id > $SOSTAVS(listbox,count)} {
        set id $SOSTAVS(listbox,count)
        set SOSTAVS(listbox,curselection) $SOSTAVS(listbox,count)
    }
    $w see $id
    $w selection set $id $id
}

proc sostavs:insert {} {
    global VS SOSTAVS SOSTAVMS SOSTAVM SOSTAVM_DATA
    
    sostavs:entry insert
    set w .allcfg.dat.sostavs.lb.listbox
    if { $SOSTAVS(entrystatus) == 1 } {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            puts $socks "sostav_ins \"$SOSTAVM_DATA(cod,$SOSTAVM(listbox,curselection))\" \
                                   \"$SOSTAVS(entry,cod)\""
            flush $socks
    
            while { [ set sostavscod [ gets $socks ] ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            sostavs:read
        } else {
            errormsg nosocks "  !"
        }
        $w see $SOSTAVS(listbox,curselection)
    }
    set SOSTAVS(entrystatus) 0
}

proc sostavs:update {} {
    global VS SOSTAVS SOSTAVS_DATA

    set w .allcfg.dat.sostavs.lb.listbox
    set SOSTAVS(entry,nam) [clipped $SOSTAVS_DATA(nam,$SOSTAVS(listbox,curselection))]
    set SOSTAVS(entry,cod) $SOSTAVS_DATA(cod,$SOSTAVS(listbox,curselection))
    sostavs:entry update
    if { $SOSTAVS(entrystatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ... " green
            puts $socks "sostav_upd $SOSTAVS_DATA(cod,$SOSTAVS(listbox,curselection)) \"$SOSTAVS(entry,cod)\" "
            flush $socks
    
            while { [ gets $socks ] != $VS(sepdata) } {
            }
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            sostavs:read
        } else {
            errormsg nosocks "  !"
        }
        $w see [set id $SOSTAVS(listbox,curselection)]
        $w selection set $id $id
    }
    set SOSTAVS(entrystatus) 0
}

proc sostavs:view {} {
    global VS SOSTAVS SOSTAVS_DATA
    
    set SOSTAVS(entry,nam) $SOSTAVS_DATA(nam,$SOSTAVS(listbox,curselection))
    set SOSTAVS(entry,cod) $SOSTAVS_DATA(cod,$SOSTAVS(listbox,curselection))
    sostavs:entry view
}

proc sostavs:print {} {
    global VS SOSTAVS SOSTAVM SOSTAVM_DATA

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "sostav_rep \"$SOSTAVM_DATA(cod,$SOSTAVM(listbox,curselection))\" \"$SOSTAVS(find)\" \"$SOSTAVS(sortstr) $SOSTAVS(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc sostavs:henam { tip win } {
    global VS SOSTAVS HE
    
    set w .allcfg.dat.sostavs.sostavsentry.inf.nam.e
    set HE(tit) "  "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 30 tovartip $SOSTAVS(entry,nam) $tip $win
    set SOSTAVS(entry,cod) $HE(cod)
    set SOSTAVS(entry,nam) [clipped $HE(nam)]
}
