proc spisaniehead:clear {} {
    global SPISANIE_DATA
    
    catch [unset SPISANIE_DATA]
    foreach i { tovarnam printnam primreznam schetnum schetdat naklnum nakldat \
                kol einam cena cenawpdv cenad kolrez kolotg skladnam klientnam \
                issernum } {
        set SPISANIE_DATA($i) ""
    }
}

proc spisanie:read { } {
    global VS SPISANIE SPISANIE_DATA SCHET SCHETTOV NAKLP NAKLPTOV
    
    set w $SPISANIE(inwin).spisanie.upr
    waiting "  ..." blue
    spisaniehead:clear
    #   
    set dat1 [clock format [expr $VS(clock) - 1209600 ] -format %d/%m/%Y]
    #    
    set dat2 [clock format [expr $VS(clock) + 604800 ] -format %d/%m/%Y]
    if { $SPISANIE(sortstr) == "" }    { set SPISANIE(sortstr) "9, 5" } 
    if { $SPISANIE(sortdesc) == "" }   { set SPISANIE(sortdesc) " "  }
    if { $SPISANIE(find) == "" } {
        set SPISANIE(find) "((a.finnaklr_dat >= '$dat1' and a.finnaklr_dat <= '$dat2') or a.finnaklr_dat is null)"
        if [info exists SPISANIE(find,listbox)] {
            if { [lsearch -exact $SPISANIE(find,listbox) $SPISANIE(find)] == -1} {
                lappend SPISANIE(find,listbox) $SPISANIE(find)
            }
        } else {
            lappend SPISANIE(find,listbox) $SPISANIE(find)
        }
    } 
    
    if { $SPISANIE(tip) == "s" } { 
        set SPISANIE(find)      "a.cod = $SCHET(cod)"
        set SPISANIE(sortstr)   $SCHETTOV(sortstr)
        foreach { i j } { tnam "4" pnam "5" koll "10" cenaa "12" enam "10" } {
            regsub -all $i $SPISANIE(sortstr) $j SPISANIE(sortstr)
        }
        set SPISANIE(sortdesc)  $SCHETTOV(sortdesc)
    }
    if { $SPISANIE(tip) == "i" } { 
        set SPISANIE(find)      "a.cod = $NAKLP(cod)"
        set SPISANIE(sortstr)   $NAKLPTOV(sortstr)
        foreach { i j } { tnam "4" pnam "5" koll "10" cenaa "12" enam "10" } {
            regsub -all $i $SPISANIE(sortstr) $j SPISANIE(sortstr)
        }
        set SPISANIE(sortdesc)  $NAKLPTOV(sortdesc)
    }
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "spisaniehead_sel $SPISANIE(ros) $SPISANIE(tip) \"$SPISANIE(find)\" \"$SPISANIE(sortstr) $SPISANIE(sortdesc)\""
        flush $socks
        set i 0
        set SPISANIE(first) 0
        $w.scale configure -from $SPISANIE(first)
        set SPISANIE(count) 0
        set SPISANIE(old_current) 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { tovarnam printnam schetnum schetdat naklnum nakldat \
                        kol einam cena cenawpdv cenad kolotg skladnam \
                        klientnam issernum } {
                set SPISANIE_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                SPISANIE_DATA($i,schetcod) \
                SPISANIE_DATA($i,naklrcod) \
                SPISANIE_DATA($i,schfnrtovcod) \
                SPISANIE_DATA($i,skladcod) \
                SPISANIE_DATA($i,tovarnam) \
                SPISANIE_DATA($i,printnam) \
                SPISANIE_DATA($i,schetnum) \
                SPISANIE_DATA($i,schetdat) \
                SPISANIE_DATA($i,naklnum) \
                SPISANIE_DATA($i,nakldat) \
                SPISANIE_DATA($i,kol) \
                SPISANIE_DATA($i,einam) \
                SPISANIE_DATA($i,cena) \
                SPISANIE_DATA($i,cenawpdv) \
                SPISANIE_DATA($i,cenad) \
                SPISANIE_DATA($i,kolotg) \
                SPISANIE_DATA($i,skladnam) \
                SPISANIE_DATA($i,klientnam) \
                SPISANIE_DATA($i,issernum)
            incr i
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        } else {
            if { $i > 0 } {
                set SPISANIE(first) 1
                $w.scale configure -from $SPISANIE(first)
            }
            set SPISANIE(count) $i
            $w.scale configure -to $SPISANIE(count)
            set SPISANIE(current) $SPISANIE(current)
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    update
}

proc spisanie:find {} {
    global VS SPISANIE SPISANIETOV SPISANIE_DATA
    
    spisanie:entry
    if { $SPISANIE(entrystatus) == 1 } {
        set SPISANIE(find) "1=1"
        foreach {i j} " \"$SPISANIE(entry,tovarnam)\"     c.nam \
                        \"$SPISANIE(entry,printnam)\"     b.printnam \
                        \"$SPISANIE(entry,schetnum)\"     a.schet_num \
                        \"$SPISANIE(entry,schetdat)\"     a.schet_dat \
                        \"$SPISANIE(entry,naklnum)\"      a.finnaklr_num \
                        \"$SPISANIE(entry,nakldat)\"      a.finnaklr_dat \
                        \"$SPISANIE(entry,kol)\"          b.kol \
                        \"$SPISANIE(entry,cena)\"         b.cena \
                        \"$SPISANIE(entry,skladnam)\"     e.nam \
                        \"$SPISANIE(entry,klientnam)\"    f.nam \
                       " {
            if { $i != "" } {
                set SPISANIE(find) "$SPISANIE(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $SPISANIE(find,listbox) $SPISANIE(find)] == -1} {
            lappend SPISANIE(find,listbox) $SPISANIE(find)
        }
        spisanietov:clear
        spisanie:read
        spisanietov:summa
    }
    set SPISANIE(entrystatus) 0
}

proc spisanie:hesklad { tip win } {
    global VS SPISANIE HE
    
    set w $SPISANIE(inwin).spisanie.entry.inf.skladnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $SPISANIE(entry,skladnam) $tip $win
    set SPISANIE(entry,skladcod) $HE(cod)
    set SPISANIE(entry,skladnam) [clipped $HE(nam)]
}

proc spisanie:hetovar { tip win } {
    global VS SPISANIE HE
    
    set w $SPISANIE(inwin).spisanie.entry.inf.tovarnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $SPISANIE(entry,tovarnam) $tip $win
    set SPISANIE(entry,tovarcod) $HE(cod)
    set SPISANIE(entry,tovarnam) [clipped $HE(nam)]
}

proc spisanie:heklient { tip win } {
    global VS SPISANIE HE
    
    set w $SPISANIE(inwin).spisanie.entry.inf.klientnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 klient $SPISANIE(entry,klientnam) $tip $win
    set SPISANIE(entry,klientcod) $HE(cod)
    set SPISANIE(entry,klientnam) [clipped $HE(nam)]
}

