proc spisanietov:varold { i } {
    global SPISANIETOV_DATA SPISANIE

    set SPISANIETOV_DATA($i,old_0)        $SPISANIETOV_DATA($i,0)
    set SPISANIETOV_DATA($i,old_1)        $SPISANIETOV_DATA($i,1)
    if { $SPISANIE(ros) == "s" } {
        set nkol 1
    } else {
        set nkol 2
    }
    set SPISANIETOV_DATA($i,old_$nkol)        $SPISANIETOV_DATA($i,$nkol)
    if { $SPISANIE(ros) == "o" } {
        if [info exists SPISANIETOV_DATA($i,4)] {
            set SPISANIETOV_DATA($i,old_4)        $SPISANIETOV_DATA($i,4)
        } else {
            set SPISANIETOV_DATA($i,old_4) {}
        }
        if [info exists SPISANIETOV_DATA($i,6)] {
            set SPISANIETOV_DATA($i,old_6)        $SPISANIETOV_DATA($i,6)
        } else {
            set SPISANIETOV_DATA($i,old_6) {}
        }
    }
}

proc spisanietov:clear {} {
    global SPISANIETOV_DATA SPISANIE SPISANIE_DATA
    
    catch [unset SPISANIETOV_DATA]
    set SPISANIE_DATA(primrez) {}
    set SPISANIETOV_DATA(active) {}
    set SPISANIETOV_DATA(-1,0) " "
    if { $SPISANIE(ros) == "s" } {
        set SPISANIETOV_DATA(-1,1) "."
        set SPISANIETOV_DATA(-1,2) ".."
        set SPISANIETOV_DATA(-1,3) " ."
        set SPISANIETOV_DATA(-1,4) ""
    } elseif { $SPISANIE(ros) == "o" } {
        set SPISANIETOV_DATA(-1,1) "."
        set SPISANIETOV_DATA(-1,2) "."
        set SPISANIETOV_DATA(-1,3) ".."
        set SPISANIETOV_DATA(-1,4) " ."
        set SPISANIETOV_DATA(-1,5) ""
        set SPISANIETOV_DATA(-1,6) " ."
        set SPISANIETOV_DATA(-1,7) " ."
        set SPISANIETOV_DATA(-1,8) " ."
    } else {
        set SPISANIETOV_DATA(-1,1) "."
        set SPISANIETOV_DATA(-1,2) "."
        set SPISANIETOV_DATA(-1,3) ".."
        set SPISANIETOV_DATA(-1,4) ""
    }
}

proc spisanietov:read {} {
    global VS SPISANIETOV_DATA SPISANIETOV SPISANIE SPISANIE_DATA
    
    set c1 [expr $SPISANIE(current) - 1]
    spisanietov:clear
    set w $SPISANIE(inwin).spisanie.tov.tbl
    if { ($SPISANIE(ros) == "r" || $SPISANIE(ros) == "o") &&
         $SPISANIE_DATA($c1,issernum) == "*" } {
        $w tag col Enabled 1
        $w tag col Disabled 2
    }
    if { ($SPISANIE(ros) == "r" || $SPISANIE(ros) == "o") &&
         $SPISANIE_DATA($c1,issernum) != "*" } {
        $w tag col Disabled 1
        $w tag col Enabled 2
    }
    waiting "  ..." blue
    switch $SPISANIE(ros) {
        r   { set runprg "reztov_sel" }
        o   { set runprg "otgtov_sel" }
        s   { set runprg "spisanietov_sel" }
    }
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "$runprg $SPISANIE_DATA($c1,schfnrtovcod)"
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach j { operrcod 0 1 2 3 4 } {
                set SPISANIETOV_DATA($i,$j) "";
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                SPISANIETOV_DATA($i,operrcod)   SPISANIETOV_DATA($i,tovarcod) \
                SPISANIETOV_DATA($i,0)          SPISANIETOV_DATA($i,1) \
                SPISANIETOV_DATA($i,2)          SPISANIETOV_DATA($i,3) \
                SPISANIETOV_DATA($i,4)          SPISANIE_DATA(primreznam) \
                SPISANIETOV_DATA(skladnam)      SPISANIETOV_DATA(datgar) \
                SPISANIETOV_DATA(cenaprih)      SPISANIETOV_DATA(cenadprih) \
                SPISANIETOV_DATA($i,datgarleft) SPISANIETOV_DATA($i,gsleft) \
                SPISANIETOV_DATA($i,datpokupkileft)
            set SPISANIETOV_DATA($i,0)    [clipped   $SPISANIETOV_DATA($i,0)]
            set SPISANIETOV_DATA($i,1)    [clipped   $SPISANIETOV_DATA($i,1)]
            set SPISANIETOV_DATA($i,4)    [clipped   $SPISANIETOV_DATA($i,4)]
            set SPISANIE_DATA(primreznam) [clipped   $SPISANIE_DATA(primreznam)]
            if { $SPISANIE(ros) == "o" } {
                set SPISANIETOV_DATA($i,5) [clipped $SPISANIETOV_DATA(skladnam)]
                set SPISANIETOV_DATA($i,6) [clipped $SPISANIETOV_DATA(datgar)]
                set SPISANIETOV_DATA($i,7) [format "%10.2f" $SPISANIETOV_DATA(cenaprih)]
                set SPISANIETOV_DATA($i,8) [format "%10.2f" $SPISANIETOV_DATA(cenadprih)]
            } else {
                set SPISANIETOV_DATA($i,4) [clipped $SPISANIETOV_DATA(skladnam)]
            }
            spisanietov:varold $i
        }
        
        set SPISANIETOV(rows) [expr $i + 2]
        if { $SPISANIETOV(rows) < 8 } { set SPISANIETOV(rows) 8 }
        $w configure -rows $SPISANIETOV(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    spisanietov:summa
    waiting "" ""
}

proc spisanietov:hetovarnam { tip win } {
    global VS SPISANIETOV_DATA HE SPISANIETOV SPISANIE SPISANIE_DATA
    
    if { $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),0) != "" } {
        set sep \003
        set c1 [expr $SPISANIE(current) - 1]
        set c2 $SPISANIETOV(ActiveRow)
        set popx 0
        if { $SPISANIE(ros) == "s" } { 
            set popx 0 
            set fm "f"
            #set HE(tit) "                                      . ..           "
            set HE(tit) "                                      . ..                                      "
            set nkol 1
        } else {
            set fm "m"
            #set HE(tit) "                                    .              . ..                                            .     "
            set HE(tit) "                             .              . ..                                       .      "
            set nkol 2
        }
        if { $SPISANIE(ros) == "r" } {
            set skladdat "$VS(day).$VS(month).$VS(year)"
        } elseif { $SPISANIE(ros) == "o" } {
            set skladdat "$VS(day).$VS(month).$VS(year)"
        } else {
            set skladdat $SPISANIE_DATA($c1,nakldat)
        }
        set w $SPISANIE(inwin).spisanie.tov.curfldval
        #he [expr [winfo rootx $w] - $popx ] [expr [winfo rooty $w] + [winfo height $w]] 8 90 tovarostatok "$fm$sep$SPISANIE_DATA($c1,skladcod)$sep$skladdat$sep$SPISANIETOV_DATA($c2,0)" $tip $win
        he [expr [winfo rootx $w] - $popx ] [expr [winfo rooty $w] + [winfo height $w]] 8 95 tovarostatoksklg "$fm$sep$skladdat$sep$SPISANIETOV_DATA($c2,0)" $tip $win
        scan $HE(cod) "%\[^\003]%*c%\[^\003]%*c%s" \
            SPISANIETOV_DATA($c2,operpcod) \
            SPISANIETOV_DATA($c2,tovarcod) \
            SPISANIETOV_DATA($c2,eicod)
        if { $HE(cod) != "" } {
            if { $SPISANIE(ros) == "s" } {
                scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\t]" \
                    SPISANIETOV_DATA($c2,datpokupki) \
                    SPISANIETOV_DATA($c2,0) \
                    SPISANIETOV_DATA($c2,kol) \
                    SPISANIETOV_DATA($c2,2) \
                    SPISANIETOV_DATA($c2,3) \
                    SPISANIETOV_DATA($c2,isnds) \
                    SPISANIETOV_DATA($c2,4)
            } else {
                scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\t]" \
                    SPISANIETOV_DATA($c2,datpokupki) \
                    SPISANIETOV_DATA($c2,0) \
                    SPISANIETOV_DATA($c2,1) \
                    SPISANIETOV_DATA($c2,kol) \
                    SPISANIETOV_DATA($c2,3) \
                    cena \
                    cenad \
                    SPISANIETOV_DATA($c2,isnds) \
                    SPISANIETOV_DATA(skladnam) \
                    SPISANIETOV_DATA(datgar) \
                    SPISANIETOV_DATA(gs) \
                    prim1
                    
                    if { $SPISANIE(ros) == "o" } {
                        catch [set SPISANIETOV_DATA($c2,5) $SPISANIETOV_DATA(skladnam)]
                        catch [set SPISANIETOV_DATA($c2,7) [format "%10.2f" $cena]]
                        catch [set SPISANIETOV_DATA($c2,8) [format "%10.2f" $cenad]]
                        if { [string length [clipped $SPISANIETOV_DATA(datgar)]] > 0 } {
                            set SPISANIETOV_DATA($c2,6) $SPISANIETOV_DATA(datgar)
                        } elseif { [string length [clipped $SPISANIETOV_DATA(gs)]] > 0 } {
                            set d $SPISANIETOV_DATA($c2,datpokupki)
                            set convdat "[string range $d 2 3]/[string range $d 0 1]/[string range $d 4 5]"
                            set SPISANIETOV_DATA($c2,6) [clock format [clock scan "$SPISANIETOV_DATA(gs) month" -base [clock scan $convdat]] -format %d.%m.%Y ]
                        }
                        if { [regexp "" $SPISANIE_DATA(printnam)] && \
                             [info exists SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)])] } {
                            set SPISANIETOV_DATA($c2,6) $SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)])
                        }
                    } else {
                        catch [set SPISANIETOV_DATA($c2,4) $SPISANIETOV_DATA(skladnam)]
                    }
            }
            
            if ![info exists SPISANIETOV_DATA($c2,kol)] { 
                set SPISANIETOV_DATA($c2,kol) 0
            }
            if { $SPISANIETOV_DATA($c2,kol) > $SPISANIETOV(spisat) } {
                catch [set SPISANIETOV_DATA($c2,$nkol) $SPISANIETOV(spisat)]
            } else {
                catch [set SPISANIETOV_DATA($c2,$nkol) $SPISANIETOV_DATA($c2,kol)]
            }
            catch [set SPISANIETOV_DATA($c2,$nkol) [format "%8.2f" $SPISANIETOV_DATA($c2,$nkol)]]
            if { $SPISANIE(ros) == "s" } {
                catch [set SPISANIETOV_DATA($c2,3) [format "%10.2f" $SPISANIETOV_DATA($c2,3)]]
            }
            catch [set SPISANIETOV_DATA($c2,0) [clipped $SPISANIETOV_DATA($c2,0)]]
            catch [set SPISANIETOV_DATA($c2,1) [clipped $SPISANIETOV_DATA($c2,1)]]
            catch [set SPISANIETOV_DATA($c2,3) [clipped $SPISANIETOV_DATA($c2,3)]]
            catch [set SPISANIETOV_DATA($c2,4) [clipped $SPISANIETOV_DATA($c2,4)]]
            catch [set SPISANIETOV_DATA($c2,5) [clipped $SPISANIETOV_DATA($c2,5)]]
        }
    }
}

proc spisanietov:hesernum { tip win } {
    global VS SPISANIETOV_DATA HE SPISANIETOV SPISANIE SPISANIE_DATA
    
    if { $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),1) != "" } {
        set sep \003
        set c1 [expr $SPISANIE(current) - 1]
        set c2 $SPISANIETOV(ActiveRow)
        #he 0 0 0 0 sernumostatok "$SPISANIE_DATA($c1,skladcod)$sep$SPISANIETOV_DATA($c2,1)" $tip $win
        he 0 0 0 0 sernumostatokskg $SPISANIETOV_DATA($c2,1) $tip $win
        scan $HE(cod) "%\[^\003]%*c%\[^\003]%*c%s" \
            SPISANIETOV_DATA($c2,operpcod) \
            SPISANIETOV_DATA($c2,tovarcod) \
            SPISANIETOV_DATA($c2,eicod)
        scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%\[^\t]" \
            SPISANIETOV_DATA($c2,datpokupki) \
            SPISANIETOV_DATA($c2,0) \
            SPISANIETOV_DATA($c2,1) \
            SPISANIETOV_DATA($c2,2) \
            SPISANIETOV_DATA($c2,3) \
            cena \
            cenad \
            SPISANIETOV_DATA($c2,isnds) \
            SPISANIETOV_DATA(skladnam) \
            SPISANIETOV_DATA(datgar)
                
        if { $SPISANIE(ros) == "o" } {
            set SPISANIETOV_DATA($c2,5) $SPISANIETOV_DATA(skladnam)
            set SPISANIETOV_DATA($c2,7) [format "%10.2f" $cena]
            set SPISANIETOV_DATA($c2,8) [format "%10.2f" $cenad]
            if { [string length [clipped $SPISANIETOV_DATA(datgar)]] > 0 } {
                set SPISANIETOV_DATA($c2,6) $SPISANIETOV_DATA(datgar)
            }
            if { [regexp "" $SPISANIE_DATA(printnam)] && \
                 [info exists SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)])] } {
                set SPISANIETOV_DATA($c2,6) $SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)])
            }
        } else {
            set SPISANIETOV_DATA($c2,4) $SPISANIETOV_DATA(skladnam)
        }
            
        set SPISANIETOV_DATA($c2,0) [clipped $SPISANIETOV_DATA($c2,0)]
        set SPISANIETOV_DATA($c2,1) [clipped $SPISANIETOV_DATA($c2,1)]
        set SPISANIETOV_DATA($c2,3) [clipped $SPISANIETOV_DATA($c2,3)]
        catch [set SPISANIETOV_DATA($c2,4) [clipped $SPISANIETOV_DATA($c2,4)]]
        catch [set SPISANIETOV_DATA($c2,5) [clipped $SPISANIETOV_DATA($c2,5)]]
        if { $SPISANIETOV_DATA($c2,operpcod) <= 0 } {
            errormsg nosocks "      !"
        }
    }
}

proc spisanietov:insert { row } {
    global VS SPISANIETOV_DATA SPISANIETOV SPISANIE SPISANIE_DATA
    
    if { $VS(login) == "olga" || $VS(login) == "anna" || $VS(login) == "val" || $VS(login) == "myk" || $VS(login) == "gvozdik" || $VS(login) == "slon2" || $VS(login) == "buh" } {
        set c1 [expr $SPISANIE(current) - 1]
        set w $SPISANIE(inwin).spisanie.tov.tbl
        if { $SPISANIE(ros) == "s" } {
            set nkol 1
        } else {
            set nkol 2
        }
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." magenta
            set datotg {}
            set datgar {}
            if { $SPISANIE(ros) == "o" } { 
                set datotg $SPISANIETOV_DATA($row,4) 
            }
            if { $SPISANIE(ros) == "s" } { 
                set datotg $SPISANIE_DATA($c1,nakldat) 
            }
            if { $SPISANIE(ros) == "o" } { 
                if [info exists SPISANIETOV_DATA($row,6)] {
                    set datgar $SPISANIETOV_DATA($row,6)
                }
            }
            puts $socks "spisanietov_ins $SPISANIE(ros) \
                                         \"$SPISANIE_DATA($c1,schetcod)\" \
                                         $SPISANIE_DATA($c1,schfnrtovcod) \
                                         $SPISANIETOV_DATA($row,operpcod) \
                                         $SPISANIETOV_DATA($row,$nkol) \
                                         $SPISANIE_DATA($c1,cena) \
                                         $SPISANIE_DATA($c1,cenad) \
                                         \"$datotg\" \
                                         \"[clipped $SPISANIE_DATA(primreznam)]\" \
                                         $datgar"
            flush $socks
       
            while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
                set SPISANIETOV_DATA($row,operrcod) $str
            }
            if { [ gets $socks ] != "0" } {
                $w tag row Magenta $row
                errormsg $socks "    !"
            } else { 
                $w tag row Normal $row 
                spisanietov:varold $row
                spisanietov:garantforptk $datgar
            }
            close $socks
            waiting "" ""
        } else { errormsg nosocks "  !" }
    } else {
        errormsg nosocks "    "
    }
}

proc spisanietov:update { row } {
    global VS SPISANIETOV_DATA SPISANIETOV SPISANIE SPISANIE_DATA
    
    if { $VS(login) == "olga" || $VS(login) == "anna" || $VS(login) == "val" || $VS(login) == "myk" || $VS(login) == "gvozdik" || $VS(login) == "slon2" || $VS(login) == "buh" } {
        set w $SPISANIE(inwin).spisanie.tov.tbl
        if { $SPISANIE(ros) == "s" } {
            set nkol 1
        } else {
            set nkol 2
        }
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." green
            set datotg {}
            set datgar {}
            if { $SPISANIE(ros) == "o" } {
                if [info exists SPISANIETOV_DATA($row,4)] {
                    set datotg $SPISANIETOV_DATA($row,4)
                }
                if [info exists SPISANIETOV_DATA($row,6)] {
                    set datgar $SPISANIETOV_DATA($row,6)
                }
            }
            puts $socks "spisanietov_upd $SPISANIE(ros) \
                                    $SPISANIETOV_DATA($row,operrcod) \
                                    \"$datotg\" \
                                    $SPISANIETOV_DATA($row,$nkol) \
                                    \"$SPISANIE_DATA(primreznam)\" \
                                    $datgar"
            flush $socks
       
            while { [ gets $socks ] != $VS(sepdata) } { }
            if { [ gets $socks ] != "0" } {
                $w tag row Green $row
                errormsg $socks "    !"
            } else { 
                $w tag row Normal $row 
                spisanietov:varold $row
                spisanietov:garantforptk $datgar
            }
            close $socks
            waiting "" ""
        } else { errormsg nosocks "  !" }
    } else {
        errormsg nosocks "    "
    }
}

proc spisanietov:garantforptk { datgar } {
    global SPISANIE_DATA 

    if [regexp "" $SPISANIE_DATA(printnam)] {
        set SPISANIE_DATA([clipped $SPISANIE_DATA(printnam)]) $datgar
    }
}

proc spisanietov:delete {} {
    global VS SPISANIETOV SPISANIETOV_DATA SPISANIE
    
    if { $VS(login) == "olga" || $VS(login) == "anna" || $VS(login) == "val" || $VS(login) == "myk" || $VS(login) == "gvozdik" || $VS(login) == "slon2" || $VS(login) == "buh" } {
        set w $SPISANIE(inwin).spisanie.tov.tbl
        if [info exists SPISANIETOV(ActiveRow)] {
            if { [info exists SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod)] } {
                set SPISANIETOV_DATA(active) ""
                $w tag row UnSelectRow $SPISANIETOV(ActiveRow)
                if { [ set socks [checkpasswd] ] != -1 } {
                    $w tag row flash $SPISANIETOV(ActiveRow)
                    waiting "  ..." red
                    puts $socks "spisanietov_del $SPISANIE(ros) $SPISANIETOV_DATA($SPISANIETOV(ActiveRow),operrcod)"
                    flush $socks
                    while { [ gets $socks ] != $VS(sepdata) } { }
                    if { [ gets $socks ] != "0" } {
                        errormsg $socks "    !"
                    }
                    close $socks
                    $w tag row SelectRow $SPISANIETOV(ActiveRow)
                    waiting "" ""
                    spisanietov:read
                } else {
                    errormsg nosocks "  !"
                }
            }
        }
    } else {
        errormsg nosocks "    "
    }
}
