proc tovartip {} {
    global VS TOVARTIP TOVARGTT TOVARTIP_DATA TOVAR

    catch [unset TOVARTIP_DATA]
    set TOVARTIP(entry,nam) {}
    set TOVARTIP(listbox,curselection) 0
    set TOVARTIP(sortdesc) {}
    set TOVARTIP_DATA(cod,0) 0
    
    set w .tovargtt.tovartip
    catch [destroy $w]
    
    frame $w -bd 5
    pack $w -side right
    frame $w.namefield
    label $w.namefield.l -font $VS(fontn) -text "  " -relief raised -anchor center -bd 1 -padx 3
    pack $w.namefield $w.namefield.l -side top
    tovartip:search

    frame $w.lb
    scrollbar $w.lb.scrollbar -command "$w.lb.listbox yview"
    listbox $w.lb.listbox -yscroll "$w.lb.scrollbar set" -height 7 -width 32 -exportselection 0
    pack $w.lb
    pack $w.lb.scrollbar -side right -fill y
    pack $w.lb.listbox -side left -expand 1 -fill both
    
    bind $w.lb.scrollbar <Button-1> {
        catch [destroy .tovargtt.setovartip]
    }
    bind $w.lb.listbox <Button-1> {
        set TOVARGTT(window) %W
    }
    bind $w.lb.listbox <B1-ButtonRelease> {
        event generate %W <<tovartip:set:variable>>
        event generate %W <<tovartip:run:read>>
    }
    bind $w.lb.listbox <<tovartip:set:variable>> {
        set id [ %W curselection ]
        if { $id == "" } { set id 0 }
        set TOVARGTT(statusline) [ %W get $id ]
        set TOVARTIP(listbox,curselection) $id
        catch [destroy .tovargtt.setovartip]
    }
    bind $w.lb.listbox <<tovartip:run:read>> {
        set TOVAR(find) "1=1"
        if ![info exists TOVAR(find,listbox)] {
            set TOVAR(find,listbox) "1=1"
        }
        tovar:read
    }
    bind $w.lb.listbox <Button-3> {
        set TOVARGTT(window) %W
        %W selection clear 0 end
        set id [ %W nearest  [ expr [winfo pointery %W] - [winfo rooty %W ] ] ]
        %W selection set $id $id
        event generate %W <<tovartip:set:variable>>
        .tovargtt.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
}

proc tovartip:search {} {
    global VS
    
    set w .tovargtt.tovartip.search
    frame $w
    label $w.lfind -relief sunken -width 31 -textvariable TOVARTIP(find) -anchor w
    button $w.lfindb -bitmap @$VS(dir)ComboBox.xbm -command tovartip:search:lb 
    pack $w
    pack $w.lfind $w.lfindb -side left

    foreach i {lfind lfindb} {
        bind $w.$i <Enter> { bindballoon %W }
        bind $w.$i <Leave> { destroy .balloon }
    }
    bind $w.lfind <B1-ButtonRelease> { tovartip:search:lb }
    bind $w.lfind <Button-1> {
        catch [destroy .tovargtt.setovartip]
    }
    bind $w.lfindb <Button-1> {
        catch [destroy .tovargtt.setovartip]
    }
}

proc tovartip:search:lb {} {
    global VS TOVARTIP TOVARGTT
    
    set w .tovargtt.tovartip.search.lfindlb
    catch [destroy $w]
    set x [winfo rootx .tovargtt.tovartip.search.lfind]
    set y [winfo rooty .tovargtt.tovartip.search.lfind]
    
    toplevel $w -cursor arrow
    wm overrideredirect $w 1
    wm geometry $w +$x+$y
    scrollbar $w.sbx -command "$w.lb xview" -orient h
    scrollbar $w.sby -command "$w.lb yview"
    listbox $w.lb -yscroll "$w.sby set" -xscroll "$w.sbx set" -height 5 -width 31
    
    foreach {i} $TOVARTIP(find,listbox) {
        $w.lb insert end $i
    }
    
    set id [lsearch -exact $TOVARTIP(find,listbox) $TOVARTIP(find)]
    $w.lb see $id
    $w.lb selection set $id $id
    
    pack $w.sby -side right -fill y
    pack $w.sbx -side bottom -fill x
    pack $w.lb -side left
    
    bind $w.lb <B1-ButtonRelease> {
        set TOVARTIP(find) [ %W get [ %W curselection ] ]
    }
    tkwait variable TOVARTIP(find)
    destroy $w
    tovartip:read
}

proc tovartip:entry {status} {
    global VS TOVARTIP
    
    set TOVARTIP(entrystatus) {}
    set w .tovargtt.tovartip.tovartipentry
    if { $status != "view" && $status != "update"} {
        set TOVARTIP(entry,nam) {}
    }
    catch [ destroy $w ]
    toplevel $w
    wm resizable $w 0 0
    #wm geometry $w +186+220
    wm geometry $w =0x0
    frame $w.msg
    switch $status {
        find { 
            set ttl "";                set ttx "  ";
            set clr "cyan"
        }
        insert { 
            set ttl "";           set ttx " ";
            set clr "magenta"
        }
        view { 
            set ttl "";             set ttx " ";
            set clr "blue"
        }
        update { 
            set ttl "";            set ttx " ";
            set clr "green"
        }
    }
    
    wm title $w $ttl
    label $w.msg.l -font $VS(fontn) -text "$ttx"
    label $w.msg.logo -image logo_$status -bg $clr -relief sunken -bd 5
    
    frame $w.inf -bd 2 -relief raised
    frame $w.inf.l
    label $w.inf.l.name -text "  " -anchor e
    
    frame $w.inf.e
    entry $w.inf.e.name -textvariable TOVARTIP(entry,nam) -width 30
    if { $status == "view" } {
        $w.inf.e.name configure -state disabled
    }
    
    frame $w.buttons
    button $w.buttons.ok -bd 3 -relief groove -text "" -command "set TOVARTIP(entrystatus) 1; destroy $w"
    button $w.buttons.clear -text "" -command "set TOVARTIP(entry,nam) {}"
    button $w.buttons.exit -text "" -command "set TOVARTIP(entrystatus) 0; destroy $w"
    if { $status == "view" } {
        $w.buttons.ok configure -state disabled
        $w.buttons.clear  configure -state disabled
    }
        
    pack $w.msg -side top -fill x
    pack $w.msg.logo -side left 
    pack $w.buttons -side bottom
    pack $w.inf -fill x
    pack $w.inf.l -side left
    pack $w.inf.e -side right
    pack $w.msg.l -padx 5 -pady 5
    pack $w.inf.l.name -padx 5 -pady 5 -anchor e
    pack $w.inf.e.name -padx 5 -pady 5 -anchor w
    pack $w.buttons.ok $w.buttons.clear $w.buttons.exit -padx 5 -pady 5 -side left
    
    if { $status != "view" } {
        focus $w.inf.e.name
    } else {
        focus $w.buttons.exit
    }
    bind $w <Key-Escape> {
        .tovargtt.tovartip.tovartipentry.buttons.exit invoke
    }
    wm geometry $w [centerwindow $w]
    tkwait window $w
}
