proc tovarwww { win tovarcod } {
    global VS TOVARWWW TOVAR

    catch [unset TOVARWWW]
    set TOVARWWW(opisanieshort) ""
    set TOVARWWW(opisanielong) ""
    set w $win.tovarwww
    catch [destroy $w]
    toplevel $w
    wm resizable $w 0 0
    wm geometry $w =0x0
    set tittxt "WWW   "
    wm title $w $tittxt
    
    frame $w.tit -relief ridge
    label $w.tit.l1 -font $VS(fontn) -text $tittxt
    label $w.tit.l2 -relief sunken -bg grey80 -fg green4 -text " $TOVAR(entry,nam) "
    frame $w.dat
    foreach { i j } { smallimage "      " \
                      bigimage   "    " } {
        frame $w.dat.$i
        label $w.dat.$i.l -text $j
        entry $w.dat.$i.e -textvar TOVARWWW($i) -width 30
    }
    
    frame $w.dat.txt1 -bd 2 -relief sunken
    label $w.dat.txt1.l1 -text "     " \
        -width 82 -anchor center -bg grey80
    label $w.dat.txt1.l2 -textvar TOVARWWW(text1count) \
        -fg blue3 -anchor w -width 82
    scrollbar $w.dat.txt1.lby -command "$w.dat.txt1.t yview" -takefocus 0
    text $w.dat.txt1.t -relief sunken -bd 1 -height 5 -wrap word \
        -yscroll "$w.dat.txt1.lby set"
    
    frame $w.dat.txt2 -bd 2 -relief sunken
    label $w.dat.txt2.l1 -text "     " \
        -width 82 -anchor center -bg grey80
    label $w.dat.txt2.l2 -textvar TOVARWWW(text2count) \
        -fg blue3 -anchor w -width 82
    scrollbar $w.dat.txt2.lby -command "$w.dat.txt2.t yview" -takefocus 0
    text $w.dat.txt2.t -relief sunken -bd 1 -height 15 -wrap word \
        -yscroll "$w.dat.txt2.lby set"
    
    
    frame $w.upr -bd 3 -relief groove
    button $w.upr.ok -text "" -bd 3 -command "tovarwww:ok $w $tovarcod" -relief groove
    button $w.upr.exit -text "" -command "destroy $w"
    
    #PACK
    pack $w.tit -fill x -pady 1
    pack $w.tit.l1 $w.tit.l2 $w.dat $w.dat.smallimage $w.dat.bigimage $w.dat.txt1 \
         $w.dat.txt2 $w.upr -padx 1 -pady 1
    foreach i { smallimage.l smallimage.e bigimage.l bigimage.e } {
        pack $w.dat.$i -side left -padx 1 -pady 1
    }
    pack $w.dat.txt1.l1 $w.dat.txt1.l2 $w.dat.txt2.l1 $w.dat.txt2.l2
    pack $w.dat.txt1.t $w.dat.txt2.t -side left
    pack $w.dat.txt1.lby $w.dat.txt2.lby -side right -fill y
    
    pack $w.upr.ok $w.upr.exit -side left -padx 15 -pady 1
    wm geometry $w [centerwindow $w]
    foreach i { 1 2 } {
        bind $w.dat.txt$i.t <KeyRelease> [list tovarwww:text:bind $i %W]
    }
    focus $w.dat.smallimage.e
    bind $w <KeyPress-Escape> [list $w.upr.exit invoke]
    tovarwww:read $w $tovarcod
}

proc tovarwww:text:bind { c win } {
    global TOVARWWW
    
    if { $c == 1 } { set lng 512 }
    if { $c == 2 } { set lng 4096 }
    set TOVARWWW(text${c}count) [ expr [string length [$win get 0.0 end]] - 1]
    if { $TOVARWWW(text${c}count) > $lng } {
        [string range $win 0 [expr [string length $win] - 3]].l2 configure -fg red3
        set TOVARWWW(text${c}count) ""
        $win delete [$win index end-2chars] end
    } else {
        [string range $win 0 [expr [string length $win] - 3]].l2 configure -fg blue3
    }
}

proc tovarwww:read { w tovarcod } {
    global VS TOVARWWW
    
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovarwww_sel $tovarcod"
        flush $socks
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                TOVARWWW(smallimage) \
                TOVARWWW(bigimage) \
                TOVARWWW(opisanieshort) \
                TOVARWWW(opisanielong)
        }
        $w.dat.txt1.t insert 0.0 $TOVARWWW(opisanieshort)
        $w.dat.txt2.t insert 0.0 $TOVARWWW(opisanielong)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
}

proc tovarwww:ok { w tovarcod } {
    global VS TOVARWWW

    regsub -all \n [$w.dat.txt1.t get 0.0 end] "" TOVARWWW(opisanieshort)
    regsub -all \n [$w.dat.txt2.t get 0.0 end] "" TOVARWWW(opisanielong)
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "tovarwww_ins $tovarcod \"[string trim $TOVARWWW(smallimage)]\" \
                                            \"[string trim $TOVARWWW(bigimage)]\" \
                                            \"[string trim $TOVARWWW(opisanieshort)]\" \
                                            \"[string trim $TOVARWWW(opisanielong)]\""
        flush $socks
    
        while { [ set gorodcod [ gets $socks ] ] != $VS(sepdata) } { }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}