proc tovcardhead:clear {} {
    global TOVCARD_DATA
    
    catch [unset TOVCARD_DATA]
    foreach i { tovarcod skladcod tovarnam einam \
                datbegin datend skladnam saldobegin saldoend } {
        set TOVCARD_DATA($i) ""
    }
}

proc tovcard:read { } {
    global VS TOVCARD TOVCARD_DATA
    
    set w $TOVCARD(inwin).tovcard.upr
    waiting "  ..." blue
    tovcardhead:clear
    #   
    set dat1 [clock format [expr $VS(clock) - 1209600 ] -format %d.%m.%Y]
    #    
    set dat2 [clock format [expr $VS(clock) + 604800 ] -format %d.%m.%Y]
    if { ![info exists TOVCARD(entry,datbegin)] || $TOVCARD(entry,datbegin) == "" } { 
        set TOVCARD(entry,datbegin) "$dat1" 
    }
    if { ![info exists TOVCARD(entry,datend)] || $TOVCARD(entry,datend) == "" } { 
        set TOVCARD(entry,datend) "$dat2" 
    }
    if { $TOVCARD(find) == "" } {
        set TOVCARD(find) "1=1"
        if [info exists TOVCARD(find,listbox)] {
            if { [lsearch -exact $TOVCARD(find,listbox) $TOVCARD(find)] == -1} {
                lappend TOVCARD(find,listbox) $TOVCARD(find)
            }
        } else {
            lappend TOVCARD(find,listbox) $TOVCARD(find)
        }
    } 
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovcardhead_sel $TOVCARD(tip) $TOVCARD(entry,datbegin) $TOVCARD(entry,datend) \"$TOVCARD(find)\""
        flush $socks
        set i 0
        set TOVCARD(first) 0
        $w.scale configure -from $TOVCARD(first)
        set TOVCARD(count) 0
        set TOVCARD(old_current) 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { tovarcod skladcod tovarnam einam \
                        datbegin datend skladnam saldobegin saldoend } {
                set TOVCARD_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                TOVCARD_DATA($i,tovarcod) \
                TOVCARD_DATA($i,skladcod) \
                TOVCARD_DATA($i,tovarnam) \
                TOVCARD_DATA($i,einam) \
                TOVCARD_DATA($i,datbegin) \
                TOVCARD_DATA($i,datend) \
                TOVCARD_DATA($i,skladnam) \
                TOVCARD_DATA($i,saldobegin) \
                TOVCARD_DATA($i,saldoend)
            incr i
        }
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        } else {
            if { $i > 0 } {
                set TOVCARD(first) 1
                $w.scale configure -from $TOVCARD(first)
            }
            set TOVCARD(count) $i
            $w.scale configure -to $TOVCARD(count)
            set TOVCARD(current) $TOVCARD(current)
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    update
}

proc tovcard:find {} {
    global VS TOVCARD TOVCARDTOV TOVCARD_DATA
    
    tovcard:entry
    if { $TOVCARD(entrystatus) == 1 } {
        set TOVCARD(find) "1=1"
        foreach {i j} " \"$TOVCARD(entry,tovarnam)\"     a.nam \
                        \"$TOVCARD(entry,skladnam)\"     d.nam \
                       " {
            if { $i != "" } {
                set TOVCARD(find) "$TOVCARD(find) and $j [construct $i]"
            }    
        }
        if { [info exists TOVCARD(entry,tovartipcod)] && \
             $TOVCARD(entry,tovartipcod) > 0 } {
            set TOVCARD(find) "$TOVCARD(find) and a.tovartip_cod = $TOVCARD(entry,tovartipcod)"
        }
        if { [lsearch -exact $TOVCARD(find,listbox) $TOVCARD(find)] == -1} {
            lappend TOVCARD(find,listbox) $TOVCARD(find)
        }
        tovcardtov:clear
        tovcard:read
        tovcardtov:summa
    }
    set TOVCARD(entrystatus) 0
}

proc tovcard:hesklad { tip win } {
    global VS TOVCARD HE
    
    set w $TOVCARD(inwin).tovcard.entry.inf.skladnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $TOVCARD(entry,skladnam) $tip $win
    set TOVCARD(entry,skladcod) $HE(cod)
    set TOVCARD(entry,skladnam) [clipped $HE(nam)]
}

proc tovcard:hetovar { tip win } {
    global VS TOVCARD HE
    
    set w $TOVCARD(inwin).tovcard.entry.inf.tovarnam.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $TOVCARD(entry,tovarnam) $tip $win
    set TOVCARD(entry,tovarcod) $HE(cod)
    set TOVCARD(entry,tovarnam) [clipped $HE(nam)]
}

proc tovcard:hetovartip { tip win } {
    global VS TOVCARD HE
    
    set w $TOVCARD(inwin).tovcard.entry.inf.tovartipnam.e
    set HE(tit) "  "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovartip "*" $tip $win
    set TOVCARD(entry,tovartipcod) $HE(cod)
    set TOVCARD(entry,tovartipnam) [clipped $HE(nam)]
}
