proc tovcardhead { } {
    global VS TOVCARD TOVCARD_DATA TOVCARDTOV TOVCARDTOV_DATA

    set w $TOVCARD(inwin).tovcard
    set TOVCARDTOV(rows) 14
    if ![info exists TOVCARDTOV(prih)] { set TOVCARDTOV(prih) "a" }
    if ![info exists TOVCARDTOV(rash)] { set TOVCARDTOV(rash) "a" }
    # head ##################################################################
    
    label $w.tit -font $VS(fontn) -text " $TOVCARD(titstr) " \
        -relief raised -anchor center -bd 1
    pack $w.tit
    
    foreach { i } { tovar dat saldo } {
        if { $i == "dat" || $i == "saldo" } {
            frame $w.sep$i -bd 1 -height 2 -relief sunken
            pack $w.sep$i -fill x
        }
        frame $w.$i
        pack $w.$i -anchor w -padx 3 -pady 2
    }
    frame $w.septov -bd 1 -height 10 -relief sunken
    pack  $w.septov -fill x
    foreach { i j } [subst { tovar    "$TOVCARD(titstr)" \
                             dat      "     : " \
                             saldo    "  " \
                           }] {
        label $w.$i.l1 -text $j
    }
    foreach { i j k } { tovar.tovarnam       tovarnam    50 \
                        tovar.einam          einam       10 \
                        dat.datbegin         datbegin    10 \
                        dat.datend           datend      10 \
                        dat.skladnam         skladnam    30 \
                        saldo.saldobegin     saldobegin  8 \
                        saldo.saldoend       saldoend    8 \
                      } {
        entry $w.$i -textvar TOVCARD_DATA($j) -width $k -state disabled
    }
    foreach i { dat.datbegin dat.datend dat.skladnam } {
        $w.$i configure -bg grey93
    }
    $w.dat.skladnam configure -bg grey98
    foreach { i j } { tovar.l2  "  " \
                      dat.l2    " " \
                      dat.l3    "         " \
                      saldo.l2  "   " \
                  } {
        label $w.$i -text $j
    }
    
    foreach i { tovar.l1 tovar.tovarnam tovar.l2 tovar.einam \
                dat.l1 dat.datbegin dat.l2 dat.datend dat.l3 dat.skladnam \
                saldo.l1 saldo.saldobegin saldo.l2 saldo.saldoend \
               } {
        pack $w.$i -side left
    }
    
    # tov ####################################################################

    switch $TOVCARD(tip) {
        f   { set wc 7 }
        m   { set wc 9 }
    }
    frame $w.to
    frame $w.tov
    pack $w.to $w.tov -fill x
    entry $w.to.curfldval -textvar TOVCARDTOV_DATA(active) -fg red \
        -bg #fffff0 -width 51 -state disabled
    if { $TOVCARD(tip) == "f" } {
        label $w.to.fuf1 -text "                              "
    } else {
        label $w.to.fuf1 -text "                                   "
    }
    label $w.to.sbegin -textvar TOVCARD_DATA(saldobegin) -bd 0 -relief sunken -anchor e -width 8 -bg gray30 -fg cyan
    scrollbar $w.tov.sby -takefocus 0 -command " $w.tov.tbl yview "
    table $w.tov.tbl -width $wc -height 14 -cols $wc -rows $TOVCARDTOV(rows) \
        -yscrollcommand " $w.tov.sby set " \
        -cursor arrow \
        -variable TOVCARDTOV_DATA \
        -titlerows 1 \
        -roworigin -1 \
        -anchor nw \
        -flashmode off \
        -selectmode browse \
        -browsecommand { tovcardtov:browsecommand %S } \
        -wrap on
        
    button $w.tov.tbl.bprih -highlightbackground grey65 -cursor arrow -bd 1 -text "" -bg grey65 -fg yellow -command tovcardtov:trprih
    button $w.tov.tbl.brash -highlightbackground grey65 -cursor arrow -bd 1 -text "" -bg grey65 -fg yellow -command tovcardtov:trrash
    $w.tov.tbl window configure -1,3 -window $w.tov.tbl.bprih -sticky wens
    $w.tov.tbl window configure -1,4 -window $w.tov.tbl.brash -sticky wens
    tovcardtov:trcolor

    
    tktableinittag $w.tov.tbl
    $w.tov.tbl tag row AnchorCenter -1
    $w.tov.tbl tag col Disabled 0 1 3 4 5 6 7
    if { $TOVCARD(tip) == "f" } {
        $w.tov.tbl width 0 7 1 11 2 37 3 8 4 8 5 8 6 10
    } else {
        $w.tov.tbl width 0 7 1 11 2 29 3 8 4 8 5 8 6 10 7 10 8 2
    }
    pack $w.to.curfldval $w.to.fuf1 $w.to.sbegin -side left
    pack $w.tov.tbl -side left
    pack $w.tov.sby -side left -fill y
    
    frame $w.itogo
    pack $w.itogo -anchor w
    if { $TOVCARD(tip) == "f" } {
        set ijkl {"                                                 :" sprih  8 50 \
                  "" srash  8 50 \
                  "          " sost   8 30 \
                }
    } else {
        set ijkl {"                                         :" sprih  8 50 \
                  "" srash  8 50 \
                  "                       " sost   8 30 \
                }
    }
    label $w.itogo.lfuf1 -text "" -bd 0
    pack $w.itogo.lfuf1 -side left
    foreach { i j k l } $ijkl {
        label $w.itogo.l$j -text $i -bd 0
        pack $w.itogo.l$j -side left
        label $w.itogo.$j -textvar TOVCARDTOV($j) -bd 0 -relief sunken -anchor e -width $k -bg gray$l -fg cyan
        pack $w.itogo.$j -side left
    }
    $w.itogo.sost configure -textvar TOVCARD_DATA(saldoend)
            
    bind $w.to.curfldval <Return> [list tkTableMoveCell $w.tbl 0 1]
    bind $w.tov.tbl <Button-3> { 
        event generate %W <Button-1>
        $TOVCARD(inwin).tovcard.menu.1 post [winfo pointerx %W] [winfo pointery %W]
    }
    bind $w.tov.tbl <KeyPress-Next> {
        tovcard:poz incr
    }
    bind $w.tov.tbl <KeyPress-Prior> {
        tovcard:poz decr
    }
    bind $w.tov.tbl <KeyPress-Home> {
        tovcard:poz first
    }
    bind $w.tov.tbl <KeyPress-End> {
        tovcard:poz last
    }
    focus $w.tov.tbl
}

proc tovcardtov:summa {} {
    global TOVCARDTOV TOVCARDTOV_DATA TOVCARD_DATA TOVCARD
    
    set i 0
    set TOVCARDTOV(sprih) 0
    set TOVCARDTOV(srash) 0
    while { [info exists TOVCARDTOV_DATA($i,0)] } {
        catch [set TOVCARDTOV(sprih) [expr $TOVCARDTOV(sprih) + $TOVCARDTOV_DATA($i,3)]]
        catch [set TOVCARDTOV(srash) [expr $TOVCARDTOV(srash) + $TOVCARDTOV_DATA($i,4)]]
        set TOVCARDTOV_DATA($i,5) [expr $TOVCARD_DATA(saldobegin) + $TOVCARDTOV(sprih) - $TOVCARDTOV(srash)]
        set TOVCARDTOV_DATA($i,5) [format "%7.2f" $TOVCARDTOV_DATA($i,5)]
        incr i
    }
}

proc tovcardtov:browsecommand { rowcol } {
    global TOVCARDTOV TOVCARDTOV_DATA TOVCARD TOVCARD_DATA VS
    
    set w $TOVCARD(inwin).tovcard.tov
    if { [info exists TOVCARDTOV(ActiveRow)] && \
         $TOVCARDTOV(ActiveRow) >= 0 } {
        $w.tbl tag row UnSelectRow $TOVCARDTOV(ActiveRow)
    }
    
    set TOVCARDTOV(ActiveRowCol) $rowcol 
    scan $TOVCARDTOV(ActiveRowCol) "%\[^,]%*c%s" TOVCARDTOV(ActiveRow) TOVCARDTOV(ActiveCol)
    
    #tovcardtov:summa
    if { $TOVCARDTOV(ActiveRow) >= 0 } {
        $w.tbl tag row SelectRow $TOVCARDTOV(ActiveRow)
    }
}


proc tovcardtov:trprih {} {
    global TOVCARDTOV
    
    if { $TOVCARDTOV(prih) == "a" } {
        set TOVCARDTOV(prih) "o"
    } else {
        set TOVCARDTOV(prih) "a"
    }
    tovcardtov:trcolor
    tovcardtov:read
}

proc tovcardtov:trrash {} {
    global TOVCARDTOV
    
    if { $TOVCARDTOV(rash) == "a" } {
        set TOVCARDTOV(rash) "o"
    } else {
        set TOVCARDTOV(rash) "a"
    }
    tovcardtov:trcolor
    tovcardtov:read
}

proc tovcardtov:trcolor {} {
    global TOVCARDTOV TOVCARD
    
    set w $TOVCARD(inwin).tovcard.tov.tbl
    if { $TOVCARDTOV(prih) == "a" } {
        $w.bprih configure -fg yellow -bg gray65 -activeforeground yellow
    } else {
        $w.bprih configure -fg black -bg yellow -activeforeground black
    }
    if { $TOVCARDTOV(rash) == "a" } {
        $w.brash configure -fg yellow -bg gray65 -activeforeground yellow
    } else {
        $w.brash configure -fg black -bg yellow -activeforeground black
    }
}
