proc tovdolgtov:clear {} {
    global TOVDOLGTOV_DATA TOVDOLG_DATA
    
    catch [unset TOVDOLGTOV_DATA]
    set TOVDOLGTOV_DATA(-2,0) ""
    set TOVDOLGTOV_DATA(-2,1) "-"
    set TOVDOLGTOV_DATA(-2,2) ""
    set TOVDOLGTOV_DATA(-2,3) ""
    set TOVDOLGTOV_DATA(-2,4) ""
    set TOVDOLGTOV_DATA(-2,5) ""
    set TOVDOLGTOV_DATA(-2,6) ""
    
    set TOVDOLGTOV_DATA(-1,0) ""
    set TOVDOLGTOV_DATA(-1,1) ""
    set TOVDOLGTOV_DATA(-1,2) "."
    set TOVDOLGTOV_DATA(-1,3) ""
    set TOVDOLGTOV_DATA(-1,4) ""
    set TOVDOLGTOV_DATA(-1,5) "."
    set TOVDOLGTOV_DATA(-1,6) " "
}

proc tovdolg:read { } {
    global VS TOVDOLG TOVDOLGTOV TOVDOLGTOV_DATA
    
    set w .tovdolg.tov
    waiting "  ..." blue
    tovdolgtov:clear
    if { $TOVDOLG(sortstr) == "" }    { set TOVDOLG(sortstr) "4, 10" } 
    if { $TOVDOLG(sortdesc) == "" }   { set TOVDOLG(sortdesc) " "  }
    if { $TOVDOLG(find) == "" } {
        set TOVDOLG(find) "1=1"
        if [info exists TOVDOLG(find,listbox)] {
            if { [lsearch -exact $TOVDOLG(find,listbox) $TOVDOLG(find)] == -1} {
                lappend TOVDOLG(find,listbox) $TOVDOLG(find)
            }
        } else {
            lappend TOVDOLG(find,listbox) $TOVDOLG(find)
        }
    } 
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "tovdolg_sel \"$TOVDOLG(find)\" \"$TOVDOLG(sortstr) $TOVDOLG(sortdesc)\""
        flush $socks
        set i 0
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            foreach j { cod tip 0 1 2 3 4 5 6 } {
                set TOVDOLGTOV_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                TOVDOLGTOV_DATA($i,cod) \
                TOVDOLGTOV_DATA($i,tip) \
                TOVDOLGTOV_DATA($i,0) \
                TOVDOLGTOV_DATA($i,1) \
                TOVDOLGTOV_DATA($i,2) \
                TOVDOLGTOV_DATA($i,3) \
                TOVDOLGTOV_DATA($i,4) \
                TOVDOLGTOV_DATA($i,5) \
                TOVDOLGTOV_DATA($i,6)
            
            set TOVDOLGTOV_DATA($i,0)     [clipped $TOVDOLGTOV_DATA($i,0)]
            set TOVDOLGTOV_DATA($i,1)     [format "%7.2f" $TOVDOLGTOV_DATA($i,1)]
            set TOVDOLGTOV_DATA($i,2)     [clipped $TOVDOLGTOV_DATA($i,2)]
            set TOVDOLGTOV_DATA($i,4)     [clipped $TOVDOLGTOV_DATA($i,4)]
            incr i
        }
        
        set TOVDOLGTOV(rows) [expr $i + 2]
        if { $TOVDOLGTOV(rows) < 20 } { set TOVDOLGTOV(rows) 20 }
        $w.tbl configure -rows $TOVDOLGTOV(rows)
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    if ![info exists TOVDOLGTOV(ActiveRowCol)] {
        $w.tbl activate 0,1
        tovdolgtov:browsecommand 0
    } else {
        $w.tbl activate $TOVDOLGTOV(ActiveRow),1
        tovdolgtov:browsecommand $TOVDOLGTOV(ActiveRow)
    }
    
    update
}

proc tovdolg:find {} {
    global VS TOVDOLG TOVDOLGTOV TOVDOLG_DATA
    
    tovdolg:entry
    if { $TOVDOLG(entrystatus) == 1 } {
        set TOVDOLG(find) "1=1"
        foreach {i j} " \"$TOVDOLG(entry,tovarnam)\"     b.nam \
                        \"$TOVDOLG(entry,kol)\"          \"a.kol - doccodkol(a.cod)\" \
                        \"$TOVDOLG(entry,klientnam)\"    f.nam \
                        \"$TOVDOLG(entry,numdoc)\"       d.num \
                        \"$TOVDOLG(entry,datdolg)\"      d.dat_dolga \
                       " {
            if { $i != "" } {
                set TOVDOLG(find) "$TOVDOLG(find) and $j [construct $i]"
            }    
        }
        if { [lsearch -exact $TOVDOLG(find,listbox) $TOVDOLG(find)] == -1} {
            lappend TOVDOLG(find,listbox) $TOVDOLG(find)
        }
        tovdolg:read
    }
    set TOVDOLG(entrystatus) 0
}

proc tovdolg:hesklad { tip win } {
    global VS TOVDOLG HE
    
    set w .tovdolg.entry.inf.sklad.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $TOVDOLG(entry,skladnam) $tip $win
    set TOVDOLG(entry,skladcod) $HE(cod)
    set TOVDOLG(entry,skladnam) [clipped $HE(nam)]
}

proc tovdolg:heoperacia { tip win } {
    global VS TOVDOLG HE
    
    set w .tovdolg.entry.inf.operacia.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 operaciar $TOVDOLG(entry,operacianam) $tip $win
    set TOVDOLG(entry,operaciacod) $HE(cod)
    set TOVDOLG(entry,operacianam) [clipped $HE(nam)]
}

proc tovdolg:heklient { tip win } {
    global VS TOVDOLG HE
    
    set w .tovdolg.entry.inf.klient.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 postpol $TOVDOLG(entry,klientnam) $tip $win
    set TOVDOLG(entry,klientcod) $HE(cod)
    set TOVDOLG(entry,klientnam) [clipped $HE(nam)]
}

proc tovdolg:hetovar { tip win } {
    global VS TOVDOLG HE
    
    set w .tovdolg.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 50 tovaronly $TOVDOLG(entry,tovarnam) $tip $win
    set TOVDOLG(entry,tovarcod) $HE(cod)
    set TOVDOLG(entry,tovarnam) [clipped $HE(nam)]
}

proc tovdolg:print {} {
    global VS TOVDOLG

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "tovdolg_rep \"$TOVDOLG(find)\" \"$TOVDOLG(sortstr) $TOVDOLG(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}
