proc vplist:summa {} {
    global VPLIST VPLIST_DATA
    
    set i 0
    set VPLIST(svp1) 0
    set VPLIST(svp2) 0
    while { $i <= $VPLIST(listbox,count) } {
        set VPLIST(svp1) [expr $VPLIST(svp1) + $VPLIST_DATA(summa1,$i)]
        set VPLIST(svp2) [expr $VPLIST(svp2) + $VPLIST_DATA(summa2,$i)]
        incr i
    }
}

proc vplist:read { } {
    global VS VPLIST VPLIST_DATA
    
    set w .vplist.lb.listbox
    event generate $w <<iconmenu-disabled>>
    waiting "  ..." blue
    
    # 1  
    set dat1 [clock format [expr $VS(clock) - 604800 ] -format %d/%m/%Y]
    #    
    set dat2 [clock format [expr $VS(clock) + 86400 ] -format %d/%m/%Y]
    if { $VPLIST(sortstr) == "" }    { set VPLIST(sortstr) "dat" } 
    if { $VPLIST(sortdesc) == "" }   { set VPLIST(sortdesc) " "  }
    if { $VPLIST(find) == "" } {
        set VPLIST(find) "dat >= '$dat1' and dat <= '$dat2'"
        if [info exists VPLIST(find,listbox)] {
            if { [lsearch -exact $VPLIST(find,listbox) $VPLIST(find)] == -1} {
                lappend VPLIST(find,listbox) $VPLIST(find)
            }
        } else {
            lappend VPLIST(find,listbox) $VPLIST(find)
        }
    } 
    $w delete 0 end
    
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "vplist_sel $VPLIST(tip) \"$VPLIST(find)\" \"$VPLIST(sortstr) $VPLIST(sortdesc)\""
        flush $socks
        set i 0
        set k 1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set VPLIST_DATA(cod,$i) "";       set VPLIST_DATA(num,$i) ""
            set VPLIST_DATA(dat,$i) ""
            set VPLIST_DATA(skladrnam,$i) ""; set VPLIST_DATA(skladpnam,$i) ""
            set VPLIST_DATA(summa1,$i) "";    set VPLIST_DATA(summa2,$i) ""
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                VPLIST_DATA(cod,$i) \
                VPLIST_DATA(num,$i) \
                VPLIST_DATA(dat,$i) \
                VPLIST_DATA(skladrnam,$i) \
                VPLIST_DATA(skladpnam,$i) \
                VPLIST_DATA(summa1,$i) \
                VPLIST_DATA(summa2,$i)
            $w insert end [format "%5d %-10s %-27.27s %-27.27s %10.2f %10.2f" \
                $VPLIST_DATA(num,$i) \
                $VPLIST_DATA(dat,$i) \
                $VPLIST_DATA(skladrnam,$i) \
                $VPLIST_DATA(skladpnam,$i) \
                $VPLIST_DATA(summa1,$i) \
                $VPLIST_DATA(summa2,$i)]
            
            if { [ expr [incr i] % $k ] == 0 } {
                update
                scan [ expr 1.15 * [incr k] ] "%\[^.]" k
            }
            set VPLIST(statusline) " $i ."
        }
        set VPLIST(listbox,count) [expr $i - 1]
        vplist:summa
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    waiting "" ""
    update
}

proc vplist:delete {} {
    global VS VPLIST VPLIST_DATA
    
    set w .vplist.lb.listbox
    if { $VPLIST(deletestatus) == 1} {
        if { [ set socks [checkpasswd] ] != -1 } {
            waiting "  ..." red
            set id $VPLIST(listbox,curselection)
            puts $socks "vp_del $VPLIST_DATA(cod,$id)"
            flush $socks
            while { [ gets $socks ] != $VS(sepdata) } {}
        
            if { [ gets $socks ] != "0" } {
                errormsg $socks "    !"
            }
            close $socks
            waiting "" ""
            vplist:read
        } else {
            errormsg nosocks "  !"
        }
        
        if { $id > $VPLIST(listbox,count)} {
            set id $VPLIST(listbox,count)
            set VPLIST(listbox,curselection) $VPLIST(listbox,count)
        }
        $w see $id
        $w selection set $id $id
        $w activate $id
        set VPLIST(listbox,curselection) $id
        event generate $w <<iconmenu-enabled>>
    }
    set VPLIST(deletestatus) 0
}

proc vplist:print {} {
    global VS VPLIST

    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." cyan
        puts $socks "vplist_rep $VPLIST(tip) \"$VPLIST(find)\" \"$VPLIST(sortstr) $VPLIST(sortdesc)\" \"$VS(lp)\""
        flush $socks
    
        while { [ gets $socks ] != $VS(sepdata) } {}
        
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
        waiting "" ""
    } else {
        errormsg nosocks "  !"
    }
}

proc vplist:find {} {
    global VS VPLIST
    
    vplist:entry
    if { $VPLIST(entrystatus) == 1 } {
        set VPLIST(find) "1=1"
        foreach {i j} " \"$VPLIST(entry,num)\" num \
                        \"$VPLIST(entry,dat)\" dat \
                        \"$VPLIST(entry,skladrnam)\" b.nam \
                        \"$VPLIST(entry,skladpnam)\" c.nam \
                        \"$VPLIST(entry,prim)\" a.prim1 \
                        \"$VPLIST(entry,summa1)\" summa1 \
                        \"$VPLIST(entry,summa2)\" summa2 \
                       " {
            if { $i != "" } {
                set VPLIST(find) "$VPLIST(find) and $j [construct $i]"
            }    
        }
        if { [string length [clipped $VPLIST(entry,tovarnam)]] > 0 || \
             [string length [clipped $VPLIST(entry,kol)]] > 0 || \
             [string length [clipped $VPLIST(entry,cena)]] > 0 || \
             [string length [clipped $VPLIST(entry,cenad)]] > 0 } {
            vplist:find:podzapros
        }
        if { [lsearch -exact $VPLIST(find,listbox) $VPLIST(find)] == -1} {
            lappend VPLIST(find,listbox) $VPLIST(find)
        }
        vplist:read
    }
    set VPLIST(entrystatus) 0
}

proc vplist:find:podzapros {} {
    global VPLIST
    
    if { $VPLIST(tip) == "f" } {
        set str_sel "select x1.cod from finoperp x1, tovar x2 where x1.tovar_cod = x2.cod and x1.doc_cod = a.cod"
    } else {
        set str_sel "select x1.cod from matoperp x1, tovar x2 where x1.tovar_cod = x2.cod and x1.doc_cod = a.cod"
    }
    foreach {i j} " \"$VPLIST(entry,tovarnam)\"  x2.nam \
                    \"$VPLIST(entry,kol)\"       x1.kol \
                    \"$VPLIST(entry,cena)\"      x1.cena \
                    \"$VPLIST(entry,cenad)\"     x1.cenad \
                   " {
        if { $i != "" } {
            set str_sel "$str_sel and $j [construct $i]"
        }    
    }
    set VPLIST(find) "$VPLIST(find) and exists ($str_sel)"
}

proc vplist:heskladr { tip win } {
    global VS VPLIST HE
    
    set w .vplist.entry.inf.skladr.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $VPLIST(entry,skladrnam) $tip $win
    set VPLIST(entry,skladrcod) $HE(cod)
    set VPLIST(entry,skladrnam) [clipped $HE(nam)]
}

proc vplist:heskladp { tip win } {
    global VS VPLIST HE
    
    set w .vplist.entry.inf.skladp.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 5 30 sklad $VPLIST(entry,skladpnam) $tip $win
    set VPLIST(entry,skladpcod) $HE(cod)
    set VPLIST(entry,skladpnam) [clipped $HE(nam)]
}

proc vplist:hetovar { tip win } {
    global VS VPLIST HE
    
    set w .vplist.entry.inf.tovar.e
    set HE(tit) " "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 10 50 tovaronly $VPLIST(entry,tovarnam) $tip $win
    set VPLIST(entry,tovarcod) $HE(cod)
    set VPLIST(entry,tovarnam) [clipped $HE(nam)]
}

proc vplist:insert {} {
    global VPLIST VPLIST_DATA SCHET VP

    set w .vplist.lb.listbox
    vp 1 $VPLIST(tip) 0 .vplist
    tkwait window .vplist.vp
    if { $VP(cod) > 0 } {
        set id [expr $VPLIST(listbox,count) + 1]
        set VPLIST(listbox,curselection) $id
        set VPLIST_DATA(cod,$id) $VP(cod)
        vplist:cor
    }
}
