proc zaimopl:varold { i } {
    global ZAIMOPL_DATA

    set ZAIMOPL_DATA($i,old_0)        $ZAIMOPL_DATA($i,0)
    set ZAIMOPL_DATA($i,old_1)        $ZAIMOPL_DATA($i,1)
    set ZAIMOPL_DATA($i,old_2)        $ZAIMOPL_DATA($i,2)
}

proc zaimopl:clear {} {
    global VS ZAIMOPL_DATA
    
    catch [unset ZAIMOPL_DATA]
    set ZAIMOPL_DATA(-1,0) ""
    set ZAIMOPL_DATA(-1,1) ""
    set ZAIMOPL_DATA(-1,2) ""
}

proc zaimopl:read {} {
    global VS ZAIMOPL_DATA ZAIMOPL NAKLP
    
    zaimopl:clear
    set w $ZAIMOPL(inwin).tbl
    waiting "  ..." blue
    if { [ set socks [checkpasswd] ] != -1 } {
        puts $socks "zaimopl_sel $ZAIMOPL(tip) $ZAIMOPL(doccod)"
        flush $socks
        set i -1
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            incr i
            foreach { j } { docoplcod 0 1 2 } {
                set ZAIMOPL_DATA($i,$j) ""
            }
            scan $str "%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\t]%*c%\[^\n]" \
                ZAIMOPL_DATA($i,docoplcod) fuf \
                ZAIMOPL_DATA($i,0)         ZAIMOPL_DATA($i,1) \
                ZAIMOPL_DATA($i,2)
            
            regsub -all "\\." $ZAIMOPL_DATA($i,0) "" ZAIMOPL_DATA($i,0)
            catch [set ZAIMOPL_DATA($i,1) [format "%9.2f" $ZAIMOPL_DATA($i,1)]]
            catch [set ZAIMOPL_DATA($i,2) [format "%9.2f" $ZAIMOPL_DATA($i,2)]]
            zaimopl:varold $i
        }
        if [info exists ZAIMOPL(ActiveRow)] { 
            if { $i < $ZAIMOPL(ActiveRow) && $i >= 0 } { set ZAIMOPL(ActiveRow) $i }
            $w see $ZAIMOPL(ActiveRow),0
            $w activate $ZAIMOPL(ActiveRow),$ZAIMOPL(ActiveCol)
        }
        
        set ZAIMOPL(rows) [expr $i + 2]
        if { $ZAIMOPL(rows) < 6 } { set ZAIMOPL(rows) 6 }
        $w configure -rows $ZAIMOPL(rows)
        if { [ gets $socks ] != "0" } {
            errormsg $socks "    !"
        }
        close $socks
    } else {
        errormsg nosocks "  !"
    }
    zaimopl:summa
    waiting "" ""
}

proc zaimopl:delete {} {
    global VS ZAIMOPL ZAIMOPL_DATA
    
    set w $ZAIMOPL(inwin).tbl
    if [info exists ZAIMOPL(ActiveRow)] {
        if [info exists ZAIMOPL_DATA($ZAIMOPL(ActiveRow),docoplcod)] {
            set ZAIMOPL_DATA(active) ""
            $w tag row UnSelectRow $ZAIMOPL(ActiveRow)
            if { [ set socks [checkpasswd] ] != -1 } {
                $w tag row flash $ZAIMOPL(ActiveRow)
                waiting "  ..." red
                puts $socks "zaimopl_del $ZAIMOPL(tip) $ZAIMOPL_DATA($ZAIMOPL(ActiveRow),docoplcod)"
                flush $socks
                while { [ gets $socks ] != $VS(sepdata) } { }
                if { [ gets $socks ] != "0" } {
                    errormsg $socks "    !"
                }
                close $socks
                $w tag row SelectRow $ZAIMOPL(ActiveRow)
                waiting "" ""
                zaimopl:read
            } else {
                errormsg nosocks "  !"
            }
        }
    }
}

proc zaimopl:insert { row } {
    global VS ZAIMOPL_DATA ZAIMOPL NAKLP STT
    
    set w $ZAIMOPL(inwin).tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." magenta
        puts $socks "zaimopl_ins $ZAIMOPL(tip) \
                                 $ZAIMOPL(doccod) \
                                 $ZAIMOPL_DATA($row,0) \
                                 $ZAIMOPL_DATA($row,1) \
                                 $ZAIMOPL_DATA($row,2) "
        flush $socks
   
        while { [ set str [ gets $socks ] ] != $VS(sepdata) } {
            set ZAIMOPL_DATA($row,docoplcod) $str
        }
        if { [ gets $socks ] != "0" } {
            $w tag row Magenta $row
            errormsg $socks "    !"
        } else { $w tag row Normal $row }
        close $socks
        set ZAIMOPL_DATA($row,old_0)        $ZAIMOPL_DATA($row,0)
        set ZAIMOPL_DATA($row,old_1)        $ZAIMOPL_DATA($row,1)
        set ZAIMOPL_DATA($row,old_2)        $ZAIMOPL_DATA($row,2)
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc zaimopl:update { row } {
    global VS ZAIMOPL_DATA ZAIMOPL
    
    set w $ZAIMOPL(inwin).tbl
    if { [ set socks [checkpasswd] ] != -1 } {
        waiting "  ..." green
        if ![info exists ZAIMOPL_DATA($row,1)] { set ZAIMOPL_DATA($row,1) 0.00 }
        if ![info exists ZAIMOPL_DATA($row,2)] { set ZAIMOPL_DATA($row,2) 0.00 }
        puts $socks "zaimopl_upd $ZAIMOPL(tip) \
                                 $ZAIMOPL_DATA($row,docoplcod) \
                                 $ZAIMOPL_DATA($row,0) \
                                 $ZAIMOPL_DATA($row,1) \
                                 $ZAIMOPL_DATA($row,2)"
        flush $socks
   
        while { [ gets $socks ] != $VS(sepdata) } { }
        if { [ gets $socks ] != "0" } {
            $w tag row Green $row
            errormsg $socks "    !"
        } else { 
            $w tag row Normal $row 
            zaimopl:varold $row
        }
        close $socks
        waiting "" ""
    } else { errormsg nosocks "  !" }
}

proc zaimopl:hetovarnam { tip win } {
    global VS ZAIMOPL_DATA HE ZAIMOPL
    
    set w $ZAIMOPL(inwin).curfldval
    set HE(tit) "                                 ..               "
    he [winfo rootx $w] [expr [winfo rooty $w] + [winfo height $w]] 6 75 tovar "$ZAIMOPL_DATA($ZAIMOPL(ActiveRow),2)" $tip $win
    scan $HE(cod) "%\[^\003]%*c%s" \
        ZAIMOPL_DATA($ZAIMOPL(ActiveRow),tovarcod) \
        ZAIMOPL_DATA($ZAIMOPL(ActiveRow),eicod)
    scan $HE(nam) "%\[^\003]%*c%\[^\003]%*c%\[^\003]%*c%s" \
        ZAIMOPL_DATA($ZAIMOPL(ActiveRow),2) \
        ZAIMOPL_DATA($ZAIMOPL(ActiveRow),4) \
        ZAIMOPL_DATA($ZAIMOPL(ActiveRow),5) \
        fuf
    set ZAIMOPL_DATA($ZAIMOPL(ActiveRow),2) [clipped $ZAIMOPL_DATA($ZAIMOPL(ActiveRow),2)]
}
