globals "globals.4gl"

function ei_del(eicod)
define
    str         char(128),
    eicod    like ei.cod

    whenever error call err

    let str = "execute procedure ei_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using eicod
    commit work
end function

function ei_sel(where_str, order_str)
define  
    p   record
        cod         like ei.cod,
        nam         like ei.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam ",
                 "from ei ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam
    end foreach
    commit work
end function

function ei_ins(einam)
define
    str     	    char(128),
    eicod	    like ei.cod,
    einam        like ei.nam
    
    let str = "execute procedure ei_ins(?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using einam
        fetch cur_ins into eicod
        display eicod
    close cur_ins
    commit work
end function

function ei_upd(eicod, einam)
define
    str     	char(128),
    eicod        like ei.cod,
    einam        like ei.nam
    
    let str = "execute procedure ei_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using eicod, einam
    commit work
end function

function ei_rep(where_str, order_str, pipe_str)
define  
    p   record
        nam         like ei.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select nam ",
                  "from ei ",
                  "where ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_ei
        foreach cur_rep into p.*
            output to report r_ei(p.nam)
        end foreach
    finish report r_ei
    commit work
end function

report r_ei(nam)
define	
    nam         like ei.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "================="
        print "     "
        print " "
        print "-----------------"
    on every row
        print "   ",nam
    on last row
        print "================="
end report

