globals "globals.4gl"



function finnaklrone_sel(schetcod)
define  
    schetcod   integer,
    p   record
        num         like schetfnr.finnaklr_num,
        dat         like schetfnr.finnaklr_dat,
        skladcod    integer,
        skladnam    like sklad.nam,
        dovnum      like schetfnr.dovnum,
        dovdat      like schetfnr.dovdat,
        dovwho      like schetfnr.dovwho
    end record

    whenever error call err
    
    initialize p to null
    let transaction = 1    
    begin work
    select  a.num, a.dat, b.cod, b.nam,
            a.dovnum, a.dovdat, a.dovwho
        into p.*
        from _finnaklr a, outer sklad b
        where a.cod = schetcod and
              a.sklad_cod = b.cod
    commit work
    
    display p.num using "#####", "\t",
        p.dat using "dd.mm.yyyy", "\t",
        p.skladcod, "\t",
        p.skladnam, "\t",
        p.dovnum, "\t",
        p.dovdat using "dd.mm.yyyy", "\t",
        p.dovwho
end function
    
function finnaklr_ins(schetcod, datt, skladcod, dovnum, dovdat, dovwho)
define
    str     	char(128),
    finnaklrnum         like schetfnr.finnaklr_num,
    datt                like schetfnr.finnaklr_dat,
    schetcod, skladcod            integer,
    dovnum              like schetfnr.dovnum,
    dovdat              like schetfnr.dovdat,
    dovwho              like schetfnr.dovwho
    
    initialize finnaklrnum to null
    let str = "execute procedure finnaklr_ins(?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using schetcod, datt, skladcod, dovnum, dovdat, dovwho
        fetch cur_ins into finnaklrnum
        display finnaklrnum using "#####"
    close cur_ins
    commit work
end function

function finnaklr_upd(schetcod, numm, datt, skladcod, dovnumm, dovdatt, dovwhoo)
define
    str     	        char(128),
    numm                like schetfnr.finnaklr_num,
    datt                like schetfnr.finnaklr_dat,
    schetcod, skladcod  integer,
    dovnumm             like schetfnr.dovnum,
    dovdatt             like schetfnr.dovdat,
    dovwhoo             like schetfnr.dovwho
    
    let str = "execute procedure finnaklr_upd(?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using schetcod, numm, datt, skladcod,
                        dovnumm, dovdatt, dovwhoo
    commit work
end function

function finnaklr_del(schetcod)
define
    str     	char(128),
    schetcod    integer
    
    let str = "execute procedure finnaklr_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using schetcod
    commit work
end function

function finnaklr_rep(schetcod, order_str, pipe_str)
define  
    schetcod    integer,
    order_str, pipe_str    char(256),
    str         char(768),
    p   record
        schetnum	like schetfnr.schet_num,
        schetdat	like schetfnr.schet_dat,
        naklnum	    like schetfnr.finnaklr_num,
        nakldat	    like schetfnr.finnaklr_dat,
        klientnam	like klient.nam,
        dovnum	    like schetfnr.dovnum,
        dovdat	    like schetfnr.dovdat,
        dovwho	    like schetfnr.dovwho,
        tovarnam	like schfnrtov.printnam,
        isnds       like tovar.isnds,
        kol		    like schfnrtov.kol,
        einam	    like ei.nam,
        cena    	like schfnrtov.cena
    end record,
    cenawithoutpdv decimal(13,6),
    pdv         decimal(13,6)
        
    let str = "select a.schet_num, a.schet_dat, a.finnaklr_num, a.finnaklr_dat, ",
                     "b.nam, a.dovnum, a.dovdat, a.dovwho, c.printnam as pnam, d.isnds, ",
                     "c.kol as kol, e.nam as enam, c.cena as cena, d.nam as tnam ",
                  "from schetfnr a, klient b, schfnrtov c, tovar d, ei e ",
                  "where a.cod = ",schetcod," and ",
                        "a.klient_cod = b.cod and ",
                        "a.cod = c.schetfnr_cod and ",
                        "c.tovar_cod = d.cod and ",
                        "d.ei_cod = e.cod ",
                  " order by ", order_str clipped
    prepare p_repfinnaklr from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repfinnaklr cursor for p_repfinnaklr
    let transaction = 1    
    begin work
    start report r_finnaklr
        foreach cur_repfinnaklr into p.*
            if p.isnds = "*" then
                call funpdv(p.nakldat, p.cena) returning cenawithoutpdv, pdv
            else
                let cenawithoutpdv = p.cena
                let pdv = 0
            end if
            output to report r_finnaklr(p.schetnum, p.schetdat, 
                                    p.naklnum, p.nakldat,
                                    p.klientnam, p.dovnum, p.dovdat,
                                    p.dovwho, p.tovarnam, p.kol, p.einam, 
                                    cenawithoutpdv, pdv, p.cena)
        end foreach
    finish report r_finnaklr
    commit work
end function

report r_finnaklr(
	       schetnum, schetdat, naklnum, nakldat, klientnam, 
	       dovnum, dovdat, dovwho, tovarnam, kol, einam, cenawithoutpdv, 
	       pdv, cena
	      ) 
define	
    schetnum	like schetfnr.schet_num,
    schetdat	like schetfnr.schet_dat,
    naklnum	    like schetfnr.finnaklr_num,
    nakldat	    like schetfnr.finnaklr_dat,
    klientnam	like klient.nam,
    dovnum	    like schetfnr.dovnum,
    dovdat	    like schetfnr.dovdat,
    dovwho	    like schetfnr.dovwho,
    tovarnam	like schfnrtov.printnam,
    kol		    like schfnrtov.kol,
    einam	    like ei.nam,
    cena, scena	like schfnrtov.cena,
    cenawithoutpdv, pdv decimal(13,6)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		21
	
format	
    first page header
      skip 10 line      
      print twicewidthon,vidon,"       ",vidoff,twicewidthoff,"N-",vidon,naklnum using "<<<<<",vidoff,"I",vidon,nakldat using "dd/mm/yyyy",vidoff
      print "                  i  N-",schetnum using "<<<<<"," i ",schetdat using "dd/mm/yyyy"
      print "               N-",dovnum," i ",dovdat using "dd/mm/yyyy"
      print "    : ",dovwho
      skip 1 line
      print ":",vidon,klientnam,vidoff
      print "==================================================================================="
      print "                             | i- |  i   |     |  C"
      print "                                               | i |   |        |  "
      print "==================================================================================="
    on every row
      print passon,tovarnam,passoff,kol using "####.##",cenawithoutpdv using "  #####.##",pdv using " #####.##",cena * kol using " #####.##"
    on last row
      print "==================================================================================="
      print "                                                             :", sum(cenawithoutpdv * kol) using "#######.##"
      print "                                                                     :", sum(pdv * kol) using "#######.##"
      print "                                                                  :", sum(cena * kol) using "#######.##"
      let scena = sum(cena * kol)
      print ":",passon,underlineon,speak(scena using "#########.##",1) clipped,underlineoff,passoff
      skip 1 line
      print "",underlineon,"          ",underlineoff,"                                   ",underlineon,"          ",underlineoff
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
