globals "globals.4gl"

function garanttalon_rep(tipdoc, cod, dat, pipe_str)
define  
    pipe_str    char(256),
    str         char(768),
    tipdoc      char(1),
    cod         integer,
    dat         date,
    p record
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperr.kol,
        dat_gar     date
    end record

    whenever error call err
        
    let transaction = 1    
    begin work
    initialize p to null
    
    if tipdoc = "s" then
        let str = "select c.nam, b.sernum, a.kol, a.dat_gar, ",
                         "e.schfnrtov_cod, d.sort_field ",
                    "from matoperr a, matoperp b, tovar c, outer sostav d, outer schfnrtovt e ",
                    "where a.schetfnr_cod = ", cod, " and ",
                          "a.matoperp_cod = b.cod and ",
                          "b.tovar_cod = c.cod and ",
                          "a.dat_gar is not null and ",
                          "c.tovartip_cod = d.slave_cod and ",
                          "a.doc_cod = e.cod ",
                    "order by e.schfnrtov_cod desc, d.sort_field, c.nam"
    end if
    if tipdoc = "n" then
        let str = "select c.nam, b.sernum, a.kol, a.dat_gar ",
                    "from matoperr a, matoperp b, tovar c ",
                    "where a.doc_cod in (select cod from naklrtov where naklr_cod = ", cod, ") and ",
                          "a.matoperp_cod = b.cod and ",
                          "b.tovar_cod = c.cod and ",
                          "a.dat_gar is not null ",
                    "order by c.nam"
    end if
    prepare p_garanttalon from str
    
    let reppipe = pipe_str
    declare cur_garanttalon cursor for p_garanttalon
    
    start report r_garanttalon
        foreach cur_garanttalon into p.*
            output to report r_garanttalon(dat, p.tovarnam, p.sernum, p.kol, p.dat_gar)
        end foreach
    finish report r_garanttalon
    commit work
end function

report r_garanttalon(dat, tovarnam, sernum, kol, datgar)
define	
    dat         date,
    tovarnam    like tovar.nam,
    sernum      like matoperp.sernum,
    kol         like matoperr.kol,
    datgar      date

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		18
	
format	
    first page header
        print ": ", vidon, dat using "dd/mm/yyyy", vidoff
        print "----------------------------------------------------------------------------"
        print "                                |                    |          |   "
        print "              |       |   . | "
        print "                                |                    |          | "
        print "----------------------------------------------------------------------------"
    on every row
        print passon, tovarnam, passoff, " ", sernum, " ", kol using "  #####.## ", datgar using "dd.mm.yyyy"
    on last row
        print "============================================================================"
        call whatsot()
        print downindex,": ",userfio clipped,indexoff,formfeed
        print topindex, underlineon, " \"-\". Copyright (c) Eduard E. Zozulya doro@doro.poltava.ua", underlineoff, indexoff, formfeed
end report
