globals "globals.4gl"
    
function gorod_del(gorodcod)
define
    str         char(128),
    gorodcod    like gorod.cod

    whenever error call err
    
    let str = "execute procedure gorod_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using gorodcod
    commit work
end function

function gorod_sel(where_str, order_str)
define  
    p   record
        cod         like gorod.cod,
        nam         like gorod.nam,
        phone_cod   like gorod.phone_cod
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam, phone_cod ",
                 "from gorod ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam, "\t", p.phone_cod
    end foreach
    commit work
end function

function gorod_ins(gorodnam, gorodphone_cod)
define
    str     	    char(128),
    gorodcod	    like gorod.cod,
    gorodnam        like gorod.nam,
    gorodphone_cod  like gorod.phone_cod
    
    let str = "execute procedure gorod_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using gorodnam, gorodphone_cod
        fetch cur_ins into gorodcod
        display gorodcod
    close cur_ins
    commit work
end function

function gorod_upd(gorodcod, gorodnam, gorodphone_cod)
define
    str     	char(128),
    gorodcod        like gorod.cod,
    gorodnam        like gorod.nam,
    gorodphone_cod  like gorod.phone_cod
    
    let str = "execute procedure gorod_upd(?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using gorodcod, gorodnam, gorodphone_cod
    commit work
end function

function gorod_rep(where_str, order_str, pipe_str)
define  
    p   record
        nam         like gorod.nam,
        phone_cod   like gorod.phone_cod
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select nam, phone_cod ",
                  "from gorod ",
                  "where ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_gorod
        foreach cur_rep into p.*
            output to report r_gorod(p.nam, p.phone_cod)
        end foreach
    finish report r_gorod
    commit work
end function

report r_gorod(nam, phonecod)
define	
    nam         like gorod.nam,
    phonecod    like gorod.phone_cod

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "==========================================="
        print "                   | "
        print "                         |    "
        print "-------------------------------------------"
    on every row
        print nam, "  ", phonecod
    on last row
        print "==========================================="
end report

function gorod_he(hegorodnam)
define
    str     	                char(128),
    gorodcod	                like gorod.cod,
    gorodnam, hegorodnam        like gorod.nam,
    phonecod                    like gorod.phone_cod,
    ret                         smallint,
    sep                         char(1)
    
    let sep = ascii 3
    let str = "execute procedure gorod_he(?)"
    prepare p_he from str
    declare cur_he cursor for p_he
    
    initialize gorodnam, phonecod to null
    let transaction = 1
    begin work
    open cur_he using hegorodnam
        while (TRUE)
            fetch cur_he into gorodcod, gorodnam, phonecod, ret
            if status = notfound then exit while end if
            display gorodcod, "\t", gorodnam, sep, phonecod, "\t", ret
        end while
    close cur_he
    commit work
end function
