globals "globals.4gl"

function jurnal_sel(dat1, dat2, order_str)
define  
    dat1        date,
    dat2        date,
    order_str   char(64),
    str         char(2048),
    pn1 record
	    schetcod    integer,
	    nnaklcod    integer,
	    nnaklnum	like nnakl.num,
	    nnakldat	like nnakl.dat,
	    klientnam	like klient.nam,
	    klientinn	like klient.inn,
	    sall		like nnakltov.summa,		#   
	    swpdv		like nnakltov.summa,		#     
	    klientnds	like klient.nds
	end record,
	pn2 record
	    operacianam	like operacia.nam,
	    datopl	    date			#   ( )
	end record,
	ret, i		smallint,
	s9, s12, s15, s16, s17, s18, s19	decimal(20,10)

    whenever error call err
        
    let str = "select unique b.cod, a.cod, a.num, a.dat, c.nam, c.inn, a.summa, ",
  	                 "(select sum(x1.summa) ",
  	                    "from nnakltov x1, schfnrtov x2, tovar x3 ",
	  	                "where x1.nnakl_cod = a.cod and ",
	  	                      "x1.schfnrtov_cod = x2.cod and ",
	  	                      "x2.tovar_cod = x3.cod and ",
	  	                      "x3.isnds is null), ",
	  	             "c.nds, d.nam, e.dat ",
	               "from _nnakls a, schetfnr b, klient c, operacia d, schetopl e ",
	               "where a.dat between '", dat1, "' and '", dat2, "' and ",
	                     "a.schetfnr_cod = b.cod and ",
	                     "b.klient_cod = c.cod and ",
	                     "b.operacia_cod = d.cod and ",
	                     "a.sofnr_cod = e.cod ",
	          "union ",
	          "select unique b.cod, a.cod, a.num, a.dat, c.nam, c.inn, a.summa, ",
  	                 "(select sum(x1.summa) ",
  	                    "from nnakltov x1, schfnrtov x2, tovar x3 ",
	  	                "where x1.nnakl_cod = a.cod and ",
	  	                      "x1.schfnrtov_cod = x2.cod and ",
	  	                      "x2.tovar_cod = x3.cod and ",
	  	                      "x3.isnds is null), ",
	  	             "c.nds, d.nam, ",
                     "(select max(x4.dat) from schetopl x4 ",
                        "where a.schetfnr_cod = x4.schet_cod and ",
                              "x4.cod not in (select sofnr_cod from nnakl)) ",
	               "from _nnakls a, schetfnr b, klient c, operacia d ",
	               "where a.dat between '", dat1, "' and '", dat2, "' and ",
	                     "a.schetfnr_cod = b.cod and ",
	                     "b.klient_cod = c.cod and ",
	                     "b.operacia_cod = d.cod and ",
	                     "a.schetfnr_cod = a.sofnr_cod ",
	          "order by ", order_str clipped
    
    prepare p_sel from str
    
    initialize pn1, pn2 to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into pn1.*, pn2.*
        let s9 = 0
        let s12 = 0
        let s15 = 0
        let s16 = 0
        let s17 = 0
        let s18 = 0
        let s19 = 0
        if pn1.sall is null then let pn1.sall = 0 end if
        if pn1.swpdv is null then let pn1.swpdv = 0 end if
	    if pn1.swpdv is not null then 
	        let s15 = pn1.sall - pn1.swpdv
	    else
	        let s15 = pn1.sall
	    end if
	    if pn1.klientnds is not null then
	        call funpdv(pn1.nnakldat, s15) returning s16, s17
	        let s9 = pn1.swpdv
	    else
	        call funpdv(pn1.nnakldat, s15) returning s18, s19
	        let s12 = pn1.swpdv
	        let pn1.klientinn = "  -= NO =-"
	    end if
	    if s9 is null then let s9 = 0 end if
	    if s12 is null then let s12 = 0 end if
	    if s15 is null then let s15 = 0 end if
	    if s16 is null then let s16 = 0 end if
	    if s17 is null then let s17 = 0 end if
	    if s18 is null then let s18 = 0 end if
	    if s19 is null then let s19 = 0 end if
        display pn1.schetcod, "\t",
                pn1.nnaklcod, "\t",
                pn1.nnaklnum using "#####", "\t",
                pn1.nnakldat using "dd.mm.yyyy", "\t",
                pn1.klientnam, "\t",
                pn1.klientinn, "\t",
                pn1.sall using "-------.--"
#                pn1.swpdv using "-------.--", "\t",
#                s9 using "-------.--", "\t",
#                s12 using "-------.--", "\t",
#                s15 using "-------.--", "\t",
#                s16 using "-------.--", "\t",
#                s17 using "-------.--", "\t",
#                s18 using "-------.--", "\t",
#                s19 using "-------.--", "\t",
#                pn2.operacianam, "\t",
#                pn2.datopl using "ddmmyy"
    end foreach
    commit work
end function

function jurnal_rep(dat1, dat2, order_str, pipe_str)
define  
    dat1        date,
    dat2        date,
    order_str, pipe_str    char(256),
    str         char(2048),
    pn1 record
        schetcod    integer,
	    nnaklcod    integer,
	    nnaklnum	like nnakl.num,
	    nnakldat	like nnakl.dat,
	    klientnam	like klient.nam,
	    klientinn	like klient.inn,
	    sall		like nnakltov.summa,		#   
	    swpdv		like nnakltov.summa,		#     
	    klientnds	like klient.nds
	end record,
	pn2 record
	    operacianam	like operacia.nam,
	    datopl	    date			#   ( )
	end record,
	ret, i		smallint,
	s9, s12, s15, s16, s17, s18, s19	decimal(20,10)
        
    let str = "select unique b.cod, a.cod, a.num, a.dat, c.nam, c.inn, a.summa, ",
  	                 "(select sum(x1.summa) ",
  	                    "from nnakltov x1, schfnrtov x2, tovar x3 ",
	  	                "where x1.nnakl_cod = a.cod and ",
	  	                      "x1.schfnrtov_cod = x2.cod and ",
	  	                      "x2.tovar_cod = x3.cod and ",
	  	                      "x3.isnds is null), ",
	  	             "c.nds, d.nam, e.dat ",
	               "from _nnakls a, schetfnr b, klient c, operacia d, schetopl e ",
	               "where a.dat between '", dat1, "' and '", dat2, "' and ",
	                     "a.schetfnr_cod = b.cod and ",
	                     "b.klient_cod = c.cod and ",
	                     "b.operacia_cod = d.cod and ",
	                     "a.sofnr_cod = e.cod ",
	          "union ",
	          "select unique b.cod, a.cod, a.num, a.dat, c.nam, c.inn, a.summa, ",
  	                 "(select sum(x1.summa) ",
  	                    "from nnakltov x1, schfnrtov x2, tovar x3 ",
	  	                "where x1.nnakl_cod = a.cod and ",
	  	                      "x1.schfnrtov_cod = x2.cod and ",
	  	                      "x2.tovar_cod = x3.cod and ",
	  	                      "x3.isnds is null), ",
	  	             "c.nds, d.nam, ",
                     "(select max(x4.dat) from schetopl x4 ",
                        "where a.schetfnr_cod = x4.schet_cod and ",
                              "x4.cod not in (select sofnr_cod from nnakl)) ",
	               "from _nnakls a, schetfnr b, klient c, operacia d ",
	               "where a.dat between '", dat1, "' and '", dat2, "' and ",
	                     "a.schetfnr_cod = b.cod and ",
	                     "b.klient_cod = c.cod and ",
	                     "b.operacia_cod = d.cod and ",
	                     "a.schetfnr_cod = a.sofnr_cod ",
	          "order by ", order_str clipped
    prepare p_rep from str
    
    initialize pn1, pn2 to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    let ret = 0
    begin work
    start report r_jurnal1
	    start report r_jurnal2
	        foreach cur_rep into pn1.*, pn2.*
	            let ret = ret + 1
	            initialize s9, s12, s15, s16, s17, s18, s19 to null
	            if pn1.swpdv is not null then 
	                let s15 = pn1.sall - pn1.swpdv
	            else
	                let s15 = pn1.sall
	            end if
	            if pn1.klientnds is not null then
	                call funpdv(pn1.nnakldat, s15) returning s16, s17
	                let s9 = pn1.swpdv
	            else
	                call funpdv(pn1.nnakldat, s15) returning s18, s19
	                let s12 = pn1.swpdv
	                let pn1.klientinn = "  -= NO =-"
	            end if
	            output to report r_jurnal1(ret, dat1, dat2, pn1.*, s9, s12)
	            output to report r_jurnal2(pn1.nnakldat, pn2.*, s15, s16, s17, s18, s19)
	        end foreach
	    finish report r_jurnal1
	finish report r_jurnal2
    commit work
end function

report r_jurnal2(nnakldat, operacianam, datopl, s15, s16, s17, s18, s19)
define	operacianam	like operacia.nam,
	datopl		date,
	nnakldat	like nnakl.dat,
	s15, s16, s17, s18, s19	decimal(14,7)

output
    report to pipe reppipe
#    report to printer
    left margin		2
    right margin 	75
    top margin		0
    bottom margin	0
    page length		25
	
format	
    first page header
      print ""
      print ""
      print passon,betweenstr8
      print ".----------------------------------------------------------------------------------------------------------------------."
      print "|      i (i, ),       |   |        i          |"
      print "|        '       |----------------------------|           i,            |"
      print "|-------------------------------------------------|. | -|            i,               |"
      print "| - |    i ii i   |  | i, i |---------------------------------------|"
      print "| i -  |---------------------------------------|.,  |,  |                | |"
      print "|     |       |     |-  |   |       (,i,       | |"
      print "|         |                   |                   ||------------------|         -        ||"
      print "|         |-------------------|-------------------| - | |                     |      |"
      print "|         |     |    |     |    |      |------------------|         i.         |        |"
      print "|         | - |  | - |  |---------| - |i-|                              |        |"
      print "|         |  |         |  |         ||| 0%   |i i  |                              |        |"
      print "|         |         |         |         |         |-| | (+,-)   ||                              |        |"
      print "|         |         |         |         |         |-|(+-)|         |(|                              |        |"
      print "|         |         |         |         |         |- |    |         |5)(+,-) |                              |        |"
      print "|         |         |         |         |         |-|    |         |        |                              |        |"
      print "|         |         |         |         |         |  |    |         |        |                              |        |"
      print "|         |         |         |         |         |(+-)|    |         |        |                              |        |"
      print "|---------|---------|---------|---------|---------|----|----|---------|--------|------------------------------|--------|"
      print "|   15    |   16    |   17    |   18    |   19    | 20 | 21 |   22    |   23   |             24               |   25   |"
      print "|---------|---------|---------|---------|---------|----|----|---------|--------|------------------------------|--------|"
    on every row
      print"|", s15 using "######.##","|", s16 using "######.##","|", s17 using "######.##","|", s18 using "######.##","|", s19 using "######.##","|    |    |         |        |",operacianam,"|",datopl using "dd/mm/yy","|"
    after group of nnakldat
      print "|",group sum(s15) using "######.##","|", group sum(s16) using "######.##","|", group sum(s17) using "######.##","|", group sum(s18) using "######.##", "|",group sum(s19) using "######.##","|    |    |         |        |                              |        |"
      print "------------------------------------------------------------------------------------------------------------------------"
    on last row
      print "========================================================================================================================"
      print betweenstr6,passoff,formfeed
end report

report r_jurnal1(npp, dat1, dat2, schetcod, nnaklcod, nnaklnum, nnakldat, klientnam, 
                 klientinn, sall, swpdv, klientnds, s9, s12)
define	npp		smallint,
	dat1, dat2	date,
	schetcod    integer,
	nnaklcod    integer,
	nnaklnum	like nnakl.num,
	nnakldat	like nnakl.dat,
	klientnam	like klient.nam,
	klientinn	like klient.inn,
	sall		like nnakltov.summa,
	swpdv, s9, s12	like nnakltov.summa,
	klientnds	like klient.nds

output
    report to pipe reppipe
#    report to printer
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		25
	
format	
    first page header
      print twicewidthon,vidon,"           i ",vidoff,twicewidthoff
      print "                     i ",vidon,dat1 using "dd/mm/yyyy",vidoff,"",vidon,dat2 using "dd/mm/yyyy",vidoff
      print passon,betweenstr8
      print ".-----------------------------------------------------------------------------------------------------------------------------------------------."
      print "| N |                                                 | - |          i (i, ),          |"
      print "|/|------------------------------------------------------------------|  - |                i '             |"
      print "|   |  N  |  |                                | Ii-  |  -|--------------------------------------------------------------|"
      print "|   |- |.|                                        |  - |  -| - |      i ii i     | - |"
      print "|   |- |      |                                        |    | i,  | i -  |---------------------|---------------------|,   |"
      print "|   |i  |      |                                        |  -  | i,  |     | , i  - |  , i     |i -|"
      print "|   |     |      |                                        |       |   | -  |        |    |,   |"
      print "|   |     |      |                                        |            | .  | (8+9+ |----|---------|------|----|---------|------|-  |"
      print "|   |     |      |                                        |            |      | +10+11+ |  | i-  |   |  | i-  |   | |"
      print "|   |     |      |                                        |            | (7+15)  | +12+13+ ||    |'-||    |'-|i|"
      print "|   |     |      |                                        |            |         | 14)     | | i     |   | | i     |   | |"
      print "|   |     |      |                                        |            |         |         |0%  | - |-|0%  | - |-|.6.2.1|"
      print "|   |     |      |                                        |            |         |         |    |  |-|    |  |-||"
      print "|   |     |      |                                        |            |         |         |    | (.5)  |   |    | (.5)  |   |2,3 . |"
      print "|   |     |      |                                        |            |         |         |    |         |.3.2 |    |         |.3.2 |6.2.2,c|"
      print "|   |     |      |                                        |            |         |         |    |         | .3 |    |         |.3  |6 -|"
      print "|   |     |      |                                        |            |         |         |    |         |      |    |         |      | 0% |"
      print "|---|-----|------|----------------------------------------|------------|---------|---------|----|---------|------|----|---------|------|--------|"
      print "| 1 |  2  |   3  |                   4                    |      5     |    6    |    7    | 8  |    9    |  10  | 11 |    12   |  13  |   14   |"
      print "|---|-----|------|----------------------------------------|------------|---------|---------|----|---------|------|----|---------|------|--------|"
    on every row
      print npp using "|###|",nnaklnum using "#####|",nnakldat using "ddmmyy|", klientnam[1,40],"|",klientinn,"|",sall using "######.##","|",swpdv using "######.##","|    |",s9 using "######.##","|      |    |", s12 using "######.##","|      |        |"
    after group of nnakldat
      print "|   |     |      |                                        |      :",group sum(sall) using "######.##","|", group sum(swpdv) using "######.##","|    |", group sum(s9) using "######.##","|      |    |", group sum(s12) using "######.##","|      |        |"
      print "-------------------------------------------------------------------------------------------------------------------------------------------------"
    on last row
      print "================================================================================================================================================="
      call whatsot()
      print betweenstr6,passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report