globals "globals.4gl"

function lgota_del(lgotacod)
define
    str         char(128),
    lgotacod    like lgota.cod

    whenever error call err
    
    let str = "execute procedure lgota_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using lgotacod
    commit work
end function

function lgota_sel(where_str, order_str)
define  
    p   record
        cod         like lgota.cod,
        nam         like lgota.nam,
        proc        like lgota.proc
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam, proc ",
                 "from lgota ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam, "\t", p.proc
    end foreach
    commit work
end function

function lgota_ins(lgotanam, lgotaproc)
define
    str     	    char(128),
    lgotacod	    like lgota.cod,
    lgotanam        like lgota.nam,
    lgotaproc       like lgota.proc
    
    let str = "execute procedure lgota_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using lgotanam, lgotaproc
        fetch cur_ins into lgotacod
        display lgotacod
    close cur_ins
    commit work
end function

function lgota_upd(lgotacod, lgotanam, lgotaproc)
define
    str     	char(128),
    lgotacod        like lgota.cod,
    lgotanam        like lgota.nam,
    lgotaproc       like lgota.proc
    
    let str = "execute procedure lgota_upd(?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using lgotacod, lgotanam, lgotaproc
    commit work
end function

function lgota_rep(where_str, order_str, pipe_str)
define  
    p   record
        nam         like lgota.nam,
        proc        like lgota.proc
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select nam, proc ",
                  "from lgota ",
                  "where ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_lgota
        foreach cur_rep into p.*
            output to report r_lgota(p.nam, p.proc)
        end foreach
    finish report r_lgota
    commit work
end function

report r_lgota(nam, proc)
define	
    nam         like lgota.nam,
    proc        like lgota.proc

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "==========================================="
        print "                   |  "
        print "                         |  "
        print "-------------------------------------------"
    on every row
        print nam, "  ", proc using "----.--"
    on last row
        print "==========================================="
end report

function lgota_he(helgotanam)
define
    str     	                char(128),
    lgotacod	                like lgota.cod,
    lgotanam, helgotanam        like lgota.nam,
    proc                        like lgota.proc,
    ret                         smallint,
    sep                         char(1)
    
    let sep = ascii 3
    let str = "execute procedure lgota_he(?)"
    prepare p_he from str
    declare cur_he cursor for p_he
    
    let transaction = 1
    begin work
    open cur_he using helgotanam
        while (TRUE)
            fetch cur_he into lgotacod, lgotanam, proc, ret
            if status = notfound then exit while end if
            display lgotacod, "\t", lgotanam, sep, proc using "###.##", "\t", ret
        end while
    close cur_he
    commit work
end function
