globals "globals.4gl"

function naklp_ins(pr, tip, num, dat, skladcod, operaciacod, klientcod, 
                   kurs, lgotaproc, prim1, datdolga)
define
    str     	char(128),
    pr, tip         char(1),
    num         like naklp.num,
    dat         like naklp.dat,
    naklpcod, skladcod, operaciacod, klientcod    integer,
    kurs        like naklp.kurs,
    lgotaproc   like naklr.lgota_proc,
    prim1       like naklp.prim1,
    datdolga    date

    whenever error call err
    
    initialize naklpcod to null
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure naklp_ins(?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using pr, tip, num, dat, skladcod, operaciacod, klientcod,
                       kurs, lgotaproc, prim1, datdolga
        fetch cur_ins into naklpcod, num
        display naklpcod, "\t",
                num
    close cur_ins
    commit work
end function

function naklp_del(pr, naklpcod)
define
    pr          char(1),
    str         char(128),
    naklpcod    integer
    
    let str = "execute procedure naklp_del(?,?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using pr, naklpcod
    commit work
end function

function naklp_upd(pr, naklpcod, num, dat, skladcod, operaciacod, klientcod, 
                   kurs, lgotaproc, prim1, datdolga)
define
    pr          char(1),
    str     	char(128),
    num         like naklp.num,
    dat         like naklp.dat,
    naklpcod, skladcod, operaciacod, klientcod    integer,
    kurs        like naklp.kurs,
    lgotaproc   like naklr.lgota_proc,
    prim1       like naklp.prim1,
    datdolga    date
    
    let str = "execute procedure naklp_upd(?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using pr, naklpcod, num, dat, skladcod, operaciacod, klientcod, 
                        kurs, lgotaproc, prim1, datdolga
    commit work
end function
    
function naklplist_sel(pr, tip, where_str, sort_str)
define  
    where_str   char(1024),
    sort_str    char(64),
    pr, tip         char(1),
    p   record
        cod         integer,
        num         like naklp.num,
        dat         like naklp.dat,
        klientnam   like klient.nam,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,
        summa1      decimal(9,2),
        summa2      decimal(9,2)
    end record,
    str         char(4096),
    tbl         char(20)
    
    case tip
        when "f" let tbl = "_naklpfs"
        when "m" let tbl = "_naklpms"
        when "n" let tbl = "_naklpns"
    end case
    if pr = "r" then let tbl = "_naklrms" end if
    
    let str = "select a.cod, a.num as num, a.dat as dat, d.nam as knam, ",
                     "b.nam as snam, c.nam as onam, ",
                     "a.summa1 as summa1, a.summa2 as summa2 ",
                 "from ", tbl clipped," a, sklad b, operacia c, klient d ",
                 "where a.sklad_cod = b.cod and ",
                       "a.operacia_cod = c.cod and ",
                       "a.klient_cod = d.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.summa1 is null then let p.summa1 = 0 end if
        if p.summa2 is null then let p.summa2 = 0 end if
        display p.cod, "\t", 
                p.num, "\t", 
                p.dat using "ddmmyy", "\t", 
                p.klientnam, "\t", 
                p.skladnam, "\t", 
                p.operacianam, "\t", 
                p.summa1 using "#######.##", "\t",
                p.summa2 using "######.##"
    end foreach
    commit work
end function

function naklplist_rep(pr, tip, where_str, sort_str, pipe_str)
define  
    where_str   char(256),
    sort_str    char(64),
    pr, tip         char(1),
    p   record
        num         like naklp.num,
        dat         like naklp.dat,
        klientnam   like klient.nam,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,
        summa1      decimal(9,2),
        summa2      decimal(9,2)
    end record,
    str         char(1024),
    tbl         char(20),
    pipe_str    char(256)
    
    case tip
        when "f" let tbl = "_naklpfs"
        when "m" let tbl = "_naklpms"
        when "n" let tbl = "_naklpns"
    end case
    if pr = "r" then let tbl = "_naklrms" end if
    
    let str = "select a.num as num, a.dat as dat, d.nam as knam, ",
                     "b.nam as snam, c.nam as onam, ",
                     "a.summa1 as summa1, a.summa2 as summa2 ",
                 "from ", tbl clipped," a, sklad b, operacia c, klient d ",
                 "where a.sklad_cod = b.cod and ",
                       "a.operacia_cod = c.cod and ",
                       "a.klient_cod = d.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_replist from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_replist cursor for p_replist
    let transaction = 1    
    begin work
    start report r_naklplist
        foreach cur_replist into p.*
            output to report r_naklplist( pr, tip, p.num, p.dat, p.klientnam, 
                                          p.skladnam, p.operacianam,
                                          p.summa1, p.summa2)
        end foreach
    finish report r_naklplist
    commit work
end function

report r_naklplist( pr, tip,num, dat, klientnam, skladnam, operacianam, summa1, summa2)
define	
    pr, tip         char(1),
    strtip, strpr   char(20),
    num         like naklp.num,
    dat         like naklp.dat,
    klientnam   like klient.nam,
    skladnam    like sklad.nam,
    operacianam like operacia.nam,
    summa1      decimal(9,2),
    summa2      decimal(9,2)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      case tip
         when "f" let strtip = " "
         when "m" let strtip = " "
         when "n" let strtip = ""
      end case
      let strpr = ""
      if pr = "r" then let strpr = "" end if
      print twicewidthon,vidon,"", strtip clipped,"   ",strpr,vidoff,twicewidthoff
      print "====================================================================="
      if pr = "r" then
        print "     |      |     |      |   |     |  " 
      else
        print "     |      |  |      |   |     |  " 
      end if
      print "---------------------------------------------------------------------"
    on every row
      print num, " ", dat, passon, klientnam, " ", skladnam, " ", operacianam,passoff,summa1 using "#######.##", " ", summa2 using "#######.##"
    on last row
      print "====================================================================="
      print "                            : ",sum(summa1) using "#######.##"," ",sum(summa2) using "#######.##"
      print "====================================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

function naklpone_sel(pr, naklpcod)
define  
    pr          char(1),
    naklpcod    integer,
    p   record
        num         like naklp.num,
        dat         like naklp.dat,
        skladcod    integer,
        skladnam    like sklad.nam,
        operaciacod integer,
        operacianam like operacia.nam,
        klientcod   integer,
        klientnam   like klient.nam,
        kurs        like naklp.kurs,
        lgotanam    like lgota.nam,
        proc        like lgota.proc,
        lgotaproc   like naklr.lgota_proc,
        prim1       like naklp.prim1,
        datdolga    date
    end record
    
    initialize p to null
    let transaction = 1    
    begin work
    if pr = "p" then
        select  a.num, a.dat, a.sklad_cod, b.nam, a.operacia_cod, c.nam,
                a.klient_cod, d.nam, a.kurs, 
                nullchar(), nulldecimal(), nulldecimal(), a.prim1,
                nulldate()
            into p.*
            from naklp a, sklad b, operacia c, klient d
            where a.cod = naklpcod and
                  a.sklad_cod = b.cod and
                  a.operacia_cod = c.cod and
                  a.klient_cod = d.cod
    end if
    if pr = "r" then
        select  a.num, a.dat, a.sklad_cod, b.nam, a.operacia_cod, c.nam,
                a.klient_cod, d.nam, 0, 
                e.nam, e.proc, a.lgota_proc, a.prim1, a.dat_dolga
            into p.*
            from naklr a, sklad b, operacia c, klient d, outer lgota e
            where a.cod = naklpcod and
                  a.sklad_cod = b.cod and
                  a.operacia_cod = c.cod and
                  d.lgota_cod = e.cod and
                  a.klient_cod = d.cod
    end if
    commit work
    
    display p.num, "\t",
        p.dat using "dd.mm.yyyy", "\t",
        p.skladcod, "\t",
        p.skladnam, "\t",
        p.operaciacod, "\t",
        p.operacianam, "\t",
        p.klientcod, "\t",
        p.klientnam, "\t",
        p.kurs using "###.##", "\t",
        p.lgotanam, "\t",
        p.proc using "###.##", "\t",
        p.lgotaproc using "---.--", "\t",
        p.prim1, "\t",
        p.datdolga using "dd.mm.yyyy"
end function
