globals "globals.4gl"

function naklpopl_ins(naklpcod, dat, summa, summad)
define
    str     	        char(128),
    naklpcod, naklpoplcod  integer,
    dat                 like naklpopl.dat,
    summa               like naklpopl.summa,
    summad              like naklpopl.summad
    
    whenever error call err

    initialize naklpoplcod to null
    let str = "execute procedure naklpopl_ins(?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using naklpcod, dat, summa, summad
        fetch cur_ins into naklpoplcod
        display naklpoplcod
    close cur_ins
    commit work
end function

function naklpopl_sel(naklpcod)
define  
    naklpcod        integer,
    p   record
        cod         integer,
        fuf         integer,
        dat         like naklpopl.dat,
        summa       like naklpopl.summa,
        summad      like naklpopl.summad
    end record,
    str         char(256)
    
    let str = "select a.cod, 0, a.dat, a.summa, a.summad ",
                 "from naklpopl a ",
                 "where a.naklp_cod = ", naklpcod,
                 " order by a.dat"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t",
                p.fuf, "\t",
                p.dat using "dd.mm.yyyy", "\t",
                p.summa using "#######.##", "\t",
                p.summad using "#######.##"
    end foreach
    commit work
end function

function naklpopl_del(naklpoplcod)
define
    str         char(128),
    naklpoplcod    integer
    
    let str = "execute procedure naklpopl_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using naklpoplcod
    commit work
end function

function naklpopl_upd(naklpoplcod, dat, summa, summad)
define
    str     	    char(128),
    naklpoplcod     integer,
    dat             like naklpopl.dat,
    summa           like naklpopl.summa,
    summad          like naklpopl.summad
    
    let str = "execute procedure naklpopl_upd(?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using naklpoplcod, dat, summa, summad
    commit work
end function

function naklpopl_rep(naklpcod, pipe_str)
define  
    naklpcod    integer,
    pipe_str    char(256),
    str         char(768),
    p   record
        num		    like naklr.num,
        dat		    date,
        klientnam	like klient.nam,
        datopl      like naklpopl.dat,
        summa       like naklpopl.summa,
        summad      like naklpopl.summad
    end record,
    sschet, sschetd      decimal(9,2)
        
    let str = "select a.num, a.dat, b.nam, c.dat, c.summa, c.summad ",
                  "from naklr a, klient b, naklpopl c ",
                  "where a.cod = ",naklpcod," and ",
                        "a.klient_cod = b.cod and ",
                        "a.cod = c.naklp_cod ",
                  " order by c.dat"
    prepare p_repschet from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repnaklpopl cursor for p_repschet
    let transaction = 1    
    begin work
    start report r_naklpopl
        foreach cur_repnaklpopl into p.*
            output to report r_naklpopl(p.num, p.dat, p.klientnam, p.datopl, 
                                    p.summa, p.summad)
        end foreach
    finish report r_naklpopl
    commit work
end function

report r_naklpopl( num, dat, klientnam, datopl, summa, summad )
define	
    num		    like naklr.num,
    dat		    date,
    klientnam	like klient.nam,
    datopl      like naklpopl.dat,
    summa       like naklpopl.summa,
    summad      like naklpopl.summad,
    sschet      decimal(9,2),
    sschetd     decimal(9,2)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"          ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"i",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "        :",vidon,klientnam,vidoff
      print "                       ================================"
      print "                             |      | " 
      print "                       ================================"
    on every row
      print datopl using "                       dd.mm.yyyy"," ",summa using "#######.##"," ",summad using "#######.##"
    on last row
      print "                       ======================"
      print "                           : ",sum(summa) using "#######.##"," ",sum(summad) using "#######.##"
      print "                       ======================"
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
