globals "globals.4gl"

function naklptov_sel(pr, tip, naklpcod, order_str)
define  
    pr, tip             like naklp.tip,
    naklpcod        integer,
    p   record
        finoperpcod     integer,
        matoperpcod     integer,
        tovarcod        integer,
        tovarcena       like tovar.cena,
        tovarnam        like tovar.nam,
        sernum          like matoperp.sernum,
        kol             like matoperp.kol,
        einam           like ei.nam,
        cena            like matoperp.cena,
        cenad           like matoperp.cenad,
        issernum        like tovar.issernum
    end record,
    str         char(768),
    order_str   char(64)
    
    whenever error call err

    if pr = 'p' then
        if tip = 'n' or tip = 'N' then
            let str = "select b.finoperp_cod, a.cod, a.tovar_cod, c.cena, c.nam as tnam, ",
                             "a.sernum, a.kol as koll, d.nam as enam, a.cena as cenaa, ",
                             "a.cenad as cenadd, c.issernum ",
                         "from matoperp a, finpmatplink b, tovar c, ei d ",
                         "where a.doc_cod = ", naklpcod, " and ",
                               "a.cod = b.matoperp_cod and ",
                               "a.tovar_cod = c.cod and ",
                               "c.ei_cod = d.cod ",
                         "order by ", order_str clipped
        end if
        if tip = 'f' or tip = 'F' then
            let str = "select a.cod, 0, a.tovar_cod, c.cena, c.nam as tnam, '', ",
                             "a.kol as koll, d.nam as enam, a.cena as cenaa, ",
                             "a.cena as cenadd, '' ",
                         "from finoperp a, tovar c, ei d ",
                         "where a.doc_cod = ", naklpcod, " and ",
                               "a.tovar_cod = c.cod and ",
                               "c.ei_cod = d.cod ",
                         "order by ", order_str clipped
        end if
        if tip = 'm' or tip = 'M' then
            let str = "select 0, a.cod, a.tovar_cod, c.cena, c.nam as tnam, a.sernum, ",
                             "a.kol as koll, d.nam as enam, a.cena as cenaa, ",
                             "a.cenad as cenadd, c.issernum ",
                         "from matoperp a, tovar c, ei d ",
                         "where a.doc_cod = ", naklpcod, " and ",
                               "a.tovar_cod = c.cod and ",
                               "c.ei_cod = d.cod ",
                         "order by ", order_str clipped
        end if
    end if
    if pr = 'r' then
        let str = "select 0, a.cod, a.tovar_cod, c.cena, c.nam as tnam, '', ",
                         "a.kol as koll, d.nam as enam, a.cena as cenaa, ",
                         "a.cenad as cenadd, c.issernum ",
                     "from naklrtov a, tovar c, ei d ",
                     "where a.naklr_cod = ", naklpcod, " and ",
                           "a.tovar_cod = c.cod and ",
                           "c.ei_cod = d.cod ",
                     "order by ", order_str clipped
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if tip = 'm' and pr = 'p' then 
            display p.finoperpcod, "\t",
                    p.matoperpcod, "\t",
                    p.tovarcod, "\t",
                    p.tovarcena, "\t",
                    p.tovarnam, "\t",
                    p.sernum, "\t",
                    p.kol using "#####.##", "\t",
                    p.einam, "\t",
                    p.cena using "#######.##", "\t",
                    p.cenad using "#######.##", "\t",
                    p.issernum
        else
            display p.finoperpcod, "\t",
                    p.matoperpcod, "\t",
                    p.tovarcod, "\t",
                    p.tovarcena, "\t",
                    p.tovarnam, "\t",
                    p.kol using "#####.##", "\t",
                    p.einam, "\t",
                    p.cena using "#######.##", "\t",
                    p.cenad using "#######.##", "\t",
                    p.sernum, "\t",
                    p.issernum
        end if
    end foreach
    commit work
end function

function naklptov_ins(pr, tip, doccod, datpokupki, skladcod, tovarcod,
                      sernum, kol, cena, cenad)
define
    str     	    char(128),
    pr, tip             like naklp.tip,
    finoperpcod, matoperpcod, doccod, skladcod, tovarcod  integer,
    datpokupki      date,
    sernum          like matoperp.sernum,
    kol             like matoperp.kol,
    cena            like matoperp.cena,
    cenad           like matoperp.cenad
    
    initialize finoperpcod, matoperpcod to null
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure naklptov_ins(?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using pr, tip, doccod, datpokupki, skladcod, tovarcod,
                       sernum, kol, cena, cenad
        fetch cur_ins into finoperpcod, matoperpcod
        display finoperpcod, "\t", matoperpcod
    close cur_ins
    commit work
end function

function naklptov_upd(pr, tip, finoperpcod, matoperpcod, tovarcod, sernum, kol, cena, cenad)
define
    pr              char(1),
    str     	    char(128),
    tip             like naklp.tip,
    finoperpcod, matoperpcod, tovarcod  integer,
    sernum          like matoperp.sernum,
    kol             like matoperp.kol,
    cena            like matoperp.cena,
    cenad           like matoperp.cenad
    
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure naklptov_upd(?,?,?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using pr, tip, finoperpcod, matoperpcod, tovarcod,
                        sernum, kol, cena, cenad
    commit work
end function

function naklptov_del(pr, tip, finoperpcod, matoperpcod)
define
    str     	    char(128),
    tip             like naklp.tip,
    pr              char(1),
    finoperpcod, matoperpcod  integer
    
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure naklptov_del(?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using pr, tip, finoperpcod, matoperpcod
    commit work
end function

function naklphead_rep(pr, tip, naklpcod, order_str, pipe_str)
define  
    pr, tip         char(1),
    naklpcod    integer,
    order_str, pipe_str    char(256),
    str         char(768),
    p   record
        num		    like naklp.num,
        dat		    date,
        kurs        like naklp.kurs,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,        
        klientnam	like klient.nam,
        prim1       like naklp.prim1,
        tovarnam	like schfnrtov.printnam,
        sernum      like matoperp.sernum,
        kol		    like matoperp.kol,
        einam		like ei.nam,
        cena		like matoperp.cena,
        cenad       like matoperp.cenad
    end record
    
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    
    if pr = 'p' then
        if tip = "N" or tip = "M" then
            let str = "select a.num, a.dat, a.kurs, c.nam, d.nam, e.nam, a.prim1, ",
                             "f.nam as tnam, b.sernum, b.kol as koll, ",
                             "g.nam as enam, b.cena as cenaa, b.cenad as cenadd ",
                          "from naklp a, matoperp b, sklad c, operacia d, ",
                               "klient e, tovar f, ei g ",
                          "where a.cod = ", naklpcod, " and ",
                                "a.cod = b.doc_cod and ",
                                "a.sklad_cod = c.cod and ",
                                "a.operacia_cod = d.cod and ",
                                "a.klient_cod = e.cod and ",
                                "b.tovar_cod = f.cod and ",
                                "f.ei_cod = g.cod ",
                          "order by ", order_str clipped
        end if
        if tip = "F" then
            let str = "select a.num, a.dat, a.kurs, c.nam, d.nam, e.nam, a.prim1, ",
                             "f.nam as tnam, '', b.kol as koll, ",
                             "g.nam as enam, b.cena as cenaa, b.cena as cenadd ",
                          "from naklp a, finoperp b, sklad c, operacia d, ",
                               "klient e, tovar f, ei g ",
                          "where a.cod = ", naklpcod, " and ",
                                "a.cod = b.doc_cod and ",
                                "a.sklad_cod = c.cod and ",
                                "a.operacia_cod = d.cod and ",
                                "a.klient_cod = e.cod and ",
                                "b.tovar_cod = f.cod and ",
                                "f.ei_cod = g.cod ",
                          "order by ", order_str clipped
        end if
    end if
    if pr = "r" then
        let str = "select a.num, a.dat, 0, c.nam, d.nam, e.nam, a.prim1, ",
                         "f.nam as tnam, '', b.kol as koll, ",
                         "g.nam as enam, b.cena as cenaa, b.cenad as cenadd ",
                      "from naklr a, naklrtov b, sklad c, operacia d, ",
                           "klient e, tovar f, ei g ",
                      "where a.cod = ", naklpcod, " and ",
                            "a.cod = b.naklr_cod and ",
                            "a.sklad_cod = c.cod and ",
                            "a.operacia_cod = d.cod and ",
                            "a.klient_cod = e.cod and ",
                            "b.tovar_cod = f.cod and ",
                            "f.ei_cod = g.cod ",
                      "order by ", order_str clipped
    end if
    prepare p_repnaklp from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repnaklp cursor for p_repnaklp
    let transaction = 1    
    begin work
    start report r_naklp
        foreach cur_repnaklp into p.*
            output to report r_naklp(pr, tip, p.num, p.dat, p.kurs, p.skladnam,
                                     p.operacianam,  p.klientnam, p.prim1, 
                                     p.tovarnam, p.sernum, p.kol, p.einam, 
                                     p.cena, p.cenad)
        end foreach
    finish report r_naklp
    commit work
end function

report r_naklp(pr, tip, num, dat, kurs, skladnam, operacianam, klientnam, prim1,
               tovarnam, sernum, kol, einam, cena, cenad)
define	
    pr, tip         char(1),
    num		    like naklp.num,
    dat		    date,
    kurs        like naklp.kurs,
    skladnam    like sklad.nam,
    operacianam like operacia.nam,        
    klientnam	like klient.nam,
    prim1       like naklp.prim1,
    tovarnam	like schfnrtov.printnam,
    sernum      like matoperp.sernum,
    kol		    like matoperp.kol,
    einam		like ei.nam,
    cena		like matoperp.cena,
    cenad       like matoperp.cenad,
    tipstr, tipstr2      char(20)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      skip 1 line
      if tip = "N" then let tipstr = "" end if
      if tip = "F" then let tipstr = " " end if
      if tip = "M" then let tipstr = " " end if
      let tipstr2 = " "
      if pr = "r" then let tipstr2 = " " end if
      print twicewidthon,vidon,tipstr clipped," ",tipstr2 clipped,vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"",vidon,dat using "dd/mm/yyyy",vidoff,"."
      if pr = "p" then
        print "    :",vidon,skladnam,vidoff
      else
        print "  :",vidon,skladnam,vidoff
      end if
      print "               :",vidon,operacianam,vidoff
      if pr = "p" then
        print "                :",vidon,klientnam,vidoff
      else
        print "                   :",vidon,klientnam,vidoff
      end if
      print "               :",vidon,prim1,vidoff
      if tip != "F" then
        print passon,"===================================================================================================================================================="
        print "                                                      |            |   -  |      |      |       |   " 
        print "                                                                        |               |    |          |          |            |"
        print "=====================================================================================================================================================",passoff
      else
        print "=============================================================================="
        print "                             | - |     |   " 
        print "                                               | |         |"
        print "=============================================================================="
      end if
    on every row
      if tip != "F" then
        print passon,tovarnam," ",sernum,kol using "####.##",cena using " #######.##", cenad using " #######.##", cena * kol using " #######.##", cenad * kol using " #######.##",passoff
      else
        print passon,tovarnam,passoff,kol using "####.##",cena using " #######.##", cena * kol using " #######.##"
      end if
    on last row
      if tip != "F" then
        print passon,"====================================================================================================================================================",passoff
      else
        print "================================================================================"
      end if
      print "                                                             :", sum(cena * kol ) using "#######.##"
      print "                                                             :", sum(cenad * kol ) using "#######.##"
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
