globals "globals.4gl"

function naklropl_ins(naklrcod, dat, summa, summad)
define
    str     	        char(128),
    naklrcod, naklroplcod  integer,
    dat                 like naklropl.dat,
    summa               like naklropl.summa,
    summad              like naklropl.summad
    
    whenever error call err

    initialize naklroplcod to null
    let str = "execute procedure naklropl_ins(?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using naklrcod, dat, summa, summad
        fetch cur_ins into naklroplcod
        display naklroplcod
    close cur_ins
    commit work
end function

function naklropl_sel(naklrcod)
define  
    naklrcod        integer,
    p   record
        cod         integer,
        fuf         integer,
        dat         like naklropl.dat,
        summa       like naklropl.summa,
        summad      like naklropl.summad
    end record,
    str         char(256)
    
    let str = "select a.cod, 0, a.dat, a.summa, a.summad ",
                 "from naklropl a ",
                 "where a.naklr_cod = ", naklrcod,
                 " order by a.dat"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t",
                p.fuf, "\t",
                p.dat using "dd.mm.yyyy", "\t",
                p.summa using "#######.##", "\t",
                p.summad using "#######.##"
    end foreach
    commit work
end function

function naklropl_del(naklroplcod)
define
    str         char(128),
    naklroplcod    integer
    
    let str = "execute procedure naklropl_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using naklroplcod
    commit work
end function

function naklropl_upd(naklroplcod, dat, summa, summad)
define
    str     	    char(128),
    naklroplcod     integer,
    dat             like naklropl.dat,
    summa           like naklropl.summa,
    summad          like naklropl.summad
    
    let str = "execute procedure naklropl_upd(?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using naklroplcod, dat, summa, summad
    commit work
end function

function naklropl_rep(naklrcod, pipe_str)
define  
    naklrcod    integer,
    pipe_str    char(256),
    str         char(768),
    p   record
        num		    like naklr.num,
        dat		    date,
        klientnam	like klient.nam,
        datopl      like naklropl.dat,
        summa       like naklropl.summa,
        summad      like naklropl.summad
    end record,
    sschet, sschetd      decimal(9,2)
        
    let str = "select a.num, a.dat, b.nam, c.dat, c.summa, c.summad ",
                  "from naklr a, klient b, naklropl c ",
                  "where a.cod = ",naklrcod," and ",
                        "a.klient_cod = b.cod and ",
                        "a.cod = c.naklr_cod ",
                  " order by c.dat"
    prepare p_repschet from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repnaklropl cursor for p_repschet
    let transaction = 1    
    begin work
    start report r_naklropl
        foreach cur_repnaklropl into p.*
            output to report r_naklropl(p.num, p.dat, p.klientnam, p.datopl, 
                                    p.summa, p.summad)
        end foreach
    finish report r_naklropl
    commit work
end function

report r_naklropl( num, dat, klientnam, datopl, summa, summad )
define	
    num		    like naklr.num,
    dat		    date,
    klientnam	like klient.nam,
    datopl      like naklropl.dat,
    summa       like naklropl.summa,
    summad      like naklropl.summad,
    sschet      decimal(9,2),
    sschetd     decimal(9,2)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"          ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"i",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "        :",vidon,klientnam,vidoff
      print "                       ================================"
      print "                             |      | " 
      print "                       ================================"
    on every row
      print datopl using "                       dd.mm.yyyy"," ",summa using "#######.##"," ",summad using "#######.##"
    on last row
      print "                       ======================"
      print "                           : ",sum(summa) using "#######.##"," ",sum(summad) using "#######.##"
      print "                       ======================"
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
