globals "globals.4gl"

function nds_ins(dat, stavka)
define
    str     	char(128),
    ndscod      integer,
    dat         like nds.dat,
    stavka      like nds.stavka
    
    whenever error call err

    initialize ndscod to null
    let str = "execute procedure nds_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using dat, stavka
        fetch cur_ins into ndscod
        display ndscod
    close cur_ins
    commit work
end function

function nds_sel()
define  
    p   record
        cod         integer,
        dat         like nds.dat,
        stavka      like nds.stavka
    end record,
    str         char(256)
    
    let str = "select a.cod, a.dat, a.stavka ",
                 "from nds a ",
                 "order by a.dat"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t",
                p.dat using "dd.mm.yyyy", "\t",
                p.stavka using "##.##"
    end foreach
    commit work
end function

function nds_del(ndscod)
define
    str         char(128),
    ndscod    integer
    
    let str = "execute procedure nds_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using ndscod
    commit work
end function

function nds_upd(ndscod, dat, stavka)
define
    str     	    char(128),
    ndscod     integer,
    dat             like nds.dat,
    stavka           like nds.stavka
    
    let str = "execute procedure nds_upd(?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using ndscod, dat, stavka
    commit work
end function

