globals "globals.4gl"

function nnakltov_ins(nnaklcod, schfnrtovcod, summa)
define
    str     	        char(128),
    nnaklcod, schfnrtovcod, nnakltovcod  integer,
    summa       like nnakltov.summa
    
    whenever error call err

    initialize nnakltovcod to null
    let str = "execute procedure nnakltov_ins(?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using nnaklcod, schfnrtovcod, summa
        fetch cur_ins into nnakltovcod
        display nnakltovcod
    close cur_ins
    commit work
end function

function nnakltov_upd(nnakltovcod, summa)
define
    str     	        char(128),
    nnakltovcod         integer,
    summa               like nnakltov.summa
    
    let str = "execute procedure nnakltov_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using nnakltovcod, summa
    commit work
end function

function nnakltov_sel(schetcod, nnaklcod, order_str)
define  
    schetcod, nnaklcod        integer,
    p   record
        cod             integer,
        schfnrtovcod    integer,
        tovarnam        like tovar.nam,
        kol             like schfnrtov.kol,
        einam           like ei.nam,
        cena            like schfnrtov.cena,
        stschet         decimal(9,2),
        stnnakla        decimal(9,2),
        summa           like nnakltov.summa
    end record,
    str         char(768),
    order_str   char(64)
    
    let str = "select e.cod, a.cod, b.nam as tnam, a.kol as koll, c.nam as enam, ",
                     "a.cena as cenaa, a.kol * a.cena, sum(d.summa), e.summa, ",
                     "a.printnam as pnam ",
                 "from schfnrtov a, tovar b, ei c, outer _nnakltovs d, outer nnakltov e ",
                 "where a.schetfnr_cod = ",schetcod, " and ",
                       "a.tovar_cod = b.cod and ",
                       "b.ei_cod = c.cod and ",
                       "a.cod = d.schfnrtov_cod and ",
                       "a.cod = e.schfnrtov_cod and ",
                       "d.nnakl_cod != ", nnaklcod, " and ",
                       "e.nnakl_cod = ", nnaklcod, " ",
                 "group by 1, 2, 3, 4, 5, 6, 7, 9, 10 ",
                 "order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.stnnakla is null then let p.stnnakla = 0 end if
        display p.cod, "\t",
                p.schfnrtovcod, "\t",
                p.tovarnam, "\t",
                p.kol using "####.##", "\t",
                p.einam, "\t",
                p.cena using "######.##", "\t",
                p.stschet using "######.##", "\t",
                p.stnnakla using "######.##", "\t",
                p.summa using "######.##"
    end foreach
    commit work
end function

function nnakltov_del(nnakltovcod)
define
    str         char(128),
    nnakltovcod    integer
    
    let str = "execute procedure nnakltov_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using nnakltovcod
    commit work
end function

function nnakltov_rep(schetcod, order_str, pipe_str)
define  
    schetcod    integer,
    order_str, pipe_str    char(256),
    str         char(768),
    p   record
        num		    like schetfnr.schet_num,
        dat		    date,
        klientnam	like klient.nam,
        lgotanam	like lgota.nam,
        lgotaproc	like schetfnr.lgota_proc,
        
        schfnrtovcod    integer,
        tovarnam1	like schfnrtov.printnam,
        kol1	    like schfnrtov.kol,
        einam1		like ei.nam,
        cena1		like schfnrtov.cena,

        tovarnam2	like schfnrtov.printnam,
        kol2	    like schfnrtov.kol,
        einam2		like ei.nam,
        cena2		like schfnrtov.cena
    end record,
    cenawithoutpdv decimal(13,6),
    pdv         decimal(13,6)
        
    let transaction = 1    
    begin work
    initialize p to null
    
    let str = "select a.schet_num, a.schet_dat, b.nam, c.nam, a.lgota_proc, ",
                     "d.cod, e.nam as tnam, d.kol as koll, f.nam as enam, d.cena as cenaa, ",
                     "h.nam, g.kol, i.nam, g.cena, d.printnam as pnam ",
                 "from schetfnr a, klient b, outer lgota c, schfnrtov d, tovar e, ei f, outer (schfnrtovt g, tovar h, ei i) ",
                 "where a.cod = ",schetcod, " and ",
                       "a.klient_cod = b.cod and ",
                       "b.lgota_cod = c.cod and ",
                       "a.cod = d.schetfnr_cod and ",
                       "d.tovar_cod = e.cod and ",
                       "e.ei_cod = f.cod and ",
                       "d.cod = g.schfnrtov_cod and ",
                       "g.tovar_cod = h.cod and ",
                       "h.ei_cod = i.cod ",
                 " order by ", order_str clipped,", h.nam"
    prepare p_repnnakltov from str
    
    let reppipe = pipe_str
    declare cur_repnnakltov cursor for p_repnnakltov
    
    start report r_nnakltov
        foreach cur_repnnakltov into p.*
            output to report r_nnakltov(p.num, p.dat, p.klientnam,
                                        p.lgotanam, p.lgotaproc,
                                        p.schfnrtovcod, p.tovarnam1, p.kol1, p.einam1, p.cena1,
                                        p.tovarnam2, p.kol2, p.einam2, p.cena2
                                       )
        end foreach
    finish report r_nnakltov
    commit work
end function

report r_nnakltov(num, dat, klientnam, lgotanam, lgotaproc,
                  schfnrtovcod, tovarnam1, kol1, einam1, cena1,
                  tovarnam2, kol2, einam2, cena2
	             )
define	
    num		    like schetfnr.schet_num,
    dat		    date,
    klientnam	like klient.nam,
    lgotanam	like lgota.nam,
    lgotaproc	like schetfnr.lgota_proc,

    schfnrtovcod    integer,
    tovarnam1	like schfnrtov.printnam,
    kol1	    like schfnrtov.kol,
    einam1		like ei.nam,
    cena1		like schfnrtov.cena,

    tovarnam2	like schfnrtov.printnam,
    kol2	    like schfnrtov.kol,
    einam2		like ei.nam,
    cena2		like schfnrtov.cena
    

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		18
	
format	
    first page header
      skip 8 line
      print twicewidthon,vidon,"          ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"i",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "        :",vidon,klientnam,vidoff
      if lgotanam is not null then
        print passon,"      i :",passoff,vidon,lgotanam clipped,vidoff," ";
      else 
        print " ";
      end if
      if lgotaproc != 0 then
        print passon,"i :",passoff,vidon,lgotaproc using "###.##",vidoff,"%"
      else
        print " "
      end if
      print "============================================================================="
      print "                             | i- |   |  i" 
      print "                                               | i |  i  |  "
      print "============================================================================="
    before group of schfnrtovcod
      print passon,tovarnam1,passoff,kol1 using "#####.## ",einam1,cena1 using " #######.##"
    on every row
      if tovarnam2 is not null then
        print passon,"    ",tovarnam2,passoff,kol2 using "#####.## ",einam2,cena2 using " #######.##"
      end if
    on last row
      print "                                                         : ",sum(kol1) using "#####.##            ", sum(kol1 * cena1) using "#######.##"
      print "                                                             : ",sum(kol2) using "#####.##            ", sum(kol2 * cena2) using "#######.##"
      print "============================================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
