globals "globals.4gl"

function noo_sel(from_str, where_str, sort_str)
define  
    from_str    char(128),
    where_str   char(2048),
    sort_str    char(64),
    p   record
        cod          integer,
        naklrnum     like naklr.num,
        naklrdat     like naklr.dat,
        oplmindat    date,
        oplallsumma  decimal(9,2),
        oplallsummad decimal(9,2),
        oplcnt       integer,
        otgmindat    date,
        otgallkol    decimal(7,2),
        naklrkol     decimal(7,2),
        naklrsumma   decimal(9,2),
        naklrsummad  decimal(9,2),
        klientnam    like klient.nam,
        operacianam  like operacia.nam,
        skladnam     like sklad.nam
    end record,
    str     char(3072),
    oplsr, otgsr, oplsc  char(1)

    whenever error call err
    
    let str = "select a.naklr_cod, a.num as naklrnum, a.dat as naklrdat, ",
                     "c.mindat as opldat, c.summa, c.summad, c.cnt as oplcnt, ",
                     "d.mindat as otgdat, d.kol, a.kol, a.summa as naklrsumma, ", 
                     "a.summad as naklrsummad, e.nam as klientnam, f.nam as operacianam, ",
                     "g.nam as skladnam ",
                 "from _naklrsmk a, ", from_str clipped, " klient e, operacia f, sklad g ",
                 "where a.naklr_cod = c.naklr_cod and ",
                       "a.num >= 0 and ",
                       "a.naklr_cod = d.naklr_cod and ",
                       "a.klient_cod = e.cod and ",
                       "a.operacia_cod = f.cod and ",
                       "a.sklad_cod = g.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.naklrsumma   is null      then let p.naklrsumma = 0 end if
        if p.naklrsummad  is null      then let p.naklrsummad = 0 end if
        if p.naklrkol is null          then let p.naklrkol = 0 end if
        
        if p.oplallsumma  = p.naklrsumma   and
           p.oplallsummad = p.naklrsummad
            then let oplsr = '=' 
        end if
        if p.oplallsumma  > p.naklrsumma or
           p.oplallsummad > p.naklrsummad
            then let oplsr = '-' 
        end if
        if p.oplallsumma  < p.naklrsumma or
           p.oplallsummad < p.naklrsummad
            then let oplsr = '+' 
        end if
        if p.oplallsumma  is null and
           p.oplallsummad is null
            then let oplsr = ' ' 
        end if
        
        if p.otgallkol = p.naklrkol then let otgsr = '=' end if
        if p.otgallkol > p.naklrkol then let otgsr = '-' end if
        if p.otgallkol < p.naklrkol then let otgsr = '+' end if
        if p.otgallkol is null      then let otgsr = ' ' end if
        if p.oplcnt > 1 then
            let oplsc = 'M'
        else
            let oplsc = ''
        end if
        
        display p.cod, "\t", 
                p.naklrnum, "\t", 
                p.naklrdat using "ddmmyy", "\t", 
                p.oplmindat using "ddmmyy", "\t",
                oplsr, "\t",
                oplsc, "\t",
                p.otgmindat using "ddmmyy", "\t",
                otgsr, "\t",
                p.naklrsumma using "#######.##", "\t",
                p.naklrsummad using "#######.##", "\t",
                p.klientnam, "\t",
                p.operacianam, "\t",
                p.skladnam
    end foreach
    commit work
end function

function nooone_sel(naklrcod)
define  
    naklrcod    integer,
    p   record
        cod          integer,
        naklrnum     like naklr.num,
        naklrdat     like naklr.dat,
        oplmindat    date,
        oplallsumma  decimal(9,2),
        oplallsummad decimal(9,2),
        oplcnt       integer,
        otgmindat    date,
        otgallkol    decimal(7,2),
        naklrkol     decimal(7,2),
        naklrsumma   decimal(9,2),
        naklrsummad  decimal(9,2),
        klientnam    like klient.nam,
        operacianam  like operacia.nam,
        skladnam     like sklad.nam
    end record,
    str     char(3072),
    oplsr, oplsc, otgsr  char(1)

    whenever error call err
    
    let str = "select a.naklr_cod, a.num as naklrnum, a.dat as naklrdat, ",
                     "c.mindat as opldat, c.summa, c.summad, c.cnt as oplcnt, ",
                     "d.mindat as otgdat, d.kol, a.kol, a.summa as naklrsumma, ", 
                     "a.summad as naklrsummad, e.nam as klientnam, ",
                     "f.nam as operacianam, g.nam as skladnam ",
                 "from _naklrsmk a, outer _naklroplmindat c, outer _naklrotgmindat d, klient e, operacia f, sklad g ",
                 "where a.naklr_cod = ", naklrcod, " and ",
                       "c.naklr_cod = ", naklrcod, " and ",
                       "d.naklr_cod = ", naklrcod, " and ",
                       "a.naklr_cod = c.naklr_cod and ",
                       "a.naklr_cod = d.naklr_cod and ",
                       "a.operacia_cod = f.cod and ",
                       "a.sklad_cod = g.cod and ",
                       "a.klient_cod = e.cod "
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel2 cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel2 into p.*
        if p.naklrsumma   is null      then let p.naklrsumma = 0 end if
        if p.naklrsummad  is null      then let p.naklrsummad = 0 end if
        if p.naklrkol is null          then let p.naklrkol = 0 end if
        
        if p.oplallsumma  = p.naklrsumma   and
           p.oplallsummad = p.naklrsummad
            then let oplsr = '=' 
        end if
        if p.oplallsumma  > p.naklrsumma or
           p.oplallsummad > p.naklrsummad
            then let oplsr = '-' 
        end if
        if p.oplallsumma  < p.naklrsumma or
           p.oplallsummad < p.naklrsummad
            then let oplsr = '+' 
        end if
        if p.oplallsumma  is null and
           p.oplallsummad is null
            then let oplsr = ' ' 
        end if
        
        if p.otgallkol = p.naklrkol then let otgsr = '=' end if
        if p.otgallkol > p.naklrkol then let otgsr = '-' end if
        if p.otgallkol < p.naklrkol then let otgsr = '+' end if
        if p.otgallkol is null      then let otgsr = ' ' end if
        if p.oplcnt > 1 then
            let oplsc = 'M'
        else
            let oplsc = ''
        end if
        display p.cod, "\t", 
                p.naklrnum, "\t", 
                p.naklrdat using "ddmmyy", "\t", 
                p.oplmindat using "ddmmyy", "\t",
                oplsr, "\t",
                oplsc, "\t",
                p.otgmindat using "ddmmyy", "\t",
                otgsr, "\t",
                p.naklrsumma using "#######.##", "\t",
                p.naklrsummad using "#######.##", "\t",
                p.klientnam, "\t",
                p.operacianam, "\t",
                p.skladnam
    end foreach
    commit work
end function

function noo_rep(from_str, where_str, sort_str, pipe_str)
define  
    from_str    char(128),
    where_str   char(2048),
    sort_str    char(64),
    pipe_str    char(256),
    str         char(3072),
    p record
        cod          integer,
        naklrnum     like naklr.num,
        naklrdat     like naklr.dat,
        oplmindat    date,
        oplallsumma  decimal(9,2),
        oplallsummad decimal(9,2),
        otgmindat    date,
        otgallkol    decimal(7,2),
        naklrkol     decimal(7,2),
        naklrsumma   decimal(9,2),
        naklrsummad  decimal(9,2),
        klientnam    like klient.nam,
        operacianam  like operacia.nam,
        skladnam     like sklad.nam,
        
        klientphone  like klient.phone_buh,
        prim1       like naklr.prim1,
        tovarnam    like tovar.nam,
        kol         like naklrtov.kol,
        cena        like naklrtov.cena,
        cenad       like naklrtov.cenad
    end record
        
    let str = "select a.naklr_cod, a.num as naklrnum, a.dat as naklrdat, ",
                     "c.mindat as opldat, c.summa, c.summad, ",
                     "d.mindat as otgdat, d.kol, a.kol, a.summa as naklrsumma, ", 
                     "a.summad as naklrsummad, e.nam as klientnam, ",
                     "f.nam as operacianam, g.nam as skladnam, ",
                     "e.phone_buh,a.prim1, k.nam, j.kol, j.cena, j.cenad ",
                 "from _naklrsmk a, ", from_str clipped, " klient e, operacia f, ",
                      "sklad g, naklrtov j, tovar k ",
                 "where a.naklr_cod = c.naklr_cod and ",
                       "a.naklr_cod = d.naklr_cod and ",
                       "a.klient_cod = e.cod and ",
                       "a.operacia_cod = f.cod and ",
                       "a.sklad_cod = g.cod and ",
                       "a.naklr_cod = j.naklr_cod and ",
                       "j.tovar_cod = k.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped, ", naklrnum"
                 #"order by naklrnum"

    prepare p_repnoo from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repnoo cursor for p_repnoo
    let transaction = 1    
    begin work
    start report r_noo
        foreach cur_repnoo into p.*
            output to report r_noo(p.naklrnum, p.naklrdat, p.oplmindat,
                                   p.klientnam, p.klientphone, 
                                   p.prim1, p.tovarnam, p.kol, p.cena, p.cenad,
                                   p.naklrsumma, p.naklrsummad,
                                   p.oplallsumma, p.oplallsummad,
                                   p.operacianam)
        end foreach
    finish report r_noo
    commit work
end function

report r_noo(naklrnum, naklrdat, opldat, klientnam, klientphone,
            prim1, tovarnam, kol, cena, cenad,
            naklrsumma, naklrsummad, oplsumma, oplsummad,
            operacianam)
define	
	naklrnum		like naklr.num,
	naklrdat		like naklr.dat,
	opldat		date,
	klientnam	like klient.nam,
	klientphone like klient.phone_buh,
	tovarnam	like tovar.nam,
	cena		like naklrtov.cena,
	cenad	    like naklrtov.cenad,
	kol		    like schfnrtov.kol,
	prim1		like naklr.prim1,
	naklrsumma	like naklrtov.cena,
	naklrsummad like naklrtov.cenad,
	oplsumma	like naklrtov.cena,
	oplsummad   like naklrtov.cenad,
	operacianam like operacia.nam

output
    report to pipe reppipe
    left margin		8
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"   //  ",vidoff,twicewidthoff
      print passon
      print "========================================================================================================================================"
      print "        |      |                               |  | "
      print "-----------------|          |-----------------------------------------------------------------------------------------------------------"
      print "  N   |      |    |                                      |      |      | -  |     1"
      print "      |          |          |                                                        |          |          |  |"
      print "========================================================================================================================================"
    before group of naklrnum
      print naklrnum using "###### ",naklrdat using "dd/mm/yyyy ", opldat using "dd/mm/yyyy ",klientnam," ", klientphone, " ", operacianam
    on every row
      print column 36, tovarnam, cena using " #######.##", cenad using " #######.##", kol using " -----.-- "
    after group of naklrnum
      print column 35, " : ", naklrsumma - oplsumma using "-------.-- ", column 80,":",group sum(cena * kol) using " #######.##          ",prim1[1,30]
      print column 35, " : ", naklrsummad - oplsummad using "-------.-- ", column 80,":",group sum(cenad * kol) using " #######.##          ",prim1[31,60]
      print "----------------------------------------------------------------------------------------------------------------------------------------"
    on last row
      print column 80,":", sum(cena * kol) using " #######.##"
      print column 80,":", sum(cenad * kol) using " #######.##"
      print "========================================================================================================================================"
      call whatsot()
      print passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report
