globals "globals.4gl"

function operacia_del(operaciacod)
define
    str         char(128),
    operaciacod    like operacia.cod

    whenever error call err

    let str = "execute procedure operacia_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using operaciacod
    commit work
end function

function operacia_sel(operacia_tip, where_str, order_str)
define  
    operacia_tip    smallint,
    p   record
        cod         like operacia.cod,
        nam         like operacia.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam ",
                 "from operacia ",
                 "where p_r = ", operacia_tip, " and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam
    end foreach
    commit work
end function

function operacia_ins(operaciapr, operacianam)
define
    str     	        char(128),
    operaciacod	        like operacia.cod,
    operaciapr          like operacia.p_r,
    operacianam         like operacia.nam
    
    let str = "execute procedure operacia_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using operaciapr, operacianam
        fetch cur_ins into operaciacod
        display operaciacod
    close cur_ins
    commit work
end function

function operacia_upd(operaciacod, operacianam)
define
    str     	char(128),
    operaciacod        like operacia.cod,
    operacianam        like operacia.nam
    
    let str = "execute procedure operacia_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using operaciacod, operacianam
    commit work
end function

function operacia_rep(operaciapr, where_str, order_str, pipe_str)
define  
    operaciapr      smallint,
    p   record
        nam         like operacia.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select nam ",
                  "from operacia ",
                  "where p_r = ", operaciapr, " and ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_operacia
        foreach cur_rep into p.*
            output to report r_operacia(operaciapr, p.nam)
        end foreach
    finish report r_operacia
    commit work
end function

report r_operacia(operaciapr, nam)
define	
    operaciapr  smallint,
    nam         like operacia.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        if operaciapr = 1 then
            print ":"
        else
            print ":"
        end if
        print "================================"
        print "                    "
        print "                        "
        print "--------------------------------"
    on every row
        print nam
    on last row
        print "================================"
end report

