globals "globals.4gl"

function oplnototg_sel(dat1, dat2, order_str)
define  
    dat1        date,
    dat2        date,
    order_str   char(64),
    str         char(2048),
    p   record
        schetcod    integer,
        schfnrtovcod    integer,
        naklnum     like schetfnr.finnaklr_num,
        nakldat     date,
        opldat      date,
        schetnum    like schetfnr.schet_num,
        klientnam   like klient.nam,
        tovarnam    like tovar.nam,
        cena        like schfnrtov.cena,
        kol         like schfnrtov.kol,
        prim1       like schetfnr.prim1,
        cenawpdv    decimal(20,10),
        pdv         decimal(20,10)
    end record
        
    whenever error call err

    let str = "select a.cod, d.cod, a.finnaklr_num, a.finnaklr_dat, b.dat, a.schet_num, ",
                     "c.nam, d.printnam, d.cena, d.kol - otgtovkol(d.cod), a.prim1, ",
                     "cenawithoutpdv(d.tovar_cod, d.cena, a.finnaklr_dat) ",
                "from schetfnr a, _schetoplmaxdat b, klient c, schfnrtov d ",
                "where a.cod = b.schet_cod and ",
                      "a.klient_cod = c.cod and ",
                      "a.cod = d.schetfnr_cod and ",
                      "b.dat between '", dat1, "' and '", dat2, "' and ",
                      "(select x0.summa from _schets x0 where x0.cod = a.cod) <= ",
                      "(select x1.summa from _schetopls x1 where x1.schet_cod = a.cod) and ",
                      "d.kol - otgtovkol(d.cod) > 0 and ",
                      "d.cod not in (select schfnrtov_cod from schfnrtovt) ",
              "union ",
              "select a.cod, e.cod, a.finnaklr_num, a.finnaklr_dat, b.dat, a.schet_num, ",
                     "c.nam, f.nam, e.cena, e.kol - otgtovkol(e.cod), a.prim1, ",
                     "cenawithoutpdv(e.tovar_cod, e.cena, a.finnaklr_dat) ",
                "from schetfnr a, _schetoplmaxdat b, klient c, schfnrtov d, ",
                     "schfnrtovt e, tovar f ",
                "where a.cod = b.schet_cod and ",
                      "a.klient_cod = c.cod and ",
                      "a.cod = d.schetfnr_cod and ",
                      "d.cod = e.schfnrtov_cod and ",
                      "e.tovar_cod = f.cod and ",
                      "b.dat between '", dat1, "' and '", dat2, "' and ",
                      "(select x0.summa from _schets x0 where x0.cod = a.cod) <= ",
                      "(select x1.summa from _schetopls x1 where x1.schet_cod = a.cod) and ",
                      "e.kol - otgtovkol(e.cod) > 0 ",
                "order by ", order_str clipped
    
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        let p.pdv = p.cena - p.cenawpdv
        if p.cena is null       then let p.cena = 0 end if
        if p.kol is null        then let p.kol = 0 end if
        if p.cenawpdv is null   then let p.cenawpdv = 0 end if
        if p.pdv is null        then let p.pdv = 0 end if
        display p.schetcod, "\t",
                p.schfnrtovcod, "\t",
                p.naklnum using "#####", "\t",
                p.nakldat using "ddmmyy", "\t",
                p.opldat using "ddmmyy", "\t",
                p.schetnum using "#####", "\t",
                p.klientnam, "\t",
                p.tovarnam, "\t",
                p.cena using "-------.--", "\t",
                p.kol using "-----.--", "\t",
                p.prim1, "\t",
                p.cenawpdv using "-------.--", "\t",
                p.pdv using "-------.--"
    end foreach
    commit work
end function


function oplnototg_rep(dat1, dat2, order_str, pipe_str)
define  
    dat1        date,
    dat2        date,
    order_str, pipe_str    char(256),
    str         char(2048),
    p   record
        schetcod    integer,
        schfnrtovcod    integer,
        naklnum     like schetfnr.finnaklr_num,
        nakldat     date,
        opldat      date,
        schetnum    like schetfnr.schet_num,
        klientnam   like klient.nam,
        tovarnam    like tovar.nam,
        cena        like schfnrtov.cena,
        kol         like schfnrtov.kol,
        prim1       like schetfnr.prim1,
        cenawpdv    decimal(20,10),
        pdv         decimal(20,10)
    end record
        
    let str = "select a.cod, d.cod, a.finnaklr_num, a.finnaklr_dat, b.dat, a.schet_num, ",
                     "c.nam, d.printnam, d.cena, d.kol - otgtovkol(d.cod), a.prim1, ",
                     "cenawithoutpdv(d.tovar_cod, d.cena, a.finnaklr_dat) ",
                "from schetfnr a, _schetoplmaxdat b, klient c, schfnrtov d ",
                "where a.cod = b.schet_cod and ",
                      "a.klient_cod = c.cod and ",
                      "a.cod = d.schetfnr_cod and ",
                      "b.dat between '", dat1, "' and '", dat2, "' and ",
                      "(select x0.summa from _schets x0 where x0.cod = a.cod) <= ",
                      "(select x1.summa from _schetopls x1 where x1.schet_cod = a.cod) and ",
                      "d.kol - otgtovkol(d.cod) > 0 and ",
                      "d.cod not in (select schfnrtov_cod from schfnrtovt) ",
              "union ",
              "select a.cod, e.cod, a.finnaklr_num, a.finnaklr_dat, b.dat, a.schet_num, ",
                     "c.nam, f.nam, e.cena, e.kol - otgtovkol(e.cod), a.prim1, ",
                     "cenawithoutpdv(e.tovar_cod, e.cena, a.finnaklr_dat) ",
                "from schetfnr a, _schetoplmaxdat b, klient c, schfnrtov d, ",
                     "schfnrtovt e, tovar f ",
                "where a.cod = b.schet_cod and ",
                      "a.klient_cod = c.cod and ",
                      "a.cod = d.schetfnr_cod and ",
                      "d.cod = e.schfnrtov_cod and ",
                      "e.tovar_cod = f.cod and ",
                      "b.dat between '", dat1, "' and '", dat2, "' and ",
                      "(select x0.summa from _schets x0 where x0.cod = a.cod) <= ",
                      "(select x1.summa from _schetopls x1 where x1.schet_cod = a.cod) and ",
                      "e.kol - otgtovkol(e.cod) > 0 ",
                "order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_oplnototg
        foreach cur_rep into p.*
            let p.pdv = p.cena - p.cenawpdv
            output to report r_oplnototg(dat1, dat2, p.naklnum, p.nakldat,
                p.opldat, p.schetnum, p.klientnam, p.tovarnam, p.cena,
                p.kol, p.prim1, p.cenawpdv, p.pdv)
        end foreach
    finish report r_oplnototg
    commit work
end function

report r_oplnototg(dat1, dat2, naklnum, nakldat, opldat, schetnum, klientnam,
	       tovarnam, cena, kol, prim1, cenawpdv, pdv)
define	
	dat1, dat2	date,
	naklnum		like schetfnr.finnaklr_num,
	nakldat		date,
	opldat		date,
	schetnum	like schetfnr.schet_num,
	klientnam	like klient.nam,
	tovarnam	like tovar.nam,
	cena		like schfnrtov.cena,
	kol		    like schfnrtov.kol,
	prim1		like schetfnr.prim1,
	cenawpdv, pdv	like schfnrtov.cena

output
    report to pipe reppipe
#    report to printer
    left margin		8
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"    ",vidoff,twicewidthoff
      print "                      ",vidon,dat1 using "dd/mm/yyyy",vidoff,"",vidon,dat2 using "dd/mm/yyyy",vidoff
      print passon
      print "========================================================================================================================================"
      print "        |      ||  "
      print "-----------------|          |     |-----------------------------------------------------------------------------------------------------"
      print "  N   |      |    ||                                |      | -  |           1 "
      print "      |          |          |     |                                                  |    |  |"
      print "========================================================================================================================================"
    before group of schetnum
      print naklnum using "###### ",nakldat using "dd/mm/yyyy ", opldat using "dd/mm/yyyy ",schetnum using "##### ",klientnam,"        "
    on every row
      print column 36, tovarnam, cenawpdv using " #######.## ", kol using "-----.-- "
    after group of schetnum
      print column 74,"  :",group sum(cena * kol) using " #######.##          ",prim1[1,30]
      print column 72,"  :",group sum(cenawpdv * kol) using " #######.##          ",prim1[31,60]
      print "----------------------------------------------------------------------------------------------------------------------------------------"
    on last row
      print column 74,"  :",sum(cena * kol) using " #######.##"
      print column 72,"  :",sum(cenawpdv * kol) using " #######.##"
      print "========================================================================================================================================"
      call whatsot()
      print passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report
