globals "globals.4gl"

function otgnotopl_sel(dat1, dat2, order_str)
define  
    dat1        date,
    dat2        date,
    order_str   char(64),
    str         char(2048),
    p   record
        schetcod    integer,
        nnaklcod    integer,
        nnaklnum    like nnakl.num,
        nnakldat    like nnakl.dat,
        nnaklsum    like nnakltov.summa,
        klientnam   like klient.nam
    end record
        
    whenever error call err

    let str = "select a.schetfnr_cod, a.cod, a.num, a.dat, a.summa, c.nam ",
	                "from _nnakls a, schetfnr b, klient c ",
	                "where a.dat between '", dat1, "' and '", dat2, "' and ",
	                      "a.schetfnr_cod = b.cod and ",
	                      "b.klient_cod = c.cod and ",
	                      "((select x0.summa from _schets x0 where x0.cod = a.schetfnr_cod) > ",
	                      "(select x1.summa from _schetopls x1 where x1.schet_cod = a.schetfnr_cod) or ",
	                      "not exists (select x1.summa from _schetopls x1 where x1.schet_cod = a.schetfnr_cod)) ",
	                "order by ", order_str clipped
    
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.schetcod, "\t",
                p.nnaklcod, "\t",
                p.nnaklnum using "#####", "\t",
                p.nnakldat using "dd.mm.yyyy", "\t",
                p.nnaklsum using "-------.--", "\t",
                p.klientnam
    end foreach
    commit work
end function

function otgnotopl_rep(dat1, dat2, order_str, pipe_str)
define  
    dat1        date,
    dat2        date,
    order_str, pipe_str    char(256),
    str         char(2048),
    p   record
        schetcod    integer,
        nnaklcod    integer,
        nnaklnum    like nnakl.num,
        nnakldat    like nnakl.dat,
        nnaklsum    like nnakltov.summa,
        klientnam   like klient.nam
    end record
        
    let str = "select a.schetfnr_cod, a.cod, a.num, a.dat, a.summa, c.nam ",
	                "from _nnakls a, schetfnr b, klient c ",
	                "where a.dat between '", dat1, "' and '", dat2, "' and ",
	                      "a.schetfnr_cod = b.cod and ",
	                      "b.klient_cod = c.cod and ",
	                      "(select x0.summa from _schets x0 where x0.cod = a.schetfnr_cod) >= ",
	                      "(select x1.summa from _schetopls x1 where x1.schet_cod = a.schetfnr_cod) ",
	                "order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_otgnotopl
        foreach cur_rep into p.*
            output to report r_otgnotopl(dat1, dat2, p.nnaklnum, p.nnakldat,
                p.nnaklsum, p.klientnam)
        end foreach
    finish report r_otgnotopl
    commit work
end function

report r_otgnotopl(dat1, dat2, nnaklnum, nnakldat, nnaklsum, klientnam) 
define	
	dat1, dat2	    date,
	nnaklnum		like nnakl.num,
	nnakldat		like nnakl.dat,
	nnaklsum        like nnakltov.summa,
	klientnam	    like klient.nam

output
    report to pipe reppipe
#    report to printer
    left margin		8
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
        print twicewidthon,vidon,"    ",vidoff,twicewidthoff
        print "                      ",vidon,dat1 using "dd/mm/yyyy",vidoff,"",vidon,dat2 using "dd/mm/yyyy",vidoff
      print elite
      print "==============================================================================="
      print "         |"
      print "---------------------------|  "
      print "  N   |      |    |"
      print "==============================================================================="
    on every row
      print nnaklnum using "######"," ",nnakldat using "dd/mm/yyyy"," ",nnaklsum using "######.##"," ",klientnam
    on last row
      print "==============================================================================="
      call whatsot()
      print passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report
