globals "globals.4gl"

function postpol_del(postpolcod)
define
    str         char(128),
    postpolcod      like klient.cod

    whenever error call err

    let str = "execute procedure postpol_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using postpolcod
    commit work
end function

function postpolone_sel(postpolcod)
define  
    postpolcod   integer,
    p   record
        lgotacod    integer,
        gorodcod    integer,
        pgorodcod    integer,
        sotcod      integer,
        nam         like klient.nam,
        balans      like klient.balans,
        urlico      like klient.urlico,
        nds         like klient.nds,
        post        like klient.post,
        datreg      like klient.datreg,
        lgotanam    like lgota.nam,
        lgotaproc   like lgota.proc,
        numcard     like klient.numcard,
        gorodnam    like gorod.nam,
        phonecod    like gorod.phone_cod,
        index       like klient.index,
        ulica       like klient.ulica,
        dom         like klient.dom,
        kv          like klient.kv,
        pgorodnam    like gorod.nam,
        pphonecod    like gorod.phone_cod,
        pindex       like klient.pindex,
        pulica       like klient.pulica,
        pdom         like klient.pdom,
        pkv          like klient.pkv,
        phoneboss   like klient.phone_boss,
        phonebuh    like klient.phone_buh,
        phoneo      like klient.phone_o,
        fax         like klient.fax,
        email       like klient.email,
        bossf       like klient.boss_f,
        bossi       like klient.boss_i,
        bosso       like klient.boss_o,
        bossi2      like klient.boss_i2,
        bosso2      like klient.boss_o2,
        bossi3      like klient.boss_i3,
        bosso3      like klient.boss_o3,
        bossborn    like klient.boss_born,
        bosssex     like klient.boss_sex,
        contfio     like klient.cont_fio,
        contdol     like klient.cont_dol,
        contpr      like klient.cont_p_r,
        contpd      like klient.cont_p_d,
        zkpo        like klient.zkpo,
        inn         like klient.inn,
        ns          like klient.ns,
        banknam     like klient.bank_nam,
        bankmfo     like klient.bank_mfo,
        bankschet   like klient.bank_schet,
        sotfio      like klient.nam,
        prim        like klient.prim
    end record
    
    initialize p to null
    let transaction = 1    
    begin work
    select  b.cod, c.cod, e.cod, d.cod, 
            a.nam, a.balans, a.urlico, a.nds, a.post, a.datreg,
            b.nam, b.proc, a.numcard, 
            c.nam, c.phone_cod, a.index, a.ulica, a.dom, a.kv, 
            e.nam, e.phone_cod, a.pindex, a.pulica, a.pdom, a.pkv, 
            a.phone_boss, a.phone_buh, a.phone_o, a.fax, a.email, 
            a.boss_f, a.boss_i, a.boss_o, a.boss_i2, a.boss_o2, 
            a.boss_i3, a.boss_o3,
            a.boss_born, a.boss_sex, a.cont_fio, a.cont_dol,
            a.cont_p_r, a.cont_p_d, a.zkpo, a.inn, a.ns,
            a.bank_nam, a.bank_mfo, a.bank_schet, d.fio, a.prim
        into p.*
        from _postpol a, gorod c, outer lgota b, outer _sot d, gorod e
        where a.lgota_cod = b.cod and
              a.gorod_cod = c.cod and
              a.sot_cod = d.cod and
              a.pgorod_cod = e.cod and
              a.cod = postpolcod
    commit work
    
    display p.lgotacod, "\t",
        p.gorodcod, "\t",
        p.pgorodcod, "\t",
        p.sotcod, "\t",
        p.nam, "\t",
        p.balans using "#######.##", "\t",
        p.urlico, "\t",
        p.nds, "\t",
        p.post, "\t",
        p.datreg using "dd.mm.yyyy", "\t",
        p.lgotanam, "\t",
        p.lgotaproc, "\t",
        p.numcard, "\t",
        p.gorodnam, "\t",
        p.phonecod, "\t",
        p.index, "\t",
        p.ulica, "\t",
        p.dom, "\t",
        p.kv, "\t",
        p.pgorodnam, "\t",
        p.pphonecod, "\t",
        p.pindex, "\t",
        p.pulica, "\t",
        p.pdom, "\t",
        p.pkv, "\t",
        p.phoneboss, "\t",
        p.phonebuh, "\t",
        p.phoneo, "\t",
        p.fax, "\t",
        p.email, "\t",
        p.bossf, "\t",
        p.bossi, "\t",
        p.bosso, "\t",
        p.bossi2, "\t",
        p.bosso2, "\t",
        p.bossi3, "\t",
        p.bosso3, "\t",
        p.bossborn using "dd.mm.yyyy", "\t",
        p.bosssex, "\t",
        p.contfio, "\t",
        p.contdol, "\t",
        p.contpr, "\t",
        p.contpd, "\t",
        p.zkpo, "\t",
        p.inn, "\t",
        p.ns, "\t",
        p.banknam, "\t",
        p.bankmfo, "\t",
        p.bankschet, "\t",
        p.sotfio, "\t",
        p.prim
end function

function postpolmany_sel(where_str, order_str)
define  
    postpolcod   integer,
    p   record
        postpolcod      like klient.cod,
        nam         like klient.nam
    end record,
    str         char(2048),
    where_str   char(1024),
    order_str   char(64),
    lgotastr    char(20),
    _sotstr     char(20),
    flg         smallint
    
    let flg = grep(where_str,"and b.")
    if flg = 1 
        then 
            let lgotastr = " lgota b"
            let flg = grep(where_str,"and b.nam is null")
            if flg = 1 then
                let lgotastr = " outer lgota b"
                let where_str = where_str clipped," and a.lgota_cod is null"
            end if
        else let lgotastr = " outer lgota b"
    end if
    
    let flg = grep(where_str,"and d.")
    if flg = 1 
        then 
            let _sotstr = " _sot d"
            let flg = grep(where_str,"and d.fio is null")
            if flg = 1 then
                let _sotstr = " outer _sot d"
                let where_str = where_str clipped," and a.sot_cod is null"
            end if
        else let _sotstr = " outer _sot d"
    end if
    
    let str = "select a.cod, a.nam ",
                 "from _postpol a, gorod c,", lgotastr clipped, "," ,_sotstr clipped, " ",
                 "where a.gorod_cod = c.cod and a.lgota_cod = b.cod and a.sot_cod = d.cod and ", where_str clipped,
                 " order by ", order_str clipped
    
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.postpolcod, "\t", p.nam
    end foreach
    commit work
end function

function postpol_ins(nam, balans, urlico, nds, post, datreg, lgotacod, numcard,
                    gorodcod, index, ulica, dom, kv, 
                    pgorodcod, pindex, pulica, pdom, pkv, 
                    phoneboss, phonebuh, 
                    phoneo, fax, email, bossf, bossi, bosso, bossi2, bosso2,
                    bossi3, bosso3, bossborn, bosssex,
                    contfio, contdol, contpr, contpd, zkpo, inn, ns,
                    banknam, bankmfo, bankschet, sotcod, prim)
define
    str         char(128),
    postpolcod      integer,
    
    nam         like klient.nam,
    balans      like klient.balans,
    urlico      like klient.urlico,
    nds         like klient.nds,
    post        like klient.post,
    datreg      char(10),
    datregd     date,
    lgotacod    integer,
    numcard     like klient.numcard,
    gorodcod    integer,
    index       like klient.index,
    ulica       like klient.ulica,
    dom         like klient.dom,
    kv          like klient.kv,
    pgorodcod    integer,
    pindex       like klient.pindex,
    pulica       like klient.pulica,
    pdom         like klient.pdom,
    pkv          like klient.pkv,
    phoneboss   like klient.phone_boss,
    phonebuh    like klient.phone_buh,
    phoneo      like klient.phone_o,
    fax         like klient.fax,
    email       like klient.email,
    bossf       like klient.boss_f,
    bossi       like klient.boss_i,
    bosso       like klient.boss_o,
    bossi2      like klient.boss_i2,
    bosso2      like klient.boss_o2,
    bossi3      like klient.boss_i3,
    bosso3      like klient.boss_o3,
    bossborn    char(10),
    bossbornd   date,
    bosssex     like klient.boss_sex,
    contfio     like klient.cont_fio,
    contdol     like klient.cont_dol,
    contpr      like klient.cont_p_r,
    contpd      like klient.cont_p_d,
    zkpo        like klient.zkpo,
    inn         like klient.inn,
    ns          like klient.ns,
    banknam     like klient.bank_nam,
    bankmfo     like klient.bank_mfo,
    bankschet   like klient.bank_schet,
    sotcod      integer,
    prim        like klient.prim
    
    let datregd = date(datreg)
    let bossbornd = date(bossborn)
    
    let str = "execute procedure postpol_ins(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using nam, balans, urlico, nds, post, datregd, lgotacod, numcard,
                    gorodcod, index, ulica, dom, kv, 
                    pgorodcod, pindex, pulica, pdom, pkv, 
                    phoneboss, phonebuh, 
                    phoneo, fax, email, bossf, bossi, bosso, bossi2, bosso2,
                    bossi3, bosso3, bossbornd, bosssex,
                    contfio, contdol, contpr, contpd, zkpo, inn, ns,
                    banknam, bankmfo, bankschet, sotcod, prim
        fetch cur_ins into postpolcod
        display postpolcod
    close cur_ins
    commit work
end function

function postpol_upd(postpolcod, 
                    nam, balans, urlico, nds, post, datreg, lgotacod, numcard,
                    gorodcod, index, ulica, dom, kv, 
                    pgorodcod, pindex, pulica, pdom, pkv, 
                    phoneboss, phonebuh, 
                    phoneo, fax, email, bossf, bossi, bosso, bossi2, bosso2,
                    bossi3, bosso3, bossborn, bosssex,
                    contfio, contdol, contpr, contpd, zkpo, inn, ns,
                    banknam, bankmfo, bankschet, sotcod, prim)
define
    str     	char(128),
    postpolcod      integer,
    
    nam         like klient.nam,
    balans      like klient.balans,
    urlico      like klient.urlico,
    nds         like klient.nds,
    post        like klient.post,
    datreg      char(10),
    datregd     date,
    lgotacod    integer,
    numcard     like klient.numcard,
    gorodcod    integer,
    index       like klient.index,
    ulica       like klient.ulica,
    dom         like klient.dom,
    kv          like klient.kv,
    pgorodcod    integer,
    pindex       like klient.pindex,
    pulica       like klient.pulica,
    pdom         like klient.pdom,
    pkv          like klient.pkv,
    phoneboss   like klient.phone_boss,
    phonebuh    like klient.phone_buh,
    phoneo      like klient.phone_o,
    fax         like klient.fax,
    email       like klient.email,
    bossf       like klient.boss_f,
    bossi       like klient.boss_i,
    bosso       like klient.boss_o,
    bossi2      like klient.boss_i2,
    bosso2      like klient.boss_o2,
    bossi3      like klient.boss_i3,
    bosso3      like klient.boss_o3,
    bossborn    char(10),
    bossbornd   date,
    bosssex     like klient.boss_sex,
    contfio     like klient.cont_fio,
    contdol     like klient.cont_dol,
    contpr      like klient.cont_p_r,
    contpd      like klient.cont_p_d,
    zkpo        like klient.zkpo,
    inn         like klient.inn,
    ns          like klient.ns,
    banknam     like klient.bank_nam,
    bankmfo     like klient.bank_mfo,
    bankschet   like klient.bank_schet,
    sotcod      integer,
    prim        like klient.prim
    
    let datregd = date(datreg)
    let bossbornd = date(bossborn)
    
    let str = "execute procedure postpol_upd(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using postpolcod, 
                    nam, balans, urlico, nds, post, datregd, lgotacod, numcard,
                    gorodcod, index, ulica, dom, kv, 
                    pgorodcod, pindex, pulica, pdom, pkv, 
                    phoneboss, phonebuh, 
                    phoneo, fax, email, bossf, bossi, bosso, bossi2, bosso2,
                    bossi3, bosso3, bossbornd, bosssex,
                    contfio, contdol, contpr, contpd, zkpo, inn, ns,
                    banknam, bankmfo, bankschet, sotcod, prim
    commit work
end function

function postpol_rep(where_str, order_str, pipe_str)
define  
    p   record
        nam         like klient.nam,
        urlico      like klient.urlico,
        nds         like klient.nds,
        post        like klient.post,
        datreg      like klient.datreg,
        lgotanam    like lgota.nam,
        lgotaproc   like lgota.proc,
        numcard     like klient.numcard,
        gorodnam    like gorod.nam,
        phonecod    like gorod.phone_cod,
        index       like klient.index,
        ulica       like klient.ulica,
        dom         like klient.dom,
        kv          like klient.kv,
        pgorodnam    like gorod.nam,
        pphonecod    like gorod.phone_cod,
        pindex       like klient.pindex,
        pulica       like klient.pulica,
        pdom         like klient.pdom,
        pkv          like klient.pkv,
        phoneboss   like klient.phone_boss,
        phonebuh    like klient.phone_buh,
        phoneo      like klient.phone_o,
        fax         like klient.fax,
        email       like klient.email,
        bossf       like klient.boss_f,
        bossi       like klient.boss_i,
        bosso       like klient.boss_o,
        bossborn    like klient.boss_born,
        bosssex     like klient.boss_sex,
        contfio     like klient.cont_fio,
        contdol     like klient.cont_dol,
        contpr      like klient.cont_p_r,
        contpd      like klient.cont_p_d,
        zkpo        like klient.zkpo,
        inn         like klient.inn,
        ns          like klient.ns,
        banknam     like klient.bank_nam,
        bankmfo     like klient.bank_mfo,
        bankschet   like klient.bank_schet,
        sotfio      like klient.nam,
        prim        like klient.prim
    end record,
    str         char(2048),
    where_str   char(1024),
    order_str   char(64),
    pipe_str    char(256)
    
    
    initialize p to null
    
    let str ="select a.nam, a.urlico, a.nds, a.post, a.datreg, b.nam, ",
                     "b.proc, a.numcard, ",
                     "c.nam, c.phone_cod, a.index, a.ulica, a.dom, a.kv, ",
                     "e.nam, e.phone_cod, a.pindex, a.pulica, a.pdom, a.pkv, ",
                     "a.phone_boss, a.phone_buh, a.phone_o, ",
                     "a.fax, a.email, a.boss_fio, a.boss_born, a.boss_sex, ",
                     "a.cont_fio, a.cont_dol, a.cont_p_r, a.cont_p_d, a.zkpo, ",
                     "a.inn, a.ns, a.bank_nam, a.bank_mfo, a.bank_schet, ",
                     "d.fio, a.prim ",
        "from _postpol a, gorod c, outer lgota b, outer _sot d, gorod e ",
        "where a.lgota_cod = b.cod and ",
              "a.gorod_cod = c.cod and ",
              "a.sot_cod = d.cod and ", 
              "a.pgorod_cod = e.cod and ",
              where_str clipped,
        " order by ", order_str clipped
    
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_postpol
        foreach cur_rep into p.*
            output to report r_postpol(p.nam, p.urlico, p.nds, p.post, 
                        p.datreg, p.lgotanam, p.lgotaproc, p.numcard, 
                        p.gorodnam, p.phonecod, p.index, p.ulica, p.dom, p.kv, 
                        p.pgorodnam, p.pphonecod, p.pindex, p.pulica, p.pdom, p.pkv, 
                        p.phoneboss, p.phonebuh, p.phoneo, p.fax, p.email, 
                        p.bossf, p.bossi, p.bosso, p.bossborn, p.bosssex, p.contfio, 
                        p.contdol, p.contpr, p.contpd, p.zkpo, p.inn, 
                        p.ns, p.banknam, p.bankmfo, p.bankschet, 
                        p.sotfio, p.prim)
        end foreach
    finish report r_postpol
    commit work
end function

report r_proba(str)
define str  char(2048)

output
    report to "1.rep"
    
format
    on every row
        print str

end report    

report r_postpol( nam,  urlico,  nds,  post, 
                  datreg,  lgotanam,  lgotaproc,  numcard,  
                  gorodnam, phonecod,  index,  ulica,  dom,  kv,
                  pgorodnam, pphonecod,  pindex,  pulica,  pdom,  pkv,
                  phoneboss,  phonebuh,  phoneo,  fax, email, 
                  bossf, bossi, bosso, bossborn,  bosssex,  contfio, 
                  contdol,  contpr,  contpd,  zkpo,  inn, 
                  ns,  banknam,  bankmfo,  bankschet, 
                  sotfio,  prim)
define	
        nam         like klient.nam,
        urlico      like klient.urlico,
        nds         like klient.nds,
        post        like klient.post,
        datreg      like klient.datreg,
        lgotanam    like lgota.nam,
        lgotaproc   like lgota.proc,
        numcard     like klient.numcard,
        gorodnam    like gorod.nam,
        phonecod    like gorod.phone_cod,
        index       like klient.index,
        ulica       like klient.ulica,
        dom         like klient.dom,
        kv          like klient.kv,
        pgorodnam    like gorod.nam,
        pphonecod    like gorod.phone_cod,
        pindex       like klient.index,
        pulica       like klient.ulica,
        pdom         like klient.dom,
        pkv          like klient.kv,
        phoneboss   like klient.phone_boss,
        phonebuh    like klient.phone_buh,
        phoneo      like klient.phone_o,
        fax         like klient.fax,
        email       like klient.email,
        bossf       like klient.boss_f,
        bossi       like klient.boss_i,
        bosso       like klient.boss_o,
        bossborn    like klient.boss_born,
        bosssex     like klient.boss_sex,
        contfio     like klient.cont_fio,
        contdol     like klient.cont_dol,
        contpr      like klient.cont_p_r,
        contpd      like klient.cont_p_d,
        zkpo        like klient.zkpo,
        inn         like klient.inn,
        ns          like klient.ns,
        banknam     like klient.bank_nam,
        bankmfo     like klient.bank_mfo,
        bankschet   like klient.bank_schet,
        sotfio      like klient.nam,
        prim        like klient.prim

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "=============================================================================="
        print "                            .    ."
        print "                                  "
        print "  .:                .    "
        print "                                                        "
        print "  .:                .    "
        print "                                                        "
        print "    :"
        print "                 e-mail"
        print "    :                                       "
        print "     : "
        print "                                          .   ."
        print "         .N        N ."
        print "    :                                          "
        print "    "
        print "    "
        print "=============================================================================="
    on every row
        print nam,"  ", urlico, "   ", nds, "   ", post, "   ", datreg
        print "    ", lgotanam, " ", lgotaproc, "      ", numcard
        print "    ", gorodnam, " ", phonecod, " ", index
        print "    ", ulica, " ", dom, " ", kv, " "
        print "    ", pgorodnam, " ", pphonecod, " ", pindex
        print "    ", pulica, " ", pdom, " ", pkv, " "
        print "    ", phoneboss, " ", phonebuh, " ", phoneo, " ", fax, " ", email
        print "    ", bossf clipped," ", bossi clipped, " ", bosso clipped, " ", bossborn, "    ", bosssex
        print "    ", contfio
        print "    ", contdol, " ", contpr, " ", contpd
        print "    ", zkpo, " ", inn, " ", ns
        print "    ", banknam, " ", bankmfo, " ", bankschet
        print "    ", sotfio
        print "    ", prim
        print "------------------------------------------------------------------------------"
    on last row
        print "=============================================================================="
end report

function klientlg_he(heklientnam)
define
    str     	                char(128),
    klientcod, lgotacod         like klient.cod,
    klientnam, heklientnam      like klient.nam,
    lgotanam                    like lgota.nam,
    lgotaproc                   like lgota.proc,
    ret                         smallint,
    sep                         char(1)
    
    let sep = ascii 3
    let str = "execute procedure klientlg_he(?)"
    prepare p_he from str
    declare cur_he cursor for p_he
    
    initialize klientcod, klientnam, lgotacod, lgotanam, lgotaproc to null
    let transaction = 1
    begin work
    open cur_he using heklientnam
        while (TRUE)
            fetch cur_he into klientcod, klientnam, lgotacod, lgotanam, lgotaproc, ret
            if status = notfound then exit while end if
            display klientcod, "\t", klientnam, sep, lgotacod, sep, lgotanam, sep, lgotaproc using "---.--", "\t", ret
        end while
    close cur_he
    commit work
end function

function klientbalans(klientcod)
define  klientcod   integer,
        balans      decimal(9,2),
        str         char(256)

    let str = "execute procedure klientbalans(?)"
    prepare p_balans from str
    declare cur_balans cursor for p_balans
    let transaction = 1
    begin work
    open cur_balans using klientcod
        fetch cur_balans into balans
        display balans using "-------.--"
    close cur_balans
    commit work        
end function

function postpol_globper(fromcod, tocod)
define  fromcod, tocod  integer

    let transaction = 1
    begin work
        update schetfnr
            set klient_cod = tocod
            where klient_cod = fromcod
        update naklr
            set klient_cod = tocod
            where klient_cod = fromcod
        update naklp
            set klient_cod = tocod
            where klient_cod = fromcod
        delete from klient where cod = fromcod
    commit work        
end function
