globals "globals.4gl"

function pricepost_sel()
define  
    p   record
        cod         integer,
        nam         like klient.nam,
        kurs        like pricepost.kurs
    end record,
    str         char(256)
    
    let str = "select a.cod, a.nam, b.kurs ",
                 "from klient a, outer pricepost b ",
                 "where a.cod = b.post_cod and ",
                       "a.post = '*' ",
                 " order by a.nam"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", 
                p.nam, "\t", 
                p.kurs
    end foreach
    commit work
end function

function pricepost_write(postcod, kurss)
define  
    postcod     integer,
    kurss       like pricepost.kurs
    
    let transaction = 1    
    begin work
        delete from pricepost where post_cod = postcod
        insert into pricepost values(postcod, kurss)
    commit work
end function

function pricetov_sel()
define  
    p   record
        tovar_cod   integer,
        post_cod    integer,
        tovar_nam   like tovar.nam,
        ei_nam      like ei.nam,
        cenap       decimal(9,2),
        nacenka     like pricetov.nacenka,
        nacenkap    decimal(5,2),
        cenaprod    decimal(7,2),
        post_nam    like klient.nam,
        kurs        like pricepost.kurs,
        tovartip_nam    like tovartip.nam
    end record,
    str         char(512),
    oldtovartipnam         like tovartip.nam
    
    let str = "select a.cod, d.cod, a.nam, a1.nam, c.cena, c.nacenka, nulldecimal(), ",
                     "nulldecimal(), d.nam, e.kurs, b.nam ",
                 "from tovar a, ei a1, tovartip b, outer (pricetov c, klient d, pricepost e) ",
                 "where a.tovartip_cod = b.cod and ",
                       "a.ispricelist = '*' and ",
                       "a.ei_cod = a1.cod and ",
                       "a.cod = c.tovar_cod and ",
                       "c.post_cod = d.cod and ",
                       "c.post_cod = e.post_cod ",
                 " order by b.nam, a.nam"
    prepare p_sel2 from str
    
    initialize p to null
    declare cur_sel2 cursor for p_sel2
    let transaction = 1    
    begin work
    foreach cur_sel2 into p.*
        if oldtovartipnam != p.tovartip_nam then
            display "-1\t", 
                    " \t",
                    p.tovartip_nam, "\t", 
                    " \t", 
                    " \t", 
                    " \t", 
                    " \t", 
                    " \t", 
                    " "
        end if
        if p.kurs is not null and p.cenap is not null and p.nacenka is not null then
            let p.nacenkap = p.nacenka * 100 / p.cenap
            let p.cenaprod = (p.cenap + p.nacenka) * p.kurs
        end if
        display p.tovar_cod, "\t", 
                p.post_cod, "\t",
                p.tovar_nam, "\t", 
                p.ei_nam, "\t", 
                p.cenap, "\t", 
                p.nacenka, "\t", 
                p.nacenkap using "###.##", "\t", 
                p.cenaprod using "#####.##", "\t", 
                p.post_nam
        let oldtovartipnam = p.tovartip_nam
    end foreach
    commit work
end function

function pricetov_write(tovarcod, cenaa, nacenkaa, cenap, postcod)
define  
    tovarcod    integer,
    cenaa       decimal(9,2),
    nacenkaa    decimal(7,2),
    cenap       decimal(9,2),
    postcod     integer
    
    let transaction = 1    
    begin work
        delete from pricetov where tovar_cod = tovarcod
        update tovar set(cena) = (cenap) where cod = tovarcod
        insert into pricetov values(tovarcod, cenaa, nacenkaa, postcod)
    commit work
end function
