globals "globals.4gl"

function prodaga_sel(dat1, dat2, order_str)
define  
    dat1        date,
    dat2        date,
    order_str   char(64),
    str         char(2048),
    p   record
        schetcod    integer,
        schfnrtovcod    integer,
        naklnum	    like schetfnr.finnaklr_num,
	    nakldat	    date,
	    opldat	    date,
	    schetnum	like schetfnr.schet_num,
	    zkpo        like klient.zkpo,
	    klientnam	like klient.nam,
	    tovarnam	like tovar.nam,
	    isnds       like tovar.isnds,
	    kolprod	    like finoperr.kol,
	    kolspis     like finoperr.kol,
	    kolspiss    like finoperr.kol,
	    cenaprod	like finoperr.cena,
	    cenapost	like finoperr.cena,
	    cenaprodwpdv decimal(20,10),
	    cenaprodpdv  decimal(20,10),
	    nacenka     decimal(20,10)
    end record
        
    whenever error call err

    let str = "select a.cod, c.cod, a.finnaklr_num, a.finnaklr_dat, ",
                     "(select x0.dat from _schetoplmaxdat x0 where x0.schet_cod = a.cod), ",
                     "a.schet_num, b.zkpo, b.nam, c.printnam, f.isnds, c.kol, sum(d.kol), ",
                     "(select sum(x0.kol) from finoperr x0 where x0.doc_cod = c.cod), ",
                     "c.cena, e.cena ",
                "from schetfnr a, klient b, schfnrtov c, outer (finoperr d, outer (finoperp e, tovar f)) ",
                "where a.finnaklr_dat between '", dat1, "' and '", dat2, "' and ",
                      "a.finnaklr_num > 0 and ",
                      "a.klient_cod = b.cod and ",
                      "a.cod = c.schetfnr_cod and ",
                      "c.cod = d.doc_cod and ",
                      "d.finoperp_cod = e.cod and ",
                      "e.tovar_cod = f.cod ",
                "group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14, 15 ",
                "order by ", order_str clipped
    
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.isnds = "*" then
            call funpdv(p.nakldat, p.cenaprod) 
                returning p.cenaprodwpdv, p.cenaprodpdv
        end if
        if p.kolspis is null then let p.kolspis = 0 end if
        if p.kolspiss is null then let p.kolspiss = 0 end if
        if p.cenapost is null then let p.cenapost = 0 end if
        if p.cenaprodwpdv is null then let p.cenaprodwpdv = 0 end if
        if p.cenaprodpdv is null then let p.cenaprodpdv = 0 end if
        if p.cenaprodwpdv = 0 then let p.cenaprodwpdv = p.cenaprod end if
        if p.kolprod = p.kolspiss then
            let p.nacenka = p.kolspis * (p.cenaprodwpdv - p.cenapost)
        else
            let p.nacenka = 0
        end if
        display p.schetcod, "\t",
                p.schfnrtovcod, "\t",
                p.naklnum using "#####", "\t",
                p.nakldat using "ddmmyy", "\t",
                p.opldat using "ddmmyy", "\t",
                p.schetnum using "#####", "\t",
                p.zkpo, "\t",
                p.klientnam, "\t",
                p.tovarnam, "\t",
                p.cenaprod using "-------.--", "\t",
                p.cenaprodwpdv using "-------.--", "\t",
                p.kolprod using "-----.--", "\t",
                p.cenapost using "-------.--", "\t",
                p.kolspis using "-----.--", "\t",
                p.kolspiss using "-----.--", "\t",
                p.nacenka using "-------.--"
        initialize p to null
    end foreach
    commit work
end function


function prodaga_rep(dat1, dat2, order_str, pipe_str)
define  
    dat1        date,
    dat2        date,
    order_str, pipe_str    char(256),
    str         char(2048),
    p   record
        schetcod    integer,
        schfnrtovcod    integer,
        naklnum	    like schetfnr.finnaklr_num,
	    nakldat	    date,
	    opldat	    date,
	    schetnum	like schetfnr.schet_num,
	    zkpo        like klient.zkpo,
	    klientnam	like klient.nam,
	    tovarnam	like tovar.nam,
	    isnds       like tovar.isnds,
	    kolprod	    like finoperr.kol,
	    kolspis     like finoperr.kol,
	    kolspiss    like finoperr.kol,
	    cenaprod	like finoperr.cena,
	    cenapost	like finoperr.cena,
	    cenaprodwpdv decimal(20,10),
	    cenaprodpdv  decimal(20,10),
	    nacenka     decimal(20,10)
    end record,
    oldschfnrtovcod, flg integer
        
    let str = "select a.cod, c.cod, a.finnaklr_num, a.finnaklr_dat, ",
                     "(select x0.dat from _schetoplmaxdat x0 where x0.schet_cod = a.cod), ",
                     "a.schet_num, b.zkpo, b.nam, c.printnam, f.isnds, c.kol, sum(d.kol), ",
                     "(select sum(x0.kol) from finoperr x0 where x0.doc_cod = c.cod), ",
                     "c.cena, e.cena ",
                "from schetfnr a, klient b, schfnrtov c, outer (finoperr d, outer (finoperp e, tovar f)) ",
                "where a.finnaklr_dat between '", dat1, "' and '", dat2, "' and ",
                      "a.finnaklr_num > 0 and ",
                      "a.klient_cod = b.cod and ",
                      "a.cod = c.schetfnr_cod and ",
                      "c.cod = d.doc_cod and ",
                      "d.finoperp_cod = e.cod and ",
                      "e.tovar_cod = f.cod ",
                "group by 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14, 15 ",
                "order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    let oldschfnrtovcod = 0
    start report r_prodaga
        foreach cur_rep into p.*
            if p.isnds = "*" then
                call funpdv(p.nakldat, p.cenaprod) 
                    returning p.cenaprodwpdv, p.cenaprodpdv
            end if
            if p.kolspis is null then let p.kolspis = 0 end if
            if p.kolspiss is null then let p.kolspiss = 0 end if
            if p.cenapost is null then let p.cenapost = 0 end if
            if p.cenaprodwpdv is null then let p.cenaprodwpdv = 0 end if
            if p.cenaprodpdv is null then let p.cenaprodpdv = 0 end if
            if p.cenaprodwpdv = 0 then let p.cenaprodwpdv = p.cenaprod end if
            if p.kolprod = p.kolspiss then
                let p.nacenka = p.kolspis * (p.cenaprodwpdv - p.cenapost)
            else
                let p.nacenka = 0
            end if
            if oldschfnrtovcod != p.schfnrtovcod then
                let flg = 1
            else
                let flg = 0
                let p.kolprod = 0
                let p.cenaprod = 0
                let p.cenaprodwpdv = 0
            end if
            output to report r_prodaga(dat1, dat2, p.naklnum, p.nakldat,
                p.opldat, p.schetnum, p.zkpo, p.klientnam, p.tovarnam, p.isnds,
                p.cenaprod, p.kolprod, p.cenapost, p.kolspis, p.nacenka,
                flg, p.cenaprodwpdv, p.kolspiss, p.schfnrtovcod,
                p.schetcod )
            let oldschfnrtovcod = p.schfnrtovcod
            initialize p to null
        end foreach
    finish report r_prodaga
    commit work
end function

report r_prodaga(dat1, dat2, naklnum, nakldat, opldat, schetnum, zkpo, klientnam, 
	       tovarnam, isnds, cenaprod, kolprod, cenapost, kolspis, nacenka,
	       flg, cenaprodwnds, kolspiss, schfnrtovcod, schetcod
	      )
define	
	dat1, dat2	date,
	naklnum		like schetfnr.finnaklr_num,
	nakldat		date,
	opldat		date,
	schetnum	like schetfnr.schet_num,
	zkpo        like klient.zkpo,
	klientnam	like klient.nam,
	tovarnam	like tovar.nam,
	isnds       like tovar.isnds,
	cenaprod	decimal(20,10),
	kolprod		decimal(7,2),
	cenapost	decimal(20,10),
	kolspis		decimal(7,2),
	nacenka		decimal(20,10),
	flg     	smallint,
	cenaprodwnds	decimal(20,10),
	kolspiss	decimal(7,2),
	schfnrtovcod, schetcod     integer

output
    report to pipe reppipe
#    report to printer
    left margin		8
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"            ",vidoff,twicewidthoff
      print "                      ",vidon,dat1 using "dd/mm/yyyy",vidoff,"",vidon,dat2 using "dd/mm/yyyy",vidoff
      print passon
      print "========================================================================================================================================="
      print "        |      ||    |  "
      print "-----------------|          |     |------------------------------------------------------------------------------------------------------"
      print "  N   |      |    ||                                | .| -  | .| -  | "
      print "      |          |          |     |                                                  |    |  |    |  |"
      print "========================================================================================================================================="
    before group of schetcod
      print naklnum using "######|",nakldat using "dd/mm/yyyy|", opldat using "dd/mm/yyyy","|",schetnum using "#####|",passoff,vidon,zkpo, " ", klientnam,vidoff,passon
    before group of schfnrtovcod
      print "      |          |          |     |", tovarnam;
    on every row
      if flg = 1 
      then
        print cenaprodwnds using " -------.--","|", kolprod using "-----.--","|", cenapost using "-------.--","|", kolspis using "-----.--","|", nacenka using "-------.--"
      else
        print "      |          |          |     |                                                             |        |",cenapost using "-------.--","|", kolspis using "-----.--","|", nacenka using "-------.--"
      end if
    after group of schfnrtovcod
      if kolspiss < group sum(kolprod) 
      then 
        print "      |          |          |     |:",tovarnam,"   : ", group sum(kolprod) - group sum(kolspis) using "-----.--","|"
      end if
    after group of schetcod
      print "      |          |          |     |                                        :", underlineon, group sum(cenaprod * kolspiss) using " -------.--",underlineoff,"|        |          |        |"
      if group sum(kolspis) = group sum(kolprod) then
        print "      |          |          |     |                                      :", 
              group sum(cenaprodwnds * kolspiss) using " -------.--",
              "|        |", underlineon,
              group sum(cenapost * kolspis) using "-------.--",underlineoff,
              "|        |", underlineon, 
              group sum(cenaprodwnds * kolspiss) - group sum(cenapost * kolspis) using "-------.--",underlineoff
      else
        print "      |          |          |     |                                      :", group sum(cenaprodwnds * kolspiss) using " -------.--","|        |", underlineon,group sum(cenapost * kolspis) using "-------.--",underlineoff,"|        |"
      end if
      print "-----------------------------------------------------------------------------------------------------------------------------------------"
    on last row
      print "========================================================================================================================================="
      call whatsot()
      print passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report
