globals "globals.4gl"

# tip = 's'  
# tip = 'S'     
# tip = 'n'  
function prodagamat_sel(tip, where_str, order_str)
define  
    tip         char(1),
    order_str   char(64),
    where_str   char(1024),
    str         char(3048),
    p   record
        cod         integer,
        num         smallint,
        dat         date,
        klientnam   like klient.nam,
        prods       decimal(9,2),
        prodsd      decimal(9,2),
        poks        decimal(9,2),
        poksd       decimal(9,2),
        kurs_p      like valuta.kurs_p,
        kurs_r      like valuta.kurs_p,
        nacenkas    decimal(9,2),
        nacenkasd   decimal(9,2)
    end record
        
    whenever error call err

    if tip = 'n' then
        let str = "select a.cod, a.num, a.dat, b.nam, ",
                         "sum(c.kol * c.cena), sum(c.kol * c.cenad), ",
                         "sum(c.kol * d.cena), sum(c.kol * d.cenad), ",
                         "kurs_prihoda(c.datotg), kurs_izr(c.datotg) ",
                    "from _naklrms2 a, klient b, naklrtov b1, matoperr c, ",
                         "matoperp d, operacia e ",
                    "where a.klient_cod = b.cod and ",
                          "a.cod = b1.naklr_cod and ",
                          "b1.cod = c.doc_cod and ",
                          "c.matoperp_cod = d.cod and ",
                          "c.datotg is not null and ",
                          "a.operacia_cod = e.cod and ",
                          where_str clipped, " ",
                    "group by 1, 2, 3, 4, 9, 10 ",
                    "order by ", order_str clipped
    end if
    if tip = 's' then
        let str = "select a.cod, a.num, a.dat, b.nam, ",
                         "sum(c.kol * c.cena), sum(c.kol * c.cenad), ",
                         "sum(c.kol * d.cena), sum(c.kol * d.cenad), ",
                         "kurs_prihoda(c.datotg), kurs_sch(c.datotg) ",
                    "from _finnaklr a, klient b, matoperr c, matoperp d, operacia e ",
                    "where a.klient_cod = b.cod and ",
                          "a.cod = c.schetfnr_cod and ",
                          "c.matoperp_cod = d.cod and ",
                          "c.datotg is not null and ",
                          "a.operacia_cod = e.cod and ",
                          where_str clipped, " ",
                    "group by 1, 2, 3, 4, 9, 10 ",
                    "order by ", order_str clipped
    end if
    if tip = 'S' then
        let str = "select a.cod, a.num, a.dat, b.nam, ",
                         "sum(c1.kol * cenawithpdv(c2.tovar_cod, c2.cena, c3.dat)), 0, ",
                         "d.matpoksum, d.matpoksumd, ",
                         "kurs_prihoda(c3.dat), 0 ",
                    "from _finnaklr a, klient b, finoperr c1, finoperp c2, _schetoplmaxdat c3, _prodmatwfmp d, operacia e ",
                    "where a.klient_cod = b.cod and ",
                          "a.cod = c1.schetfnr_cod and ",
                          "c1.finoperp_cod = c2.cod and ",
                          "a.cod = c3.schet_cod and ",
                          "a.cod = d.schet_cod and ",
                          "a.operacia_cod = e.cod and ",
                          where_str clipped, " ",
                    "group by 1, 2, 3, 4, 6, 7, 8, 9, 10 ",
                    "order by ", order_str clipped
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if tip != 'S' then
            let p.nacenkas  = p.prods - p.poks + p.prodsd * p.kurs_r - p.poksd * p.kurs_p
            let p.nacenkasd = p.prods / p.kurs_r - p.poks / p.kurs_p + p.prodsd - p.poksd
            if p.prods     is null then let p.prods = 0 end if
            if p.prodsd    is null then let p.prodsd = 0 end if
            if p.poks      is null then let p.poks = 0 end if
            if p.poksd     is null then let p.poksd = 0 end if
            if p.nacenkas  is null then let p.nacenkas = 0 end if
            if p.nacenkasd is null then let p.nacenkasd = 0 end if
        else
            let p.nacenkas = 0
            let p.nacenkasd = p.prods / p.kurs_p - p.poksd - p.poks / p.kurs_p
        end if
        display p.cod, "\t",
                p.num using "#####", "\t",
                p.dat using "ddmmyy", "\t",
                p.klientnam, "\t",
                p.prods     using "#######.##", "\t",
                p.prodsd    using "#######.##", "\t",
                p.poks      using "#######.##", "\t",
                p.poksd     using "#######.##", "\t",
                p.nacenkas  using "--------.--", "\t",
                p.nacenkasd using "--------.--"
    end foreach
    commit work
end function

