globals "globals.4gl"

function prodmattov_sel(doccod, tip)
define  
    doccod  integer,
    tip     char(1),
    p   record
        tovarnam    like tovar.nam,
        kol         decimal(7,2),
        cenaprod    decimal(9,2),
        cenaprodd   decimal(9,2),
        cenapok     decimal(9,2),
        cenapokd    decimal(9,2),
        kurs_p      like valuta.kurs_p,
        kurs_r      like valuta.kurs_p,
        nacenka     decimal(9,2)
    end record,
    str         char(1024)
    
    whenever error call err
    
    if tip = "S" then
        let str = "select unique d.nam, a.kol, ",
                         "sum(b1.kol * cenawithpdv(b2.tovar_cod, b2.cena, b3.dat)), 0, ",
                         "c.matpoksum, c.matpoksumd, ",
                         "kurs_prihoda(b3.dat), 0 ",
                    "from schfnrtov a, finoperr b1, finoperp b2, _schetoplmaxdat b3, _prodmatwfmptov c, tovar d ",
                    "where a.cod = b1.doc_cod and ",
                          "b1.finoperp_cod = b2.cod and ",
                          "a.schetfnr_cod = b3.schet_cod and ",
                          "a.cod = c.doc_cod and ",
                          "a.schetfnr_cod = ", doccod, " and ",
                          "a.tovar_cod = d.cod ",
                    "group by 1, 2, 4, 5, 6, 7, 8 ",
                  "union ",
                  "select unique d.nam, a.kol, ",
                         "sum(b1.kol * cenawithpdv(b2.tovar_cod, b2.cena, b3.dat)), 0, ",
                         "c.matpoksum, c.matpoksumd, ",
                         "kurs_prihoda(b3.dat), 0 ",
                    "from schfnrtov a, finoperr b1, finoperp b2, _schetoplmaxdat b3, _prodmatwfmptovt c, tovar d ",
                    "where a.cod = b1.doc_cod and ",
                          "b1.finoperp_cod = b2.cod and ",
                          "a.schetfnr_cod = b3.schet_cod and ",
                          "a.cod = c.schfnrtov_cod and ",
                          "a.schetfnr_cod = ", doccod, " and ",
                          "a.tovar_cod = d.cod ",
                    "group by 1, 2, 4, 5, 6, 7, 8 ",
                    "order by 1"
    end if
    if tip = "s" then
        let str = "select c.nam, sum(a.kol), sum(a.kol * a.cena), ",
                         "sum(a.kol * a.cenad), ",
                         "sum(a.kol * b.cena), sum(a.kol * b.cenad), ",
                         "kurs_prihoda(a.datotg), kurs_sch(a.datotg) ",
                    "from matoperr a, matoperp b, tovar c ",
                    "where a.matoperp_cod = b.cod and ",
                          "a.schetfnr_cod = ", doccod, " and ",
                          "b.tovar_cod = c.cod and ",
                          "a.datotg is not null ",
                    "group by 1, 7, 8 ",
                    "order by 1"
    end if
    if tip = "k" then
        let str = "select c.nam, sum(a.kol), sum(a.kol * a.cena), ",
                         "sum(a.kol * a.cenad), ",
                         "sum(a.kol * b.cena), sum(a.kol * b.cenad), ",
                         "kurs_prihoda(a.datotg), kurs_sch(a.datotg) ",
                    "from schfnrtovt a0, matoperr a, matoperp b, tovar c ",
                    "where a.matoperp_cod = b.cod and ",
                          "a0.schfnrtov_cod = ", doccod, " and ",
                          "a0.cod = a.doc_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "a.datotg is not null ",
                    "group by 1, 7, 8 ",
                    "order by 1"
    end if
    if tip = "i" then
        let str = "select c.nam, sum(a.kol), sum(a.kol * a.cena), ",
                         "sum(a.kol * a.cenad), ",
                         "sum(a.kol * b.cena), sum(a.kol * b.cenad), ",
                         "kurs_prihoda(a.datotg), kurs_izr(a.datotg) ",
                    "from naklrtov a0, matoperr a, matoperp b, tovar c ",
                    "where a.matoperp_cod = b.cod and ",
                          "a0.naklr_cod = ", doccod, " and ",
                          "a0.cod = a.doc_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "a.datotg is not null ",
                    "group by 1, 7, 8 ",
                    "order by 1"
    end if

    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if tip != 'S' then
            let p.cenaprodd = p.cenaprodd + p.cenaprod / p.kurs_r
            let p.cenapokd = p.cenapokd + p.cenapok / p.kurs_p
            let p.nacenka = p.cenaprodd - p.cenapokd
        else
            let p.nacenka = p.cenaprod / p.kurs_p - p.cenapok / p.kurs_p - p.cenapokd
            let p.cenaprodd = p.cenaprod
            let p.cenapokd = p.cenapok / p.kurs_p + p.cenapokd
        end if
        display p.tovarnam, "\t", 
                p.kol using "#####.##", "\t",
                p.cenaprodd using "#######.##", "\t", 
                p.cenapokd using "#######.##", "\t", 
                p.nacenka using "-------.--"
    end foreach
    commit work
end function
