globals "globals.4gl"
    
function schetnnakl_sel(schetcod)
define  
    schetcod    integer,
    p   record
        cod     integer,
        pon     char(1),
        poo     char(1),
        num     like nnakl.num,
        dat     like nnakl.dat,
        summa   decimal(9,2),
        summands   decimal(9,2)
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    whenever error call err

    #let str = "select a.cod, b.cod, 0, a.num, a.dat, a.summa, a.summands ",
    #             "from _nnaklsnds a, schetfnr b ",
    #             "where a.sofnr_cod = b.cod and ",
    #                   "b.cod = ",schetcod," ",
    #           "union ",
    #           "select a.cod, 0, b.cod, a.num, a.dat, a.summa, a.summands ",
    #             "from _nnaklsnds a, schetopl b ",
    #             "where a.sofnr_cod = b.cod and ",
    #                   "b.schet_cod = ",schetcod," ",
    #           " order by 4"
    let str = "select a.cod, 10, 0, a.num, a.dat, a.summa, a.summands ",
                 "from _nnaklsnds a ",
                 "where a.sofnr_cod = ", schetcod," ",
               "union ",
               "select a.cod, 0, 10, a.num, a.dat, a.summa, a.summands ",
                 "from _nnaklsnds a ",
                 "where a.sofnr_cod in ( select cod from schetopl where schet_cod = ", schetcod, ") ",
               " order by 4"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.pon != '0' then let p.pon = '*' end if
        if p.pon = '0' then let p.pon = ' ' end if
        if p.poo != '0' then let p.poo = '*' end if
        if p.poo = '0' then let p.poo = ' ' end if
        if p.summa is null then let p.summa = 0 end if
        if p.summands is null then let p.summands = 0 end if
        display p.cod, "\t", 
                p.pon, "\t", 
                p.poo, "\t", 
                p.num, "\t", 
                p.dat, "\t", 
                p.summa using "#######.##", "\t",
                p.summands using "#######.##"
    end foreach
    commit work
end function

function schetnnakl_rep(schetcod, pipe_str)
define  
    schetcod    integer,
    pipe_str    char(256),
    str         char(768),
    p1   record
        num		    like schetfnr.schet_num,
        dat		    date,
        klientnam	like klient.nam,
        lgotanam	like lgota.nam,
        lgotaproc	like schetfnr.lgota_proc
    end record,
    p2   record
        pon     char(1),
        poo     char(1),
        num     like nnakl.num,
        dat     like nnakl.dat,
        summa   decimal(9,2)
    end record,
    sschet      decimal(9,2)
    
    initialize p1, p2 to null
    select a.schet_num, a.schet_dat, b.nam, c.nam, a.lgota_proc
        into p1.*
        from schetfnr a, klient b, outer lgota c
        where a.cod = schetcod and
              a.klient_cod = b.cod and
              b.lgota_cod = c.cod
    
    select summa into sschet from _schets where cod = schetcod

    let str = "select b.cod, 0, a.num, a.dat, a.summa ",
                 "from _nnakls a, schetfnr b ",
                 "where a.sofnr_cod = b.cod and ",
                       "b.cod = ",schetcod," ",
               "union ",
               "select 0, b.cod, a.num, a.dat, a.summa ",
                 "from _nnakls a, schetopl b ",
                 "where a.sofnr_cod = b.cod and ",
                       "b.schet_cod = ",schetcod," ",
               " order by 3"
    prepare p_rep from str
    
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_schetnnakl
        foreach cur_rep into p2.*
            if p2.pon != '0' then let p2.pon = '*' end if
            if p2.pon = '0'  then let p2.pon = ' ' end if
            if p2.poo != '0' then let p2.poo = '*' end if
            if p2.poo = '0'  then let p2.poo = ' ' end if
            output to report r_schetnnakl(p1.num, p1.dat, p1.klientnam, 
                                          p1.lgotanam, p1.lgotaproc, 
                                          p2.pon, p2.poo, p2.num, p2.dat,
                                          p2.summa, sschet)
        end foreach
    finish report r_schetnnakl
    commit work
end function

report r_schetnnakl(snum, sdat, klientnam, lgotanam, lgotaproc, 
                    pon, poo, nnum, ndat, summa, sschet )
define	
    snum		    like schetfnr.schet_num,
    sdat		    date,
    klientnam	like klient.nam,
    lgotanam	like lgota.nam,
    lgotaproc	like schetfnr.lgota_proc,
    pon         char(1),
    poo         char(1),
    nnum        like nnakl.num,
    ndat        date,
    summa       like nnakltov.summa,
    sschet      decimal(9,2)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"",vidoff,twicewidthoff,"N-",vidon,snum using "<<<<<",vidoff,"i",vidon,sdat using "dd/mm/yyyy",vidoff,"."
      print ":",vidon,klientnam,vidoff
      if lgotanam is not null then
        print passon," i :",passoff,vidon,lgotanam clipped,vidoff," ";
      else 
        print " ";
      end if
      if lgotaproc != 0 then
        print passon,"i :",passoff,vidon,lgotaproc using "###.##",vidoff,"%"
      else
        print " "
      end if
      print "========================================================="
      print " i |  i |  |      |    " 
      print "---------------------------------------------------------"
    on every row
      print "      ", pon,"             ", poo, "        ",nnum," ",ndat using "dd.mm.yyyy"," ", summa using "#######.##"
    on last row
      print "========================================================="
      print "                            : ",sum(summa) using "#######.##"
      print "                              : ", sschet using "#######.##"
      print "========================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
