globals "globals.4gl"

function schetopl_ins(schetcod, dat, summa)
define
    str     	        char(128),
    schetcod, schetoplcod  integer,
    dat                 like schetopl.dat,
    summa               like schetopl.summa
    
    whenever error call err

    initialize schetoplcod to null
    let str = "execute procedure schetopl_ins(?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using schetcod, dat, summa
        fetch cur_ins into schetoplcod
        display schetoplcod
    close cur_ins
    commit work
end function

function schetopl_summa(schetcod)
define
    str       char(128),
    schetcod  integer,
    summaa               like schetopl.summa
    
    let transaction = 1
    begin work
    select summa into summaa
        from _schetopls
        where schet_cod = schetcod
    commit work
    display summaa
end function

function schetopl_sel(schetcod)
define  
    schetcod        integer,
    p   record
        cod         integer,
        nnaklcod    integer,
        nnaklnum    like nnakl.num,
        dat         like schetopl.dat,
        summa       like schetopl.summa
    end record,
    str         char(256)
    
    let str = "select a.cod, b.cod, b.num, a.dat, a.summa ",
                 "from schetopl a, outer nnakl b ",
                 "where a.cod = b.sofnr_cod and ", 
                       "a.schet_cod = ", schetcod,
                 " order by a.dat"
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t",
                p.nnaklcod, "\t",
                p.nnaklnum, "\t",
                p.dat using "dd.mm.yyyy", "\t",
                p.summa using "#######.##"
    end foreach
    commit work
end function

function schetopl_del(schetoplcod)
define
    str         char(128),
    schetoplcod    integer
    
    let str = "execute procedure schetopl_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using schetoplcod
    commit work
end function

function schetopl_upd(schetoplcod, dat, summa)
define
    str     	    char(128),
    schetoplcod     integer,
    dat             like schetopl.dat,
    summa           like schetopl.summa
    
    let str = "execute procedure schetopl_upd(?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using schetoplcod, dat, summa
    commit work
end function

function schetopl_rep(schetcod, pipe_str)
define  
    schetcod    integer,
    pipe_str    char(256),
    str         char(768),
    p   record
        num		    like schetfnr.schet_num,
        dat		    date,
        klientnam	like klient.nam,
        datopl      like schetopl.dat,
        sumopl      like schetopl.summa,
        lgotanam	like lgota.nam,
        lgotaproc	like schetfnr.lgota_proc
    end record,
    sschet      decimal(9,2)
        
    let str = "select a.schet_num, a.schet_dat, b.nam, c.dat, c.summa, ",
                     "f.nam, a.lgota_proc ",
                  "from schetfnr a, klient b, schetopl c, outer lgota f ",
                  "where a.cod = ",schetcod," and ",
                        "a.klient_cod = b.cod and ",
                        "a.cod = c.schet_cod and ",
                        "b.lgota_cod = f.cod ",
                  " order by c.dat"
    prepare p_repschet from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repschetopl cursor for p_repschet
    let transaction = 1    
    begin work
    select summa
        into sschet
        from _schfnrtovfins
        where schetfnr_cod = schetcod
    start report r_schetopl
        foreach cur_repschetopl into p.*
            output to report r_schetopl(p.num, p.dat, p.klientnam, p.datopl, 
                                    p.sumopl, p.lgotanam, p.lgotaproc, sschet)
        end foreach
    finish report r_schetopl
    commit work
end function

report r_schetopl(
	       num, dat, klientnam, datopl, sumopl, lgotanam, lgotaproc, sschet )
define	
    num		    like schetfnr.schet_num,
    dat		    date,
    klientnam	like klient.nam,
    datopl      like schetopl.dat,
    sumopl      like schetopl.summa,
    lgotanam	like lgota.nam,
    lgotaproc	like schetfnr.lgota_proc,
    sschet      decimal(9,2)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"          ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"i",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "        :",vidon,klientnam,vidoff
      if lgotanam is not null then
        print passon,"      i :",passoff,vidon,lgotanam clipped,vidoff," ";
      else 
        print " ";
      end if
      if lgotaproc != 0 then
        print passon,"i :",passoff,vidon,lgotaproc using "###.##",vidoff,"%"
      else
        print " "
      end if
      print "                       ======================"
      print "                             | " 
      print "                       ======================"
    on every row
      print datopl using "                       dd.mm.yyyy"," ",sumopl using "#######.##"
    on last row
      print "                       ======================"
      print "                           : ",sum(sumopl) using "#######.##"
      print "                            : ", sschet - sum(sumopl) using "-------.--"
      print "                       ======================"
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
