globals "globals.4gl"

function schettovt_ins(schetfnrcod, schfnrtovcod, tovarcod, kol, cena)
define
    str     	        char(128),
    schetfnrcod, schfnrtovcod, tovarcod, schfnrtovtcod  integer,
    kol                 like schfnrtov.kol,
    cena                like schfnrtov.cena
    
    whenever error call err

    initialize schfnrtovtcod to null
    let str = "execute procedure schettovt_ins(?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using schetfnrcod, schfnrtovcod, tovarcod, kol, cena
        fetch cur_ins into schfnrtovtcod
        display schfnrtovtcod
    close cur_ins
    commit work
end function

function schettovt_upd(schfnrtovtcod, tovarcod, kol, cena)
define
    str     	        char(128),
    schfnrtovtcod, tovarcod integer,
    kol                 like schfnrtov.kol,
    cena                like schfnrtov.cena
    
    let str = "execute procedure schettovt_upd(?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using schfnrtovtcod, tovarcod, kol, cena
    commit work
end function

function schettovt_sel(schfnrtovcod, order_str)
define  
    schfnrtovcod    integer,
    p   record
        cod         integer,
        tovarcod    integer,
        tovarnam    like tovar.nam,
        kol         like schfnrtov.kol,
        einam       like ei.nam,
        cena        like schfnrtov.cena,
        tovarcena   like tovar.cena
    end record,
    str         char(768),
    order_str   char(64)
    
    let str = "select a.cod, b.cod, b.nam as tnam, a.kol as kol, ",
                     "c.nam as enam, a.cena as cena, b.cena ",
                 "from schfnrtovt a, tovar b, ei c ",
                 "where a.tovar_cod = b.cod and ", 
                       "b.ei_cod = c.cod and ", 
                       "a.schfnrtov_cod = ", schfnrtovcod,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t",
                p.tovarcod, "\t",
                p.tovarcena using "#######.##", "\t",
                p.tovarnam, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.cena using "#######.##"
    end foreach
    commit work
end function

function schettovt2_sel(schfnrtovcod, tovarcod, order_str)
define  
    schfnrtovcod, tovarcod, tovartipcod    integer,
    p   record
        cod         integer,
        tovarcod    integer,
        tovartipcod integer,
        tovartipnam like tovartip.nam,
        tovarnam    like tovar.nam,
        kol         like schfnrtov.kol,
        einam       like ei.nam,
        cena        like schfnrtov.cena,
        sort_field  decimal(32,0),
        tovarcena   like tovar.cena
    end record,
    str         char(768),
    order_str   char(64)
    
    let transaction = 1    
    begin work
    select tovartip_cod into tovartipcod
        from tovar
        where cod = tovarcod
    
    let str = "select c.cod, d.cod, b.cod, b.nam, d.nam, ",
                     "c.kol, e.nam, c.cena, ",
                     "a.sort_field, d.cena ",
                 "from sostav a, tovartip b, outer (schfnrtovt c, tovar d, ei e) ",
                 "where a.master_cod = ", tovartipcod, " and ", 
                       "a.slave_cod = b.cod and ",
                       "c.schfnrtov_cod = ",schfnrtovcod, " and ",
                       "c.tovar_cod = d.cod and ",
                       "d.tovartip_cod = a.slave_cod and ",
                       "d.ei_cod = e.cod ",
              "union ",
              "select c.cod, d.cod, 0, '                 ', ",
                     "d.nam, c.kol, e.nam, ",
                     "c.cena, c.cod * 100000, d.cena ",
                 "from schfnrtovt c, tovar d, ei e ",
                 "where c.tovar_cod = d.cod and ",
                       "c.schfnrtov_cod = ",schfnrtovcod, " and ",
                       "d.ei_cod = e.cod and ",
                       "d.tovartip_cod not in (select slave_cod from sostav) ",
                 " order by ", order_str clipped
    prepare p_sel2 from str
    
    initialize p to null
    declare cur_sel2 cursor for p_sel2
    foreach cur_sel2 into p.*
        display p.cod, "\t",
                p.tovarcod, "\t",
                p.tovartipcod, "\t",
                p.tovarcena using "#######.##", "\t",
                p.tovartipnam, "\t",
                p.tovarnam, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.cena using "#######.##"
    end foreach
    commit work
end function

function schettovt_del(schfnrtovtcod)
define
    str         char(128),
    schfnrtovtcod    integer
    
    let str = "execute procedure schettovt_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using schfnrtovtcod
    commit work
end function

function schettovt1_rep(schfnrtovcod, order_str, pipe_str)
define  
    schfnrtovcod, schetcod integer,
    order_str, pipe_str    char(256),
    str         char(768),
    p1   record
        num		    like schetfnr.schet_num,
        dat		    date,
        klientnam	like klient.nam,
        lgotanam	like lgota.nam,
        lgotaproc	like schetfnr.lgota_proc
    end record,
    p2   record
        tovarnam	like schfnrtov.printnam,
        kol		    like schfnrtov.kol,
        einam		like ei.nam,
        cena		like schfnrtov.cena
    end record,
    p3   record
        tovarnam	like schfnrtov.printnam,
        kol		    like schfnrtov.kol,
        einam		like ei.nam,
        cena		like schfnrtov.cena
    end record,
    cenawithoutpdv decimal(13,6),
    pdv         decimal(13,6)
        
    let str = "select b.nam as tnam, a.kol as kol, c.nam as enam, a.cena as cena ",
                  "from schfnrtovt a, tovar b, ei c ",
                  "where a.schfnrtov_cod = ", schfnrtovcod, " and ",
                        "a.tovar_cod = b.cod and ",
                        "b.ei_cod = c.cod ",
                  " order by ", order_str clipped
    prepare p_repschettovt1 from str
    
    initialize p1, p2, p3 to null
    let reppipe = pipe_str
    declare cur_repschettovt1 cursor for p_repschettovt1
    let transaction = 1    
    begin work
    
    select a.schetfnr_cod, b.nam, a.kol, c.nam, a.cena
        into schetcod, p2.*
        from schfnrtov a, tovar b, ei c
        where a.cod = schfnrtovcod and
              a.tovar_cod = b.cod and
              b.ei_cod = c.cod
    
    select a.schet_num, a.schet_dat, b.nam, c.nam, a.lgota_proc
        into p1.*
        from schetfnr a, klient b, outer lgota c
        where a.cod = schetcod and
              a.klient_cod = b.cod and
              b.lgota_cod = c.cod   
    
    start report r_schettovt1
        foreach cur_repschettovt1 into p3.*
            output to report r_schettovt1(p1.num, p1.dat, p1.klientnam,
                                          p1.lgotanam, p1.lgotaproc,
                                          p2.tovarnam, p2.kol, p2.einam, p2.cena,
                                          p3.tovarnam, p3.kol, p3.einam, p3.cena
                                         )
        end foreach
    finish report r_schettovt1
    commit work
end function

report r_schettovt1(num, dat, klientnam, lgotanam, lgotaproc,
                    tovarnam1, kol1, einam1, cena1,
                    tovarnam2, kol2, einam2, cena2
	               )
define	
    num		    like schetfnr.schet_num,
    dat		    date,
    klientnam	like klient.nam,
    lgotanam	like lgota.nam,
    lgotaproc	like schetfnr.lgota_proc,
    tovarnam1	like schfnrtov.printnam,
    kol1	    like schfnrtov.kol,
    einam1		like ei.nam,
    cena1		like schfnrtov.cena,
    tovarnam2	like schfnrtov.printnam,
    kol2	    like schfnrtov.kol,
    einam2		like ei.nam,
    cena2		like schfnrtov.cena
    

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		18
	
format	
    first page header
      skip 8 line
      print twicewidthon,vidon,"          ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"i",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "        :",vidon,klientnam,vidoff
      if lgotanam is not null then
        print passon,"      i :",passoff,vidon,lgotanam clipped,vidoff," ";
      else 
        print " ";
      end if
      if lgotaproc != 0 then
        print passon,"i :",passoff,vidon,lgotaproc using "###.##",vidoff,"%"
      else
        print " "
      end if
      print " : "
      print passon,tovarnam1,passoff,kol1 using "#####.## ",einam1,cena1 using " #######.##"
      print "============================================================================="
      print "                             | i- |   |  i" 
      print "                                               | i |  i  |  "
      print "============================================================================="
    on every row
      print passon,tovarnam2,passoff,kol2 using "#####.## ",einam2,cena2 using " #######.##"
    on last row
      print "                                        : ",sum(kol2) using "#####.##            ", sum(kol2 * cena2) using "#######.##"
      print "                                                           : ",kol1 * cena1 - sum(kol2 * cena2) using "-------.--"
      print "==================================================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

function schettovt2_rep(schfnrtovcod, order_str, pipe_str)
define  
    schfnrtovcod, tovartipcod, schetcod integer,
    order_str, pipe_str    char(256),
    str         char(768),
    p1   record
        num		    like schetfnr.schet_num,
        dat		    date,
        klientnam	like klient.nam,
        lgotanam	like lgota.nam,
        lgotaproc	like schetfnr.lgota_proc
    end record,
    p2   record
        tovarnam	like schfnrtov.printnam,
        kol		    like schfnrtov.kol,
        einam		like ei.nam,
        cena		like schfnrtov.cena
    end record,
    p3   record
        f1          integer,
        f2          integer,
        f3          integer,
        tovartipnam like tovartip.nam,
        tovarnam	like schfnrtov.printnam,
        kol		    like schfnrtov.kol,
        einam		like ei.nam,
        cena		like schfnrtov.cena,
        f4          integer
    end record,
    cenawithoutpdv decimal(13,6),
    pdv         decimal(13,6)
        
    let transaction = 1    
    begin work
    initialize p1, p2, p3 to null
    
    select a.schetfnr_cod, b.tovartip_cod, b.nam, a.kol, c.nam, a.cena
        into schetcod, tovartipcod, p2.*
        from schfnrtov a, tovar b, ei c
        where a.cod = schfnrtovcod and
              a.tovar_cod = b.cod and
              b.ei_cod = c.cod
    
    select a.schet_num, a.schet_dat, b.nam, c.nam, a.lgota_proc
        into p1.*
        from schetfnr a, klient b, outer lgota c
        where a.cod = schetcod and
              a.klient_cod = b.cod and
              b.lgota_cod = c.cod
    
    let str = "select c.cod, d.cod, b.cod, b.nam, d.nam, ",
                     "c.kol, e.nam, c.cena, ",
                     "a.sort_field ",
                 "from sostav a, tovartip b, outer (schfnrtovt c, tovar d, ei e) ",
                 "where a.master_cod = ", tovartipcod, " and ", 
                       "a.slave_cod = b.cod and ",
                       "c.schfnrtov_cod = ",schfnrtovcod, " and ",
                       "c.tovar_cod = d.cod and ",
                       "d.tovartip_cod = a.slave_cod and ",
                       "d.ei_cod = e.cod ",
              "union ",
              "select c.cod, d.cod, 0, '                 ', ",
                     "d.nam, c.kol, e.nam, ",
                     "c.cena, c.cod * 100000 ",
                 "from schfnrtovt c, tovar d, ei e ",
                 "where c.tovar_cod = d.cod and ",
                       "c.schfnrtov_cod = ",schfnrtovcod, " and ",
                       "d.ei_cod = e.cod and ",
                       "d.tovartip_cod not in (select slave_cod from sostav) ",
                 " order by ", order_str clipped
    prepare p_repschettovt2 from str
    
    let reppipe = pipe_str
    declare cur_repschettovt2 cursor for p_repschettovt2
    
    start report r_schettovt2
        foreach cur_repschettovt2 into p3.*
#            if p3.kol is null then let p3.kol = 0 end if
#            if p3.cena is null then let p3.cena = 0 end if
            output to report r_schettovt2(p1.num, p1.dat, p1.klientnam,
                                          p1.lgotanam, p1.lgotaproc,
                                          p2.tovarnam, p2.kol, p2.einam, p2.cena,
                                          p3.tovartipnam, p3.tovarnam, p3.kol, p3.einam, p3.cena
                                         )
        end foreach
    finish report r_schettovt2
    commit work
end function

report r_schettovt2(num, dat, klientnam, lgotanam, lgotaproc,
                    tovarnam1, kol1, einam1, cena1,
                    tovartipnam, tovarnam2, kol2, einam2, cena2
	               )
define	
    num		    like schetfnr.schet_num,
    dat		    date,
    klientnam	like klient.nam,
    lgotanam	like lgota.nam,
    lgotaproc	like schetfnr.lgota_proc,
    tovarnam1	like schfnrtov.printnam,
    kol1	    like schfnrtov.kol,
    einam1		like ei.nam,
    cena1		like schfnrtov.cena,
    tovartipnam like tovartip.nam,
    tovarnam2	like schfnrtov.printnam,
    kol2	    like schfnrtov.kol,
    einam2		like ei.nam,
    cena2		like schfnrtov.cena
    

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		18
	
format	
    first page header
      skip 8 line
      print twicewidthon,vidon,"          ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"i",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "        :",vidon,klientnam,vidoff
      if lgotanam is not null then
        print passon,"      i :",passoff,vidon,lgotanam clipped,vidoff," ";
      else 
        print " ";
      end if
      if lgotaproc != 0 then
        print passon,"i :",passoff,vidon,lgotaproc using "###.##",vidoff,"%"
      else
        print " "
      end if
      print " : "
      print passon,tovarnam1,passoff,kol1 using "#####.## ",einam1,cena1 using " #######.##"
      print "=============================================================================================="
      print "       |                             | i- |   |  i" 
      print "                |                                               | i |  i  |  "
      print "=============================================================================================="
    on every row
      print passon,tovartipnam[1,24]," ",tovarnam2,passoff,kol2 using "#####.## ",einam2,cena2 using " #######.##"
    on last row
      print "                                                         : ",sum(kol2) using "#####.##            ", sum(kol2 * cena2) using "#######.##"
      print "                                                                            : ",kol1 * cena1 - sum(kol2 * cena2) using "-------.--"
      print "=============================================================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
