globals "globals.4gl"
    
function sklad_del(skladcod)
define
    str         char(128),
    skladcod    like sklad.cod
    
    whenever error call err

    let str = "execute procedure sklad_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using skladcod
    commit work
end function

function sklad_sel(where_str, order_str)
define  
    p   record
        cod         like sklad.cod,
        nam         like sklad.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam ",
                 "from sklad ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam
    end foreach
    commit work
end function

function sklad_selmo(matotvcod, where_str, order_str)
define  
    matotvcod       integer,
    p   record
        cod         like sklad.cod,
        nam         like sklad.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam ",
                 "from sklad ",
                 "where matotv_cod =",matotvcod," and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_selmo cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_selmo into p.*
        display p.cod, "\t", p.nam
    end foreach
    commit work
end function

function sklad_ins(matotvcod, skladnam)
define
    str     	    char(128),
    skladcod	    like sklad.cod,
    skladnam        like sklad.nam,
    matotvcod       integer
    
    let str = "execute procedure sklad_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using matotvcod, skladnam
        fetch cur_ins into skladcod
        display skladcod
    close cur_ins
    commit work
end function

function sklad_upd(skladcod, skladnam)
define
    str     	char(128),
    skladcod        like sklad.cod,
    skladnam        like sklad.nam
    
    let str = "execute procedure sklad_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using skladcod, skladnam
    commit work
end function

function sklad_repmo(matotvcod, where_str, order_str, pipe_str)
define  
    matotvcod       integer,
    matotvnam       like klient.nam,
    p   record
        nam         like sklad.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    select fio
        into matotvnam
        from _sot
        where cod = matotvcod
    
    let str = "select nam ",
                  "from sklad ",
                  "where matotv_cod = ",matotvcod," and ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_skladmo
        foreach cur_rep into p.*
            output to report r_skladmo(matotvnam, p.nam)
        end foreach
    finish report r_skladmo
    commit work
end function

report r_skladmo(matotvnam, nam)
define	
    nam         like sklad.nam,
    matotvnam   like klient.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print " : ",matotvnam
        print "================================"
        print "                   "
        print "                         "
        print "-------------------------------"
    on every row
        print nam
    on last row
        print "==============================="
end report

