globals "globals.4gl"

function snnno_sel(from_str, where_str, sort_str)
define  
    from_str    char(128),
    where_str   char(2048),
    sort_str    char(64),
    p   record
        cod         integer,
        schetnum    like schetfnr.schet_num,
        schetdat    like schetfnr.schet_dat,
        naklnum     like schetfnr.finnaklr_num,
        nakldat     like schetfnr.finnaklr_dat,
        nnmindat    date,
        nnallsumma  decimal(9,2),
        oplmindat   date,
        oplallsumma decimal(9,2),
        otgmindat   date,
        otgallkol   decimal(7,2),
        schetmatkol decimal(7,2),
        schetsumma  decimal(9,2),
        klientnam   like klient.nam
    end record,
    str     char(3072),
    nnsr, oplsr, otgsr  char(1)

    whenever error call err
    
    let str = "select a.schet_cod, a.snum as schetnum, a.sdat as schetdat, ",
                     "a.nnum as naklnum, a.ndat as nakldat, ",
                     "b.mindat as nnakldat, b.summa, c.dat as opldat, c.summa, ",
                     "d.mindat as otgdat, d.kol, a.kol, a.summa as schetsumma, ", 
                     "e.nam as klientnam ",
                 "from _schetsmk a, outer _schetnnmindat b,", from_str clipped, " klient e ",
                 "where a.schet_cod = b.schet_cod and ",
                       "a.schet_cod = c.schet_cod and ",
                       "a.schet_cod = d.schet_cod and ",
                       "a.klient_cod = e.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.schetsumma is null then let p.schetsumma = 0 end if
        if p.schetmatkol is null then let p.schetmatkol = 0 end if
        if p.nnallsumma = p.schetsumma then let nnsr = '=' end if
        if p.nnallsumma > p.schetsumma then let nnsr = '-' end if
        if p.nnallsumma < p.schetsumma then let nnsr = '+' end if
        if p.nnallsumma is null        then let nnsr = ' ' end if
        
        if p.oplallsumma = p.schetsumma then let oplsr = '=' end if
        if p.oplallsumma > p.schetsumma then let oplsr = '-' end if
        if p.oplallsumma < p.schetsumma then let oplsr = '+' end if
        if p.oplallsumma is null        then let oplsr = ' ' end if
        
        if p.otgallkol = p.schetmatkol then let otgsr = '=' end if
        if p.otgallkol > p.schetmatkol then let otgsr = '-' end if
        if p.otgallkol < p.schetmatkol then let otgsr = '+' end if
        if p.otgallkol is null         then let otgsr = ' ' end if
        if p.schetsumma is null then let p.schetsumma = 0 end if
        display p.cod, "\t", 
                p.schetnum, "\t", 
                p.schetdat using "ddmmyy", "\t", 
                p.naklnum, "\t", 
                p.nakldat using "ddmmyy", "\t",
                p.nnmindat using "ddmmyy", "\t",
                nnsr, "\t",
                p.oplmindat using "ddmmyy", "\t",
                oplsr, "\t",
                p.otgmindat using "ddmmyy", "\t",
                otgsr, "\t",
                p.schetsumma using "#######.##", "\t",
                p.klientnam
    end foreach
    commit work
end function

function snnnoone_sel(schetcod)
define  
    schetcod        integer,
    p   record
        cod         integer,
        schetnum    like schetfnr.schet_num,
        schetdat    like schetfnr.schet_dat,
        naklnum     like schetfnr.finnaklr_num,
        nakldat     like schetfnr.finnaklr_dat,
        nnmindat    date,
        nnallsumma  decimal(9,2),
        oplmindat   date,
        oplallsumma decimal(9,2),
        otgmindat   date,
        otgallkol   decimal(7,2),
        schetmatkol decimal(7,2),
        schetsumma  decimal(9,2),
        klientnam   like klient.nam
    end record,
    str     char(1024),
    nnsr, oplsr, otgsr  char(1)
    
    let str = "select a.schet_cod, a.snum as schetnum, a.sdat as schetdat, ",
                     "a.nnum as naklnum, a.ndat as nakldat, ",
                     "b.mindat as nnakldat, b.summa, c.dat as opldat, c.summa, ",
                     "d.mindat as otgdat, d.kol, a.kol, a.summa as schetsumma, e.nam as klientnam ",
                 "from _schetsmk a, outer _schetnnmindat b, outer _schetoplmindat c, ",
                      "outer _schetotgmindat d, klient e ",
                 "where a.schet_cod = ", schetcod, " and ",
                       "b.schet_cod = ", schetcod, " and ",
                       "c.schet_cod = ", schetcod, " and ",
                       "d.schet_cod = ", schetcod, " and ",
                       "a.schet_cod = b.schet_cod and ",
                       "a.schet_cod = c.schet_cod and ",
                       "a.schet_cod = d.schet_cod and ",
                       "a.klient_cod = e.cod"
    prepare p_sel from str
    
    initialize p to null
    declare cur_onesel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_onesel into p.*
        if p.schetsumma is null then let p.schetsumma = 0 end if
        if p.schetmatkol is null then let p.schetmatkol = 0 end if
        if p.nnallsumma = p.schetsumma then let nnsr = '=' end if
        if p.nnallsumma > p.schetsumma then let nnsr = '-' end if
        if p.nnallsumma < p.schetsumma then let nnsr = '+' end if
        if p.nnallsumma is null        then let nnsr = ' ' end if
        
        if p.oplallsumma = p.schetsumma then let oplsr = '=' end if
        if p.oplallsumma > p.schetsumma then let oplsr = '-' end if
        if p.oplallsumma < p.schetsumma then let oplsr = '+' end if
        if p.oplallsumma is null        then let oplsr = ' ' end if
        
        if p.otgallkol = p.schetmatkol then let otgsr = '=' end if
        if p.otgallkol > p.schetmatkol then let otgsr = '-' end if
        if p.otgallkol < p.schetmatkol then let otgsr = '+' end if
        if p.otgallkol is null         then let otgsr = ' ' end if
        if p.schetsumma is null then let p.schetsumma = 0 end if
        display p.cod, "\t", 
                p.schetnum, "\t", 
                p.schetdat using "ddmmyy", "\t", 
                p.naklnum, "\t", 
                p.nakldat using "ddmmyy", "\t",
                p.nnmindat using "ddmmyy", "\t",
                nnsr, "\t",
                p.oplmindat using "ddmmyy", "\t",
                oplsr, "\t",
                p.otgmindat using "ddmmyy", "\t",
                otgsr, "\t",
                p.schetsumma using "#######.##", "\t",
                p.klientnam
    end foreach
    commit work
end function

function snnno_rep(from_str, where_str, sort_str, pipe_str)
define  
    from_str    char(128),
    where_str   char(2048),
    sort_str    char(64),
    pipe_str    char(256),
    str         char(3072),
    p record
        schetcod    integer,
        schetnum    like schetfnr.schet_num,
        schetdat    like schetfnr.schet_dat,
        naklnum     like schetfnr.finnaklr_num,
        nakldat     like schetfnr.finnaklr_dat,
        nnmindat    date,
        nnallsumma  decimal(9,2),
        oplmaxdat   date,
        oplallsumma decimal(9,2),
        otgmindat   date,
        otgallkol   decimal(7,2),
        schetmatkol decimal(7,2),
        schetsumma  decimal(9,2),
        klientnam   like klient.nam,
        klientphone like klient.phone_buh,
        prim1       like schetfnr.prim1,
        tovarnam    like tovar.nam,
        kol         like schfnrtov.kol,
        cena        like schfnrtov.cena,
        cenawpdv    decimal(20,10),
        pdv         decimal(20,10),
        isnds       like tovar.isnds
    end record
        
    let str = "select a.schet_cod, a.snum as schetnum, a.sdat as schetdat, ",
                     "a.nnum as naklnum, a.ndat as nakldat, ",
                     "b.mindat as nnakldat, b.summa, c.dat as opldat, c.summa, ",
                     "d.mindat as otgdat, d.kol, a.kol, a.summa as schetsumma, ", 
                     "e.nam as klientnam, e.phone_buh, ",
                     "a.prim1, g.nam, f.kol, f.cena, 0, 0, g.isnds ",
                 "from _schetsmk a, outer _schetnnmindat b,", from_str clipped,
                     " klient e, schfnrtov f, tovar g ",
                 "where a.schet_cod = b.schet_cod and ",
                       "a.schet_cod = c.schet_cod and ",
                       "a.schet_cod = d.schet_cod and ",
                       "a.klient_cod = e.cod and ",
                       "a.schet_cod = f.schetfnr_cod and ",
                       "f.tovar_cod = g.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped, ", schetnum "
                 #"order by schetnum"


    prepare p_repsnnno from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repsnnno cursor for p_repsnnno
    let transaction = 1    
    begin work
    start report r_snnno
        foreach cur_repsnnno into p.*
            if p.isnds = "*" then
                call funpdv(p.schetdat, p.cena) returning p.cenawpdv, p.pdv
            else
                let p.cenawpdv = p.cena
            end if
            output to report r_snnno(p.naklnum, p.nakldat, p.oplmaxdat,
                                     p.schetnum, p.klientnam, p.klientphone, 
                                     p.prim1, p.tovarnam, p.kol, p.cena,
                                     p.cenawpdv, p.pdv)
        end foreach
    finish report r_snnno
    commit work
end function

report r_snnno(naklnum, nakldat, opldat, schetnum, klientnam, klientphone,
            prim1, tovarnam, kol, cena, cenawpdv, pdv)
define	
	naklnum		like schetfnr.finnaklr_num,
	nakldat		like schetfnr.finnaklr_dat,
	opldat		date,
	schetnum	like schetfnr.schet_num,
	klientnam	like klient.nam,
	klientphone like klient.phone_buh,
	tovarnam	like tovar.nam,
	cena		like schfnrtov.cena,
	kol		    like schfnrtov.kol,
	prim1		like schetfnr.prim1,
	cenawpdv, pdv	decimal(20,10)

output
    report to pipe reppipe
    left margin		8
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"   //  .",vidoff,twicewidthoff
      print passon
      print "========================================================================================================================================"
      print "        |      ||                               | "
      print "-----------------|          |     |-----------------------------------------------------------------------------------------------------"
      print "  N   |      |    ||                                |      | -  |           1 "
      print "      |          |          |     |                                                  |    |  |"
      print "========================================================================================================================================"
    before group of schetnum
      print naklnum using "###### ",nakldat using "dd/mm/yyyy ", opldat using "dd/mm/yyyy ",schetnum using "##### ",klientnam," ", klientphone
    on every row
      print column 36, tovarnam, cenawpdv using " #######.## ", kol using "-----.-- "
    after group of schetnum
      print column 74,"  :",group sum(cena * kol) using " #######.##          ",prim1[1,30]
      print column 72,"  :",group sum(cenawpdv * kol) using " #######.##          ",prim1[31,60]
      print "----------------------------------------------------------------------------------------------------------------------------------------"
    on last row
      print column 74,"  :",sum(cena * kol) using " #######.##"
      print column 72,"  :",sum(cenawpdv * kol) using " #######.##"
      print "========================================================================================================================================"
      call whatsot()
      print passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report
