globals "globals.4gl"

function sostav_del(sostavcod)
define
    str         char(128),
    sostavcod    like sostav.cod

    whenever error call err
    
    let str = "execute procedure sostav_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using sostavcod
    commit work
end function

function sostav_sel(mastercod, where_str, order_str)
define  
    mastercod   integer,
    p   record
        cod         integer,
        slavecod    integer,
        slavenam    like tovartip.nam,
        sortfield   like sostav.sort_field
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select a.cod, b.cod, b.nam, a.sort_field ",
                 "from sostav a, tovartip b ",
                 "where a.slave_cod = b.cod and a.master_cod = ", mastercod, " and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t",
                p.slavecod, "\t",
                p.slavenam, "\t",
                p.sortfield
    end foreach
    commit work
end function

function sostavm_sel(where_str, order_str)
define  
    p   record
        tovargroup_cod  integer,
        cod         integer,
        nam         like tovartip.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select tovargroup_cod, cod, nam ",
                 "from tovartip ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_selm cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_selm into p.*
        display p.tovargroup_cod, "\t",
                p.cod, "\t",
                p.nam
    end foreach
    commit work
end function

function sostav_ins(mastercod, slavecod)
define
    str     	    char(128),
    mastercod       integer,
    slavecod        integer,
    sostavcod       integer
    
    let str = "execute procedure sostav_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using mastercod, slavecod
        fetch cur_ins into sostavcod
        display sostavcod
    close cur_ins
    commit work
end function

function sostav_upd(sostavcod, slavecod)
define
    str     	char(128),
    sostavcod        like sostav.cod,
    slavecod        integer
    
    let str = "execute procedure sostav_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using sostavcod, slavecod
    commit work
end function

function sostav_rep(mastercod, where_str, order_str, pipe_str)
define  
    mastercod   integer,
    p record
        masternam   like tovartip.nam,
        slavenam    like tovartip.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    initialize p to null
    
    select nam 
        into p.masternam
        from tovartip
        where cod = mastercod
        
    let str = "select b.nam, a.sort_field ",
                 "from sostav a, tovartip b ",
                 "where a.slave_cod = b.cod and a.master_cod = ", mastercod, " and ", where_str clipped,
                 " order by ", order_str clipped
    
    prepare p_rep from str
    
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_sostav
        foreach cur_rep into p.slavenam
            output to report r_sostav(p.masternam, p.slavenam)
        end foreach
    finish report r_sostav
    commit work
end function

report r_sostav(masternam, slavenam)
define	
    masternam   like tovartip.nam,
    slavenam    like tovartip.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print " : ", masternam
        print "================================"
        print "      "
        print "--------------------------------"
    on every row
        print " ",slavenam
    on last row
        print "================================"
end report
