globals "globals.4gl"

function sot_del(sotcod)
define
    str         char(128),
    sotcod      like klient.cod

    whenever error call err

    let str = "execute procedure sot_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using sotcod
    commit work
end function

function sotone_sel(sotcod)
define  
    sotcod   integer,
    p   record
        gorodcod    integer,
        fio         like klient.nam,
        matotv      like klient.matotv,
        datborn     like klient.datreg,
        gorodnam    like gorod.nam,
        phonecod    like gorod.phone_cod,
        index       like klient.index,
        ulica       like klient.ulica,
        dom         like klient.dom,
        kv          like klient.kv,
        phone       like klient.phone_boss,
        email       like klient.email,
        prim        like klient.prim,
        login       like klient.login
    end record
    
    initialize p to null
    let transaction = 1    
    begin work
    select b.cod, a.fio, a.matotv, a.datborn, b.nam, b.phone_cod, a.index,
           a.ulica, a.dom, a.kv, a.phone, a.email, a.prim, a.login
        into p.*
        from _sot a, gorod b
        where a.gorod_cod = b.cod and a.cod = sotcod
    commit work
    
    display p.gorodcod, "\t", 
            p.fio, "\t", 
            p.matotv, "\t", 
            p.datborn using "dd.mm.yyyy", "\t", 
            p.gorodnam, "\t", 
            p.phonecod, " \t", 
            p.index, "\t", 
            p.ulica, "\t", 
            p.dom, "\t", 
            p.kv, "\t", 
            p.phone, "\t", 
            p.email, "\t", 
            p.prim, "\t", 
            p.login
end function

function sotmany_sel(where_str, order_str)
define  
    sotcod   integer,
    p   record
        sotcod      like klient.cod,
        fio         like klient.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select a.cod, a.fio ",
                 "from _sot a, gorod b ",
                 "where a.gorod_cod = b.cod and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.sotcod, "\t", p.fio
    end foreach
    commit work
end function

function sot_ins(fio, matotv, datborn, gorodcod, 
                 index, ulica, dom, kv, 
                 phone, email, prim, login)
define
    str         char(128),
    sotcod      integer,
    fio         like klient.nam,
    matotv      like klient.matotv,
    datborn     char(10),
    gorodcod    integer,
    index       like klient.index,
    ulica       like klient.ulica,
    dom         like klient.dom,
    kv          like klient.kv,
    phone       like klient.phone_boss,
    email       like klient.email,
    prim        like klient.prim,
    login       like klient.login,
    datb        date
    
    let datb = date(datborn)
    let str = "execute procedure sot_ins(?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using fio, matotv, datb, gorodcod, 
                       index, ulica, dom, kv, 
                       phone, email, prim, login)
        fetch cur_ins into sotcod
        display sotcod
    close cur_ins
    commit work
end function

function sot_upd(sotcod, fio, matotv, datborn, gorodcod, 
                 index, ulica, dom, kv, 
                 phone, email, prim, login)
define
    str     	char(128),
    sotcod      integer,
    fio         like klient.nam,
    matotv      like klient.matotv,
    datborn     char(10),
    gorodcod    integer,
    index       like klient.index,
    ulica       like klient.ulica,
    dom         like klient.dom,
    kv          like klient.kv,
    phone       like klient.phone_boss,
    email       like klient.email,
    prim        like klient.prim,
    login       like klient.login,
    datb        date
    
    let datb = date(datborn)
    let str = "execute procedure sot_upd(?,?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using sotcod, 
                       fio, matotv, datb, gorodcod, 
                       index, ulica, dom, kv, 
                       phone, email, prim, login)
    commit work
end function

function sot_rep(where_str, order_str, pipe_str)
define  
    p   record
        fio         like klient.nam,
        matotv      like klient.matotv,
        datborn     like klient.datreg,
        gorodnam    like gorod.nam,
        phonecod    like gorod.phone_cod,
        index       like klient.index,
        ulica       like klient.ulica,
        dom         like klient.dom,
        kv          like klient.kv,
        phone       like klient.phone_boss,
        email       like klient.email,
        prim        like klient.prim,
        login       like klient.login
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select a.fio, a.matotv, a.datborn, b.nam, b.phone_cod, ",
                     "a.index, a.ulica, a.dom, a.kv, a.phone, a.email, ",
                     "a.prim, a.login ",
                 "from  _sot a, gorod b ",
                 "where a.gorod_cod = b.cod and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_sot
        foreach cur_rep into p.*
            output to report r_sot(p.fio, p.matotv, p.datborn, p.gorodnam, 
                                   p.phonecod, p.index, p.ulica,
                                   p.dom, p.kv, p.phone, p.email, p.prim, 
                                   p.login)
        end foreach
    finish report r_sot
    commit work
end function

report r_sot(fio, matotv, datborn, gorodnam, phonecod, index, ulica, dom, 
             kv, phone, email, prim, login)
define	
        fio         like klient.nam,
        matotv      like klient.matotv,
        datborn     like klient.datreg,
        gorodnam    like gorod.nam,
        phonecod    like gorod.phone_cod,
        index       like klient.index,
        ulica       like klient.ulica,
        dom         like klient.dom,
        kv          like klient.kv,
        phone       like klient.phone_boss,
        email       like klient.email,
        prim        like klient.prim,
        login       like klient.login

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "=============================================================================="
        print ", ,                              .   login"
        print "            "
        print "                                                            "
        print "                 e-mail"
        print "    "
        print "=============================================================================="
    on every row
        print fio,"  ",matotv,"    ",login
        print "    : ",index," ",gorodnam
        print "           ",ulica," ",dom," ",kv
        print "           (",phonecod clipped,") ",phone," ",email
        print "    ",prim
        print "------------------------------------------------------------------------------"
    on last row
        print "=============================================================================="
end report

