globals "globals.4gl"
    
function stt_sel()
define  
    p   record
        vppcod       like operacia.cod,
        vprcod       like operacia.cod,
        sgpcod       like sklad.cod,
        shtcod       like ei.cod,
        zaimtocod    integer,
        pzaimtocod   integer,
        zaimfromcod  integer,
        pzaimfromcod integer,
        gklp1cod     integer,
        gklp2cod     integer,
        gklr1cod     integer,
        gklr2cod     integer,
        gpsr1cod     integer,
        gpsr2cod     integer,
        gpsp1cod     integer,
        gpsp2cod     integer,
        
        vppnam      like operacia.nam,
        vprnam      like operacia.nam,
        sgpnam      like sklad.nam,
        shtnam      like ei.nam,
        zaimtonam      like operacia.nam,
        pzaimtonam     like operacia.nam,
        zaimfromnam    like operacia.nam,
        pzaimfromnam   like operacia.nam,
        gklp1nam     like operacia.nam,
        gklp2nam     like operacia.nam,
        gklr1nam     like operacia.nam,
        gklr2nam     like operacia.nam,
        gpsr1nam     like operacia.nam,
        gpsr2nam     like operacia.nam,
        gpsp1nam     like operacia.nam,
        gpsp2nam     like operacia.nam
    end record

    whenever error call err
    
    initialize p to null
    
    let transaction = 1    
    begin work
    select b.cod, c.cod, d.cod, e.cod, 
           f1.cod, f2.cod, f3.cod, f4.cod,
           g1.cod, g2.cod, g3.cod, g4.cod,
           g5.cod, g6.cod, g7.cod, g8.cod,
           b.nam, c.nam, d.nam, e.nam,
           f1.nam, f2.nam, f3.nam, f4.nam,
           g1.nam, g2.nam, g3.nam, g4.nam,
           g5.nam, g6.nam, g7.nam, g8.nam
        into p.*
        from stt a, outer operacia b, outer operacia c, outer sklad d, outer ei e,
             outer operacia f1, outer operacia f2, outer operacia f3, outer operacia f4,
             outer operacia g1, outer operacia g2, outer operacia g3, outer operacia g4,
             outer operacia g5, outer operacia g6, outer operacia g7, outer operacia g8
        where a.vpp = b.cod and a.vpr = c.cod and a.sgp = d.cod and a.sht = e.cod and
              a.zaimto = f1.cod and
              a.pzaimto = f2.cod and
              a.zaimfrom = f3.cod and
              a.pzaimfrom = f4.cod and
              a.gklp1 = g1.cod and
              a.gklp2 = g2.cod and
              a.gklr1 = g3.cod and
              a.gklr2 = g4.cod and
              a.gpsr1 = g5.cod and
              a.gpsr2 = g6.cod and
              a.gpsp1 = g7.cod and
              a.gpsp2 = g8.cod
    commit work
    
    display 
        p.vppcod, " \t",
        p.vprcod, " \t",
        p.sgpcod, " \t",
        p.shtcod, " \t",
        p.zaimtocod, " \t",
        p.pzaimtocod, " \t",
        p.zaimfromcod, " \t",
        p.pzaimfromcod, " \t",
        p.gklp1cod, " \t",
        p.gklp2cod, " \t",
        p.gklr1cod, " \t",
        p.gklr2cod, " \t",
        p.gpsr1cod, " \t",
        p.gpsr2cod, " \t",
        p.gpsp1cod, " \t",
        p.gpsp2cod, " \t",
        
        p.vppnam, " \t",
        p.vprnam, " \t",
        p.sgpnam, " \t",
        p.shtnam, " \t",
        p.zaimtonam, " \t",
        p.pzaimtonam, " \t",
        p.zaimfromnam, " \t",
        p.pzaimfromnam, " \t",
        p.gklp1nam, " \t",
        p.gklp2nam, " \t",
        p.gklr1nam, " \t",
        p.gklr2nam, " \t",
        p.gpsr1nam, " \t",
        p.gpsr2nam, " \t",
        p.gpsp1nam, " \t",
        p.gpsp2nam
end function

function stt_ins(vppcod, vprcod, sgpcod, shtcod, 
                 zaimtocod, pzaimtocod, zaimfromcod, pzaimfromcod,
                 gklp1cod, gklp2cod, gklr1cod, gklr2cod,
                 gpsr1cod, gpsr2cod, gpsp1cod, gpsp2cod)
define
    str   	    char(128),
    vppcod      integer,
    vprcod      integer,
    sgpcod      integer,
    shtcod      integer,
    zaimtocod      integer,
    pzaimtocod      integer,
    zaimfromcod      integer,
    pzaimfromcod      integer,
    gklp1cod     integer,
    gklp2cod     integer,
    gklr1cod     integer,
    gklr2cod     integer,
    gpsr1cod     integer,
    gpsr2cod     integer,
    gpsp1cod     integer,
    gpsp2cod     integer
    
    let str = "execute procedure stt_ins(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    
    let transaction = 1
    begin work
    execute p_ins using vppcod, vprcod, sgpcod, shtcod, 
                        zaimtocod, pzaimtocod, zaimfromcod, pzaimfromcod,
                        gklp1cod, gklp2cod, gklr1cod, gklr2cod,
                        gpsr1cod, gpsr2cod, gpsp1cod, gpsp2cod
    commit work
end function

