globals "globals.4gl"

function tovar_del(tovarcod)
define
    str         char(128),
    tovarcod    like tovar.cod

    whenever error call err
    
    let str = "execute procedure tovar_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using tovarcod
    commit work
end function

function tovar_sel(tovartipcod, where_str, order_str)
define  
    tovartipcod   integer,
    p   record
        cod         like tovar.cod,
        ei_cod      like ei.cod,
        nam         like tovar.nam,
        ei_nam      like ei.nam,
        cena        like tovar.cena,
        gs          like tovar.gs,
        isnds       like tovar.isnds,
        ispricelist like tovar.ispricelist,
        issernum    like tovar.issernum,
        newbuy      like tovar.newbuy,
        saleviawww  like tovar.saleviawww
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select a.cod, b.cod, a.nam, b.nam, a.cena, a.gs, a.isnds, a.ispricelist, a.issernum, ",
                     "a.newbuy, a.saleviawww ",
                 "from tovar a, ei b ",
                 "where a.ei_cod = b.cod and a.tovartip_cod=", tovartipcod, " and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", 
                p.ei_cod, "\t", 
                p.nam, "\t", 
                p.ei_nam, "\t", 
                p.cena using "#######.##", "\t", 
                p.gs, "\t", 
                p.isnds, "\t", 
                p.ispricelist, "\t", 
                p.issernum, "\t",
                p.newbuy, "\t",
                p.saleviawww
    end foreach
    commit work
end function

function tovar_ins(tovargroupcod, tovartipcod, tovarnam, ei_cod, cena, gs, 
                   isnds, ispricelist, issernum, newbuy, saleviawww)
define
    str     	    char(128),
    tovargroupcod, tovartipcod   integer,
    tovarcod	    like tovar.cod,
    ei_cod       like ei.cod,
    tovarnam         like tovar.nam,
    cena        like tovar.cena,
    gs          like tovar.gs,
    isnds       like tovar.isnds,
    ispricelist like tovar.ispricelist,
    issernum    like tovar.issernum,
    newbuy      like tovar.newbuy,
    saleviawww  like tovar.saleviawww
    
    let str = "execute procedure tovar_ins(?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using tovargroupcod, tovartipcod, tovarnam, ei_cod, cena, 
                       gs, isnds, ispricelist, issernum, newbuy, saleviawww
        fetch cur_ins into tovarcod
        display tovarcod
    close cur_ins
    commit work
end function

function tovar_upd(tovarcod, tovarnam, ei_cod, cena, gs, isnds, ispricelist, 
                   issernum, newbuy, saleviawww)
define
    str     	char(128),
    tovarcod        like tovar.cod,
    ei_cod       like ei.cod,
    tovarnam         like tovar.nam,
    cena        like tovar.cena,
    gs          like tovar.gs,
    isnds       like tovar.isnds,
    ispricelist like tovar.ispricelist,
    issernum    like tovar.issernum,
    newbuy      like tovar.newbuy,
    saleviawww  like tovar.saleviawww
    
    let str = "execute procedure tovar_upd(?,?,?,?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using tovarcod, tovarnam, ei_cod, cena, gs, isnds, 
                        ispricelist, issernum, newbuy, saleviawww
    commit work
end function

function tovar_rep(tovartipcod, where_str, order_str, pipe_str)
define  
    tovartipcod   integer,
    p   record
        groupnam    like tovar.nam,
        tipnam      like tovar.nam,
        nam         like tovar.nam,
        ei_nam      like ei.nam,
        cena        like tovar.cena,
        gs          like tovar.gs,
        isnds       like tovar.isnds,
        ispricelist like tovar.ispricelist,
        issernum    like tovar.issernum
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select c.nam, d.nam, a.nam, b.nam, a.cena, a.gs, a.isnds, a.ispricelist, a.issernum ",
                 "from tovar a, ei b, tovargroup c, tovartip d ",
                 "where a.tovargroup_cod = c.cod and a.tovartip_cod =d.cod and a.ei_cod = b.cod and a.tovartip_cod=", tovartipcod, " and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_tovar
        foreach cur_rep into p.*
            output to report r_tovar(p.groupnam, p.tipnam, p.nam, p.ei_nam, p.cena, p.gs, p.isnds, p.ispricelist, p.issernum)
        end foreach
    finish report r_tovar
    commit work
end function

report r_tovar(tovargroupnam, tovartipnam, tovarnam, ei_nam, cena, gs, isnds, ispricelist, issernum)
define	
    tovargroupnam    like tovargroup.nam,
    tovartipnam      like tovartip.nam,
    tovarnam         like tovar.nam,
    ei_nam       like ei.nam,
    cena        like tovar.cena,
    gs          like tovar.gs,
    isnds       like tovar.isnds,
    ispricelist like tovar.ispricelist,
    issernum    like tovar.issernum

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print " : ",tovargroupnam
        print "    : ",tovartipnam
        print "==================================================================================="
        print "              ..             ..     .."
        print "-----------------------------------------------------------------------------------"
    on every row
        print tovarnam, " ",ei_nam, " ",cena, " ",gs, "   ",isnds, "       ",ispricelist, "       ",issernum
    on last row
        print "==================================================================================="
end report

function tovar_he(hetovarnam)
define
    str     	                char(128),
    tovarcod, eicod             integer,
    tovarnam, hetovarnam        like tovar.nam,
    einam                       like ei.nam,
    cenaa                       like tovar.cena,
    isnds                       like tovar.isnds,
    ret                         smallint,
    sep                         char(1)
    
    let sep = ascii 3
    let str = "execute procedure tovar_he(?)"
    prepare p_he from str
    declare cur_he cursor for p_he
    
    let transaction = 1
    begin work
    open cur_he using hetovarnam
        while (TRUE)
            fetch cur_he into tovarcod, eicod, tovarnam, einam, cenaa, isnds, ret
            if status = notfound then exit while end if
            display tovarcod, sep, eicod, "\t", tovarnam, sep, einam, sep, cenaa using "#######.##", sep, isnds, "\t", ret
        end while
    close cur_he
    commit work
end function

function tovarp_he(hetovarnam)
define
    str     	                char(128),
    tovarcod, eicod             integer,
    tovarnam, hetovarnam        like tovar.nam,
    einam                       like ei.nam,
    issernum                    like tovar.isnds,
    ret                         smallint,
    sep                         char(1)
    
    let sep = ascii 3
    let str = "execute procedure tovarp_he(?)"
    prepare p_he3 from str
    declare cur_he3 cursor for p_he3
    
    let transaction = 1
    begin work
    open cur_he3 using hetovarnam
        while (TRUE)
            fetch cur_he3 into tovarcod, eicod, tovarnam, einam, issernum, ret
            if status = notfound then exit while end if
            display tovarcod, sep, eicod, "\t", tovarnam, sep, einam, sep, issernum, "\t", ret
        end while
    close cur_he3
    commit work
end function

function tovarbytip_he(hetovarnam)
define
    str     	                char(128),
    tovarcod, eicod, tovartipcod  integer,
    tovarnam, hetovarnam        like tovar.nam,
    einam                       like ei.nam,
    cenaa                       like tovar.cena,
    isnds                       like tovar.isnds,
    ret                         smallint,
    sep                         char(1),
    i                           smallint
    
    let i = 1
    while true
        if hetovarnam[i] = ':' then exit while end if
        let i = i + 1
    end while
    let i = i - 1
    let tovartipcod = hetovarnam[2,i]
    let i = i + 2
    let hetovarnam = "*",hetovarnam[i,50] clipped
    let sep = ascii 3
    let str = "execute procedure tovarbytip_he(?,?)"
    prepare p_he2 from str
    declare cur_he2 cursor for p_he2
    let transaction = 1
    begin work
    open cur_he2 using hetovarnam, tovartipcod
        while (TRUE)
            fetch cur_he2 into tovarcod, eicod, tovarnam, einam, cenaa, isnds, ret
            if status = notfound then exit while end if
            display tovarcod, sep, eicod, "\t", tovarnam, sep, einam, sep, cenaa using "#######.##", sep, isnds, "\t", ret
        end while
    close cur_he2
    commit work
end function

function tovarostatok_he(tip, skladcod, datpr, hetovarnam)
define
    tip                 char(1),
    str                 char(128),
    skladcod            integer,
    hetovarnam          like tovar.nam,
    datpr               date,
    ret                 smallint,
    sep                 char(1),
    operpcod            integer,
    tovarcod            integer,
    eicod               integer,
    datpokupki          date,
    tovarnam            like tovar.nam,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    einam               like ei.nam,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad,
    isnds               like tovar.isnds
    
    if tip = "m" then let tip = "M" end if
    if tip = "f" then let tip = "F" end if
    let sep = ascii 3
    let str = "execute procedure tovarostatok_he(?,?,?,?)"
    prepare p_he4 from str
    declare cur_he4 cursor for p_he4
    
    let transaction = 1
    begin work
    open cur_he4 using tip, skladcod, datpr, hetovarnam
        while (TRUE)
            fetch cur_he4 into operpcod,    tovarcod,   eicod,
                               datpokupki, tovarnam,    sernum,     kol,
                               einam,       cena,       cenad,  isnds, ret
            if status = notfound then exit while end if
            if tip = "M" then
                display operpcod, sep, 
                        tovarcod, sep, 
                        eicod, "\t", 
                        datpokupki using "ddmmyy", sep,
                        tovarnam, sep, 
                        sernum, sep,
                        kol using "-----.--", sep,
                        einam, sep, 
                        cena using "#####.##", sep,
                        cenad using "#####.##", sep,
                        " ",isnds, " \t", 
                        ret
            end if
            if tip = "F" then
                display operpcod, sep, 
                        tovarcod, sep, 
                        eicod, "\t", 
                        datpokupki using "ddmmyy", sep,
                        tovarnam, sep, 
                        kol using "-----.--", sep,
                        einam, sep, 
                        cena using "#####.##", sep,
                        " ",isnds, " \t",
                        ret
            end if
        end while
    close cur_he4
    commit work
end function

function tovarostatokskl_he(tip, datpr, hetovarnam)
define
    tip                 char(1),
    str                 char(128),
    hetovarnam          like tovar.nam,
    datpr               date,
    ret                 smallint,
    sep                 char(1),
    operpcod            integer,
    tovarcod            integer,
    eicod               integer,
    datpokupki          date,
    tovarnam            like tovar.nam,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    einam               like ei.nam,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad,
    isnds               like tovar.isnds,
    skladnam            like sklad.nam
    
    if tip = "m" then let tip = "M" end if
    if tip = "f" then let tip = "F" end if
    let sep = ascii 3
    let str = "execute procedure tovarostatokskl_he(?,?,?)"
    prepare p_he5 from str
    declare cur_he5 cursor for p_he5
    
    let transaction = 1
    begin work
    open cur_he5 using tip, datpr, hetovarnam
        while (TRUE)
            fetch cur_he5 into operpcod,    tovarcod,   eicod,
                               datpokupki,  tovarnam,   sernum,     kol,
                               einam,       cena,       cenad,      isnds, 
                               skladnam,    ret
            if status = notfound then exit while end if
            if tip = "M" then
                display operpcod, sep, 
                        tovarcod, sep, 
                        eicod, "\t", 
                        datpokupki using "ddmmyy", sep,
                        tovarnam, sep, 
                        sernum, sep,
                        kol using "-----.--", sep,
                        einam, sep, 
                        cena using "#####.##", sep,
                        cenad using "#####.##", sep,
                        " ",isnds, sep, 
                        skladnam, "\t",
                        ret
            end if
            if tip = "F" then
                display operpcod, sep, 
                        tovarcod, sep, 
                        eicod, "\t", 
                        datpokupki using "ddmmyy", sep,
                        tovarnam, sep, 
                        kol using "-----.--", sep,
                        einam, sep, 
                        cena using "#####.##", sep,
                        " ",isnds, sep,
                        skladnam, "\t",
                        ret
            end if
        end while
    close cur_he5
    commit work
end function

#    tovarostatokskl      
function tovarostatoksklg_he(tip, datpr, hetovarnam)
define
    tip                 char(1),
    str                 char(128),
    hetovarnam          like tovar.nam,
    datpr               date,
    ret                 smallint,
    sep                 char(1),
    operpcod            integer,
    tovarcod            integer,
    eicod               integer,
    datpokupki          date,
    tovarnam            char(43),
    sernum              char(20),
    kol                 like matoperp.kol,
    einam               char(5),
    cena                like matoperp.cena,
    cenad               like matoperp.cenad,
    isnds               like tovar.isnds,
    skladnam            like sklad.nam,
    datgar              date,
    gs                  like tovar.gs,
    prim                char(20)
    
    if tip = "m" then let tip = "M" end if
    if tip = "f" then let tip = "F" end if
    let sep = ascii 3
    let str = "execute procedure tovostsklg_he(?,?,?)"
    prepare p_he6 from str
    declare cur_he6 cursor for p_he6
    
    let transaction = 1
    begin work
    open cur_he6 using tip, datpr, hetovarnam
        while (TRUE)
            fetch cur_he6 into operpcod,    tovarcod,   eicod,
                               datpokupki,  tovarnam,   sernum,     kol,
                               einam,       cena,       cenad,      isnds, 
                               skladnam,    datgar,     gs,         prim,
                               ret
            if status = notfound then exit while end if
            if tip = "M" then
                display operpcod, sep, 
                        tovarcod, sep, 
                        eicod, "\t", 
                        datpokupki using "ddmmyy", sep,
                        tovarnam, sep, 
                        sernum, sep,
                        kol using "-----.--", sep,
                        einam, sep, 
                        cena using "#####.##", sep,
                        cenad using "#####.##", sep,
                        " ",isnds, sep, 
                        skladnam, sep,
                        datgar using "dd.mm.yyyy", sep,
                        gs, sep,
                        prim, "\t",
                        ret
            end if
            if tip = "F" then
                display operpcod, sep, 
                        tovarcod, sep, 
                        eicod, "\t", 
                        datpokupki using "ddmmyy", sep,
                        tovarnam, sep, 
                        kol using "-----.--", sep,
                        einam, sep, 
                        cena using "#####.##", sep,
                        " ",isnds, sep,
                        skladnam, "\t",
                        ret
            end if
        end while
    close cur_he6
    commit work
end function

function whattovarkol(tip, operrcod)
define
    str         char(128),
    tip         char(1),
    operrcod    integer,
    kol         like matoperp.kol
    
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    initialize kol to null
    let str = "execute procedure whattovarkol(?,?)"
    prepare p_whatkol from str
    declare cur_whatkol cursor for p_whatkol
    let transaction = 1
    begin work
    open cur_whatkol using tip, operrcod
        fetch cur_whatkol into kol
        display kol using "#####.##"
    close cur_whatkol
    commit work
end function

function tovarmany_sel(where_str, order_str)
define  
    p   record
        cod         like tovar.cod,
        nam         like tovar.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select a.cod, a.nam ",
                 "from tovar a ",
                 "where ", where_str, " ",
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel2 cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel2 into p.*
        display p.cod, "\t", 
                p.nam
    end foreach
    commit work
end function

function tovar_globper(fromcod, tocod)
define  fromcod, tocod  integer,
    str     char(256)

    let transaction = 1    
    database vipsklad exclusive
    
    let str = "set triggers for finoperp disabled"
    prepare p1 from str
    execute p1
    let str = "set triggers for finoperr disabled"
    prepare p2 from str
    execute p2
    let str = "set triggers for matoperp disabled"
    prepare p3 from str
    execute p3
    let str = "set triggers for matoperr disabled"
    prepare p4 from str
    execute p4
    let str = "set triggers for naklp disabled"
    prepare p5 from str
    execute p5
    let str = "set triggers for naklrtov disabled"
    prepare p6 from str
    execute p6
    let str = "set triggers for schetfnr disabled"
    prepare p7 from str
    execute p7
    let str = "set triggers for schfnrtov disabled"
    prepare p8 from str
    execute p8
    let str = "set triggers for schfnrtovt disabled"
    prepare p9 from str
    execute p9
    let str = "set triggers for vp disabled"
    prepare p10 from str
    execute p10
    
    begin work
        update schfnrtov
            set tovar_cod = tocod
            where tovar_cod = fromcod
        update schfnrtovt
            set tovar_cod = tocod
            where tovar_cod = fromcod
        update naklrtov
            set tovar_cod = tocod
            where tovar_cod = fromcod
        update matoperp
            set tovar_cod = tocod
            where tovar_cod = fromcod
        update finoperp
            set tovar_cod = tocod
            where tovar_cod = fromcod
        delete from tovar
            where cod = fromcod
    commit work
    
    let str = "set triggers for finoperp enabled"
    prepare p11 from str
    execute p11
    let str = "set triggers for finoperr enabled"
    prepare p12 from str
    execute p12
    let str = "set triggers for matoperp enabled"
    prepare p13 from str
    execute p13
    let str = "set triggers for matoperr enabled"
    prepare p14 from str
    execute p14
    let str = "set triggers for naklp enabled"
    prepare p15 from str
    execute p15
    let str = "set triggers for naklrtov enabled"
    prepare p16 from str
    execute p16
    let str = "set triggers for schetfnr enabled"
    prepare p17 from str
    execute p17
    let str = "set triggers for schfnrtov enabled"
    prepare p18 from str
    execute p18
    let str = "set triggers for schfnrtovt enabled"
    prepare p19 from str
    execute p19
    let str = "set triggers for vp enabled"
    prepare p20 from str
    execute p20
end function
