globals "globals.4gl"

function tovargroup_del(tovargroupcod)
define
    str         char(128),
    tovargroupcod    like tovargroup.cod

    whenever error call err

    let str = "execute procedure tovargroup_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using tovargroupcod
    commit work
end function

function tovargroup_sel(where_str, order_str)
define  
    p   record
        cod         like tovargroup.cod,
        nam         like tovargroup.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam ",
                 "from tovargroup ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam
    end foreach
    commit work
end function

function tovargroup_ins(tovargroupnam)
define
    str     	    char(128),
    tovargroupcod	    like tovargroup.cod,
    tovargroupnam        like tovargroup.nam
    
    let str = "execute procedure tovargroup_ins(?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using tovargroupnam
        fetch cur_ins into tovargroupcod
        display tovargroupcod
    close cur_ins
    commit work
end function

function tovargroup_upd(tovargroupcod, tovargroupnam)
define
    str     	char(128),
    tovargroupcod        like tovargroup.cod,
    tovargroupnam        like tovargroup.nam
    
    let str = "execute procedure tovargroup_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using tovargroupcod, tovargroupnam
    commit work
end function

function tovargroup_rep(where_str, order_str, pipe_str)
define  
    p   record
        nam         like tovargroup.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select nam ",
                  "from tovargroup ",
                  "where ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_tovargroup
        foreach cur_rep into p.*
            output to report r_tovargroup(p.nam)
        end foreach
    finish report r_tovargroup
    commit work
end function

report r_tovargroup(nam)
define	
    nam         like tovargroup.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "================================"
        print "      "
        print "--------------------------------"
    on every row
        print " ",nam
    on last row
        print "================================"
end report
