globals "globals.4gl"

function tovartip_del(tovartipcod)
define
    str         char(128),
    tovartipcod    like tovartip.cod

    whenever error call err

    let str = "execute procedure tovartip_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using tovartipcod
    commit work
end function

function tovartip_sel(tovargroupcod, where_str, order_str)
define  
    tovargroupcod   integer,
    p   record
        cod         like tovartip.cod,
        nam         like tovartip.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, nam ",
                 "from tovartip ",
                 "where tovargroup_cod=", tovargroupcod, " and ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", p.nam
    end foreach
    commit work
end function

function tovartip_ins(tovargroupcod, tovartipnam)
define
    str     	    char(128),
    tovargroupcod   integer,
    tovartipcod	    like tovartip.cod,
    tovartipnam     like tovartip.nam
    
    let str = "execute procedure tovartip_ins(?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using tovargroupcod, tovartipnam
        fetch cur_ins into tovartipcod
        display tovartipcod
    close cur_ins
    commit work
end function

function tovartip_upd(tovartipcod, tovartipnam)
define
    str     	char(128),
    tovartipcod        like tovartip.cod,
    tovartipnam        like tovartip.nam
    
    let str = "execute procedure tovartip_upd(?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using tovartipcod, tovartipnam
    commit work
end function

function tovartip_rep(tovargroupcod, where_str, order_str, pipe_str)
define  
    tovargroupcod   integer,
    p   record
        tovargroupnam   like tovargroup.nam,
        nam         like tovartip.nam
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    select nam 
        into p.tovargroupnam
        from tovargroup
        where cod = tovargroupcod
        
    let str = "select nam ",
                  "from tovartip ",
                  "where tovargroup_cod=", tovargroupcod, " and ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_tovartip
        foreach cur_rep into p.nam
            output to report r_tovartip(p.tovargroupnam, p.nam)
        end foreach
    finish report r_tovartip
    commit work
end function

report r_tovartip(tovargroupnam, nam)
define	
    tovargroupnam   like tovargroup.nam,
    nam             like tovartip.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print " : ", tovargroupnam
        print "================================"
        print "      "
        print "--------------------------------"
    on every row
        print " ",nam
    on last row
        print "================================"
end report

function tovargtip_he(hetovargroupcod, hetovartipnam)
define
    str     	                 char(128),
    tovartipcod, hetovargroupcod integer,
    tovartipnam, hetovartipnam   like tovar.nam,
    ret                          smallint

    let str = "execute procedure tovargtip_he(?,?)"
    prepare p_he from str
    declare cur_he cursor for p_he
    
    let transaction = 1
    begin work
    open cur_he using hetovargroupcod, hetovartipnam
        while (TRUE)
            fetch cur_he into tovartipcod, tovartipnam, ret
            if status = notfound then exit while end if
            display tovartipcod, "\t", 
                    tovartipnam, "\t", 
                    ret
        end while
    close cur_he
    commit work
end function
