globals "globals.4gl"

function tovdolg_sel(where_str, sort_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        fuf_cod     integer,
        doc_cod     integer,
        doc_tip     char(1),
        tovarnam    like tovar.nam,
        kol         decimal(7,2),
        einam       like ei.nam,
        docsumma    decimal(9,2),
        oplsumma    decimal(9,2),
        klientnam   like klient.nam,
        numdoc      smallint,
        datdolga    date,
        oplmindat   date
    end record,
    str         char(5096),
    tip         char(1),
    flgopl      char(1),
    datdolga    date
    
    whenever error call err

    let str = "select a.cod, a.schetfnr_cod, 's', ",
                     "b.nam, a.kol - doccodkol(a.cod), c.nam, ",
                     "d.summa, e.summa, f.nam, d.num, ",
                     "whatdatdolga(d.dat_dolga, e.dat), ",
                     "e.dat, d.summa - e.summa ",
                "from schfnrtov a, tovar b, ei c, _schetshead d, ",
                     "outer _schetoplmindat e, klient f ",
                "where a.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                      "a.tovar_cod = b.cod and ",
                      "b.ei_cod = c.cod and ",
                      "a.schetfnr_cod = d.cod and ",
                      "a.schetfnr_cod = e.schet_cod and ",
                      "d.klient_cod = f.cod and ",
                      where_str clipped," ",
                "union ",
                "select a.cod, a.schetfnr_cod, 's', ",
                     "b.nam, a.kol - doccodkol(a.cod), c.nam, ",
                     "d.summa, e.summa, f.nam, d.num, ",
                     "whatdatdolga(d.dat_dolga, e.dat), ",
                     "e.dat, d.summa - e.summa ",
                "from schfnrtovt a, tovar b, ei c, _schetshead d, ",
                     "outer _schetoplmindat e, klient f ",
                "where a.tovar_cod = b.cod and ",
                      "b.ei_cod = c.cod and ",
                      "a.schetfnr_cod = d.cod and ",
                      "a.schetfnr_cod = e.schet_cod and ",
                      "d.klient_cod = f.cod and ",
                      where_str clipped," ",
                "union ",
                "select a.cod, a.naklr_cod, 'i', ",
                     "b.nam, a.kol - doccodkol(a.cod), c.nam, ",
                     "d.summa, e.summaall, f.nam, d.num, ",
                     "whatdatdolga(d.dat_dolga, e.mindat), ",
                     "e.mindat, d.summa - e.summaall ",
                "from naklrtov a, tovar b, ei c, _naklrshead d, ",
                     "outer _naklroplmindat e, klient f ",
                "where a.tovar_cod = b.cod and ",
                      "b.ei_cod = c.cod and ",
                      "a.naklr_cod = d.cod and ",
                      "a.naklr_cod = e.naklr_cod and ",
                      "d.klient_cod = f.cod and ",
                      where_str clipped," ",
                "order by ", sort_str clipped

    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.kol > 0 and p.datdolga is not null
        then
            if p.oplsumma is null then let p.oplsumma = 0 end if
            if p.docsumma = p.oplsumma then let flgopl = '=' end if
            if p.docsumma > p.oplsumma then let flgopl = '+' end if
            if p.docsumma < p.oplsumma then let flgopl = '-' end if
            if p.oplsumma = 0 then let flgopl = '0' end if
            display p.doc_cod, "\t",
                    p.doc_tip, "\t",
                    p.tovarnam, "\t",
                    p.kol using "#####.##", "\t",
                    p.einam, "\t",
                    flgopl, "\t",
                    p.klientnam, "\t",
                    p.numdoc, "\t",
                    p.datdolga using "dd.mm.yyyy"
        end if
    end foreach
    commit work
end function

function tovdolg_rep(where_str, sort_str, pipe_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        fuf_cod     integer,
        doc_cod     integer,
        doc_tip     char(1),
        tovarnam    like tovar.nam,
        kol         decimal(7,2),
        einam       like ei.nam,
        docsumma    decimal(9,2),
        oplsumma    decimal(9,2),
        klientnam   like klient.nam,
        numdoc      smallint,
        datdolga    date,
        oplmindat   date
    end record,
    flgopl      char(1),
    str         char(2048),
    pipe_str    char(256),
    datdolga    date
    
    let reppipe = pipe_str
    let str = "select a.cod, a.schetfnr_cod, 's', ",
                     "b.nam, a.kol - doccodkol(a.cod), c.nam, ",
                     "d.summa, e.summa, f.nam, d.num, ",
                     "whatdatdolga(d.dat_dolga, e.dat), ",
                     "e.dat, d.summa - e.summa ",
                "from schfnrtov a, tovar b, ei c, _schetshead d, ",
                     "outer _schetoplmindat e, klient f ",
                "where a.cod not in (select schfnrtov_cod from schfnrtovt) and ",
                      "a.tovar_cod = b.cod and ",
                      "b.ei_cod = c.cod and ",
                      "a.schetfnr_cod = d.cod and ",
                      "a.schetfnr_cod = e.schet_cod and ",
                      "d.klient_cod = f.cod and ",
                      where_str clipped," ",
                "union ",
                "select a.cod, a.schetfnr_cod, 's', ",
                     "b.nam, a.kol - doccodkol(a.cod), c.nam, ",
                     "d.summa, e.summa, f.nam, d.num, ",
                     "whatdatdolga(d.dat_dolga, e.dat), ",
                     "e.dat, d.summa - e.summa ",
                "from schfnrtovt a, tovar b, ei c, _schetshead d, ",
                     "outer _schetoplmindat e, klient f ",
                "where a.tovar_cod = b.cod and ",
                      "b.ei_cod = c.cod and ",
                      "a.schetfnr_cod = d.cod and ",
                      "a.schetfnr_cod = e.schet_cod and ",
                      "d.klient_cod = f.cod and ",
                      where_str clipped," ",
                "union ",
                "select a.cod, a.naklr_cod, 'i', ",
                     "b.nam, a.kol - doccodkol(a.cod), c.nam, ",
                     "d.summa, e.summaall, f.nam, d.num, ",
                     "whatdatdolga(d.dat_dolga, e.mindat), ",
                     "e.mindat, d.summa - e.summaall ",
                "from naklrtov a, tovar b, ei c, _naklrshead d, ",
                     "outer _naklroplmindat e, klient f ",
                "where a.tovar_cod = b.cod and ",
                      "b.ei_cod = c.cod and ",
                      "a.naklr_cod = d.cod and ",
                      "a.naklr_cod = e.naklr_cod and ",
                      "d.klient_cod = f.cod and ",
                      where_str clipped," ",
                "order by ", sort_str clipped
    prepare p_rep from str
    
    initialize p to null
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_tovdolg
        foreach cur_rep into p.*
            if p.kol > 0 and p.datdolga is not null
            then
                if p.oplsumma is null then let p.oplsumma = 0 end if
                if p.docsumma = p.oplsumma then let flgopl = '=' end if
                if p.docsumma > p.oplsumma then let flgopl = '+' end if
                if p.docsumma < p.oplsumma then let flgopl = '-' end if
                if p.oplsumma = 0 then let flgopl = '0' end if
                output to report r_tovdolg(p.tovarnam, p.kol, p.einam, flgopl, 
                                           p.klientnam, p.numdoc, p.datdolga )
            end if
        end foreach
    finish report r_tovdolg
    commit work
end function

report r_tovdolg(tovarnam, kol, einam, flgopl, klientnam, numdoc, datdolga)
define	
    tovarnam    like tovar.nam,
    kol         like matoperp.kol,
    einam       like ei.nam,
    flgopl      char(1),
    klientnam   like klient.nam,
    numdoc      char(10),
    datdolga    date

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"  ",vidoff,twicewidthoff, passon
      print "==============================================================================================================================="
      print "                            | -  |  .  |  |                            |     |      |"
      print "                                  |  |  . |  |                                 |    .  |     |"
      print "-------------------------------------------------------------------------------------------------------------------------------"
    on every row
      print tovarnam[1,40], " ", kol using "#####.##", " ", einam[1,7], "   ", flgopl, "   ", klientnam[1,40], " ", numdoc, " ", datdolga using "dd.mm.yyyy"
    on last row
      print "===============================================================================================================================", passoff
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

