globals "globals.4gl"

function tovinrez_sel(where_str, sort_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        opercod     integer,
        doccod      integer,
        tipdoc      char(40),
        num         smallint,
        dat         date,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,
        klientnam   like klient.nam,
        prim1       char(60),
        primrez     like primrez.nam,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        mindatopl   date,
        sall        decimal(9,2),
        sopl        decimal(9,2)
    end record,
    str         char(3096),
    tip         char(1),
    flgopl      char(1)
    
    whenever error call err

    let str = "select a.cod, a.schetfnr_cod, '', b.num, b.dat, ",
                     "c.nam, d.nam, e.nam, b.prim1, j.nam, g.nam, f.sernum, a.kol, ",
                     "h.nam,  l.dat, k.summa, l.summa, k.summa - l.summa ",
                "from matoperr a, _schet b, sklad c, operacia d, klient e, ",
                     "matoperp f, tovar g, ei h, primrez j, _schets k, ",
                     "outer _schetoplmindat l ",
                "where a.datotg is null and ",
                      "a.schetfnr_cod = b.cod and ",
                      "f.sklad_cod = c.cod and ",
                      "b.operacia_cod = d.cod and ",
                      "b.klient_cod = e.cod and ",
                      "a.matoperp_cod = f.cod and ",
                      "f.tovar_cod = g.cod and ",
                      "g.ei_cod = h.cod and ",
                      "a.cod = j.matoperr_cod and ",
                      "a.schetfnr_cod = k.cod and ",
                      "a.schetfnr_cod = l.schet_cod and ",
                      where_str clipped," ",
                "union ",
                "select a.cod, b.cod, '   ', b.num, b.dat, ",
                     "c.nam, d.nam, e.nam, b.prim1, j.nam, g.nam, f.sernum, a.kol, ",
                     "h.nam,  l.mindat, k.summaall, l.summaall, k.summaall - l.summaall ",
                "from matoperr a, naklrtov b1, naklr b, outer sklad c, operacia d, klient e, ",
                     "matoperp f, tovar g, ei h, primrez j, _naklrs k, ",
                     "outer _naklroplmindat l ",
                "where a.datotg is null and ",
                      "a.doc_cod = b1.cod and ",
                      "b1.naklr_cod = b.cod and ",
                      "a.schetfnr_cod is null and ",
                      "f.sklad_cod = c.cod and ",
                      "b.operacia_cod = d.cod and ",
                      "b.klient_cod = e.cod and ",
                      "a.matoperp_cod = f.cod and ",
                      "f.tovar_cod = g.cod and ",
                      "g.ei_cod = h.cod and ",
                      "a.cod = j.matoperr_cod and ",
                      "b1.naklr_cod = k.cod and ",
                      "b1.naklr_cod = l.naklr_cod and ",
                      where_str clipped," ",
                "order by ", sort_str clipped

    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.sopl is null then let p.sopl = 0 end if
        if p.sall = p.sopl then
            let flgopl = '='
        end if
        if p.sall > p.sopl then
            let flgopl = '+'
        end if
        if p.sall < p.sopl then
            let flgopl = '-'
        end if
        if p.sopl = 0 then
            let flgopl = ''
        end if
        display p.doccod, "\t", 
                p.tipdoc, "\t", 
                p.num, "\t", 
                p.dat using "dd.mm.yyyy", "\t", 
                p.skladnam, "\t",
                p.operacianam, "\t",
                p.klientnam, "\t",
                p.prim1, "\t",
                p.primrez, "\t",
                p.tovarnam, "\t",
                p.sernum, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.mindatopl, "\t",
                flgopl
    end foreach
    commit work
end function

function tovinrez_rep(where_str, sort_str, pipe_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        opercod     integer,
        doccod      integer,
        tipdoc      char(40),
        num         smallint,
        dat         date,
        skladnam    like sklad.nam,
        operacianam like operacia.nam,
        klientnam   like klient.nam,
        prim1       char(60),
        primrez     like primrez.nam,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        mindatopl   date,
        sall        decimal(9,2),
        sopl        decimal(9,2)
    end record,
    str         char(3096),
    tip         char(1),
    flgopl      char(1),
    pipe_str    char(256)
    
    let reppipe = pipe_str

    let str = "select a.cod, a.schetfnr_cod, '', b.num, b.dat, ",
                     "c.nam, d.nam, e.nam, b.prim1, j.nam, g.nam, f.sernum, a.kol, ",
                     "h.nam,  l.dat, k.summa, l.summa, k.summa - l.summa ",
                "from matoperr a, _schet b, sklad c, operacia d, klient e, ",
                     "matoperp f, tovar g, ei h, primrez j, _schets k, ",
                     "outer _schetoplmindat l ",
                "where a.datotg is null and ",
                      "a.schetfnr_cod = b.cod and ",
                      "f.sklad_cod = c.cod and ",
                      "b.operacia_cod = d.cod and ",
                      "b.klient_cod = e.cod and ",
                      "a.matoperp_cod = f.cod and ",
                      "f.tovar_cod = g.cod and ",
                      "g.ei_cod = h.cod and ",
                      "a.cod = j.matoperr_cod and ",
                      "a.schetfnr_cod = k.cod and ",
                      "a.schetfnr_cod = l.schet_cod and ",
                      where_str clipped," ",
                "union ",
                "select a.cod, b.cod, '   ', b.num, b.dat, ",
                     "c.nam, d.nam, e.nam, b.prim1, j.nam, g.nam, f.sernum, a.kol, ",
                     "h.nam,  l.mindat, k.summaall, l.summaall, k.summaall - l.summaall ",
                "from matoperr a, naklrtov b1, naklr b, outer sklad c, operacia d, klient e, ",
                     "matoperp f, tovar g, ei h, primrez j, _naklrs k, ",
                     "outer _naklroplmindat l ",
                "where a.datotg is null and ",
                      "a.doc_cod = b1.cod and ",
                      "b1.naklr_cod = b.cod and ",
                      "a.schetfnr_cod is null and ",
                      "f.sklad_cod = c.cod and ",
                      "b.operacia_cod = d.cod and ",
                      "b.klient_cod = e.cod and ",
                      "a.matoperp_cod = f.cod and ",
                      "f.tovar_cod = g.cod and ",
                      "g.ei_cod = h.cod and ",
                      "a.cod = j.matoperr_cod and ",
                      "b1.naklr_cod = k.cod and ",
                      "b1.naklr_cod = l.naklr_cod and ",
                      where_str clipped," ",
                "order by ", sort_str clipped

    prepare p_sel from str
    
    initialize p to null
    declare cur_sel2 cursor for p_sel
    let transaction = 1    
    begin work
    start report r_tovinrez
        foreach cur_sel2 into p.*
            if p.sopl is null then let p.sopl = 0 end if
            if p.sall = p.sopl then
                let flgopl = '='
            end if
            if p.sall > p.sopl then
                let flgopl = '+'
            end if
            if p.sall < p.sopl then
                let flgopl = '-'
            end if
            if p.sopl = 0 then
                let flgopl = ''
            end if
            output to report r_tovinrez(flgopl, p.num, p.dat, p.klientnam,
                p.tovarnam, p.sernum, p.kol, p.skladnam, p.operacianam)
        end foreach
    finish report r_tovinrez
    commit work
end function

report r_tovinrez(flgopl, num, dat, klientnam,
                  tovarnam, sernum, kol, skladnam, operacianam)
define	
    flgopl      char(1),
    num         like naklr.num,
    dat         like naklr.dat,
    klientnam   like klient.nam,
    skladnam    like sklad.nam,
    tovarnam    like tovar.nam,
    sernum      like matoperp.sernum,
    kol         like matoperp.kol,
    operacianam like operacia.nam

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"           ",vidoff,twicewidthoff,passon
      print "============================================================================================================================"
      print "|  N  |      |              |               |       | . |          |       "
      print "----------------------------------------------------------------------------------------------------------------------------"
    on every row
      print " ", flgopl, " ", num, " ", dat, " ", klientnam[1,20], " ", tovarnam[1,20], " ", sernum, " ", kol using "#####.##", " ", skladnam[1,15]," ", operacianam[1,15]
    on last row
      print "============================================================================================================================"
      call whatsot()
      print passoff,downindex,": ",userfio clipped,indexoff,formfeed
end report

