globals "globals.4gl"
    
function valuta_del(valutacod)
define
    str         char(128),
    valutacod    like valuta.cod

    whenever error call err
    
    let str = "execute procedure valuta_del(?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using valutacod
    commit work
end function

function valuta_sel(where_str, order_str)
define  
    p   record
        cod         like valuta.cod,
        dat         like valuta.dat,
        kurs_p      like valuta.kurs_p,
        kurs_s      like valuta.kurs_s,
        kurs_i      like valuta.kurs_i
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64)
    
    let str = "select cod, dat, kurs_p, kurs_s, kurs_i ",
                 "from valuta ",
                 "where ", where_str clipped,
                 " order by ", order_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.cod, "\t", 
                p.dat, "\t", 
                p.kurs_p, "\t",
                p.kurs_s, "\t",
                p.kurs_i
    end foreach
    commit work
end function

function valuta_ins(dat, kursp, kurss, kursi)
define
    str     	    char(128),
    cod	            like valuta.cod,
    dat             like valuta.dat,
    kursp           like valuta.kurs_p,
    kurss           like valuta.kurs_s,
    kursi           like valuta.kurs_i
    
    let str = "execute procedure valuta_ins(?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using dat, kursp, kurss, kursi
        fetch cur_ins into cod
        display cod
    close cur_ins
    commit work
end function

function valuta_upd(cod, dat, kursp, kurss, kursi)
define
    str     	char(128),
    cod         like valuta.cod,
    dat         like valuta.dat,
    kursp       like valuta.kurs_p,
    kurss       like valuta.kurs_s,
    kursi       like valuta.kurs_i
    
    let str = "execute procedure valuta_upd(?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using cod, dat, kursp, kurss, kursi
    commit work
end function

function valuta_rep(where_str, order_str, pipe_str)
define  
    p   record
        dat         like valuta.dat,
        kurs_p      like valuta.kurs_p,
        kurs_s      like valuta.kurs_s,
        kurs_i      like valuta.kurs_i
    end record,
    str         char(768),
    where_str   char(128),
    order_str   char(64),
    pipe_str    char(256)
    
    let str = "select dat, kurs_p, kurs_s, kurs_i ",
                  "from valuta ",
                  "where ", where_str clipped,
                  " order by ", order_str clipped
    prepare p_rep from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_valuta
        foreach cur_rep into p.*
            output to report r_valuta(p.dat, p.kurs_p, p.kurs_s, p.kurs_i)
        end foreach
    finish report r_valuta
    commit work
end function

report r_valuta(dat, kursp, kurss, kursi)
define	
    dat         like valuta.dat,
    kursp       like valuta.kurs_p,
    kurss       like valuta.kurs_s,
    kursi       like valuta.kurs_i

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		19
	
format	
    first page header
        print "========================================="
        print "      |     |     | "
        print "          |  |    | ."
        print "-----------------------------------------"
    on every row
        print dat using "dd.mm.yyyy", "     ", kursp using "#.####","     ", kurss using "#.####","     ", kursi using "#.####"
    on last row
        print "========================================="
end report

