globals "globals.4gl"

function vplist_sel(tip, where_str, sort_str)
define  
    where_str   char(256),
    sort_str    char(64),
    tip         char(1),
    p   record
        cod         integer,
        num         like vp.num,
        dat         like vp.dat,
        skladrnam   like sklad.nam,
        skladpnam   like sklad.nam,
        summa1      decimal(9,2),
        summa2      decimal(9,2)
    end record,
    str         char(1024),
    tbl         char(20)

    whenever error call err
    
    case tip
        when "f" let tbl = "_vpfs"
        when "m" let tbl = "_vpms"
    end case
    
    let str = "select a.cod, a.num as num, a.dat as dat, b.nam as srnam, ",
                     "c.nam as spnam, a.summa1 as summa1, a.summa2 as summa2 ",
                 "from ", tbl clipped," a, sklad b, sklad c ",
                 "where a.skladr_cod = b.cod and ",
                       "a.skladp_cod = c.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.summa1 is null then let p.summa1 = 0 end if
        if p.summa2 is null then let p.summa2 = 0 end if
        display p.cod, "\t", 
                p.num, "\t", 
                p.dat using "dd.mm.yyyy", "\t", 
                p.skladrnam, "\t", 
                p.skladpnam, "\t", 
                p.summa1 using "#######.##", "\t",
                p.summa2 using "#######.##"
    end foreach
    commit work
end function

function vplist_rep(tip, where_str, sort_str, pipe_str)
define  
    where_str   char(256),
    sort_str    char(64),
    tip         char(1),
    p   record
        num         like vp.num,
        dat         like vp.dat,
        skladrnam   like sklad.nam,
        skladpnam   like sklad.nam,
        summa1      decimal(9,2),
        summa2      decimal(9,2)
    end record,
    str         char(1024),
    tbl         char(20),
    pipe_str    char(256)
    
    case tip
        when "f" let tbl = "_vpfs"
        when "m" let tbl = "_vpms"
        when "n" let tbl = "_vpns"
    end case
    
    let str = "select a.num as num, a.dat as dat, b.nam as srnam, ",
                     "c.nam as spnam, a.summa1 as summa1, a.summa2 as summa2 ",
                 "from ", tbl clipped," a, sklad b, sklad c ",
                 "where a.skladr_cod = b.cod and ",
                       "a.skladp_cod = c.cod and ",
                       where_str clipped," ",
                 "order by ", sort_str clipped
    prepare p_replist from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_replist cursor for p_replist
    let transaction = 1    
    begin work
    start report r_vplist
        foreach cur_replist into p.*
            if p.summa1 is null then let p.summa1 = 0 end if
            if p.summa2 is null then let p.summa2 = 0 end if
            output to report r_vplist( tip, p.num, p.dat, p.skladrnam, 
                                          p.skladpnam, p.summa1, 
                                          p.summa2)
        end foreach
    finish report r_vplist
    commit work
end function

report r_vplist(tip,num, dat, skladrnam, skladpnam, summa1, summa2)
define	
    tip         char(1),
    strtip      char(20),
    num         like vp.num,
    dat         like vp.dat,
    skladrnam   like sklad.nam,
    skladpnam    like sklad.nam,
    summa1      decimal(9,2),
    summa2      decimal(9,2)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      case tip
         when "f" let strtip = " "
         when "m" let strtip = " "
      end case
      print twicewidthon,vidon,"", strtip clipped,"    ",vidoff,twicewidthoff
      print "====================================================================="
      print "     |      |   |      |      |  " 
      print "---------------------------------------------------------------------"
    on every row
      print num, " ", dat, passon, skladrnam, " ", skladpnam,passoff,summa1 using "#######.##", " ", summa2 using "#######.##"
    on last row
      print "====================================================================="
      print "                            : ",sum(summa1) using "#######.##"," ",sum(summa2) using "#######.##"
      print "====================================================================="
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

