globals "globals.4gl"

function vptov_upd(tip, operrcod, vpoperpcod, kol)
define
    str     	    char(128),
    tip             like vp.tip,
    vpoperpcod, operrcod  integer,
    kol             like matoperp.kol

    whenever error call err
    
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure vptov_upd(?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using tip, operrcod, vpoperpcod, kol
    commit work
end function

function vptov_sel(tip, vpcod, order_str)
define  
    tip             like vp.tip,
    vpcod        integer,
    p   record
        operrcod        integer,
        vpoperpcod      integer,
        operpcod        integer,
        tovarcod        integer,
        tovarnam        like tovar.nam,
        sernum          like matoperp.sernum,
        kol             like matoperp.kol,
        einam           like ei.nam,
        cena            like matoperp.cena,
        cenad           like matoperp.cenad
    end record,
    str         char(768),
    order_str   char(64)
    
    if tip = 'm' or tip = 'M' then
        let str = "select a.cod, a.vpmatoperp_cod, a.matoperp_cod, ",
                         "b.tovar_cod, c.nam as tnam, ",
                         "b.sernum as sernumm, a.kol as koll, d.nam as enam, ",
                         "a.cena as cenaa, a.cenad as cenadd ",
                     "from matoperr a, matoperp b, tovar c, ei d ",
                     "where a.matoperp_cod = b.cod and ",
                           "a.doc_cod = ", vpcod, " and ",
                           "b.tovar_cod = c.cod and ",
                           "c.ei_cod = d.cod ",
                     "order by ", order_str clipped
    end if
    
    if tip = 'f' or tip = 'F' then
        let str = "select a.cod, a.vpfinoperp_cod, a.finoperp_cod, ",
                         "b.tovar_cod, c.nam as tnam, ",
                         "'', a.kol as koll, d.nam as enam, ",
                         "a.cena as cenaa, 0 ",
                     "from finoperr a, finoperp b, tovar c, ei d ",
                     "where a.finoperp_cod = b.cod and ",
                           "a.doc_cod = ", vpcod, " and ",
                           "b.tovar_cod = c.cod and ",
                           "c.ei_cod = d.cod ",
                     "order by ", order_str clipped
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if tip = 'm' or tip = 'M' then
            display p.operrcod, "\t",
                    p.vpoperpcod, "\t",
                    p.operpcod, "\t",
                    p.tovarcod, "\t",
                    p.tovarnam, "\t",
                    p.sernum, "\t",
                    p.kol using "#####.##", "\t",
                    p.einam, "\t",
                    p.cena using "#######.##", "\t",
                    p.cenad using "#######.##"
        end if
        if tip = 'f' or tip = 'F' then
            display p.operrcod, "\t",
                    p.vpoperpcod, "\t",
                    p.operpcod, "\t",
                    p.tovarcod, "\t",
                    p.tovarnam, "\t",
                    p.kol using "#####.##", "\t",
                    p.einam, "\t",
                    p.cena using "#######.##"
        end if
    end foreach
    commit work
end function

function vptov_del(tip, operrcod, operpcod)
define
    str     	    char(128),
    tip             like vp.tip,
    operrcod, operpcod  integer
    
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure vptov_del(?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using tip, operrcod, operpcod
    commit work
end function

function vptov_ins(tip, vpcod, operpcodhe, skladpcod, datotg, kol)
define
    str     	    char(128),
    tip             like vp.tip,
    vpcod, operpcodhe, skladpcod integer,
    operrcod, operpcod  integer,
    datotg          date,
    kol             like matoperp.kol
    
    initialize operrcod, operpcod to null
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    let str = "execute procedure vptov_ins(?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using tip, vpcod, operpcodhe, skladpcod, datotg, kol
        fetch cur_ins into operrcod, operpcod
        display operrcod, "\t", operpcod
    close cur_ins
    commit work
end function

function vphead_rep(tip, vpcod, order_str, pipe_str)
define  
    tip         char(1),
    vpcod    integer,
    order_str, pipe_str    char(256),
    str         char(768),
    p   record
        num		    like vp.num,
        dat		    date,
        skladrnam   like sklad.nam,
        skladpnam   like sklad.nam,
        prim1       like vp.prim1,
        tovarnam	like schfnrtov.printnam,
        sernum      like matoperp.sernum,
        kol		    like matoperp.kol,
        einam		like ei.nam,
        cena		like matoperp.cena,
        cenad       like matoperp.cenad
    end record
    
    if tip = 'n' then let tip = 'N' end if
    if tip = 'f' then let tip = 'F' end if
    if tip = 'm' then let tip = 'M' end if
    
    if tip = "N" or tip = "M" then
        let str = "select x0.num, x0.dat, x1.nam, x2.nam, x0.prim1, ",
                         "c.nam as tnam, ",
                         "b.sernum as sernumm, a.kol as koll, d.nam as enam, ",
                         "a.cena as cenaa, a.cenad as cenadd ",
                     "from vp x0, sklad x1, sklad x2, matoperr a, matoperp b, tovar c, ei d ",
                     "where x0.cod = ", vpcod, " and ",
                           "x0.skladr_cod = x1.cod and ",
                           "x0.skladp_cod = x2.cod and ",
                           "a.doc_cod = x0.cod and ",
                           "a.matoperp_cod = b.cod and ",
                           "b.tovar_cod = c.cod and ",
                           "c.ei_cod = d.cod ",
                     "order by ", order_str clipped
    end if
    if tip = "F" then
        let str = "select x0.num, x0.dat, x1.nam, x2.nam, x0.prim1, ",
                         "c.nam as tnam, ",
                         "'', a.kol as koll, d.nam as enam, ",
                         "a.cena as cenaa, 0 ",
                     "from vp x0, sklad x1, sklad x2, finoperr a, finoperp b, tovar c, ei d ",
                     "where x0.cod = ", vpcod, " and ",
                           "x0.skladr_cod = x1.cod and ",
                           "x0.skladp_cod = x2.cod and ",
                           "a.doc_cod = x0.cod and ",
                           "a.finoperp_cod = b.cod and ",
                           "b.tovar_cod = c.cod and ",
                           "c.ei_cod = d.cod ",
                     "order by ", order_str clipped
    end if
    prepare p_repvp from str
    
    initialize p to null
    let reppipe = pipe_str
    declare cur_repvp cursor for p_repvp
    let transaction = 1    
    begin work
    start report r_vp
        foreach cur_repvp into p.*
            output to report r_vp(tip, p.num, p.dat, p.skladrnam,
                                  p.skladpnam, p.prim1,
                                  p.tovarnam, p.sernum, p.kol, p.einam, 
                                  p.cena, p.cenad)
        end foreach
    finish report r_vp
    commit work
end function

report r_vp(tip, num, dat, skladrnam, skladpnam, prim1,
            tovarnam, sernum, kol, einam, cena, cenad)
define	
    tip         char(1),
    num		    like vp.num,
    dat		    date,
    skladrnam   like sklad.nam,
    skladpnam   like sklad.nam,
    prim1       like vp.prim1,
    tovarnam	like schfnrtov.printnam,
    sernum      like matoperp.sernum,
    kol		    like matoperp.kol,
    einam		like ei.nam,
    cena		like matoperp.cena,
    cenad       like matoperp.cenad,
    tipstr      char(20)

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      skip 1 line
      if tip = "F" then let tipstr = "" end if
      if tip = "M" then let tipstr = "" end if
      print twicewidthon,vidon,tipstr clipped,"  ",vidoff,twicewidthoff,"N-",vidon,num using "<<<<<",vidoff,"",vidon,dat using "dd/mm/yyyy",vidoff,"."
      print "  :",vidon,skladrnam,vidoff
      print "    :",vidon,skladpnam,vidoff
      print ":",vidon,prim1,vidoff
      if tip != "F" then
        print "================================================================================================================"
        print "                             |  | - |     |     |       |   " 
        print "                                               |     | |         |         |            |"
        print "================================================================================================================"
      else
        print "=============================================================================="
        print "                             | - |     |   " 
        print "                                               | |         |"
        print "=============================================================================="
      end if
    on every row
      if tip != "F" then
        print passon,tovarnam," ",sernum,passoff,kol using "####.##",cena using " #######.##", cenad using " #######.##", cena * kol using " #######.##", cenad * kol using " #######.##"
      else
        print passon,tovarnam,passoff,kol using "####.##",cena using " #######.##", cena * kol using " #######.##"
      end if
    on last row
      if tip != "F" then
        print "================================================================================================================"
      else
        print "================================================================================"
      end if
      print "                                                             :", sum(cena * kol ) using "#######.##"
      print "                                                             :", sum(cenad * kol ) using "#######.##"
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report
