globals "globals.4gl"

function zaimlist_sel(tip, where_str, sort_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        doc_cod     integer,
        doc_tip     char(1),
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         decimal(7,2),
        einam       like ei.nam,
        tovsum      decimal(9,2),
        gashsum     decimal(9,2),
        oplsum      decimal(9,2),
        klientnam   like klient.nam,
        numdoc      char(10),
        datzaima    date
    end record,
    str         char(5096),
    flggash     char(1),
    pogashenie  decimal(9,2),
    tip         char(1)
    
    whenever error call err

    if tip = 'z' then
        let str = "select a.cod, 'P', c.nam, b.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, a.num, a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklpzaimtovsum a, matoperp b, tovar c, ei d, ",
                         "outer _naklpzaimgashsum e, outer _naklpzaimoplsum f, ",
                         "klient g ",
                    "where a.cod = b.naklp_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklp_cod and ",
                          "a.cod = f.naklp_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                  "union ",
                  "select a.cod, 'R', c.nam, b1.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, itoc(a.num), a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklrzaimtovsum a, naklrtov a1, matoperr b, matoperp b1, ",
                         "tovar c, ei d, ",
                         "outer _naklrzaimgashsum e, outer _naklrzaimoplsum f, ",
                         "klient g ",
                    "where a.cod = a1.naklr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b1.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklr_cod and ",
                          "a.cod = f.naklr_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                    "order by ", sort_str clipped
    end if
    
    if tip = 'g' then
        let str = "select a.cod, 'P', c.nam, b.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, a.num, a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklpgartovsum a, matoperp b, tovar c, ei d, ",
                         "outer _naklpgargashsum e, outer _naklpgaroplsum f, ",
                         "klient g ",
                    "where a.cod = b.naklp_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklp_cod and ",
                          "a.cod = f.naklp_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                  "union ",
                  "select a.cod, 'R', c.nam, b1.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, itoc(a.num), a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklrgartovsum a, naklrtov a1, matoperr b, matoperp b1, ",
                         "tovar c, ei d, ",
                         "outer _naklrgargashsum e, outer _naklrgaroplsum f, ",
                         "klient g ",
                    "where a.cod = a1.naklr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b1.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklr_cod and ",
                          "a.cod = f.naklr_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                    "order by ", sort_str clipped
    end if

    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        if p.gashsum is null then let p.gashsum = 0 end if
        if p.oplsum is null then let p.oplsum = 0 end if
        let pogashenie = p.gashsum + p.oplsum
        if p.tovsum = pogashenie then let flggash = '=' end if
        if p.tovsum > pogashenie then let flggash = '+' end if
        if p.tovsum < pogashenie then let flggash = '-' end if
        if pogashenie = 0 then let flggash = '0' end if
        if flggash != '=' then
            display p.doc_cod, "\t",
                    p.doc_tip, "\t",
                    p.tovarnam, "\t",
                    p.sernum, "\t",
                    p.kol using "#####.##", "\t",
                    p.einam, "\t",
                    flggash, "\t",
                    p.klientnam, "\t",
                    p.numdoc, "\t",
                    p.datzaima using "ddmmyy"
        end if
    end foreach
    commit work
end function

function zaimlist_rep(tip, where_str, sort_str, pipe_str)
define  
    where_str   char(1048),
    sort_str    char(64),
    p   record
        doc_cod     integer,
        doc_tip     char(1),
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         decimal(7,2),
        einam       like ei.nam,
        tovsum      decimal(9,2),
        gashsum     decimal(9,2),
        oplsum      decimal(9,2),
        klientnam   like klient.nam,
        numdoc      char(10),
        datzaima    date
    end record,
    str         char(5096),
    flggash     char(1),
    pogashenie  decimal(9,2),
    pipe_str    char(256),
    tip         char(1)
    
    let reppipe = pipe_str
    if tip = 'z' then
        let str = "select a.cod, 'P', c.nam, b.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, a.num, a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklpzaimtovsum a, matoperp b, tovar c, ei d, ",
                         "outer _naklpzaimgashsum e, outer _naklpzaimoplsum f, ",
                         "klient g ",
                    "where a.cod = b.naklp_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklp_cod and ",
                          "a.cod = f.naklp_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                  "union ",
                  "select a.cod, 'R', c.nam, b1.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, itoc(a.num), a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklrzaimtovsum a, naklrtov a1, matoperr b, matoperp b1, ",
                         "tovar c, ei d, ",
                         "outer _naklrzaimgashsum e, outer _naklrzaimoplsum f, ",
                         "klient g ",
                    "where a.cod = a1.naklr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b1.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklr_cod and ",
                          "a.cod = f.naklr_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                    "order by ", sort_str clipped
    end if
    if tip = 'g' then
        let str = "select a.cod, 'P', c.nam, b.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, a.num, a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklpgartovsum a, matoperp b, tovar c, ei d, ",
                         "outer _naklpgargashsum e, outer _naklpgaroplsum f, ",
                         "klient g ",
                    "where a.cod = b.naklp_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklp_cod and ",
                          "a.cod = f.naklp_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                  "union ",
                  "select a.cod, 'R', c.nam, b1.sernum, b.kol, d.nam, a.sumtov, ",
                         "e.sumgash, f.sumopl, g.nam, itoc(a.num), a.dat, ",
                         "a.sumtov - nulltozero(e.sumgash) - nulltozero(f.sumopl) ",
                    "from _naklrgartovsum a, naklrtov a1, matoperr b, matoperp b1, ",
                         "tovar c, ei d, ",
                         "outer _naklrgargashsum e, outer _naklrgaroplsum f, ",
                         "klient g ",
                    "where a.cod = a1.naklr_cod and ",
                          "a1.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b1.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.cod = e.naklr_cod and ",
                          "a.cod = f.naklr_cod and ",
                          "a.klient_cod = g.cod and ",
                          where_str clipped," ",
                    "order by ", sort_str clipped
    end if
    prepare p_rep from str
    
    initialize p to null
    declare cur_rep cursor for p_rep
    let transaction = 1    
    begin work
    start report r_zaimlist
        foreach cur_rep into p.*
            if p.gashsum is null then let p.gashsum = 0 end if
            if p.oplsum is null then let p.oplsum = 0 end if
            let pogashenie = p.gashsum + p.oplsum
            if p.tovsum = pogashenie then let flggash = '=' end if
            if p.tovsum > pogashenie then let flggash = '+' end if
            if p.tovsum < pogashenie then let flggash = '-' end if
            if pogashenie = 0 then let flggash = '0' end if
            if flggash != '=' then
                output to report r_zaimlist(p.tovarnam, p.sernum, p.kol, p.einam, flggash, 
                                            p.klientnam, p.numdoc, p.datzaima )
            end if
        end foreach
    finish report r_zaimlist
    commit work
end function

report r_zaimlist(tovarnam, sernum, kol, einam, flggash, klientnam, numdoc, datzaima)
define	
    tovarnam    like tovar.nam,
    sernum      like matoperp.sernum,
    kol         like matoperp.kol,
    einam       like ei.nam,
    flggash      char(1),
    klientnam   like klient.nam,
    numdoc      char(10),
    datzaima    date

output
    report to pipe reppipe
    left margin		0
    right margin 	75
    top margin		0
    bottom margin	0
    page length		16
	
format	
    first page header
      print twicewidthon,vidon,"",vidoff,twicewidthoff, passon
      print "==============================================================================================================================="
      print "                       |       | -  |  .  |-|             |     |      |"
      print "                             |                    |  |  . ||                  |    .  |  .    |"
      print "-------------------------------------------------------------------------------------------------------------------------------"
    on every row
      print tovarnam[1,35], " ", sernum, " ", kol using "#####.##", " ", einam[1,7], "   ", flggash, "   ", klientnam[1,25], " ", numdoc, " ", datzaima using "dd.mm.yyyy"
    on last row
      print "===============================================================================================================================", passoff
      call whatsot()
      print downindex,": ",userfio clipped,indexoff,formfeed
end report

