globals "globals.4gl"

function zaimtov_ins(tip, doccod, dat, skladcod, operaciacod, klientcod,
                     tovarcod, operpcod, sernum, kol, cena, cenad)
define
    str     	        char(128),
    tip                 char(4),
    num, naklcod, matopercod     integer,
    doccod, skladcod, operaciacod, klientcod, tovarcod, operpcod  integer,
    dat                 date,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad
    
    whenever error call err

    initialize matopercod to null
    let str = "execute procedure zaimtov_ins(?,?,?,?,?,?,?,?,?,?,?,?)"
    prepare p_ins from str
    declare cur_ins cursor for p_ins
    let transaction = 1
    begin work
    open cur_ins using tip, doccod, dat, skladcod, operaciacod, klientcod,
                       tovarcod, operpcod, sernum, kol, cena, cenad
        fetch cur_ins into naklcod, matopercod, num
        display naklcod, "\t",
                matopercod, "\t",
                num using "-----"
    close cur_ins
    commit work
end function

function zaimtov_upd(tip, naklcod, matopercod, tovarcod, dat, sernum, kol, cena, cenad)
define
    str     	        char(128),
    tip                 char(4),
    naklcod, matopercod, tovarcod   integer,
    dat                 date,
    sernum              like matoperp.sernum,
    kol                 like matoperp.kol,
    cena                like matoperp.cena,
    cenad               like matoperp.cenad
    
    let str = "execute procedure zaimtov_upd(?,?,?,?,?,?,?,?,?)"
    prepare p_upd from str
    let transaction = 1
    begin work
    execute p_upd using tip, naklcod, matopercod, tovarcod, dat, 
                        sernum, kol, cena, cenad
    commit work
end function

function zaimtov_sel(tip, doccod)
define  
    doccod  integer,
    tip     char(4),
    p   record
        naklcod     integer,
        matopercod  integer,
        tovarcod    integer,
        num         smallint,
        dat         date,
        tovarnam    like tovar.nam,
        sernum      like matoperp.sernum,
        kol         like matoperp.kol,
        einam       like ei.nam,
        cena        like matoperp.cena,
        cenad        like matoperp.cenad
    end record,
    str         char(1024)
    
    if tip = "to" then
        let str = "select a.cod, b.cod, c.cod, a.num, a.dat, ",
                         "c.nam, b.sernum, b.kol, d.nam, b.cena, b.cenad ",
                    "from naklp a, matoperp b, tovar c, ei d ",
                    "where a.cod in (select slave_cod from zaimlink where master_cod = ", doccod, ") and ",
                          "a.cod = b.naklp_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.tip = 'Z' ",
                    " order by a.dat, a.num"
    end if
    if tip = "from" then
        let str = "select a.cod, b.cod, c.cod, a.num, a.dat, ",
                         "c.nam, b1.sernum, b.kol, d.nam, b.cena, b.cenad ",
                    "from naklr a, matoperr b, matoperp b1, tovar c, ei d ",
                    "where a.cod in (select slave_cod from zaimlink where master_cod = ", doccod, ") and ",
                          "a.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b1.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod ",
                    " order by a.dat, a.num"
    end if
    if tip = "gklp" then
        let str = "select a.cod, b.cod, c.cod, a.num, a.dat, ",
                         "c.nam, b1.sernum, b.kol, d.nam, b.cena, b.cenad ",
                    "from naklr a, matoperr b, matoperp b1, tovar c, ei d ",
                    "where a.cod in (select slave_cod from garlink where master_cod = ", doccod, ") and ",
                          "a.cod = b.doc_cod and ",
                          "b.matoperp_cod = b1.cod and ",
                          "b1.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod ",
                    " order by a.dat, a.num"
    end if
    if tip = "gpsr" then
        let str = "select a.cod, b.cod, c.cod, a.num, a.dat, ",
                         "c.nam, b.sernum, b.kol, d.nam, b.cena, b.cenad ",
                    "from naklp a, matoperp b, tovar c, ei d ",
                    "where a.cod in (select slave_cod from garlink where master_cod = ", doccod, ") and ",
                          "a.cod = b.naklp_cod and ",
                          "b.tovar_cod = c.cod and ",
                          "c.ei_cod = d.cod and ",
                          "a.tip = 'G' ",
                    " order by a.dat, a.num"
    end if
    prepare p_sel from str
    
    initialize p to null
    declare cur_sel cursor for p_sel
    let transaction = 1    
    begin work
    foreach cur_sel into p.*
        display p.naklcod, "\t",
                p.matopercod, "\t",
                p.tovarcod, "\t",
                p.num using "-----", "\t",
                p.dat using "ddmmyyyy", "\t",
                p.tovarnam, "\t",
                p.sernum, "\t",
                p.kol using "#####.##", "\t",
                p.einam, "\t",
                p.cena using "#######.##", "\t",
                p.cenad using "#######.##"
    end foreach
    commit work
end function

function zaimtov_del(tip, naklcod, matopercod)
define
    str         char(128),
    tip         char(4),
    naklcod, matopercod  integer
    
    let str = "execute procedure zaimtov_del(?,?,?)"
    prepare p_del from str
    let transaction = 1
    begin work
    execute p_del using tip, naklcod, matopercod
    commit work
end function

