#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <shadow.h>
#include <crypt.h>
#include <unistd.h>
#include <pwd.h>
#include <time.h>
#include <fcntl.h>

int     myport;
int     backlog;
char    logfile[80], workdir[80], informixdir[80], informixserver[80];
char    client_locale[80], db_locale[80], dbpath[80], path[80], dbdate[80];
char    dbtemp[80];
char    par[80], val[80], myportc[80], backlogc[80];

FILE *fcfg, *flog, *fopen();

main()
{
    int     sockfd, new_fd;            /* listen on sock_fd, new connection on new_fd */
    struct  sockaddr_in my_addr;    /* my address information */
    struct  sockaddr_in their_addr; /* connector's address information */
    int     sin_size;
    char    password[20], login[20], key[2], *newpasswd, lopa[45];
    struct  spwd *shadow;
    struct  passwd *ppwd;
    time_t  t;
    char    *ts;
    FILE    *ffd, *fopen();

    if ( ( fcfg = fopen("/etc/tiketd.cfg", "r") ) == NULL ) {
        fprintf(stderr,"Error open config file: /etc/tiketd.cfg\n");
        exit(-1);
    }
    
    rcfg();

    if ( ( sockfd = socket (AF_INET, SOCK_STREAM, 0) ) == -1) {
        fprintf(stderr,"socket error\n");
        exit (-1);
    }

    my_addr.sin_family = AF_INET;         /* host byte order */
    my_addr.sin_port = htons(myport);     /* short, network byte order */
    my_addr.sin_addr.s_addr = INADDR_ANY; /* auto-fill with my IP */
    bzero(&(my_addr.sin_zero), 8);        /* zero the rest of the struct */
    
    if ( bind (sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
        fprintf(stderr,"bind error\n");
        exit (-2);
    }
     
    if ( listen (sockfd, backlog) == -1) {
        fprintf(stderr,"listen error\n");
        exit (-3);
    }
    
    setenv("DBDATE","dbdate");
    setenv("INFORMIXDIR", informixdir);   
    setenv("INFORMIXSERVER", informixserver);
    setenv("CLIENT_LOCALE", client_locale);
    setenv("DB_LOCALE", db_locale);
    setenv("DBPATH", dbpath);
    setenv("PATH", path);
    setenv("DBDATE", dbdate);
    setenv("DBTEMP", dbtemp);
    chdir(workdir);

    umask(077);
    flog = fopen(logfile, "a+");
    
    time(&t);
    ts = ctime(&t);
    fprintf(flog,"----------=> RUN TIKETD in %s", ts);
    fflush(flog);
    
    while(1) {  /* main accept() loop */
        
        sin_size = sizeof(struct sockaddr_in);
        
        if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size)) == -1) {
            fprintf (stderr,"accept error\n");
            continue;
        }
        
        ffd = fdopen(new_fd,"a+");
        
        time(&t);
        ts = ctime(&t);
        fprintf(flog, "got connection from %s in\t%s", inet_ntoa(their_addr.sin_addr), ts);
        fflush(flog);
        
        if ( !fork() ) { /* this is the child process */
            if ( fprintf(ffd, "SERVICE OK\n") < 0 ) {
                time(&t);
                ts = ctime(&t);
                fprintf(flog, "\topen service error in\t\t%s",ts);
                fflush(flog);
            }
            fflush(ffd);
            fgets(lopa, 45, ffd);
            sscanf(lopa,"%s%s", login, password);
            
            time(&t);
            ts = ctime(&t);
            fprintf(flog,"\tlogin %s in\t\t\t%s", login, ts);
            fflush(flog);
            
            if ( (ppwd = getpwnam(login)) != NULL ) {
                shadow = getspnam(login);     /*    /etc/shadow */         
                key[0] = shadow->sp_pwdp[0];
                key[1] = shadow->sp_pwdp[1];
                newpasswd = crypt(password,key);

                if ( ppwd->pw_uid != 0 ) {
                    if ( strcmp(newpasswd, shadow->sp_pwdp) == 0 && strlen(newpasswd) > 0 ) {
                        setuid(ppwd->pw_uid);
                        resolvrunprg(ffd);
                    } else {
                        fprintf(ffd,"BAD PASSWD\n");
                        fflush(ffd);
                        time(&t);
                        ts = ctime(&t);
                        fprintf(flog,"\tbad password for login %s in\t%s", login, ts);
                        fflush(flog);
                    }
                } else {
                    fprintf(ffd,"BAD PASSWD\n");
                    fflush(ffd);
                    time(&t);
                    ts = ctime(&t);
                    fprintf(flog,"\troot no access in\t\t%s", ts);
                    fflush(flog);
                }
            } else {
                fprintf(ffd,"BAD PASSWD\n");
                fflush(ffd);
                time(&t);
                ts = ctime(&t);
                fprintf(flog,"\tuser not found in\t\t%s", ts);
                fflush(flog);
            }
            
            time(&t);
            ts = ctime(&t);
            fprintf(flog, "close connection from %s in\t%s", inet_ntoa(their_addr.sin_addr), ts);
            fflush(flog);
            
            fclose(ffd);
            close(new_fd);
            exit(0);
        }
        fclose(ffd);
        close(new_fd);  /* parent doesn't need this */
        while ( waitpid (-1, NULL, WNOHANG) > 0); /* clean up child processes */
    }
    fclose (flog);
}

resolvrunprg(FILE *ffd)
{
    char    nameprg[5120];
    FILE    *fp, *popen();
    int     reterr, flgwrite, ch;
    
    fprintf(ffd,"PASSWD OK\n");
    fflush(ffd);
    
    fgets(nameprg, 5119, ffd);
    nameprg[strlen(nameprg) - 2] = ' ';
    //     '\n'    ' '
    //    '\000' 
    // ,       
    //      -  '\n'
    fp = popen(nameprg, "r");
    

    fprintf(flog,"\trun %s\n", nameprg);
    fflush(flog);
    
    flgwrite = 0;
    while  ( ( ch = fgetc(fp) ) != EOF ) {
        fputc(ch, ffd);
        flgwrite = 1;
    }

    /*   ,      
    * -
    */

    reterr = pclose(fp);

    /*  -   -1    0 
    *   
    */
    if ( reterr != 0 ) {
        fprintf(flog,"\terror run %s\n", nameprg);
        fflush(flog);
        if ( flgwrite == 0 ) {
            fprintf(ffd, "\001\002\003\004\005\006\007\n-1\nshell:    \n");
        }
    } else {
        fprintf(ffd, "\001\002\003\004\005\006\007\n0\n");
    }
    fflush(ffd);
}

rcfg() /*   conf- */
    {
     int    c, flg_comentar, i;
     char   parameters[160];

     flg_comentar = i = 0;
     
     while( ( c = fgetc(fcfg) ) != EOF) {
        if(c == '\n') { /*          par  var */ 
            flg_comentar=i=0; 
            sscanf(parameters,"%s%s",par,val);
            idpar();
        }
        
        if(flg_comentar == 1) continue; /*   */
        if(c == '#') { 
            flg_comentar=1; 
            for ( i = 0; i < 160; i++ ) parameters[i]='\0'; 
        } 
        
        /*  -_  parameters */
        if(flg_comentar == 0 && c != '\n') { 
            if ( c == '\t') c=' '; 
            parameters[i]=c; 
            i++;
        } 
     }
     fclose(fcfg);
    }

idpar() /*   */
    {
     if( strcmp(par, "myport") == 0)         strcpy(myportc, val);
     myport = atoi(myportc);
     if( strcmp(par, "backlog") == 0)        strcpy(backlogc, val);
     backlog = atoi(backlogc);
     if( strcmp(par, "logfile") == 0)        strcpy(logfile, val);
     if( strcmp(par, "workdir") == 0)        strcpy(workdir, val);
     if( strcmp(par, "informixdir") == 0)    strcpy(informixdir, val);
     if( strcmp(par, "informixserver") == 0) strcpy(informixserver, val);
     if( strcmp(par, "client_locale") == 0)  strcpy(client_locale, val);
     if( strcmp(par, "db_locale") == 0)      strcpy(db_locale, val);
     if( strcmp(par, "dbpath") == 0)         strcpy(dbpath, val);
     if( strcmp(par, "path") == 0)           strcpy(path, val);
     if( strcmp(par, "dbdate") == 0)         strcpy(dbdate, val);
     if( strcmp(par, "dbtemp") == 0)         strcpy(dbtemp, val);
    }
   
