{ TABLE ei row size = 14 number of columns = 2 index size = 33 }
create table ei 
  (
    cod serial not null ,
    nam nchar(10) not null ,
    unique (nam)  constraint u101_4,
    primary key (cod) 
  );

{ TABLE gorod row size = 40 number of columns = 3 index size = 72 }
create table gorod 
  (
    cod serial not null ,
    nam nchar(30) not null ,
    phone_cod char(6),
    unique (nam,phone_cod)  constraint u102_8,
    primary key (cod) 
  );

{ TABLE lgota row size = 38 number of columns = 3 index size = 63 }
create table lgota 
  (
    cod serial not null ,
    nam nchar(30) not null ,
    proc decimal(5,2) not null ,
    unique (nam)  constraint u103_12,
    primary key (cod) 
  );

{ TABLE myorg row size = 470 number of columns = 20 index size = 0 }
create table myorg 
  (
    nam nchar(50),
    gorod_nam nchar(50),
    phone_cod char(6),
    index char(6),
    ulica nchar(50),
    boss_fio nchar(50),
    boss_phone char(9),
    glbuh_fio nchar(50),
    glbuh_phone char(9),
    bank_nam nchar(50),
    bank_mfo char(6),
    bank_schet1 char(14),
    bank_schet2 char(14),
    zkpo char(8),
    inn char(12),
    ns char(8),
    phone_o char(9),
    fax char(9),
    email char(30),
    www char(30)
  );

{ TABLE nds row size = 11 number of columns = 3 index size = 12 }
create table nds 
  (
    cod serial not null ,
    dat date not null ,
    stavka decimal(4,2),
    unique (dat)  constraint u106_30,
    
    check (stavka >= 0.00 )
  );

{ TABLE operacia row size = 36 number of columns = 3 index size = 66 }
create table operacia 
  (
    cod serial not null ,
    p_r smallint not null ,
    nam nchar(30) not null ,
    unique (nam,p_r)  constraint u107_35,
    
    check (p_r IN (-1 ,1 )),
    primary key (cod) 
  );

{ TABLE tovargroup row size = 34 number of columns = 2 index size = 63 }
create table tovargroup 
  (
    cod serial not null ,
    nam nchar(30) not null ,
    unique (nam)  constraint u108_41,
    primary key (cod) 
  );

{ TABLE tovartip row size = 38 number of columns = 3 index size = 75 }
create table tovartip 
  (
    cod serial not null ,
    tovargroup_cod integer not null ,
    nam nchar(30) not null ,
    unique (nam)  constraint u109_45,
    primary key (cod) 
  );

{ TABLE codes_sofnr row size = 4 number of columns = 1 index size = 12 }
create table codes_sofnr 
  (
    cod serial not null ,
    primary key (cod) 
  );

{ TABLE sklad row size = 38 number of columns = 3 index size = 75 }
create table sklad 
  (
    cod serial not null ,
    matotv_cod integer not null ,
    nam nchar(30) not null ,
    unique (nam)  constraint u112_68,
    primary key (cod) 
  );

{ TABLE naklp row size = 102 number of columns = 10 index size = 60 }
create table naklp 
  (
    cod integer not null ,
    num nchar(10) not null ,
    dat date not null ,
    kurs decimal(4,2),
    sklad_cod integer not null ,
    operacia_cod integer not null ,
    klient_cod integer not null ,
    prim1 nchar(60),
    usr char(8) not null ,
    tip char(1),
    
    check (kurs > 0.00 ),
    
    check (tip IN ('N' ,'M' ,'F' ,'Z' ,'G' )) constraint c_tip,
    primary key (cod) 
  );

create index "slon2".naklp1 on naklp (dat);
{ TABLE finoperp row size = 43 number of columns = 9 index size = 79 }
create table finoperp 
  (
    cod serial not null ,
    doc_cod integer not null ,
    naklp_cod integer not null ,
    dat_pokupki date not null ,
    sklad_cod integer not null ,
    tovar_cod integer not null ,
    kol decimal(7,2) not null ,
    cena decimal(9,2) not null ,
    usr char(8) not null ,
    
    check (kol > 0.00 ),
    
    check (cena > 0.00 ),
    primary key (cod) 
  );

create index "slon2".finoperp1 on finoperp (sklad_cod,
    tovar_cod,dat_pokupki,kol);
{ TABLE naklropl row size = 24 number of columns = 5 index size = 24 }
create table naklropl 
  (
    cod serial not null ,
    naklr_cod integer not null ,
    dat date not null ,
    summa decimal(9,2) 
        default 0.00 not null ,
    summad decimal(9,2) 
        default 0.00 not null ,
    
    check (summa >= 0.00 ),
    
    check (summa >= 0.00 ),
    primary key (cod) 
  );

{ TABLE naklrtov row size = 37 number of columns = 7 index size = 36 }
create table naklrtov 
  (
    cod integer not null ,
    naklr_cod integer not null ,
    tovar_cod integer not null ,
    kol decimal(7,2) not null ,
    cena decimal(9,2) 
        default 0.00 not null ,
    cenad decimal(9,2) 
        default 0.00 not null ,
    usr char(8) not null ,
    unique (cod)  constraint u121_316,
    
    check (kol > 0.00 ),
    
    check (cena >= 0.00 ),
    
    check (cenad >= 0.00 )
  );

{ TABLE nnakl row size = 206 number of columns = 9 index size = 36 }
create table nnakl 
  (
    cod serial not null ,
    schetfnr_cod integer not null ,
    sofnr_cod integer not null ,
    num smallint not null ,
    dat date not null ,
    umova nchar(60),
    forma nchar(60),
    prim1 nchar(60),
    usr char(8) not null ,
    primary key (cod) 
  );

{ TABLE schfnrtov row size = 106 number of columns = 7 index size = 36 }
create table schfnrtov 
  (
    cod integer not null ,
    schetfnr_cod integer not null ,
    tovar_cod integer not null ,
    printnam nchar(75),
    kol decimal(7,2) not null ,
    cena decimal(9,2) not null ,
    usr char(8) not null ,
    
    check (kol > 0.00 ),
    
    check (cena > 0.00 ),
    primary key (cod) 
  );

{ TABLE schfnrtovt row size = 35 number of columns = 7 index size = 36 }
create table schfnrtovt 
  (
    cod integer not null ,
    schetfnr_cod integer not null ,
    schfnrtov_cod integer not null ,
    tovar_cod integer not null ,
    kol decimal(7,2) not null ,
    cena decimal(9,2) not null ,
    usr char(8) not null ,
    
    check (kol > 0.00 ),
    
    check (cena > 0.00 )
  );

{ TABLE nnakltov row size = 26 number of columns = 5 index size = 36 }
create table nnakltov 
  (
    cod serial not null ,
    nnakl_cod integer not null ,
    schfnrtov_cod integer not null ,
    summa decimal(9,2),
    usr char(8) not null ,
    
    check (summa > 0.00 ),
    primary key (cod) 
  );

{ TABLE primrez row size = 74 number of columns = 2 index size = 12 }
create table primrez 
  (
    matoperr_cod integer not null ,
    nam nchar(70),
    unique (matoperr_cod)  constraint u127_240
  );

{ TABLE schetopl row size = 18 number of columns = 4 index size = 24 }
create table schetopl 
  (
    cod integer not null ,
    schet_cod integer not null ,
    dat date not null ,
    summa decimal(9,2) not null ,
    
    check (summa > 0.00 )
  );

{ TABLE sostav row size = 14 number of columns = 4 index size = 36 }
create table sostav 
  (
    cod serial not null ,
    master_cod integer not null ,
    slave_cod integer not null ,
    sort_field smallint not null ,
    primary key (cod) 
  );

{ TABLE vp row size = 87 number of columns = 8 index size = 48 }
create table vp 
  (
    cod integer not null ,
    num smallint not null ,
    dat date not null ,
    skladr_cod integer not null ,
    skladp_cod integer not null ,
    prim1 nchar(60),
    usr char(8) not null ,
    tip char(1) not null ,
    
    check (tip IN ('F' ,'M' )),
    primary key (cod) 
  );

create index "slon2".vp1 on vp (dat);
{ TABLE finpmatplink row size = 8 number of columns = 2 index size = 24 
              }
create table finpmatplink 
  (
    finoperp_cod integer not null ,
    matoperp_cod integer not null ,
    unique (finoperp_cod)  constraint u132_273,
    unique (matoperp_cod)  constraint u132_274
  );

{ TABLE klient row size = 762 number of columns = 48 index size = 129 }
create table klient 
  (
    cod serial not null constraint n104_20,
    nam nchar(50) not null constraint n104_21,
    balans decimal(9,2) 
        default 0.00 not null constraint n104_22,
    urlico char(1),
    sot char(1),
    matotv char(1),
    nds char(1),
    post char(1),
    datreg date,
    lgota_cod integer,
    numcard nchar(5),
    gorod_cod integer not null constraint n104_28,
    index char(6),
    ulica nchar(50),
    dom nchar(8),
    kv nchar(4),
    pgorod_cod integer,
    pindex char(6),
    pulica char(50),
    pdom nchar(8),
    pkv nchar(4),
    phone_boss char(9),
    phone_buh char(9),
    phone_o char(9),
    fax char(9),
    email char(30),
    boss_f nchar(20),
    boss_i nchar(20),
    boss_o nchar(20),
    boss_i2 nchar(20),
    boss_o2 nchar(20),
    boss_i3 nchar(20),
    boss_o3 nchar(20),
    boss_born date,
    boss_sex nchar(1),
    cont_fio nchar(50),
    cont_dol nchar(50),
    cont_p_r char(9),
    cont_p_d char(30),
    zkpo char(8),
    inn char(12),
    ns char(8),
    bank_nam nchar(50),
    bank_mfo char(6),
    bank_schet char(14),
    sot_cod integer,
    prim nchar(80),
    login char(8),
    unique (nam)  constraint u104_17,
    
    check (urlico IN ('*' , '')) constraint c104_23,
    
    check (sot IN ('*' , '')) constraint c104_24,
    
    check (matotv IN ('*' , '')) constraint c104_25,
    
    check (nds IN ('*' , '')) constraint c104_26,
    
    check (post IN ('*' , '')) constraint c104_27,
    
    check (boss_sex IN ('' ,'' , '')) constraint c104_29,
    primary key (cod)  constraint u104_16
  );

{ TABLE matoperp row size = 73 number of columns = 12 index size = 79 }
create table matoperp 
  (
    cod serial not null constraint n117_131,
    doc_cod integer not null constraint n117_132,
    naklp_cod integer not null constraint n117_133,
    dat_pokupki date not null constraint n117_134,
    sklad_cod integer not null constraint n117_135,
    tovar_cod integer not null constraint n117_136,
    sernum nchar(20),
    dat_gar date,
    kol decimal(7,2) not null constraint n117_137,
    cena decimal(9,2),
    cenad decimal(9,2) 
        default 0.00,
    usr char(8) not null constraint n117_141,
    
    check (kol > 0.00 ) constraint c117_138,
    
    check (cena >= 0.00 ) constraint c117_139,
    
    check (cenad >= 0.00 ) constraint c117_140,
    primary key (cod)  constraint u117_126
  );

create index "slon2".matoperp1 on matoperp (sklad_cod,
    tovar_cod,dat_pokupki,kol);
{ TABLE matoperr row size = 53 number of columns = 11 index size = 60 }
create table matoperr 
  (
    cod serial not null constraint n118_147,
    schetfnr_cod integer,
    doc_cod integer not null constraint n118_148,
    matoperp_cod integer not null constraint n118_149,
    vpmatoperp_cod integer,
    datotg date,
    dat_gar date,
    kol decimal(7,2) not null constraint n118_151,
    cena decimal(9,2),
    cenad decimal(9,2) 
        default 0.00,
    usr char(8) not null constraint n118_155,
    
    check (datotg > '01011999' ) constraint c118_150,
    
    check (kol > 0.00 ) constraint c118_152,
    
    check (cena >= 0.00 ) constraint c118_153,
    
    check (cenad >= 0.00 ) constraint c118_154,
    primary key (cod)  constraint u118_142
  );

create index "slon2".matoperr1 on matoperr (datotg);
{ TABLE schetfnr row size = 238 number of columns = 16 index size = 60 }
create table schetfnr 
  (
    cod integer not null constraint n115_108,
    schet_num smallint not null constraint n115_109,
    schet_dat date not null constraint n115_110,
    operacia_cod integer not null constraint n115_111,
    klient_cod integer not null constraint n115_112,
    lgota_proc decimal(5,2),
    prim1 nchar(60),
    prim2 nchar(60),
    finnaklr_num smallint,
    finnaklr_dat date,
    sklad_cod integer,
    dovnum nchar(10),
    dovdat date,
    dovwho nchar(60),
    dat_dolga date,
    usr char(8) not null constraint n115_113,
    primary key (cod)  constraint u115_103
  );

create index "slon2".schetfnr1 on schetfnr (schet_dat);
    
{ TABLE finoperr row size = 43 number of columns = 9 index size = 48 }
create table finoperr 
  (
    cod serial not null constraint n116_119,
    schetfnr_cod integer,
    doc_cod integer not null constraint n116_120,
    finoperp_cod integer not null constraint n116_121,
    vpfinoperp_cod integer,
    datotg date 
        default today not null ,
    kol decimal(7,2) not null constraint n116_122,
    cena decimal(9,2),
    usr char(8) not null constraint n116_125,
    
    check (kol > 0.00 ) constraint c116_123,
    
    check (cena >= 0.00 ) constraint c116_124,
    primary key (cod)  constraint u116_114
  );

{ TABLE tovar row size = 79 number of columns = 12 index size = 156 }
create table tovar 
  (
    cod serial not null constraint n110_55,
    tovargroup_cod integer not null constraint n110_56,
    tovartip_cod integer not null constraint n110_57,
    nam nchar(50) not null constraint n110_58,
    ei_cod integer not null constraint n110_59,
    cena decimal(9,2) not null constraint n110_60,
    gs char(2),
    isnds char(1),
    ispricelist char(1),
    issernum char(1),
    newbuy char(1),
    saleviawww char(1),
    unique (tovargroup_cod,tovartip_cod,nam,ei_cod,cena)  constraint u110_51,
    
    check (cena >= 0.00 ) constraint c110_61,
    
    check (isnds = '*' ) constraint c110_62,
    
    check (ispricelist = '*' ) constraint c110_63,
    
    check (issernum = '*' ) constraint c110_64,
    
    check (newbuy = '*' ) constraint c_newbuy,
    
    check (saleviawww = '*' ) constraint c_saleviawww,
    primary key (cod)  constraint u110_50
  );

{ TABLE tovarwww row size = 2644 number of columns = 5 index size = 12 }
create table tovarwww 
  (
    tovar_cod integer not null ,
    smallimage char(40),
    bigimage char(40),
    opisanieshort char(512),
    opisanielong char(2048),
    unique (tovar_cod)  constraint u226_289
  );

{ TABLE valuta row size = 20 number of columns = 5 index size = 24 }
create table valuta 
  (
    cod serial not null constraint n207_282,
    dat date not null constraint n207_283,
    kurs_p decimal(5,4) 
        default 0.0000 not null constraint n207_284,
    kurs_s decimal(5,4) 
        default 0.0000 not null constraint n207_285,
    kurs_i decimal(5,4) 
        default 0 not null ,
    unique (dat)  constraint u207_281,
    primary key (cod)  constraint u207_280
  );

{ TABLE zaimlink row size = 8 number of columns = 2 index size = 0 }
create table zaimlink 
  (
    master_cod integer not null ,
    slave_cod integer not null 
  );

{ TABLE naklr row size = 98 number of columns = 10 index size = 60 }
create table naklr 
  (
    cod integer not null ,
    num smallint not null constraint n119_161,
    dat date not null constraint n119_162,
    sklad_cod integer not null constraint n119_163,
    operacia_cod integer not null constraint n119_164,
    klient_cod integer not null constraint n119_165,
    lgota_proc decimal(5,2),
    prim1 nchar(60),
    dat_dolga date,
    usr char(8) not null constraint n119_166,
    primary key (cod) 
  );

create index "slon2".naklr1 on naklr (dat);
{ TABLE naklpopl row size = 24 number of columns = 5 index size = 24 }
create table naklpopl 
  (
    cod serial not null ,
    naklp_cod integer not null ,
    dat date not null ,
    summa decimal(9,2) 
        default 0 not null ,
    summad decimal(9,2) 
        default 0 not null ,
    
    check (summa >= 0.00 ),
    
    check (summa >= 0.00 ),
    primary key (cod) 
  );

{ TABLE stt row size = 64 number of columns = 16 index size = 192 }
create table stt 
  (
    vpp integer,
    vpr integer,
    sgp integer,
    sht integer,
    zaimto integer,
    pzaimto integer,
    zaimfrom integer,
    pzaimfrom integer,
    gklp1 integer,
    gklp2 integer,
    gklr1 integer,
    gklr2 integer,
    gpsr1 integer,
    gpsr2 integer,
    gpsp1 integer,
    gpsp2 integer
  );

{ TABLE garlink row size = 8 number of columns = 2 index size = 0 }
create table garlink 
  (
    master_cod integer not null ,
    slave_cod integer not null 
  );

{ TABLE "slon2".pricepost row size = 9 number of columns = 2 index size = 12 }
create table "slon2".pricepost 
  (
    post_cod integer not null ,
    kurs decimal(7,2),
    unique (post_cod)  constraint "slon2".u256_334
  );

{ TABLE "slon2".pricetov row size = 19 number of columns = 4 index size = 24 }
create table "slon2".pricetov 
  (
    tovar_cod integer not null ,
    cena decimal(9,2),
    nacenka decimal(7,2),
    post_cod integer not null ,
    unique (tovar_cod)  constraint "slon2".u257_337
  );

{ TABLE codes_doc row size = 4 number of columns = 1 index size = 12 }
create table codes_doc 
  (
    cod serial not null 
  );

create unique index "slon2".ix258_1 on codes_doc (cod);
    

alter table klient add constraint (foreign key (lgota_cod) 
    references lgota  constraint r104_18);

alter table klient add constraint (foreign key (gorod_cod) 
    references gorod  constraint r104_19);

alter table tovartip add constraint (foreign key (tovargroup_cod) 
    references tovargroup );

alter table tovar add constraint (foreign key (tovargroup_cod) 
    references tovargroup  constraint r110_52);
    

alter table tovar add constraint (foreign key (tovartip_cod) 
    references tovartip  constraint r110_53);
    

alter table tovar add constraint (foreign key (ei_cod) 
    references ei  constraint r110_54);

alter table sklad add constraint (foreign key (matotv_cod) 
    references klient );

alter table naklp add constraint (foreign key (sklad_cod) 
    references sklad );

alter table naklp add constraint (foreign key (operacia_cod) 
    references operacia );

alter table naklp add constraint (foreign key (klient_cod) 
    references klient );

alter table finoperp add constraint (foreign key (naklp_cod) 
    references naklp );

alter table finoperp add constraint (foreign key (sklad_cod) 
    references sklad );

alter table finoperp add constraint (foreign key (tovar_cod) 
    references tovar );

alter table schetfnr add constraint (foreign key (cod) 
    references codes_sofnr  constraint r115_104);
    

alter table schetfnr add constraint (foreign key (operacia_cod) 
    references operacia  constraint r115_105);
    

alter table schetfnr add constraint (foreign key (klient_cod) 
    references klient  constraint r115_106);

alter table schetfnr add constraint (foreign key (sklad_cod) 
    references sklad  constraint r115_107);

alter table finoperr add constraint (foreign key (schetfnr_cod) 
    references schetfnr  constraint r116_115);
    

alter table finoperr add constraint (foreign key (finoperp_cod) 
    references finoperp  constraint r116_117);
    

alter table finoperr add constraint (foreign key (vpfinoperp_cod) 
    references finoperp  constraint r116_118);
    

alter table matoperp add constraint (foreign key (naklp_cod) 
    references naklp  constraint r117_128);

alter table matoperp add constraint (foreign key (sklad_cod) 
    references sklad  constraint r117_129);

alter table matoperp add constraint (foreign key (tovar_cod) 
    references tovar  constraint r117_130);

alter table matoperr add constraint (foreign key (schetfnr_cod) 
    references schetfnr  constraint r118_143);
    

alter table matoperr add constraint (foreign key (matoperp_cod) 
    references matoperp  constraint r118_145);
    

alter table matoperr add constraint (foreign key (vpmatoperp_cod) 
    references matoperp  constraint r118_146);
    

alter table naklr add constraint (foreign key (sklad_cod) 
    references sklad  constraint r119_157);

alter table naklr add constraint (foreign key (operacia_cod) 
    references operacia  constraint r119_158);
    

alter table naklr add constraint (foreign key (klient_cod) 
    references klient  constraint r119_159);

alter table naklpopl add constraint (foreign key (naklp_cod) 
    references naklp );

alter table naklrtov add constraint (foreign key (tovar_cod) 
    references tovar );

alter table nnakl add constraint (foreign key (schetfnr_cod) 
    references schetfnr );

alter table nnakl add constraint (foreign key (sofnr_cod) 
    references codes_sofnr );

alter table schfnrtov add constraint (foreign key (schetfnr_cod) 
    references schetfnr );

alter table schfnrtov add constraint (foreign key (tovar_cod) 
    references tovar );

alter table schfnrtovt add constraint (foreign key (schetfnr_cod) 
    references schetfnr );

alter table schfnrtovt add constraint (foreign key (schfnrtov_cod) 
    references schfnrtov );

alter table schfnrtovt add constraint (foreign key (tovar_cod) 
    references tovar );

alter table nnakltov add constraint (foreign key (nnakl_cod) 
    references nnakl );

alter table nnakltov add constraint (foreign key (schfnrtov_cod) 
    references schfnrtov );

alter table primrez add constraint (foreign key (matoperr_cod) 
    references matoperr );

alter table schetopl add constraint (foreign key (cod) 
    references codes_sofnr );

alter table schetopl add constraint (foreign key (schet_cod) 
    references schetfnr );

alter table sostav add constraint (foreign key (master_cod) 
    references tovartip );

alter table sostav add constraint (foreign key (slave_cod) 
    references tovartip );

alter table stt add constraint (foreign key (vpp) references 
    operacia  constraint r130_257);

alter table stt add constraint (foreign key (vpr) references 
    operacia  constraint r130_258);

alter table stt add constraint (foreign key (sgp) references 
    sklad  constraint r130_259);

alter table stt add constraint (foreign key (sht) references 
    ei  constraint r130_260);

alter table vp add constraint (foreign key (skladr_cod) 
    references sklad );

alter table vp add constraint (foreign key (skladp_cod) 
    references sklad );

alter table finpmatplink add constraint (foreign key 
    (finoperp_cod) references finoperp );

alter table finpmatplink add constraint (foreign key 
    (matoperp_cod) references matoperp );

alter table klient add constraint (foreign key (pgorod_cod) 
    references gorod  constraint r177_279);

alter table tovarwww add constraint (foreign key (tovar_cod) 
    references tovar );

alter table stt add constraint (foreign key (zaimto) 
    references operacia  constraint r228_294);
    

alter table stt add constraint (foreign key (pzaimto) 
    references operacia  constraint r228_295);
    

alter table stt add constraint (foreign key (zaimfrom) 
    references operacia  constraint r228_296);
    

alter table stt add constraint (foreign key (pzaimfrom) 
    references operacia  constraint r228_297);
    

alter table naklrtov add constraint (foreign key (naklr_cod) 
    references naklr );

alter table naklropl add constraint (foreign key (naklr_cod) 
    references naklr );

alter table stt add constraint (foreign key (gklp1) 
    references operacia );

alter table stt add constraint (foreign key (gklp2) 
    references operacia );

alter table stt add constraint (foreign key (gklr1) 
    references operacia );

alter table stt add constraint (foreign key (gklr2) 
    references operacia );

alter table stt add constraint (foreign key (gpsr1) 
    references operacia );

alter table stt add constraint (foreign key (gpsr2) 
    references operacia );

alter table stt add constraint (foreign key (gpsp1) 
    references operacia );

alter table stt add constraint (foreign key (gpsp2) 
    references operacia );

alter table "slon2".pricepost add constraint (foreign key (post_cod) 
    references klient );

alter table "slon2".pricetov add constraint (foreign key (tovar_cod) 
    references tovar );

alter table "slon2".pricetov add constraint (foreign key (post_cod) 
    references klient );


create procedure nullchar()
    returning char(1);

    define ch   char(1);

    let ch = null;

    return ch;
end procedure;

create procedure nulldecimal()
    returning decimal(20,10);
    
    define i  decimal(20,10);
  
    let i = null;
    
    return i;
end procedure;

create procedure nullint()
    returning int;
    
    define i  int;
  
    let i = null;
    
    return i;
end procedure;

create procedure cenawithoutpdv(tovarcod int, cenaa decimal(9,2), 
                                datt date)
        returning decimal(20,10);
        
    define cenawpdv decimal(20,10);
    define stavkaa  decimal(4,2);
    define isndss   char(1);
    
    let cenawpdv = cenaa;
    select isnds
        into isndss
        from tovar
        where cod = tovarcod;
    
    if isndss = '*' then
        let stavkaa = 0;
        select a.stavka
            into stavkaa
            from nds a
            where a.dat = (select max(x.dat) from nds x where x.dat <= datt);
        let cenawpdv = 100 * cenaa / (100 + stavkaa);
    end if;
    return cenawpdv;
end procedure;

create procedure cenawithpdv(tovarcod int, cenaa decimal(9,2), 
                             datt date)
        returning decimal(20,10);
        
    define cenawpdv decimal(20,10);
    define stavkaa  decimal(4,2);
    
    let cenawpdv = cenaa;
    if exists (select cod from tovar where cod = tovarcod and isnds = '*') then
        let stavkaa = 0;
        select a.stavka
            into stavkaa
            from nds a
            where a.dat = (select max(x.dat) from nds x where x.dat <= datt);
        let cenawpdv = cenaa + cenaa * stavkaa / 100;
    end if;
    return cenawpdv;
end procedure;

create procedure schfnrmattovkol(schetcod int)
    returning decimal(7,2);
    
    define koll     decimal(7,2);
    define retkol   decimal(7,2);
    
    let retkol = 0;
    
    select sum(kol) into koll
        from schfnrtov a
        where a.schetfnr_cod = schetcod and
              a.cod not in (select schfnrtov_cod from schfnrtovt);
    
    if koll is null then
        let koll = 0;
    end if;
    let retkol = retkol + koll;
    
    select sum(kol) into koll
        from schfnrtovt
        where schetfnr_cod = schetcod;
    
    if koll is null then
        let koll = 0;
    end if;
    let retkol = retkol + koll;

    return retkol;
end procedure;

create procedure kolfintovrforp(finoperpcod int) returning decimal(7,2);
    define  koll decimal(7,2);

    select sum(kol)
        into koll
        from finoperr
        where finoperp_cod = finoperpcod;
    
    if koll is null then
        let koll = 0;
    end if;
    return koll;
end procedure;

create procedure kolfintovrforpdas(finoperpcod int, datt date) 
    returning decimal(7,2);
    
    define  koll   decimal(7,2);
    
    select sum(kol)
        into koll
        from finoperr
        where finoperp_cod = finoperpcod and
              datotg < datt;
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure kolfintovrforpdat(finoperpcod int, datt date) 
    returning decimal(7,2);
    
    define  koll decimal(7,2);
    
    select sum(kol)
        into koll
        from finoperr
        where finoperp_cod = finoperpcod and
              (doc_cod in (select x0.cod from vp x0 where x0.dat <= datt) or
               doc_cod in (select x1.cod from schfnrtov x1 
                            where x1.schetfnr_cod in 
                                (select x2.cod from schetfnr x2 where x2.finnaklr_dat <= datt))
              );
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure kolmattovrforp(matoperpcod int) returning decimal(7,2);
    define  koll decimal(7,2);
    
    select sum(kol)
        into koll
        from matoperr
        where matoperp_cod = matoperpcod;
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure kolmattovrforpdas(matoperpcod int, datt date) 
    returning decimal(7,2);
    
    define  koll decimal(7,2);

    select sum(kol)
        into koll
        from matoperr
        where matoperp_cod = matoperpcod and
              (datotg < datt or datotg is null);
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure kolmattovrforpdat(matoperpcod int, datt date) 
    returning decimal(7,2);
    
    define  koll decimal(7,2);
    
    select sum(kol)
        into koll
        from matoperr
        where matoperp_cod = matoperpcod and
              datotg <= datt;
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure ei_del(eicod int)
	
	delete from ei where cod = eicod;
end procedure;

create procedure ei_he(heeinam char(10)) returning int, char(10), int;
	define 	eicod, cnt, ret	int;
	define	einam	char(10);

	select count(*) into cnt
	  from ei
	  where nam matches heeinam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into eicod, einam
	      from ei
	      order by nam
	      
	      return eicod, einam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into eicod, einam
	      from ei
	      where nam matches heeinam
	      order by nam
	      
	      return eicod, einam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into eicod, einam
            from ei
            where nam matches heeinam;

            return eicod, einam, ret;
	end if;
end procedure;

create procedure ei_ins(einam char(10))
	returning int;
	
	define	cod	int;
	insert into ei values(0, einam);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure ei_upd(eicod int, einam char(10))
	
	update ei set (nam) = (einam)
	    where cod = eicod;
end procedure;

create procedure finnaklr_del(schetcod int)
	
	update schetfnr 
	    set (finnaklr_num, finnaklr_dat, sklad_cod, dovnum, dovdat, dovwho, usr) = 
	        (null, null, null, null, null, null, user)
	    where cod = schetcod;
end procedure;

create procedure finnaklr_ins(schetcod int, datt date, skladcod int, dovnumm char(10),
                            dovdatt date, dovwhoo char(60))
    returning int;

	define  numm int;

	select max(num+1)
	    into numm
	    from _finnaklr
	    where year(dat) = year(datt);

	if numm is null
	then
	    let numm = 1;
	end if;

    update _finnaklr
        set (num, dat, sklad_cod, dovnum, dovdat, dovwho) = (numm, datt, skladcod, dovnumm, dovdatt, dovwhoo)
        where cod = schetcod;

    return numm;
end procedure;

create procedure finnaklr_upd(schetcod int, numm int, datt date, skladcod int, dovnumm char(10),
                            dovdatt date, dovwhoo char(60))
    update _finnaklr
        set (num, dat, sklad_cod, dovnum, dovdat, dovwho) = (numm, datt, skladcod, dovnumm, dovdatt, dovwhoo)
        where cod = schetcod;
end procedure;

create procedure finoperp_del(finoperpcod int)
    
    delete from finoperp where cod = finoperpcod;
end procedure;

create procedure finoperp_ins(doccod int, naklpcod int, tovarcod int,
                               koll decimal(7,2), cenaa decimal(9,2))
	returning int;
	
	define	cod	int;
	
	insert into finoperp(cod, doc_cod, naklp_cod, tovar_cod, kol, cena, usr) 
	    values(0, doccod, naklpcod, tovarcod, koll, cenaa, user);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure finoperp_upd(finoperpcod int, tovarcod int,
                               koll decimal(7,2), cenaa decimal(9,2))
	update finoperp 
	    set (tovar_cod, kol, cena, usr)=
	        (tovarcod, koll, cenaa, user)
	    where cod = finoperpcod;
end procedure;

create procedure fio(cnt int, nam char(80))
    returning char(80);

    define  ret     char(80);
    define  i       int;
    define  j       int;
    define  cnts    int;
    
    --   
    for j = 1 to 80
        if nam{j} != ' ' then
            exit for;
        end if
    end for;
    
    let cnts = 0;
    for i = j to 80
        if nam{i} = ' ' then
            let cnts = cnts + 1;
        end if
        if cnts = cnt then
            exit for;
        end if;
        let ret = nam{j,i};
    end for;
    
    let ret = nam{2,3};
    return ret;
end procedure;

create procedure gorod_del(gorodcod int)
	
	delete from gorod where cod = gorodcod;
end procedure;

create procedure gorod_he(hegorodnam char(30)) returning int, char(30), char(6), int;
	define 	gorodcod, cnt, ret	int;
	define	gorodnam	char(30);
	define  phonecod    char(6);

	select count(*) into cnt
	  from gorod
	  where nam matches hegorodnam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam, phone_cod
	      into gorodcod, gorodnam, phonecod
	      from gorod
	      order by nam
	      
	      return gorodcod, gorodnam, phonecod, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam, phone_cod
	      into gorodcod, gorodnam, phonecod
	      from gorod
	      where nam matches hegorodnam
	      order by nam
	      
	      return gorodcod, gorodnam, phonecod, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam, phone_cod
            into gorodcod, gorodnam, phonecod
            from gorod
            where nam matches hegorodnam;

            return gorodcod, gorodnam, phonecod, ret;
	end if;
end procedure;

create procedure gorod_ins(gorodnam char(30), phonecod char(6))
	returning int;
	
	define	cod	int;
	insert into gorod values(0, gorodnam, phonecod);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure gorod_upd(gorodcod int, gorodnam char(30), phonecod char(6))
	
	update gorod set (nam, phone_cod) = (gorodnam, phonecod)
	    where cod = gorodcod;
end procedure;

create procedure issofnrnnakl(sofnrcod int)
	returning int;
	
	define	nnaklcod	        int;
	
	select cod into nnaklcod
	    from nnakl
	    where sofnr_cod = sofnrcod;
	return nnaklcod;
end procedure;

create procedure issostav(tovarcod int)
	returning int;
	
	define	cnt	        int;
	define  tovartipcod int;
	
	select tovartip_cod into tovartipcod
	    from tovar
	    where cod = tovarcod;
	
	let cnt = 0;
	select count(*) into cnt
	    from sostav
	    where master_cod = tovartipcod;
	
	return cnt;
end procedure;

create procedure itoc(i int)
    returning char(10);
    
    define c    char(10);
    
    let c = i;
    
    return c;
end procedure;

create procedure klient_he(heklientnam char(50)) 
returning int, char(50), int;

	define 	klientcod, cnt, ret	int;
	define	klientnam     char(50);

    let cnt = 0;
    let ret = 3;
    foreach
        select a.cod, a.nam into klientcod, klientnam
	        from klient a 
	        where a.nam matches heklientnam
	        order by a.nam
	        return klientcod, klientnam, ret with resume;
        
        let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
    end foreach;

    if cnt = 0 then
        let ret = 1;
        foreach
            select a.cod, a.nam into klientcod, klientnam
    	        from klient a 
    	        order by a.nam
    	        return klientcod, klientnam, ret with resume;
        end foreach;
    end if;
end procedure;

create procedure klientbalans(klientcod int)
    returning decimal(9,2);

    define  balans  decimal(9,2);
    define  sumopl  decimal(9,2);
    define  sumotg  decimal(9,2);
    
    select sum(a.summa) into sumopl
        from schetopl a, schetfnr b
        where a.schet_cod = b.cod and
              b.klient_cod = klientcod;
    
    if sumopl is null then
        let sumopl = 0;
    end if;
    
    select sum(a.kol * a.cena) into sumotg
        from matoperr a, schetfnr b
        where a.schetfnr_cod = b.cod and
              b.klient_cod = klientcod and
              a.datotg is not null;
    
    if sumotg is null then
        let sumotg = 0;
    end if;
    
    let balans = sumopl - sumotg;
    return balans;
end procedure;

create procedure klientlg_he(heklientnam char(50)) 
returning int, char(50), int, char(30), decimal(5,2), int;

	define 	klientcod, lgotacod, cnt, ret	int;
	define	klientnam     char(50);
	define  lgotanam      char(30);
	define  lgotaproc     decimal(5,2);

    let cnt = 0;
    let ret = 3;
    foreach
        select a.cod, a.nam, b.cod, b.nam, b.proc
	        into klientcod, klientnam, lgotacod, lgotanam, lgotaproc
	        from klient a, outer lgota b 
	        where a.lgota_cod = b.cod and
	              a.nam matches heklientnam
	        order by a.nam
	        return klientcod, klientnam, lgotacod, lgotanam, lgotaproc, ret with resume;
	    
	    let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
	end foreach;
	if cnt = 0 then
	    let ret = 1;
        return 0, '    ', 0, '    ', 0, ret with resume;
--	    foreach
--	        select a.cod, a.nam, b.cod, b.nam, b.proc
--	            into klientcod, klientnam, lgotacod, lgotanam, lgotaproc
--	            from klient a, outer lgota b 
--	            where a.lgota_cod = b.cod
--	            order by a.nam
--	            return klientcod, klientnam, lgotacod, lgotanam, lgotaproc, ret with resume;
--	    end foreach;
	end if;
end procedure;

create procedure lgota_del(lgotacod int)
	
	delete from lgota where cod = lgotacod;
end procedure;

create procedure lgota_he(helgotanam char(30)) returning int, char(30), decimal(5,2), int;
	define 	lgotacod, cnt, ret	int;
	define	lgotanam	char(30);
	define  lgotaproc   decimal(5,2);

	select count(*) into cnt
	  from lgota
	  where nam matches helgotanam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam, proc
	      into lgotacod, lgotanam, lgotaproc
	      from lgota
	      order by nam
	      
	      return lgotacod, lgotanam, lgotaproc, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam, proc
	      into lgotacod, lgotanam, lgotaproc
	      from lgota
	      where nam matches helgotanam
	      order by nam
	      
	      return lgotacod, lgotanam, lgotaproc, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam, proc
            into lgotacod, lgotanam, lgotaproc
            from lgota
            where nam matches helgotanam;

            return lgotacod, lgotanam, lgotaproc, ret;
	end if;
end procedure;

create procedure lgota_ins(lgotanam char(30), lgotaproc decimal(5,2))
	returning int;
	
	define	cod	int;
	insert into lgota values(0, lgotanam, lgotaproc);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure lgota_upd(lgotacod int, lgotanam char(30), lgotaproc decimal(5,2))
	
	update lgota set (nam, proc) = (lgotanam, lgotaproc)
	    where cod = lgotacod;
end procedure;

create procedure matoperp_del(matoperpcod int)
    
    delete from matoperp where cod = matoperpcod;
end procedure;

create procedure matoperp_ins(doccod int, naklpcod int, tovarcod int, 
                               sernumm char(20), koll decimal(7,2), 
                               cenaa decimal(9,2), cenadd decimal(9,2))
	returning int;
	
	define	cod	int;
	
	insert into matoperp(cod, doc_cod, naklp_cod, tovar_cod, sernum, kol, 
	                     cena, cenad, usr) 
	    values(0, doccod, naklpcod, tovarcod, sernumm, koll, cenaa, cenadd, user);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure "slon2".matoperp_upd(matoperpcod int, tovarcod int, sernumm char(20),
                               koll decimal(7,2), cenaa decimal(9,2),
                               cenadd decimal(9,2))
	
	define old_tovarcod     integer;
	define old_sernum       char(20);
	define old_kol          decimal(7,2);
	
	select tovar_cod, sernum, kol
	    into old_tovarcod, old_sernum, old_kol
	    from matoperp
	    where cod = matoperpcod;
	
	--   
	update matoperp 
	    set (cena, cenad, usr) = (cenaa, cenadd, user)
	    where cod = matoperpcod;
    	
    --     
    if old_tovarcod != tovarcod or
       old_sernum != sernumm or
       old_kol != koll
    then
    	update matoperp 
    	    set (tovar_cod, sernum, kol, usr) = (tovarcod, sernumm, koll, user)
    	    where cod = matoperpcod;
    end if;
end procedure;

create procedure myorg_ins(nam char(50), gorodnam char(50), phonecod char(6), index char(6), 
     ulica char(50), bossfio char(50), bossphone char(9), glbuhfio char(50), 
     glbuhphone char(9), banknam char(50), bankmfo char(6), bankschet1 char(14),
     bankschet2 char(14), zkpo char(8), inn char(12), ns char(8), 
     phoneo char(9), fax char(9), email char(30), www char(30))

    delete from myorg;
	insert into myorg values(nam, gorodnam, phonecod, index,
	                         ulica, bossfio, bossphone, glbuhfio,
	                         glbuhphone, banknam, bankmfo, bankschet1,
	                         bankschet2, zkpo, inn, ns,
	                         phoneo, fax, email, www);
end procedure;

create procedure naklp_del(pr char(1), naklpcod int)
    
    if pr = "p" then
        delete from zaimlink where slave_cod = naklpcod;
        delete from zaimlink where master_cod = naklpcod;
        delete from finpmatplink
            where matoperp_cod in (select cod from matoperp where doc_cod = naklpcod);
        delete from matoperp where doc_cod = naklpcod;
        delete from finoperp where doc_cod = naklpcod;
        delete from naklp where cod = naklpcod;
    end if;
    if pr = "r" then
        delete from zaimlink where slave_cod = naklpcod;
        delete from zaimlink where master_cod = naklpcod;
        delete from matoperr where doc_cod = naklpcod;
        delete from naklrtov where naklr_cod = naklpcod;
        delete from naklr where cod = naklpcod;
    end if;
end procedure;

create procedure naklp_ins(pr char(1), tip char(1), num char(10), datt date, 
                            skladcod int, operaciacod int, klientcod int, 
                            kurs decimal(3,2), lgotaproc decimal(5,2), prim1 char(60),
                            datdolga date)
	returning int, int;
	
	define	global CodesDocCod	int default -1;
	define  numm int;
	
	if pr = "p" then
	    let numm = -1;
	    insert into naklp values(CodesDocCod, num, datt, kurs, skladcod, operaciacod, klientcod, prim1, user, tip);
	end if
	if pr = "r" then
	    select max(a.num+1)
	        into numm
	        from naklr a
	        where year(a.dat) = year(datt);
	    
	    if numm is null 
	    then 
	        let numm = 1;
	    end if;
	    insert into naklr values(CodesDocCod, numm, datt, skladcod, operaciacod, klientcod, lgotaproc, prim1, datdolga, user);
	end if
	return CodesDocCod, numm;
end procedure;

create procedure naklp_upd(pr char(1), naklpcod int, numm char(10), datt date, 
                            skladcod int, operaciacod int, klientcod int,
                            kurss decimal(3,2), lgotaproc decimal(5,2), prim11 char(60),
                            datdolga date)
	
	define old_dat          date;
	define old_skladcod     int;
	
	if pr = "p"
	then
	    select dat, sklad_cod
	        into old_dat, old_skladcod
	        from naklp
	        where cod = naklpcod;
	    
	    --   ;
	    update naklp 
	        set (num, kurs, operacia_cod, klient_cod, usr, prim1) =
	            (numm, kurss, operaciacod, klientcod, user, prim11)
	        where cod = naklpcod;
	    
	    --     ;
	    if old_dat != datt or
	       old_skladcod != skladcod
	    then
    	    update naklp 
    	        set (dat, sklad_cod, usr) = (datt, skladcod, user)
    	        where cod = naklpcod;
	    end if;
	end if;
	if pr = "r"
	then
	    update naklr 
	        set (num, dat, sklad_cod, operacia_cod, klient_cod, lgota_proc, usr, prim1, dat_dolga) =
	            (numm, datt, skladcod, operaciacod, klientcod, lgotaproc, user, prim11, datdolga)
	        where cod = naklpcod;
	end if;
end procedure;

create procedure naklpf_ins(num char(10), dat date, kurs decimal(4,2), 
                             skladcod int, operaciacod int, klientcod int)
	returning int;
	
	define	cod	int;
	
	insert into codes_doc values(0);
	let cod = dbinfo("sqlca.sqlerrd1");
	insert into naklp values(cod, num, dat, kurs, skladcod, operaciacod,
	                         klientcod, user, 'F');
	return cod;
end procedure;

create procedure naklpm_ins(num char(10), dat date, kurs decimal(4,2), 
                             skladcod int, operaciacod int, klientcod int)
	returning int;
	
	define	cod	int;
	
	insert into codes_doc values(0);
	let cod = dbinfo("sqlca.sqlerrd1");
	insert into naklp values(cod, num, dat, kurs, skladcod, operaciacod,
	                         klientcod, user, 'M');
	return cod;
end procedure;

create procedure naklpn_ins(num char(10), dat date, kurs decimal(4,2), 
                             skladcod int, operaciacod int, klientcod int)
	returning int;
	
	define	cod	int;
	
	insert into codes_doc values(0);
	let cod = dbinfo("sqlca.sqlerrd1");
	insert into naklp values(cod, num, dat, kurs, skladcod, operaciacod,
	                         klientcod, user, 'N');
	return cod;
end procedure;

create procedure naklptov_del(pr char(1), tip char(1), finoperpcod int, 
                               matoperpcod int)
	if pr = 'p' then
    	if tip = 'N' then
    	    delete from finpmatplink
    	        where matoperp_cod = matoperpcod;
    	    delete from finoperp
    	        where cod = finoperpcod;
    	    delete from matoperp
    	        where cod = matoperpcod;
    	end if;
    	
    	if tip = 'F' then
    	    delete from finoperp
    	        where cod = finoperpcod;
    	end if;
    	
    	if tip = 'M' then
    	    delete from matoperp
    	        where cod = matoperpcod;
    	end if;
	end if;
	
	if pr = 'r' then
	    delete from naklrtov
	        where cod = matoperpcod;
	end if;
end procedure;

create procedure naklptov_ins(pr char(1), tip char(1), doccod int, 
                               datpokupki date, 
                               skladcod int, tovarcod int, sernum char(20),
                               kol decimal(7,2),
                               cena decimal(9,2), cenad decimal(9,2))
                               
	returning int, int;
	
	define	matoperpcod	int;
	define  finoperpcod int;
	define  global CodesDocCod int default -1;
	
	let finoperpcod = 0;
	let matoperpcod = 0;
    if cena is null then
    	let cena = 0;
    end if;
    if cenad is null then
    	let cenad = 0;
    end if;
    if pr = 'p' then
	    if tip = 'N' then
	        insert into matoperp
	            values(0, doccod, doccod, datpokupki, skladcod, tovarcod, null,
	                   null, kol, cena, cenad, user);
	        let matoperpcod = dbinfo("sqlca.sqlerrd1");
	        insert into finoperp
	            values(0, doccod, doccod, datpokupki, skladcod, tovarcod,
	                   kol, cena, user);
	        let finoperpcod = dbinfo("sqlca.sqlerrd1");
	        insert into finpmatplink
	            values(finoperpcod, matoperpcod);
	    end if;
	    if tip = 'F' then
	        insert into finoperp
	            values(0, doccod, doccod, datpokupki, skladcod, tovarcod,
	                   kol, cena, user);
	        let finoperpcod = dbinfo("sqlca.sqlerrd1");
	    end if;
	    if tip = 'M' then
	        insert into matoperp
	            values(0, doccod, doccod, datpokupki, skladcod, tovarcod, sernum,
	                   null, kol, cena, cenad, user);
	        let matoperpcod = dbinfo("sqlca.sqlerrd1");
	    end if;
	end if;
	
	if pr = 'r' then
       insert into naklrtov
            values(CodesDocCod, doccod, tovarcod, kol, cena, cenad, user);
       let matoperpcod = CodesDocCod;
    end if;	
	return finoperpcod, matoperpcod;
end procedure;

create procedure "slon2".naklptov_upd(pr char(1), tip char(1), finoperpcod int, 
                               matoperpcod int, 
                               tovarcod int, sernumm char(20),
                               koll decimal(7,2),
                               cenaa decimal(9,2), cenadd decimal(9,2))

    define old_tovarcod     integer;
	define old_sernum       char(20);
	define old_kol          decimal(7,2);

	if pr = 'p' then
    	if tip = 'N' then
    	    update finoperp
    	        set (tovar_cod, kol, cena, usr) = (tovarcod, koll, cenaa, user)
    	        where cod = finoperpcod;
    	    update matoperp
    	        set (tovar_cod, kol, cena, cenad, usr) = 
    	            (tovarcod, koll, cenaa, cenadd, user)
    	        where cod = matoperpcod;
    	end if;
    	
    	if tip = 'F' then
    	    update finoperp
    	        set (tovar_cod, kol, cena, usr) = (tovarcod, koll, cenaa, user)
    	        where cod = finoperpcod;
    	end if;
    	
    	if tip = 'M' then
    	    select tovar_cod, sernum, kol
	            into old_tovarcod, old_sernum, old_kol
	            from matoperp
	            where cod = matoperpcod;
	            
            --   
        	update matoperp 
        	    set (cena, cenad, usr) = (cenaa, cenadd, user)
        	    where cod = matoperpcod;
            	
            --     
            if old_tovarcod != tovarcod or
               old_sernum != sernumm or
               (old_sernum is null and sernumm is not null) or
               (old_sernum is not null and sernumm is null) or
               old_kol != koll
            then
            	update matoperp 
            	    set (tovar_cod, sernum, kol, usr) = (tovarcod, sernumm, koll, user)
            	    where cod = matoperpcod;
            end if;
    	end if;
	end if;
	if pr = 'r' then
	    select kol
	        into old_kol
	        from naklrtov
	        where cod = matoperpcod;
	    
	    --   ;
	    update naklrtov
    	    set (cena, cenad, usr) = (cenaa, cenadd, user)
    	    where cod = matoperpcod;
	    
	    --     ;
	    if old_kol != koll
	    then
	        update naklrtov
    	        set (kol, usr) = (koll, user)
    	        where cod = matoperpcod;
    	end if;
	end if
end procedure;

create procedure naklropl_del(naklroplcod int)
	delete from naklropl where cod = naklroplcod;
end procedure;

create procedure naklropl_ins(naklrcod int, dat date, summa decimal(9,2),
                               summad decimal(9,2))
	returning int;
	
	define  cod    int;
	
	if summa is null then let summa = 0; end if;
	if summad is null then let summad = 0; end if;
	insert into naklropl values(0, naklrcod, dat, summa, summad);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure naklropl_upd(naklroplcod int, datt date, summaa decimal(9,2),
                               summadd decimal(9,2))
                               
    if summaa is null then let summaa = 0; end if;
    if summadd is null then let summadd = 0; end if;
	update naklropl
	    set (dat, summa, summad) = (datt, summaa, summadd)
	    where cod = naklroplcod;
end procedure;

create procedure nds_del(ndscod int)
	delete from nds where cod = ndscod;
end procedure;

create procedure nds_ins(datt date, stavkaa decimal(4,2))
	returning int;
	
	define	cod	int;
	
	insert into nds values(0, datt, stavkaa);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure nds_upd(ndscod int, datt date, stavkaa decimal(4,2))
	update nds
	    set (dat, stavka) = (datt, stavkaa)
	    where cod = ndscod;
end procedure;

create procedure nnakl_del(nnaklcod int)
	
	delete from nnakltov where nnakl_cod = nnaklcod;
	delete from nnakl where cod = nnaklcod;
end procedure;

create procedure nnakl_upd(nnaklcod int, numm int, datt date,
                            umovaa char(60), formaa char(60), prim11 char(60))

	update nnakl set (num, dat, umova, forma, prim1, usr) =
	                 (numm, datt, umovaa, formaa, prim11, user)
	    where cod = nnaklcod;
end procedure;

create procedure "slon2".nnaklgenerate(schetcod int, sofnrcod int, st char(8))
	define  schets          decimal(9,2);
	define  schetnnakls     decimal(9,2);
	define  currentnnakls   decimal(9,2);
	define  schetnum        char(5);
	define  schetdat        char(10);
	define  umova           char(60);
	define  forma           char(60);
	define  nnaklnum        int;
	define  nnakldat        date;
	define  nnaklcod        int;
	define  schfnrtovcod    int;
	define  stschet         decimal(9,2);
	define  stnnakl         decimal(9,2);
	define  summa           decimal(9,2);

	select schet_num, schet_dat into schetnum, schetdat
	    from schetfnr
	    where cod = schetcod;
	let umova = " N-",schetnum,"  ",schetdat," ";
	if exists (select cod from operacia where nam matches "**")
	then
	    let forma = " ";
	else 
	    let forma = "   ";
	end if

	if st = "finnaklr" then
	    select finnaklr_dat into nnakldat from schetfnr where cod = schetcod;
	end if;
	if st = "schetopl" then
	    select dat into nnakldat from schetopl where cod = sofnrcod;
	end if;

	select max(num) + 1 into nnaklnum
	    from nnakl
	    where year(dat) = year(nnakldat);
	if nnaklnum is null then
	    let nnaklnum = 1;
	end if;

	insert into nnakl values(0, sofnrcod, nnaklnum, nnakldat, umova, forma, '',user);
	let nnaklcod = dbinfo("sqlca.sqlerrd1");

	--   
	select summa into schets from _schets where cod = schetcod;

	--      
	select summa into schetnnakls from _schetnnakls where schet_cod = schetcod;
	if schetnnakls is null then
	    let schetnnakls = 0;
	end if;

	--    
	if st = "finnaklr" then
        foreach
            select schfnrtov_cod, st_schet, st_nnakl
                into schfnrtovcod, stschet, stnnakl
                from _schetnnakltovs
                where schet_cod = schetcod
            if stnnakl is null then
                let stnnakl = 0;
            end if
            
            let summa = stschet - stnnakl;
            
            if summa > 0 then
                insert into nnakltov values(0, nnaklcod, schfnrtovcod, summa, user);
            end if;
        end foreach;
	end if;
end procedure;

create procedure nnakltov_del(nnakltovcod int)
	delete from nnakltov where cod = nnakltovcod;
end procedure;

create procedure nnakltov_ins(nnaklcod int, schfnrtovcod int,
                               summa decimal(9,2))
	returning int;
	
	define	cod	int;
	
	insert into nnakltov values(0, nnaklcod, schfnrtovcod, summa, user);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure nnakltov_upd(nnakltovcod int, summaa decimal(9,2))
	update nnakltov
	    set (summa, usr) = (summaa, user)
	    where cod = nnakltovcod;
end procedure;

create procedure operacia_del(operaciacod int)
	
	delete from operacia where cod = operaciacod;
end procedure;

create procedure operacia_ins(operaciapr int, operacianam char(30))
	returning int;
	
	define	cod	int;
	insert into operacia values(0, operaciapr, operacianam);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure operacia_upd(operaciacod int, operacianam char(30))
	
	update operacia set (nam) = (operacianam)
	    where cod = operaciacod;
end procedure;

create procedure operaciap_he(heoperaciapnam char(30)) returning int, char(30), int;
	define 	operaciapcod, cnt, ret	int;
	define	operaciapnam	char(30);

	select count(*) into cnt
	  from _operaciap
	  where nam matches heoperaciapnam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into operaciapcod, operaciapnam
	      from _operaciap
	      order by nam
	      
	      return operaciapcod, operaciapnam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into operaciapcod, operaciapnam
	      from _operaciap
	      where nam matches heoperaciapnam
	      order by nam
	      
	      return operaciapcod, operaciapnam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into operaciapcod, operaciapnam
            from _operaciap
            where nam matches heoperaciapnam;

            return operaciapcod, operaciapnam, ret;
	end if;
end procedure;

create procedure operaciar_he(heoperaciarnam char(30)) returning int, char(30), int;
	define 	operaciarcod, cnt, ret	int;
	define	operaciarnam	char(30);

	select count(*) into cnt
	  from _operaciar
	  where nam matches heoperaciarnam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into operaciarcod, operaciarnam
	      from _operaciar
	      order by nam
	      
	      return operaciarcod, operaciarnam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into operaciarcod, operaciarnam
	      from _operaciar
	      where nam matches heoperaciarnam
	      order by nam
	      
	      return operaciarcod, operaciarnam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into operaciarcod, operaciarnam
            from _operaciar
            where nam matches heoperaciarnam;

            return operaciarcod, operaciarnam, ret;
	end if;
end procedure;

create procedure otgtovforoperr(matoperrcod int)
    returning decimal(7,2);
    
    define kolotg   decimal(7,2);
    
    select sum(kol) into kolotg
        from matoperr
        where cod = matoperrcod and datotg is not null;
        
    if kolotg is null then
        let kolotg = 0;
    end if;
    
    return kolotg;
end procedure;

create procedure otgtovkol(schfnrtovcod int)
    returning decimal(7,2);

    define otgkol   decimal(7,2);

    select sum(a.kol) into otgkol
        from matoperr a
        where a.doc_cod = schfnrtovcod and
              a.datotg is not null;

    if otgkol is null then
        let otgkol = 0;
    end if;

    return otgkol;
end procedure;

create procedure postavschik_he(hepostavschiknam char(50)) 
returning int, char(50), int;

	define 	postavschikcod, cnt, ret	int;
	define	postavschiknam     char(50);

    let cnt = 0;
    let ret = 3;
    foreach
        select a.cod, a.nam into postavschikcod, postavschiknam
	        from _postavschik a 
	        where a.nam matches hepostavschiknam
	        order by a.nam
	      
	        return postavschikcod, postavschiknam, ret with resume;
        let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
    end foreach;

    if cnt = 0 then
        let ret = 1;
        foreach
            select a.cod, a.nam into postavschikcod, postavschiknam
    	        from _postavschik a 
    	        order by a.nam
    	      
    	        return postavschikcod, postavschiknam, ret with resume;
        end foreach;
    end if;
end procedure;

create procedure postpol_del(postpolcod int)
	
	delete from klient where cod = postpolcod;
end procedure;

create procedure postpol_he(hepostpolnam char(50)) returning int, char(50), int;
	define 	postpolcod, cnt, ret	int;
	define	postpolnam     char(50);

    let cnt = 0;
    let ret = 3;
    foreach
	    select cod, nam
	        into postpolcod, postpolnam
	        from _postpol
	        where nam matches hepostpolnam
	        order by nam
	        return postpolcod, postpolnam, ret with resume;
	    
	    let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
	end foreach;

	if cnt = 0 then
	    let ret = 1;
	    foreach
	        select cod, nam
	        into postpolcod, postpolnam
	        from _postpol
	        order by nam
	        return postpolcod, postpolnam, ret with resume;
	    end foreach;
	end if;
end procedure;

create procedure postpol_ins(nam char(50), balans decimal(9,2), 
                    urlico char(1), nds char(1),
                    post char(1), datreg date, lgotacod int, numcard char(5),
                    gorodcod int, index char(6), ulica char(50), dom char(8), kv char(4), 
                    pgorodcod int, pindex char(6), pulica char(50), pdom char(8), pkv char(4), 
                    phone_boss char(9), phone_buh char(9), 
                    phone_o char(9), fax char(9), email char(30), 
                    boss_f char(20), boss_i char(20), boss_o char(20),
                    boss_i2 char(20), boss_o2 char(20),
                    boss_i3 char(20), boss_o3 char(20), 
                    boss_born date, boss_sex char(1),
                    cont_fio char(50), cont_dol char(50), cont_p_r char(9),
                    cont_p_d char(30), zkpo char(8), inn char(12), ns char(8),
                    bank_nam char(50), bank_mfo char(6), bank_schet char(14),
                    sot_cod int, prim char(80)
                    )
	returning int;
	
	define	cod	int;
	if balans is null then 
	    let balans = 0;
	end if;
	if pgorodcod is null then
	    let pgorodcod = gorodcod;
	end if;
	if pindex is null then
	    let pindex = index;
	end if;
	if pulica is null then
	    let pulica = ulica;
	end if;
	if pdom is null then
	    let pdom = dom;
	end if;
	if pkv is null then
	    let pkv = kv;
	end if;
	if urlico = ' ' then
	    let urlico = null;
	end if;
	if nds = ' ' then
	    let nds = null;
	end if;
	insert into _postpol values(0, nam, balans, urlico, nds,
                    post, datreg, lgotacod, numcard,
                    gorodcod, index, ulica, dom, kv, 
                    pgorodcod, pindex, pulica, pdom, pkv, 
                    phone_boss, phone_buh, 
                    phone_o, fax, email, 
                    boss_f, boss_i, boss_o, boss_i2, boss_o2, 
                    boss_i3, boss_o3, boss_born, boss_sex,
                    cont_fio, cont_dol, cont_p_r,
                    cont_p_d, zkpo, inn, ns,
                    bank_nam, bank_mfo, bank_schet,
                    sot_cod, prim);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure postpol_upd(postpolcod int, 
                    nam char(50), balans decimal(9,2), urlico char(1), nds char(1),
                    post char(1), datreg date, lgotacod int, numcard char(5),
                    gorodcod int, index char(6), ulica char(50), dom char(8), kv char(4), 
                    pgorodcod int, pindex char(6), pulica char(50), pdom char(8), pkv char(4), 
                    phone_boss char(9), phone_buh char(9), 
                    phone_o char(9), fax char(9), email char(30), 
                    boss_f char(20), boss_i char(20), boss_o char(20),
                    boss_i2 char(20), boss_o2 char(20),
                    boss_i3 char(20), boss_o3 char(20),
                    boss_born date, boss_sex char(1),
                    cont_fio char(50), cont_dol char(50), cont_p_r char(9),
                    cont_p_d char(30), zkpo char(8), inn char(12), ns char(8),
                    bank_nam char(50), bank_mfo char(6), bank_schet char(14),
                    sot_cod int, prim char(80)
                    )
	
    if balans is null then 
        let balans = 0;
    end if;
    if pgorodcod is null then
	    let pgorodcod = gorodcod;
	end if;
	if pindex is null then
	    let pindex = index;
	end if;
	if pulica is null then
	    let pulica = ulica;
	end if;
	if pdom is null then
	    let pdom = dom;
	end if;
	if pkv is null then
	    let pkv = kv;
	end if;
	if urlico = ' ' then
	    let urlico = null;
	end if;
	if nds = ' ' then
	    let nds = null;
	end if;
	update _postpol set(nam, balans, urlico, nds,
                    post, datreg, lgota_cod, numcard,
                    gorod_cod, index, ulica, dom, kv, 
                    pgorod_cod, pindex, pulica, pdom, pkv, 
                    phone_boss, phone_buh, 
                    phone_o, fax, email, 
                    boss_f, boss_i, boss_o,
                    boss_i2, boss_o2, boss_i3, boss_o3,
                    boss_born, boss_sex,
                    cont_fio, cont_dol, cont_p_r,
                    cont_p_d, zkpo, inn, ns,
                    bank_nam, bank_mfo, bank_schet,
                    sot_cod, prim) =
	                (nam, balans, urlico, nds,
                    post, datreg, lgotacod, numcard,
                    gorodcod, index, ulica, dom, kv, 
                    pgorodcod, pindex, pulica, pdom, pkv, 
                    phone_boss, phone_buh, 
                    phone_o, fax, email, 
                    boss_f, boss_i, boss_o,
                    boss_i2, boss_o2, boss_i3, boss_o3,
                    boss_born, boss_sex,
                    cont_fio, cont_dol, cont_p_r,
                    cont_p_d, zkpo, inn, ns,
                    bank_nam, bank_mfo, bank_schet,
                    sot_cod, prim)
        where cod = postpolcod;
end procedure;

create procedure replay_in1(ch char(1))
    returning int;
    
    define  ret int;
    
    if ch = "*" then
        let ret = 1;
    else
        let ret = 0;
    end if;
    
    return ret;
end procedure;

create procedure saldofintovkolsd(skladcod int, tovarcod int, datt date)
    returning decimal(7,2);
    
    define koll decimal(7,2);
    
    select sum(a.kol - kolfintovrforpdas(a.cod, datt))
        into koll
        from finoperp a
        where a.sklad_cod = skladcod and
              a.tovar_cod = tovarcod and
              a.dat_pokupki < datt;
     
    if koll is null then
        let koll = 0;
    end if;

    return koll;
end procedure;

create procedure saldomattovkolsd(skladcod int, tovarcod int, datt date)
    returning decimal(7,2);
    
    define koll, koll1, koll2 decimal(7,2);

--    set debug file to "/tmp/ddd";
--    trace on;

--        vp
--    select sum(a.kol - kolmattovrforpdas(a.cod, datt))
--        into koll
--        from matoperp a
--        where a.tovar_cod = tovarcod and
--              a.sklad_cod = skladcod and
--              a.dat_pokupki < datt;
              
    select sum(a.kol - kolmattovrforpdas(a.cod, datt))
        into koll1
        from matoperp a, naklp b
        where a.tovar_cod = tovarcod and
              a.sklad_cod = skladcod and
              -- b.sklad_cod = skladcod and
              a.doc_cod = b.cod and
              b.dat < datt;
    
    if koll1 is null then
        let koll1 = 0;
    end if;

    select sum(a.kol - kolmattovrforpdas(a.cod, datt))
        into koll2
        from matoperp a, vp b
        where a.tovar_cod = tovarcod and
              a.sklad_cod = skladcod and
              -- b.skladp_cod = skladcod and
              a.doc_cod = b.cod and
              b.dat < datt;
    
    if koll2 is null then
        let koll2 = 0;
    end if;
    
    let koll = koll1 + koll2;
    return koll;
end procedure;

create procedure saldomattovkolsdcp(operpcod int, skladcod int, tovarcod int, datt date)
    returning decimal(7,2);
    
    define koll  decimal(7,2);
    define koll2 decimal(7,2);
    
    select sum(a.kol - kolmattovrforpdat(a.cod, datt))
        into koll
        from matoperp a
        where a.sklad_cod = skladcod and
              a.tovar_cod = tovarcod and
              a.dat_pokupki <= datt and
              a.cod != operpcod;
    
    if koll is null then
        let koll = 0;
    end if;           
              
    select a.kol
        into koll2
        from matoperp a
        where a.sklad_cod = skladcod and
              a.tovar_cod = tovarcod and
              a.cod = operpcod;
     
    if koll2 is null then
        let koll2 = 0;
    end if;
    
    let koll = koll + koll2;

    return koll;
end procedure;

create procedure schet_del(schetcod int)
    define schfnrtovcod int;
    
    foreach
	    select cod  into schfnrtovcod
	      from schfnrtov
	      where schetfnr_cod = schetcod
	    
        execute procedure schettov_del(schfnrtovcod);
    end foreach;
	
	delete from schetfnr where cod = schetcod;
end procedure;

create procedure schet_ins(datt date, operaciacod int, klientcod int, 
                            lgotaproc decimal(5,2), prim1 char(60), prim2 char(60),
                            datdolga date)
	returning int, int;
	
	define  numm int;
	define global CodesSofnrCod int default -1;

	select max(num+1)
	    into numm
	    from _schet
	    where year(dat) = year(datt);
	    
	if numm is null 
	then 
	    let numm = 1;
	end if;
	
	insert into _schet values(CodesSofnrCod, numm, datt, operaciacod, klientcod, lgotaproc, prim1, prim2, datdolga, user);
	return CodesSofnrCod, numm;
end procedure;

create procedure schet_upd(schetcod int, schetnum int, schetdat date, operaciacod int,
                            klientcod int, lgotaproc decimal(5,2), schetprim1 char(60),
                            schetprim2 char(60), datdolga date)
	
	update schetfnr set (schet_num, schet_dat, operacia_cod,
	                     klient_cod, lgota_proc, prim1, prim2, dat_dolga) = 
	                    (schetnum, schetdat, operaciacod, 
	                     klientcod, lgotaproc, schetprim1, schetprim2, datdolga)
	    where cod = schetcod;
end procedure;

create procedure schetopl_del(schetoplcod int)
	delete from schetopl where cod = schetoplcod;
end procedure;

create procedure schetopl_ins(schetcod int, dat date, summa decimal(9,2))
	returning int;
	
	define global CodesSofnrCod int default -1;
	
	insert into schetopl values(CodesSofnrCod, schetcod, dat, summa);
	return CodesSofnrCod;
end procedure;

create procedure schetopl_upd(schetoplcod int, datt date, summaa decimal(9,2))
	update schetopl
	    set (dat, summa) = (datt, summaa)
	    where cod = schetoplcod;
end procedure;

create procedure schettov_del(schettovcod int)
	define schfnrtovtcod    int;
	
    delete from schfnrtovt where schfnrtov_cod = schettovcod;
    delete from schfnrtov where cod = schettovcod;
end procedure;

create procedure schettov_ins(schetcod int, tovarcod int, printnam char(80),
                               kol decimal(7,2), cena decimal(9,2))
	returning int;
	
	define	global CodesDocCod	int default -1;
	
	insert into schfnrtov values(CodesDocCod, schetcod, tovarcod, printnam, kol, cena, user);
	return CodesDocCod;
end procedure;

create procedure schettov_upd(schfnrcod int, tovarcod int, printnamm char(80),
                               koll decimal(7,2), cenaa decimal(9,2))
	update schfnrtov
	    set (tovar_cod, printnam, kol, cena, usr) = 
	        (tovarcod, printnamm, koll, cenaa, user)
	    where cod = schfnrcod;
end procedure;

create procedure schettovt_del(schettovtcod int)
	delete from schfnrtovt where cod = schettovtcod;
end procedure;

create procedure schettovt_ins(schetfnrcod int, schfnrtovcod int, 
                                tovarcod int,
                                kol decimal(7,2), cena decimal(9,2))
	returning int;
	
	define	global CodesDocCod	int default -1;
	
	if not exists (select a.cod
	                from matoperr a
	                where doc_cod = schfnrtovcod)
	then
    	insert into schfnrtovt values(CodesDocCod, schetfnrcod, schfnrtovcod, tovarcod, kol, cena, user);
	else
	    raise exception -746, 0, ' !!!        .';
	end if;
	return CodesDocCod;
end procedure;

create procedure schettovt_upd(schfnrtovtcod int, tovarcod int,
                               koll decimal(7,2), cenaa decimal(9,2))
	update schfnrtovt
	    set (tovar_cod, kol, cena, usr) = 
	        (tovarcod, koll, cenaa, user)
	    where cod = schfnrtovtcod;
end procedure;

create procedure sernumostatok_he(skladcod int, hesernum char(20))
    returning int, int, int, date, char(50), char(20), decimal(7,2),
              char(10), decimal(9,2), decimal(9,2), char(1), int;

	define 	operpcod, tovarcod, eicod, cnt, ret	int;
	define  datpokupki  date;
	define	tovarnam    char(50);
	define  sernumm     char(20);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  cenadd      decimal(9,2);
	define  isndss      char(1);
	define  koll        decimal(7,2);

    let cenadd = 0;
    let ret = 3;
    select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
           kol, ei_nam, cena, cenad, isnds
        into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
             koll, einam, cenaa, cenadd, isndss
        from _tovarostatokmat
           where sklad_cod = skladcod and
                 sernum = hesernum;
  
       return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
           koll, einam, cenaa, cenadd, isndss, ret;
end procedure;

create procedure sernumtov_del(opercod int)
	
    if exists (select cod
                        from matoperr
                        where matoperp_cod = opercod
                   )
    then
        raise exception -746,0,' !!!   .';
    end if;

	update matoperp
	    set (sernum, usr) = (null, user)
	    where cod = opercod;
end procedure;

create procedure sernumtov_upd(opercod int, sernumm char(20), datgar date)

    if exists (select cod
                        from matoperr
                        where matoperp_cod = opercod
                   )
    then
        raise exception -746,0,' !!!   .';
    end if;
	
	update matoperp
	    set (sernum, dat_gar, usr) = (sernumm, datgar, user)
	    where cod = opercod;
end procedure;

create procedure sklad_del(skladcod int)
	
	delete from sklad where cod = skladcod;
end procedure;

create procedure sklad_he(heskladnam char(30)) returning int, char(30), int;
	define 	skladcod, cnt, ret	int;
	define	skladnam	char(30);

	select count(*) into cnt
	  from sklad
	  where nam matches heskladnam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into skladcod, skladnam
	      from sklad
	      order by nam
	      
	      return skladcod, skladnam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into skladcod, skladnam
	      from sklad
	      where nam matches heskladnam
	      order by nam
	      
	      return skladcod, skladnam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into skladcod, skladnam
            from sklad
            where nam matches heskladnam;

            return skladcod, skladnam, ret;
	end if;
end procedure;

create procedure sklad_ins(matotvcod int, skladnam char(30))
	returning int;
	
	define	cod	int;
	insert into sklad values(0, matotvcod, skladnam);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure sklad_upd(skladcod int, skladnam char(30))
	
	update sklad set (nam) = (skladnam)
	    where cod = skladcod;
end procedure;

create procedure sostav_del(sostavcod int)
	
	delete from sostav where cod = sostavcod;
end procedure;

create procedure sostav_ins(mastercod int, slavecod int)
	returning int;
	
	define	cod	int;
	define  sortfield int;
	
	select max(sort_field) 
	    into sortfield
	    from sostav
	    where master_cod = mastercod;
	
	if sortfield is null 
	then
	    let sortfield = 1;
	else
	    let sortfield = sortfield + 1;
	end if;
	
	insert into sostav values(0, mastercod, slavecod, sortfield);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure sostav_upd(sostavcod int, slavecod int)
	
	update sostav set (slave_cod) = (slavecod)
	    where cod = sostavcod;
end procedure;

create procedure sot_del(sotcod int)
	
	delete from klient where cod = sotcod;
end procedure;

create procedure sot_he(hesotfio char(50)) returning int, char(50), int;
	define 	sotcod, cnt, ret	int;
	define	sotfio     char(50);

	select count(*) into cnt
	  from _sot
	  where fio matches hesotfio;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, fio
	      into sotcod, sotfio
	      from _sot
	      order by fio
	      
	      return sotcod, sotfio, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, fio
	      into sotcod, sotfio
	      from _sot
	      where fio matches hesotfio
	      order by fio
	      
	      return sotcod, sotfio, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, fio
            into sotcod, sotfio
            from _sot
            where fio matches hesotfio;

            return sotcod, sotfio, ret;
	end if;
end procedure;

create procedure sot_ins(fio char(50), matotv char(1), datborn date, gorodcod int,
                          index char(6), ulica char(50), dom char(8), kv char(4),
                          phone char(9), email char(30), prim char(80), login char(8)
                         )
	returning int;
	
	define	cod	int;
	insert into _sot values(0, fio, '*', matotv, datborn, gorodcod, 
	                       index, ulica, dom, kv,
	                       phone, email, prim, login);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure sot_upd(sotcod int, 
                          fio char(50), matotv char(1), datborn date, gorodcod int,
                          index char(6), ulica char(50), dom char(8), kv char(4),
                          phone char(9), email char(30), prim char(80), login char(8)
                         )
	
	update _sot set(fio, matotv, datborn, gorod_cod, index, ulica, dom, kv,
	                phone, email, prim, login) =
	                (fio, matotv, datborn, gorodcod, index, ulica, dom, kv,
	                phone, email, prim, login)
        where cod = sotcod;
end procedure;

create procedure spisanietov_del(ros char(1), operrcod int)

    if ros = 's' then
	    delete from finoperr    where cod = operrcod;
    else
        delete from primrez     where matoperr_cod = operrcod;
        delete from matoperr    where cod = operrcod;
	end if;
end procedure;

create procedure "slon2".spisanietov_ins(ros char(1), schetcod int,
                                 schfnrtovcod int, operpcod int,
                                 koll decimal(7,2), cenaa decimal(9,2),
                                 cenadd decimal(9,2), datotgg date,
                                 primreznam char(80), datgar date)
	returning int;

	define	operrcod int;

	let operrcod = 0;
    if ros = 's' then
        insert into finoperr
            values(0, schetcod, schfnrtovcod, operpcod, null, datotgg, koll, cenaa, user);
        let operrcod = dbinfo("sqlca.sqlerrd1");
    end if
    if ros = 'r' then
        if not exists (select cod from schfnrtovt where schfnrtov_cod = schfnrtovcod) then
            insert into matoperr
                values(0, schetcod, schfnrtovcod, operpcod, null, null, null, koll, cenaa, cenadd, user);
            let operrcod = dbinfo("sqlca.sqlerrd1");
        else
            raise exception -746, 0, ' !!!        .';
        end if
    end if
    if ros = 'o' then
        if not exists (select cod from schfnrtovt where schfnrtov_cod = schfnrtovcod) then
            insert into matoperr
                values(0, schetcod, schfnrtovcod, operpcod, null, datotgg, datgar, koll, cenaa, cenadd, user);
            let operrcod = dbinfo("sqlca.sqlerrd1");
        else
            raise exception -746, 0, ' !!!        .';
        end if
    end if
    if ros = 'r' or ros = 'o' then
        insert into primrez values(operrcod, primreznam);
    end if
	return operrcod;
end procedure;

create procedure spisanietov_upd(ros char(1), operrcod int, datotgg date, 
                                  koll decimal(7,2), primreznam char(80),
                                  datgar date)
        
        
        if ros = 's' then
            update finoperr
                set (kol, usr) = (koll, user)
                where cod = operrcod;
        end if;
        if ros = 'r' then
            update matoperr
                set (kol, usr) = (koll, user)
                where cod = operrcod;
        end if;
        if ros = 'o' then
            update matoperr
                set (datotg, dat_gar, kol, usr) = (datotgg, datgar, koll, user)
                where cod = operrcod;
        end if;
        if ros = 'r' or ros = 'o' then
            update primrez
                set (nam) = (primreznam)
                where matoperr_cod = operrcod;
        end if;
end procedure;

create procedure spisanoschtovkol(schfnrtovcod int)
    returning decimal(7,2);
    
    define spisanokol   decimal(7,2);
    
    select sum(kol) into spisanokol
        from finoperr
        where doc_cod = schfnrtovcod;
    
    if spisanokol is null then
        let spisanokol = 0;
    end if;
        
    return spisanokol;
end procedure;

create procedure stt_ins(vppcod int, vprcod int, sgpcod int, shtcod int,
                          zaimto int, pzaimto int, zaimfrom int, pzaimfrom int,
                          gklp1cod int, gklp2cod int, gklr1cod int, gklr2cod int,
                          gpsr1cod int, gpsr2cod int, gpsp1cod int, gpsp2cod int)

    delete from stt;
	insert into stt values(vppcod, vprcod, sgpcod, shtcod, zaimto, pzaimto,
	                       zaimfrom, pzaimfrom,
	                       gklp1cod, gklp2cod, gklr1cod, gklr2cod,
                           gpsr1cod, gpsr2cod, gpsp1cod, gpsp2cod);
end procedure;

create procedure t_codes_doc_del(codd int)
--    on exception in ( -692 )
        delete from codes_doc where cod = codd;
--    end exception with resume;
end procedure;

create procedure t_codes_doc_ins()
    define global CodesDocCod    int default 0;
    
    insert into codes_doc values(0);
    let CodesDocCod = dbinfo("sqlca.sqlerrd1");
end procedure;

create procedure t_codes_sofnr_del(codd int)
    delete from codes_sofnr where cod = codd;
end procedure;

create procedure t_codes_sofnr_ins()
    define global CodesSofnrCod    int default 0;
    
    insert into codes_sofnr values(0);
    let CodesSofnrCod = dbinfo("sqlca.sqlerrd1");
end procedure;

create procedure t_finoperp_upd1(finoperpcod int)
    if exists (select cod
                   from finoperr
                   where finoperp_cod = finoperpcod)
    then
        raise exception -746, 0, ' !!!   .';
    end if;
end procedure;

create procedure t_finoperr_kol(finoperpcod int, doccod int)

    define kolostatokp   decimal(7,2);
    define kolostatoks   decimal(7,2);
    define kolschet      decimal(7,2);
    
    let kolostatokp = -1;
    select kol into kolostatokp
	    from _tovostfinonly
	    where finoperp_cod = finoperpcod;

    if kolostatokp < 0 then
        raise exception -746, 0, ' !!!     .';
    end if;
    
    select kol into kolschet
        from schfnrtov
        where cod = doccod;
    if DBINFO("sqlca.sqlerrd2") > 0 then
        select sum(kol) into kolostatoks
            from finoperr
            where doc_cod = doccod;
        if kolostatoks > kolschet then
            raise exception -746, 0, ' !!!       .';
        end if;
    end if;
end procedure;

create procedure t_matoperp_upd1(matoperpcod int)
    if exists (select cod
                   from matoperr
                   where matoperp_cod = matoperpcod)
    then
        raise exception -746, 0, ' !!!   .';
    end if;
end procedure;

create procedure t_matoperr_kol(matoperrcod int, matoperpcod int, doccod int)

    define kolostatokp   decimal(7,2);
    define kolostatoks   decimal(7,2);
    
    
    --if exists (select cod
    --            from matoperr
    --            where cod = matoperrcod and datotg is not null)
    --then
    --    raise exception -746, 0, ' !!!   .';
    --end if;
    
    let kolostatokp = -1;
    select kol
	    into kolostatokp
	    from _tovostmatonly
	    where matoperp_cod = matoperpcod;

    if kolostatokp < 0 then
        raise exception -746, 0, ' !!!     .';
    end if;
    
    select kol into kolostatoks
        from schfnrtov
        where cod = doccod;
    if DBINFO("sqlca.sqlerrd2") = 0 then
        select kol into kolostatoks
            from schfnrtovt
            where cod = doccod;
        if DBINFO("sqlca.sqlerrd2") = 0 then
            select kol into kolostatoks
                from naklrtov
                where cod = doccod;
        end if;
    end if;
    select sum(kol) into kolostatokp
        from matoperr
        where doc_cod = doccod;
    if kolostatokp > kolostatoks then
        raise exception -746, 0, ' !!!       .';
    end if;
end procedure;

create procedure t_naklp_upd1(codd int, datt date, tip char(1))

    if tip = 'M' then
        if not exists (select a.cod
                       from matoperr a, matoperp b
                       where b.naklp_cod = codd and
                             a.matoperp_cod = b.cod)
        then
            update matoperp
                set (dat_pokupki) = (datt)
                where naklp_cod = codd;
        else
            raise exception -746, 0, ' !!!   .';
        end if;
    end if;
    
    if tip = 'F' then
        if not exists (select a.cod
                        from finoperr a, finoperp b
                        where b.naklp_cod = codd and
                              a.finoperp_cod = b.cod)
        then
            update finoperp
                set (dat_pokupki) = (datt)
                where naklp_cod = codd;
        else
            raise exception -746, 0, ' !!!   .';
        end if;
    end if;
    
    if tip = 'N' then
        if not exists (select a.cod
                        from finoperr a, finoperp b
                        where b.naklp_cod = codd and
                              a.finoperp_cod = b.cod)
           and not exists
                        (select a.cod
                        from matoperr a, matoperp b
                        where b.naklp_cod = codd and
                              a.matoperp_cod = b.cod)
        then
            update finoperp
                set (dat_pokupki) = (datt)
                where naklp_cod = codd;
            update matoperp
                set (dat_pokupki) = (datt)
                where naklp_cod = codd;
        else
            raise exception -746, 0, ' !!!   .';
        end if;
    end if;
end procedure;

create procedure t_naklp_upd2(codd int, skladcod int, tip char(1))

    if tip = 'M' then
        if not exists (select a.cod
                       from matoperr a, matoperp b
                       where b.naklp_cod = codd and
                             a.matoperp_cod = b.cod)
        then
            update matoperp
                set (sklad_cod) = (skladcod)
                where doc_cod = codd;
        else
            raise exception -746, 0, ' !!!   .';
        end if;
    end if;
    
    if tip = 'F' then
        if not exists (select a.cod
                        from finoperr a, finoperp b
                        where b.naklp_cod = codd and
                              a.finoperp_cod = b.cod)
        then
            update finoperp
                set (sklad_cod) = (skladcod)
                where doc_cod = codd;
        else
            raise exception -746, 0, ' !!!   .';
        end if;
    end if;
    
    if tip = 'N' then
        if not exists (select a.cod
                        from finoperr a, finoperp b
                        where b.naklp_cod = codd and
                              a.finoperp_cod = b.cod)
           and not exists
                        (select a.cod
                        from matoperr a, matoperp b
                        where b.naklp_cod = codd and
                              a.matoperp_cod = b.cod)
        then
            update finoperp
                set (sklad_cod) = (skladcod)
                where doc_cod = codd;
            update matoperp
                set (sklad_cod) = (skladcod)
                where doc_cod = codd;
        else
            raise exception -746, 0, ' !!!   .';
        end if;
    end if;
end procedure;

create procedure t_naklrtov_upd1(naklrtovcod int, koll decimal(7,2))

    define  kolspis decimal(7,2);
    
    select sum(a.kol)
        into kolspis
        from matoperr a
        where a.doc_cod = naklrtovcod;
    
    if kolspis is null then
        let kolspis = 0;
    end if;

    if koll < kolspis
    then
        raise exception -746, 0, ' !!!       .';
    end if;
end procedure;

create procedure t_naklrtov_upd2(naklrtovcod int, cenaa decimal(9,2),
                                 cenadd decimal(9,2))

    update matoperr
        set (cena, cenad, usr) = (cenaa, cenadd, user)
        where doc_cod = naklrtovcod;
end procedure;

create procedure t_schetfnr_upd1(schetfnrcod int, num int, dat date, skladcod int)

    if exists (select b.sklad_cod
                from finoperr a, finoperp b
                where a.schetfnr_cod = schetfnrcod and
                      a.finoperp_cod = b.cod and
                      b.sklad_cod != skladcod
              )
    then
        raise exception -746, 0, ' !!!      .';
    else
        if num is null or
           dat is null or
           skladcod is null
        then
            if exists ( select cod
                        from finoperr
                        where schetfnr_cod = schetfnrcod
                      )
            then
                raise exception -746, 0, ' !!!   .  .';
            end if;
        end if;
    end if;
    if dat is not null then
        update finoperr
            set (datotg) = (dat)
            where schetfnr_cod = schetfnrcod;
    end if;
end procedure;

create procedure t_schetopl_upd1(schetoplcod int)

    if exists (select a.cod
                    from nnakl a
                    where a.sofnr_cod = schetoplcod)
    then
        raise exception -746, 0, ' !!!     .';
    end if;
end procedure;

create procedure t_schfnrtov_upd1(schfnrtovcod int, koll decimal(7,2))

    define  kolspis decimal(7,2);

    if exists (select a.cod
                    from nnakltov a
                    where a.schfnrtov_cod = schfnrtovcod)
    then
        raise exception -746, 0, ' !!!  .';
    end if;
    if exists (select a.cod
                    from finoperr a
                    where a.doc_cod = schfnrtovcod)
    then
        raise exception -746, 0, ' !!!   .';
    end if;
    
    select sum(a.kol)
        into kolspis
        from matoperr a
        where a.doc_cod = schfnrtovcod;
    if kolspis is null then
        let kolspis = 0;
    end if;
    if koll < kolspis
    then
        raise exception -746, 0, ' !!!       .';
    end if;
end procedure;

create procedure t_schfnrtov_upd2(schfnrtovcod int, cenaa decimal(9,2))

    if exists (select a.cod
                    from nnakltov a
                    where a.schfnrtov_cod = schfnrtovcod)
    then
        raise exception -746, 0, ' !!!  .';
    end if;
    
    if exists (select a.cod
                    from finoperr a
                    where a.doc_cod = schfnrtovcod)
    then
        raise exception -746, 0, ' !!!   .';
    end if;

    update matoperr
        set (cena, usr) = (cenaa, user)
        where doc_cod = schfnrtovcod;
end procedure;

create procedure t_schfnrtovt_upd1(schfnrtovtcod int)

    if exists (select a.cod
                    from matoperr a
                    where a.doc_cod = schfnrtovtcod)
    then
        raise exception -746, 0, ' !!!   .';
    end if;
end procedure;

create procedure t_schfnrtovt_upd2(schfnrtovtcod int, cenaa decimal(9,2))

    update matoperr
        set (cena, usr) = (cenaa, user)
        where doc_cod = schfnrtovtcod;
end procedure;

create procedure t_vp_upd1(codd int, datt date, tipp char(1))

    if tipp = 'M' then
        if not exists (select a.cod
                       from matoperr a, matoperp b
                       where a.doc_cod = codd and
                             a.matoperp_cod = b.cod and
                             b.dat_pokupki > datt)
        then
            update matoperr
                set (datotg) = (datt)
                where doc_cod = codd;
        else
            raise exception -746, 0, ' !!!      .';
        end if;
    end if;
    
    if tipp = 'F' then
        if not exists (select a.cod
                       from finoperr a, finoperp b
                       where a.doc_cod = codd and
                             a.finoperp_cod = b.cod and
                             b.dat_pokupki > datt)
        then
            update finoperr
                set (datotg) = (datt)
                where doc_cod = codd;
        else
            raise exception -746, 0, ' !!!      .';
        end if;
    end if;
end procedure;

create procedure tipdocp_he(hetipdocnam char(30)) 
    returning char(1), char(35), int;

    return 1,'   ', 1 with resume;
    return 3,' ', 1 with resume;
end procedure;

create procedure tipdocr_he(hetipdocnam char(30)) 
    returning char(1), char(35), int;

    return 1,'   ', 1 with resume;
    return 2,'  ', 1 with resume;
end procedure;

create procedure tovar_del(tovarcod int)
	
	delete from tovar where cod = tovarcod;
end procedure;

create procedure tovar_he(hetovarnam char(50)) 
    returning int, int, char(50), char(10), decimal(9,2), char(1), int;

	define 	tovarcod, eicod, cnt, ret	int;
	define	tovarnam    char(50);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  isndss      char(1);

    let cnt = 0;
    let ret = 3;
    foreach
	    select a.cod, b.cod, a.nam, b.nam, a.cena, a.isnds
	        into tovarcod, eicod, tovarnam, einam, cenaa, isndss
	        from tovar a, ei b
	        where a.nam matches hetovarnam and
	              a.ei_cod = b.cod
	        order by a.nam
	        return tovarcod, eicod, tovarnam, einam, cenaa, isndss, ret with resume;
	    
	    let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
	end foreach;
	
	if cnt = 0 then
	    let ret = 1;
	    return 0, 0, '    ', '    ', 0, '', ret with resume;
--	    foreach
--	        select a.cod, b.cod, a.nam, b.nam, a.cena, a.isnds
--	        into tovarcod, eicod, tovarnam, einam, cenaa, isndss
--	        from tovar a, ei b
--	        where a.ei_cod = b.cod
--	        order by a.nam
--	        return tovarcod, eicod, tovarnam, einam, cenaa, isndss, ret with resume;
--	  end foreach;
	end if;
end procedure;

create procedure tovar_ins(tovargroupcod int, tovartipcod int, 
                            tovarnam char(50), eicod int, cena decimal(9,2), 
                            gs char(2), isnds char(1), ispricelist char(1), 
                            issernum char(1), newbuy char(1),
                            saleviawww char(1))
	returning int;
	
	define	cod	int;
	insert into tovar values(0, tovargroupcod, tovartipcod, tovarnam, eicod, 
	                         cena, gs, isnds, ispricelist, issernum,
	                         newbuy, saleviawww);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure tovar_upd(tovarcod int, tovarnam char(50), eicod int, 
                            cena decimal(9,2), gs char(2), isnds char(1), 
                            ispricelist char(1), issernum char(1),
                            newbuy char(1), saleviawww char(1))
	
	update tovar 
	    set (nam, ei_cod, cena, gs, isnds, ispricelist, issernum, newbuy, saleviawww ) = 
	        (tovarnam, eicod, cena, gs, isnds, ispricelist, issernum, newbuy, saleviawww)
	    where cod = tovarcod;
end procedure;

create procedure tovarbytip_he(hetovarnam char(50), tovartipcod int) 
    returning int, int, char(50), char(10), decimal(9,2), char(1), int;

	define 	tovarcod, eicod, cnt, ret	int;
	define	tovarnam    char(50);
	define  einam	    char(10);
	define  cenaa    decimal(9,2);
	define  isndss      char(1);

	select count(*) into cnt
	  from tovar a
	  where a.nam matches hetovarnam and tovartip_cod = tovartipcod;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select a.cod, b.cod, a.nam, b.nam, a.cena, a.isnds
	      into tovarcod, eicod, tovarnam, einam, cenaa, isndss
	      from tovar a, ei b
	      where a.ei_cod = b.cod and 
	            a.tovartip_cod = tovartipcod
	      order by a.nam
	      
	      return tovarcod, eicod, tovarnam, einam, cenaa, isndss, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select a.cod, b.cod, a.nam, b.nam, a.cena, a.isnds
	      into tovarcod, eicod, tovarnam, einam, cenaa, isndss
	      from tovar a, ei b
	      where a.nam matches hetovarnam and
	            a.ei_cod = b.cod and
	            a.tovartip_cod = tovartipcod
	      order by a.nam
	      
	      return tovarcod, eicod, tovarnam, einam, cenaa, isndss, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select a.cod, b.cod, a.nam, b.nam, a.cena, a.isnds
            into tovarcod, eicod, tovarnam, einam, cenaa, isndss
            from tovar a, ei b
            where a.nam matches hetovarnam and
                  a.ei_cod = b.cod and
                  a.tovartip_cod = tovartipcod;

            return tovarcod, eicod, tovarnam, einam, cenaa, isndss, ret;
	end if;
end procedure;

create procedure tovargroup_del(tovargroupcod int)
	
	delete from tovar where tovargroup_cod = tovargroupcod;
	delete from tovartip where tovargroup_cod = tovargroupcod;
	delete from tovargroup where cod = tovargroupcod;
end procedure;

create procedure tovargroup_ins(tovargroupnam char(30))
	returning int;
	
	define	cod	int;
	insert into tovargroup values(0, tovargroupnam);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure tovargroup_upd(tovargroupcod int, tovargroupnam char(30))
	
	update tovargroup set (nam) = (tovargroupnam)
	    where cod = tovargroupcod;
end procedure;

create procedure tovaronly_he(hetovaronlynam char(50)) returning int, char(50), int;
	define 	tovaronlycod, cnt, ret	int;
	define	tovaronlynam	char(50);

    let cnt = 0;
    let ret = 3;
    foreach
	    select cod, nam
	        into tovaronlycod, tovaronlynam
	        from tovar
	        where nam matches hetovaronlynam
	        order by nam
	        return tovaronlycod, tovaronlynam, ret with resume;
	    
	    let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
	end foreach;

	if cnt = 0 then
	    let ret = 1;
	    foreach
	        select cod, nam
	            into tovaronlycod, tovaronlynam
	            from tovar
	            order by nam
	            return tovaronlycod, tovaronlynam, ret with resume;
	  end foreach;
	end if;
end procedure;

create procedure tovarostatok_he(tip char(1), skladcod int, datpr date,
                                 hetovarnam char(50))
    returning int, int, int, date, char(50), char(20), decimal(7,2),
              char(10), decimal(9,2), decimal(9,2), char(1), int;

	define 	operpcod, tovarcod, eicod, cnt, ret	int;
	define  datpokupki  date;
	define	tovarnam    char(50);
	define  sernumm     char(20);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  cenadd      decimal(9,2);
	define  isndss      char(1);
	define  koll        decimal(7,2);

    let sernumm = "";
    let cenadd = 0;
    let cnt = 0;
    let ret = 3;
	if tip = "F" or tip = "f" then
	    foreach
            select finoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam,
	               kol, ei_nam, cena, isnds
	            into operpcod, tovarcod, eicod, datpokupki, tovarnam,
	                 koll, einam, cenaa, isndss
	            from _tovarostatokfin
	            where sklad_cod = skladcod and
	                  tovar_nam matches hetovarnam and
	                  dat_pokupki <= datpr
	            order by tovar_nam, dat_pokupki, kol
	            return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                   koll, einam, cenaa, cenadd, isndss, ret with resume;
	        
	        let cnt = cnt + 1;
            if cnt > 0 then
                let ret = 2;
            end if;
        end foreach;

	    if cnt = 0 then
	        let ret = 1;
	        foreach
	            select finoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam,
	                   kol, ei_nam, cena, isnds
	                into operpcod, tovarcod, eicod, datpokupki, tovarnam,
	                     koll, einam, cenaa, isndss
	                from _tovarostatokfin
	                where sklad_cod = skladcod and
	                      dat_pokupki <= datpr
	                order by tovar_nam, dat_pokupki, kol
	                return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                       koll, einam, cenaa, cenadd, isndss, ret with resume;
	        end foreach;
	    end if;
	end if;
	
	if tip = "M" or tip = "m" then
        foreach
            select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
	               kol, ei_nam, cena, cenad, isnds
	            into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                 koll, einam, cenaa, cenadd, isndss
	            from _tovarostatokmat
	            where sklad_cod = skladcod and
	                  tovar_nam matches hetovarnam and
                      dat_pokupki <= datpr
	            order by tovar_nam, dat_pokupki, kol
	            return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                   koll, einam, cenaa, cenadd, isndss, ret with resume;
	        let cnt = cnt + 1;
            if cnt > 0 then
                let ret = 2;
            end if;
	    end foreach;

	    if cnt = 0 then
	        let ret = 1;
	        foreach
	            select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
	                   kol, ei_nam, cena, cenad, isnds
	                into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                     koll, einam, cenaa, cenadd, isndss
	                from _tovarostatokmat
	                where sklad_cod = skladcod and
                          dat_pokupki <= datpr
	                order by tovar_nam, dat_pokupki, kol
	                return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                        koll, einam, cenaa, cenadd, isndss, ret with resume;
	        end foreach;
	    end if;
	end if;
end procedure;

create procedure tovarp_he(hetovarnam char(50)) 
    returning int, int, char(50), char(10), char(1), int;

	define 	tovarcod, eicod, cnt, ret	int;
	define	tovarnam    char(50);
	define  einam	    char(10);
	define  issernumm   char(1);

    let cnt = 0;
    let ret = 3;
    foreach
	    select a.cod, b.cod, a.nam, b.nam, a.issernum
	        into tovarcod, eicod, tovarnam, einam, issernumm
	        from tovar a, ei b
	        where a.nam matches hetovarnam and
	              a.ei_cod = b.cod
	        order by a.nam
	        return tovarcod, eicod, tovarnam, einam, issernumm, ret with resume;
	    
	    let cnt = cnt + 1;
        if cnt > 0 then
            let ret = 2;
        end if;
	end foreach;

	if cnt = 0 then
	    let ret = 1;
	    return 0, 0, '    ', '    ', '', ret with resume;
--	    foreach
--	        select a.cod, b.cod, a.nam, b.nam, a.issernum
--	            into tovarcod, eicod, tovarnam, einam, issernumm
--	            from tovar a, ei b
--	            where a.ei_cod = b.cod
--	            order by a.nam
--	        return tovarcod, eicod, tovarnam, einam, issernumm, ret with resume;
--	    end foreach;
	end if;
end procedure;

create procedure tovartip_del(tovartipcod int)
	
	delete from tovar where tovartip_cod = tovartipcod;
	delete from tovartip where cod = tovartipcod;
end procedure;

create procedure tovartip_he(hetovartipnam char(30)) returning int, char(30), int;
	define 	tovartipcod, cnt, ret	int;
	define	tovartipnam	char(30);

	select count(*) into cnt
	  from tovartip
	  where nam matches hetovartipnam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into tovartipcod, tovartipnam
	      from tovartip
	      order by nam
	      
	      return tovartipcod, tovartipnam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into tovartipcod, tovartipnam
	      from tovartip
	      where nam matches hetovartipnam
	      order by nam
	      
	      return tovartipcod, tovartipnam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into tovartipcod, tovartipnam
            from tovartip
            where nam matches hetovartipnam;

            return tovartipcod, tovartipnam, ret;
	end if;
end procedure;

create procedure tovartip_ins(tovargroupcod int, tovartipnam char(30))
	returning int;
	
	define	cod	int;
	insert into tovartip values(0, tovargroupcod, tovartipnam);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure tovartip_upd(tovartipcod int, tovartipnam char(30))
	
	update tovartip set (nam) = (tovartipnam)
	    where cod = tovartipcod;
end procedure;

create procedure vp_del(vpcod int)

    delete from matoperr where doc_cod = vpcod;
    delete from matoperp where doc_cod = vpcod;
    delete from finoperr where doc_cod = vpcod;
    delete from finoperp where doc_cod = vpcod;
    delete from vp where cod = vpcod;
end procedure;

create procedure vp_ins(tipp char(1), datt date, skladrcod int, 
                         skladpcod int, prim1 char(60))
	returning int, int;
	
	define	global CodesDocCod	int default -1;
	define  numm int;
	
	select max(num+1)
	    into numm
	    from vp
	    where year(dat) = year(datt) and
	          tip = tipp;
	    
	if numm is null 
	then 
	    let numm = 1;
	end if;
	
	insert into vp values(CodesDocCod, numm, datt, skladrcod, skladpcod, prim1, user, tipp);
	return CodesDocCod, numm;
end procedure;

create procedure vp_upd(vpcod int, numm char(10), datt date, 
                         skladrcod int, skladpcod int, prim11 char(60))
	update vp 
	    set (num, dat, skladr_cod, skladp_cod, usr, prim1) =
	        (numm, datt, skladrcod, skladpcod, user, prim11)
	    where cod = vpcod;
end procedure;

create procedure vptov_del(tip char(1), operrcod int, operpcod int)
	if tip = 'M' then
	    delete from matoperr
	        where cod = operrcod;
	    delete from matoperp
	        where cod = operpcod;
	end if;
	
	if tip = 'F' then
	    delete from finoperr
	        where cod = operrcod;
	    delete from finoperp
	        where cod = operpcod;
	end if;
end procedure;

create procedure vptov_ins(tip char(1), vpcod int, operpcodhe int,
                            skladpcod int, datotg date, koll decimal(7,2))

	returning int, int;

	define operrcod	    int;
	define operpcod     int;
	define naklpcod     int;
	define datpokupki   date;
	define tovarcod     int;
	define sernumm      char(20);
	define cenaa        decimal(9,2);
	define cenadd       decimal(9,2);
    define datgar       date;

	let operrcod = 0;
	let operpcod = 0;

	if tip = 'M' then
	    select naklp_cod, dat_pokupki, tovar_cod, sernum, dat_gar, cena, cenad
	        into naklpcod, datpokupki, tovarcod, sernumm, datgar, cenaa, cenadd
	        from _tovarostatokmat
	        where matoperp_cod = operpcodhe;

	    insert into matoperr
	        values(0, null, vpcod, operpcodhe, null, datotg, null, koll, cenaa, cenadd, user);
	    let operrcod = dbinfo("sqlca.sqlerrd1");

	    insert into matoperp
	        values(0, vpcod, naklpcod, datpokupki, skladpcod, tovarcod, sernumm,
	               datgar, koll, cenaa, cenadd, user);
	    let operpcod = dbinfo("sqlca.sqlerrd1");
	    update matoperr
	        set (vpmatoperp_cod) = (operpcod)
	        where cod = operrcod;
	end if;

	if tip = 'F' then
	    select naklp_cod, dat_pokupki, tovar_cod, cena
	        into naklpcod, datpokupki, tovarcod, cenaa
	        from _tovarostatokfin
	        where finoperp_cod = operpcodhe;

	    insert into finoperr
	        values(0, null, vpcod, operpcodhe, null, datotg, koll, cenaa, user);
	    let operrcod = dbinfo("sqlca.sqlerrd1");

	    insert into finoperp
	        values(0, vpcod, naklpcod, datpokupki, skladpcod, tovarcod,
	               koll, cenaa, user);
	    let operpcod = dbinfo("sqlca.sqlerrd1");
	    update finoperr
	        set (vpfinoperp_cod) = (operpcod)
	        where cod = operrcod;
	end if;

	return operrcod, operpcod;
end procedure;

create procedure vptov_upd(tip char(1), operrcod int, vpoperpcod int, 
                            koll decimal(7,2))
	if tip = 'M' then
        update matoperr
            set (kol, usr) = (koll, user)
            where cod = operrcod;
        update matoperp
            set (kol, usr) = (koll, user)
            where cod = vpoperpcod;
	end if;
	if tip = 'F' then
        update finoperr
            set (kol, usr) = (koll, user)
            where cod = operrcod;
        update finoperp
            set (kol, usr) = (koll, user)
            where cod = vpoperpcod;
	end if;
end procedure;

create procedure whattovarkol(tip char(1), operrcod int)
    returning decimal(7,2);
    
    define koll     decimal(7,2);
    define operpcod int;
    
    if tip = 'F' then
        select finoperp_cod 
            into operpcod
            from finoperr
            where cod = operrcod;
            
        select kol
            into koll
            from _tovostfinonly
            where finoperp_cod = operpcod;
        
        if koll is null then let koll = 0; end if;
        return koll;
    end if;
    
    if tip = 'M' then
        select matoperp_cod 
            into operpcod
            from matoperr
            where cod = operrcod;
            
        select kol
            into koll
            from _tovostmatonly
            where matoperp_cod = operpcod;
        
        if koll is null then let koll = 0; end if;
        return koll;
    end if;
        
end procedure;

create procedure tovargroup_he(hetovargroupnam char(30)) 
    returning int, char(30), int;
	
	define 	tovargroupcod, cnt, ret	int;
	define	tovargroupnam	char(30);

	select count(*) into cnt
	  from tovargroup
	  where nam matches hetovargroupnam;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into tovargroupcod, tovargroupnam
	      from tovargroup
	      order by nam
	      
	      return tovargroupcod, tovargroupnam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into tovargroupcod, tovargroupnam
	      from tovargroup
	      where nam matches hetovargroupnam
	      order by nam
	      
	      return tovargroupcod, tovargroupnam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into tovargroupcod, tovargroupnam
            from tovargroup
            where nam matches hetovargroupnam;

            return tovargroupcod, tovargroupnam, ret;
	end if;
end procedure;

create procedure tovargtip_he(hetovargroupcod int, hetovartipnam char(30)) 
    returning int, char(30), int;
	
	define 	tovartipcod, cnt, ret	int;
	define	tovartipnam	char(30);

	select count(*) into cnt
	  from tovartip
	  where nam matches hetovartipnam and
	        tovargroup_cod = hetovargroupcod;

	if cnt = 0 then
	  let ret = 1;
	  foreach
	    select cod, nam
	      into tovartipcod, tovartipnam
	      from tovartip
	      where tovargroup_cod = hetovargroupcod
	      order by nam
	      
	      return tovartipcod, tovartipnam, ret with resume;
	  end foreach;
	end if;

	if cnt > 1 then
	  let ret = 2;
	  foreach
	    select cod, nam
	      into tovartipcod, tovartipnam
	      from tovartip
	      where nam matches hetovartipnam and
	            tovargroup_cod = hetovargroupcod
	      order by nam
	      
	      return tovartipcod, tovartipnam, ret with resume;
	  end foreach;
	end if;
	
	if cnt = 1 then
	  let ret = 3;
          select cod, nam
            into tovartipcod, tovartipnam
            from tovartip
            where nam matches hetovartipnam and
                  tovargroup_cod = hetovargroupcod;

            return tovartipcod, tovartipnam, ret;
	end if;
end procedure;

create procedure schetsumma(codd int)
    returning decimal(9,2);

    define ssum decimal(9,2);
    
    select sum(a.kol * a.cena)
        into ssum
        from schfnrtov a
        where a.schetfnr_cod = codd;
    
    if ssum is null then
        let ssum = 0;
    end if;
    return ssum;
end procedure;

create procedure kolmattovrforpr(matoperpcod int) returning decimal(7,2);
    define  koll decimal(7,2);
    
    select sum(kol)
        into koll
        from matoperr
        where matoperp_cod = matoperpcod and
              datotg is null;
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure nulltozero(fl decimal(9,2))
    returning decimal(9,2);

    if fl is null then
        let fl = 0;
    end if;
    return fl;
end procedure;

create procedure sernumostatoksk_he(hesernum char(20))
    returning int, int, int, date, char(50), char(20), decimal(7,2),
              char(10), decimal(9,2), decimal(9,2), char(1), char(30), int;

	define 	operpcod, tovarcod, eicod, cnt, ret	int;
	define  datpokupki  date;
	define	tovarnam    char(50);
	define  sernumm     char(20);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  cenadd      decimal(9,2);
	define  isndss      char(1);
	define  koll        decimal(7,2);
	define  skladnam    char(30);

    let cenadd = 0;
    let ret = 3;
    select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
           kol, ei_nam, cena, cenad, isnds, sklad_nam
        into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
             koll, einam, cenaa, cenadd, isndss, skladnam
        from _tovarostatokmatsk
           where sernum = hesernum;
  
       return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
           koll, einam, cenaa, cenadd, isndss, skladnam, ret;
end procedure;

create procedure tovarostatokskl_he(tip char(1), datpr date, hetovarnam char(50))
    returning int, int, int, date, char(50), char(20), decimal(7,2),
              char(10), decimal(9,2), decimal(9,2), char(1), char(30), int;

	define 	operpcod, tovarcod, eicod, cnt, ret	int;
	define  datpokupki  date;
	define	tovarnam    char(50);
	define  sernumm     char(20);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  cenadd      decimal(9,2);
	define  isndss      char(1);
	define  koll        decimal(7,2);
	define  skladnam    char(30);

    let sernumm = "";
    let cenadd = 0;
    let cnt = 0;
    let ret = 3;
	if tip = "F" or tip = "f" then
	    foreach
            select finoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam,
	               kol, ei_nam, cena, isnds, sklad_nam
	            into operpcod, tovarcod, eicod, datpokupki, tovarnam,
	                 koll, einam, cenaa, isndss, skladnam
	            from _tovarostatokfinsk
	            where tovar_nam matches hetovarnam and
	                  dat_pokupki <= datpr
	            order by tovar_nam, dat_pokupki, kol
	            return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                   koll, einam, cenaa, cenadd, isndss, skladnam, ret with resume;

	        let cnt = cnt + 1;
            if cnt > 0 then
                let ret = 2;
            end if;
        end foreach;

	    if cnt = 0 then
	        let ret = 1;
	        return 0, 0, 0, '', '    ', '', 0, '', 0, 0, '', '', ret with resume;
--	        foreach
--	            select finoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam,
--	                   kol, ei_nam, cena, isnds, sklad_nam
--	                into operpcod, tovarcod, eicod, datpokupki, tovarnam,
--	                     koll, einam, cenaa, isndss, skladnam
--	                from _tovarostatokfinsk
--	                where dat_pokupki <= datpr
--	                order by tovar_nam, dat_pokupki, kol
--	                return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
--	                       koll, einam, cenaa, cenadd, isndss, skladnam, ret with resume;
--	        end foreach;
	    end if;
	end if;

	if tip = "M" or tip = "m" then
        foreach
            select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
	               kol, ei_nam, cena, cenad, isnds, sklad_nam
	            into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                 koll, einam, cenaa, cenadd, isndss, skladnam
	            from _tovarostatokmatsk
	            where tovar_nam matches hetovarnam and
                      dat_pokupki <= datpr
	            order by tovar_nam, dat_pokupki, kol
	            return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                   koll, einam, cenaa, cenadd, isndss, skladnam, ret with resume;
	        let cnt = cnt + 1;
            if cnt > 0 then
                let ret = 2;
            end if;
	    end foreach;

	    if cnt = 0 then
	        let ret = 1;
	        return 0, 0, 0, '', '    ', '', 0, '', 0, 0, '', '', ret with resume;
--	        foreach
--	            select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
--	                   kol, ei_nam, cena, cenad, isnds, sklad_nam
--	                into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
--	                     koll, einam, cenaa, cenadd, isndss, skladnam
--	                from _tovarostatokmatsk
--	                where dat_pokupki <= datpr
--	                order by tovar_nam, dat_pokupki, kol
--	                return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
--	                        koll, einam, cenaa, cenadd, isndss, skladnam, ret with resume;
--	        end foreach;
	    end if;
	end if;
end procedure;

create procedure sernumostskg_he(hesernum char(20))
    returning int, int, int, date, char(50), char(20), decimal(7,2),
              char(10), decimal(9,2), decimal(9,2), char(1), char(30), 
              date, int;

	define 	operpcod, tovarcod, eicod, cnt, ret	int;
	define  datpokupki  date;
	define	tovarnam    char(50);
	define  sernumm     char(20);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  cenadd      decimal(9,2);
	define  isndss      char(1);
	define  koll        decimal(7,2);
	define  skladnam    char(30);
	define  datgar      date;

    let cenadd = 0;
    let ret = 3;
    select matoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam, sernum,
           kol, ei_nam, cena, cenad, isnds, sklad_nam, dat_gar
        into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
             koll, einam, cenaa, cenadd, isndss, skladnam, datgar
        from _tovostmatsklg
           where sernum = hesernum;
  
       return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
           koll, einam, cenaa, cenadd, isndss, skladnam, datgar, ret;
end procedure;

create procedure tovostsklg_he(tip char(1), datpr date, hetovarnam char(50))
    returning int, int, int, date, char(50), char(20), decimal(7,2),
              char(10), decimal(9,2), decimal(9,2), char(1), char(30), 
              date, char(2), char(60), int;

	define 	operpcod, tovarcod, eicod, cnt, ret	int;
	define  datpokupki  date;
	define	tovarnam    char(50);
	define  sernumm     char(20);
	define  einam	    char(10);
	define  cenaa       decimal(9,2);
	define  cenadd      decimal(9,2);
	define  isndss      char(1);
	define  koll        decimal(7,2);
	define  skladnam    char(30);
	define  datgar      date;
	define  gss         char(2);
    define prim         char(60);

    let sernumm = "";
    let cenadd = 0;
    let cnt = 0;
    let ret = 3;
    let gss = "";
    let prim = "";
	if tip = "F" or tip = "f" then
	    foreach
            select finoperp_cod, tovar_cod, ei_cod, dat_pokupki, tovar_nam,
	               kol, ei_nam, cena, isnds, sklad_nam, nullchar(), nullchar(),
	               nullchar()
	            into operpcod, tovarcod, eicod, datpokupki, tovarnam,
	                 koll, einam, cenaa, isndss, skladnam, datgar, gss, prim
	            from _tovarostatokfinsk
	            where tovar_nam matches hetovarnam and
	                  dat_pokupki <= datpr
	            order by tovar_nam, dat_pokupki, kol
	            return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                   koll, einam, cenaa, cenadd, isndss, skladnam, datgar, 
	                   gss, prim, ret with resume;

	        let cnt = cnt + 1;
            if cnt > 0 then
                let ret = 2;
            end if;
        end foreach;

	    if cnt = 0 then
	        let ret = 1;
	        return 0, 0, 0, '', '    ', '', 0, '', 0, 0, '', '', '', '', '', ret with resume;
	    end if;
	end if;

	if tip = "M" or tip = "m" then
        foreach
            select a.matoperp_cod, a.tovar_cod, a.ei_cod, a.dat_pokupki, a.tovar_nam, a.sernum,
	               a.kol, a.ei_nam, a.cena, a.cenad, a.isnds, a.sklad_nam, a.dat_gar, a.gs, 
	               b.prim1
	            into operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                 koll, einam, cenaa, cenadd, isndss, skladnam, datgar, gss, prim
	            from _tovostmatsklg a, outer vp b
	            where a.tovar_nam matches hetovarnam and
                      a.dat_pokupki <= datpr and
                      a.docp_cod = b.cod
	            order by tovar_nam, dat_pokupki, kol
	            return operpcod, tovarcod, eicod, datpokupki, tovarnam, sernumm,
	                   koll, einam, cenaa, cenadd, isndss, skladnam, datgar, 
	                   gss, prim, ret with resume;
	        let cnt = cnt + 1;
            if cnt > 0 then
                let ret = 2;
            end if;
	    end foreach;

	    if cnt = 0 then
	        let ret = 1;
	        return 0, 0, 0, '', '    ', '', 0, '', 0, 0, '', '', '', '', '', ret with resume;
	    end if;
	end if;
end procedure;

create procedure kolmattovrforpdasr(matoperpcod int) 
    returning decimal(7,2);
    
    define  koll decimal(7,2);
    
    select sum(kol)
        into koll
        from matoperr
        where matoperp_cod = matoperpcod and
              datotg is null;
    
    if koll is null then
        let koll = 0;
    end if
    return koll;
end procedure;

create procedure kurs_prihoda(datt date)
        returning decimal(5,4);
        
    define kurs decimal(5,4);

    select a.kurs_p
        into kurs
        from valuta a
        where a.dat = (select max(x.dat) from valuta x where x.dat <= datt);
    
    return kurs;
end procedure;

create procedure kurs_rashoda(datt date)
        returning decimal(5,4);
        
    define kurs decimal(5,4);

    select a.kurs_r
        into kurs
        from valuta a
        where a.dat = (select max(x.dat) from valuta x where x.dat <= datt);
    
    return kurs;
end procedure;

create procedure valuta_del(valutacod int)
	
	delete from valuta where cod = valutacod;
end procedure;

create procedure valuta_ins(datt date, kursp decimal(5,4), 
                             kurss decimal(5,4), kursi decimal(5,4))
	returning int;
	
	define	cod	int;
	insert into valuta values(0, datt, kursp, kurss, kursi);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure valuta_upd(valutacod int, datt date, kursp decimal(5,4),
                             kurss decimal(5,4), kursi decimal(5,4))

	update valuta set (dat, kurs_p, kurs_s, kurs_i) =
	                  (datt, kursp, kurss, kursi)
	    where cod = valutacod;
end procedure;

create procedure doccodkol( doccod int )
    returning decimal(7,2);
    
    define  ret decimal(7,2);
    
    select sum(kol) into ret
        from matoperr
        where doc_cod = doccod;
        
    if ret is null then
        let ret = 0;
    end if;
    return ret;
end procedure;

create procedure nulldate()
    returning date;

    define dt   date;

    let dt = null;

    return dt;
end procedure;

create procedure kurs_izr(datt date)
        returning decimal(5,4);
        
    define kurs decimal(5,4);

    select a.kurs_i
        into kurs
        from valuta a
        where a.dat = (select max(x.dat) from valuta x where x.dat <= datt);
    
    return kurs;
end procedure;

create procedure kurs_sch(datt date)
        returning decimal(5,4);
        
    define kurs decimal(5,4);

    select a.kurs_s
        into kurs
        from valuta a
        where a.dat = (select max(x.dat) from valuta x where x.dat <= datt);
    
    return kurs;
end procedure;

create procedure tovarwww_ins(tovarcod integer,
                               smallimage char(40), bigimage char(40),
                               opisanieshort char(512),
                               opisanielong char(4096))
    if exists (select tovar_cod
                from tovarwww
                where tovar_cod = tovarcod)
    then
        update tovarwww
            set(smallimage, bigimage, opisanieshort, opisanielong) =
               (smallimage, bigimage, opisanieshort, opisanielong)
            where tovar_cod = tovarcod;
    else
        insert into tovarwww
            values(tovarcod, smallimage, bigimage, opisanieshort, opisanielong);
    end if;
end procedure;

create procedure pdvonly(datt date)
        returning decimal(4,2);
        
    define stavkaa  decimal(4,2);
    
    select a.stavka into stavkaa
        from nds a
        where a.dat = (select max(x.dat) from nds x where x.dat <= datt);
    return stavkaa;
end procedure;

create procedure whatdatdolga(datdolga date, datopl date)
        returning date;
        
    define ret date;
    let ret = datdolga;
    if ret is null then
        let ret = datopl;
    end if;
    return ret;
end procedure;

create procedure zaimtov_del(tip char(4), naklcod int, matopercod int)

    define cnt  int;
	
	if tip = "to" then
        select count(a.cod) into cnt
            from matoperp a
            where a.naklp_cod = naklcod;
        
        if cnt > 1 then
	        delete from matoperp
	            where cod = matopercod;
	    end if;
	    if cnt = 1 then
	        delete from matoperp
	            where cod = matopercod;
	        delete from naklp
	            where cod = naklcod;
	    end if;
	end if;
	if tip = "from" then
        select count(a.cod) into cnt
            from matoperr a
            where a.doc_cod = naklcod;
        
        if cnt > 1 then
	        delete from matoperr
	            where cod = matopercod;
	    end if;
	    if cnt = 1 then
	        delete from matoperr
	            where cod = matopercod;
	        delete from naklr
	            where cod = naklcod;
	    end if;
	end if;
	if tip = "gklp" then
        select count(a.cod) into cnt
            from matoperr a
            where a.doc_cod = naklcod;
        
        if cnt > 1 then
	        delete from matoperr
	            where cod = matopercod;
	    end if;
	    if cnt = 1 then
	        delete from matoperr
	            where cod = matopercod;
	        delete from naklr
	            where cod = naklcod;
	    end if;
	end if;
	if tip = "gpsr" then
        select count(a.cod) into cnt
            from matoperp a
            where a.naklp_cod = naklcod;
        
        if cnt > 1 then
	        delete from matoperp
	            where cod = matopercod;
	    end if;
	    if cnt = 1 then
	        delete from matoperp
	            where cod = matopercod;
	        delete from naklp
	            where cod = naklcod;
	    end if;
	end if;
end procedure;

create procedure zaimtov_ins(tip char(4), doccod int, datt date, 
                            skladcod int, operaciacod int, klientcod int, 
                            tovarcod int, operpcod int,
                            sernumm char(20), koll decimal(7,2), cenaa decimal(9,2),
                            cenadd decimal(9,2))
	returning int, int, int;
	
	define	global CodesDocCod	int default -1;
	define  numm  int;
	define  numc  char(10);
	define  naklcod int;
	define  matopercod int;
	
	if tip = "to" then
	    select unique a.cod, a.num into naklcod, numm
	        from naklp a, zaimlink b
	        where a.cod = b.slave_cod and
	              b.master_cod = doccod and
	              a.dat = datt and
	              a.sklad_cod = skladcod and
	              a.operacia_cod = operacia_cod and
   	              a.klient_cod = klientcod;
	    if naklcod > 0 and numm < 0
   	    then
	        insert into matoperp(cod, doc_cod, naklp_cod, dat_pokupki, 
                                 sklad_cod, tovar_cod, 
                                 sernum, kol, cena, cenad, usr) 
	            values(0, naklcod, naklcod, datt, 
	                   skladcod, tovarcod,
	                   sernumm, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        else
            select min(a.num) into numc
    	        from naklp a
    	        where a.tip = 'Z' and
    	              year(a.dat) = year(datt);
    	    
    	    let numm = numc;
    	    if numm is null then
    	        let numm = -1;
    	    else
    	        let numm = numm - 1;
    	    end if;
    	    
            insert into naklp 
                values(CodesDocCod, numm, datt, null, skladcod,
                       operaciacod, klientcod, "  -", user, 'Z');
            let naklcod = CodesDocCod;
            insert into zaimlink 
                values(doccod, CodesDocCod);
            insert into matoperp(cod, doc_cod, naklp_cod, dat_pokupki, 
                                 sklad_cod, tovar_cod, 
                                 sernum, kol, cena, cenad, usr) 
	            values(0, CodesDocCod, CodesDocCod, datt, 
	                   skladcod, tovarcod,
	                   sernumm, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        end if;
	end if;
	
	if tip = "from" then
	    select a.sklad_cod into skladcod
	        from matoperp a
	        where a.cod = operpcod;
	    
	    select unique a.cod, a.num into naklcod, numm
	        from naklr a, zaimlink b
	        where a.cod = b.slave_cod and
	              b.master_cod = doccod and
	              a.dat = datt and
	              a.sklad_cod = skladcod and
	              a.operacia_cod = operacia_cod and
   	              a.klient_cod = klientcod;
	    if naklcod > 0 and numm < 0
   	    then
	        insert into matoperr(cod, doc_cod, matoperp_cod, datotg, kol, cena, cenad, usr) 
	            values(0, naklcod, operpcod, datt, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        else
            select min(a.num) into numc
    	        from naklr a
    	        where a.cod in (select slave_cod from zaimlink) and
    	              year(a.dat) = year(datt);
    	    
    	    let numm = numc;
    	    if numm is null then
    	        let numm = -1;
    	    else
    	        let numm = numm - 1;
    	    end if;
    	    
            insert into naklr 
                values(CodesDocCod, numm, datt, skladcod,
                       operaciacod, klientcod, null, "   -", null, user);
            let naklcod = CodesDocCod;
            insert into zaimlink 
                values(doccod, CodesDocCod);
	        insert into matoperr(cod, doc_cod, matoperp_cod, datotg, kol, cena, cenad, usr) 
	            values(0, naklcod, operpcod, datt, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        end if;
	end if;
	
	if tip = "gklp" then
	    select a.sklad_cod into skladcod
	        from matoperp a
	        where a.cod = operpcod;
	    
	    select unique a.cod, a.num into naklcod, numm
	        from naklr a, garlink b
	        where a.cod = b.slave_cod and
	              b.master_cod = doccod and
	              a.dat = datt and
	              a.sklad_cod = skladcod and
	              a.operacia_cod = operacia_cod and
   	              a.klient_cod = klientcod;
	    if naklcod > 0 and numm < 0
   	    then
	        insert into matoperr(cod, doc_cod, matoperp_cod, datotg, kol, cena, cenad, usr) 
	            values(0, naklcod, operpcod, datt, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        else
            select min(a.num) into numc
    	        from naklr a
    	        where a.cod in (select slave_cod from garlink) and
    	              year(a.dat) = year(datt);
    	    
    	    let numm = numc;
    	    if numm is null then
    	        let numm = -1;
    	    else
    	        let numm = numm - 1;
    	    end if;
    	    
            insert into naklr 
                values(CodesDocCod, numm, datt, skladcod,
                       operaciacod, klientcod, null, "  ", null, user);
            let naklcod = CodesDocCod;
            insert into garlink 
                values(doccod, CodesDocCod);
	        insert into matoperr(cod, doc_cod, matoperp_cod, datotg, kol, cena, cenad, usr) 
	            values(0, naklcod, operpcod, datt, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        end if;
	end if;
	
	if tip = "gpsr" then
	    select unique a.cod, a.num into naklcod, numm
	        from naklp a, garlink b
	        where a.cod = b.slave_cod and
	              b.master_cod = doccod and
	              a.dat = datt and
	              a.sklad_cod = skladcod and
	              a.operacia_cod = operacia_cod and
   	              a.klient_cod = klientcod;
	    if naklcod > 0 and numm < 0
   	    then
	        insert into matoperp(cod, doc_cod, naklp_cod, dat_pokupki, 
                                 sklad_cod, tovar_cod, 
                                 sernum, kol, cena, cenad, usr) 
	            values(0, naklcod, naklcod, datt, 
	                   skladcod, tovarcod,
	                   sernumm, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        else
            select min(a.num) into numc
    	        from naklp a
    	        where a.tip = 'G' and
    	              year(a.dat) = year(datt);
    	    
    	    let numm = numc;
    	    if numm is null then
    	        let numm = -1;
    	    else
    	        let numm = numm - 1;
    	    end if;
    	    
            insert into naklp 
                values(CodesDocCod, numm, datt, null, skladcod,
                       operaciacod, klientcod, "  ", user, 'G');
            let naklcod = CodesDocCod;
            insert into garlink 
                values(doccod, CodesDocCod);
            insert into matoperp(cod, doc_cod, naklp_cod, dat_pokupki, 
                                 sklad_cod, tovar_cod, 
                                 sernum, kol, cena, cenad, usr) 
	            values(0, CodesDocCod, CodesDocCod, datt, 
	                   skladcod, tovarcod,
	                   sernumm, koll, cenaa, cenadd, user);
	        let matopercod = dbinfo("sqlca.sqlerrd1");
        end if;
	end if;
	return naklcod, matopercod, numm;
end procedure;

create procedure zaimtov_upd(tip char(4), naklcod int, matopercod int,
                             tovarcod int, datt date, 
                             sernumm char(20), koll decimal(7,2),
                             cenaa decimal(9,2), cenadd decimal(9,2))
	
	if tip = "to" then
        update matoperp
            set(dat_pokupki, tovar_cod, sernum, kol, cena, cenad) =
               (datt, tovarcod, sernumm, koll, cenaa, cenadd)
            where cod = matopercod;
        update naklp
            set (dat) = (datt)
            where cod = naklcod;
	end if;
	if tip = "from" then
        update matoperr
            set(datotg, kol, cena, cenad) =
               (datt, koll, cenaa, cenadd)
            where cod = matopercod;
        update naklr
            set (dat) = (datt)
            where cod = naklcod;
	end if;
	if tip = "gklp" then
        update matoperr
            set(datotg, kol, cena, cenad) =
               (datt, koll, cenaa, cenadd)
            where cod = matopercod;
        update naklr
            set (dat) = (datt)
            where cod = naklcod;
	end if;
	if tip = "gpsr" then
        update matoperp
            set(dat_pokupki, tovar_cod, sernum, kol, cena, cenad) =
               (datt, tovarcod, sernumm, koll, cenaa, cenadd)
            where cod = matopercod;
        update naklp
            set (dat) = (datt)
            where cod = naklcod;
	end if;
end procedure;

create procedure naklpopl_del(naklpoplcod int)
	delete from naklpopl where cod = naklpoplcod;
end procedure;

create procedure naklpopl_ins(naklpcod int, dat date, summa decimal(9,2),
                               summad decimal(9,2))
	returning int;
	
	define  cod    int;
	
	if summa is null then let summa = 0; end if;
	if summad is null then let summad = 0; end if;
	insert into naklpopl values(0, naklpcod, dat, summa, summad);
	let cod = dbinfo("sqlca.sqlerrd1");
	return cod;
end procedure;

create procedure naklpopl_upd(naklpoplcod int, datt date, summaa decimal(9,2),
                               summadd decimal(9,2))
                               
    if summaa is null then let summaa = 0; end if;
    if summadd is null then let summadd = 0; end if;
	update naklpopl
	    set (dat, summa, summad) = (datt, summaa, summadd)
	    where cod = naklpoplcod;
end procedure;

create view _finnaklr (cod,num,dat,operacia_cod,klient_cod,sklad_cod,dovnum,dovdat,dovwho,lgota_proc,prim1,prim2,usr,tip) as 
  select x0.cod ,x0.finnaklr_num ,x0.finnaklr_dat ,x0.operacia_cod 
    ,x0.klient_cod ,x0.sklad_cod ,x0.dovnum ,x0.dovdat ,x0.dovwho 
    ,x0.lgota_proc ,x0.prim1 ,x0.prim2 ,x0.usr ,'N' from schetfnr 
    x0 ;                                                
create view _naklpf (cod,num,dat,kurs,sklad_cod,operacia_cod,klient_cod,usr) as 
  select x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,x0.usr from naklp x0 where (x0.tip 
    = 'F' ) ;                            
create view _naklpfs (cod,num,dat,kurs,sklad_cod,operacia_cod,klient_cod,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,sum((x1.kol * x1.cena ) ) ,0 from naklp 
    x0 ,outer(finoperp x1 ) where ((x0.tip = 'F' ) AND 
    (x0.cod = x1.doc_cod ) ) group by x0.cod ,x0.num ,x0.dat 
    ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod ,x0.klient_cod ,9 
    ;                                     
create view _naklpm (cod,num,dat,kurs,sklad_cod,operacia_cod,klient_cod,usr) as 
  select x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,x0.usr from naklp x0 where (x0.tip 
    = 'M' ) ;                            
create view _naklpn (cod,num,dat,kurs,sklad_cod,operacia_cod,klient_cod,usr) as 
  select x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,x0.usr from naklp x0 where (x0.tip 
    = 'N' ) ;                            
create view _naklpns (cod,num,dat,kurs,sklad_cod,operacia_cod,klient_cod,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,sum((x1.kol * x1.cena ) ) ,sum((x1.kol * 
    x1.cenad ) ) from naklp x0 ,outer(matoperp 
    x1 ) where ((x0.tip = 'N' ) AND (x0.cod = x1.doc_cod ) ) group 
    by x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ;               
create view _naklr (cod,schet_num,schet_dat,finnaklr_num,finnaklr_dat,sklad_cod,operacia_cod,klient_cod,prim1,usr,tip) as 
  select x0.cod ,nullint(),DATE (NULL ) ,x0.num ,x0.dat 
    ,x0.sklad_cod ,x0.operacia_cod ,x0.klient_cod ,x0.prim1 ,
    x0.usr ,'M' from naklr x0 ;                       
              
create view _naklr2 (cod,num,dat,sklad_cod,operacia_cod,klient_cod,prim1,usr,tip) as 
  select x0.cod ,x0.num ,x0.dat ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,x0.prim1 ,x0.usr ,'M' from naklr x0 
    ;                                       
create view _naklrms (cod,num,dat,sklad_cod,operacia_cod,klient_cod,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,sum((x1.kol * x1.cena ) ) ,sum((x1.kol * 
    x1.cenad ) ) from naklr x0 ,outer(naklrtov 
    x1 ) where (x0.cod = x1.naklr_cod ) group by x0.cod ,x0.num 
    ,x0.dat ,x0.sklad_cod ,x0.operacia_cod ,x0.klient_cod ;  
                                                             
    
create view _naklrtov (cod,naklr_cod,tovar_cod,printnam,kol,cena,cenad,usr) as 
  select x0.cod ,x0.naklr_cod ,x0.tovar_cod ,nullchar(),
    x0.kol ,x0.cena ,x0.cenad ,x0.usr from naklrtov x0 
    ;                                            
create view _nnakls (cod,schetfnr_cod,sofnr_cod,num,dat,summa) as 
  select x0.cod ,x0.schetfnr_cod ,x0.sofnr_cod ,x0.num ,x0.dat 
    ,sum(x1.summa ) from nnakl x0 ,outer(nnakltov 
    x1 ) where (x0.cod = x1.nnakl_cod ) group by x0.cod ,x0.schetfnr_cod 
    ,x0.sofnr_cod ,x0.num ,x0.dat ;                    
create view _nnakltovnds (cod,nnakl_cod,schfnrtov_cod,summa,summands,usr) as 
  select x1.cod ,x0.cod ,x2.cod ,x1.summa ,(x1.summa - cenawithoutpdv(x2.tovar_cod 
    ,x1.summa ,x0.dat )) ,x1.usr from nnakl x0 ,nnakltov 
    x1 ,schfnrtov x2 where ((x0.cod = x1.nnakl_cod ) 
    AND (x1.schfnrtov_cod = x2.cod ) ) ;                     
                          
create view _nnaklsnds (cod,schetfnr_cod,sofnr_cod,num,dat,summa,summands) as 
  select x0.cod ,x0.schetfnr_cod ,x0.sofnr_cod ,x0.num ,x0.dat 
    ,sum(x1.summa ) ,sum(x1.summands ) from nnakl x0 
    ,outer(_nnakltovnds x1 ) where (x0.cod = x1.nnakl_cod 
    ) group by x0.cod ,x0.schetfnr_cod ,x0.sofnr_cod ,x0.num 
    ,x0.dat ;                                                
     
create view _nnakltovs (nnakl_cod,schfnrtov_cod,summa) as 
  select x0.nnakl_cod ,x0.schfnrtov_cod ,sum(x0.summa ) from nnakltov 
    x0 group by x0.nnakl_cod ,x0.schfnrtov_cod ;    
create view _operaciap (cod,nam) as 
  select x0.cod ,x0.nam from operacia x0 where (x0.p_r 
    = 1 ) ;              
create view _operaciar (cod,nam) as 
  select x0.cod ,x0.nam from operacia x0 where (x0.p_r 
    = -1 ) ;             
create view _schetnnakls (schet_cod,summa) as 
  select x0.schetfnr_cod ,sum(x1.summa ) from schfnrtov 
    x0 ,outer(nnakltov x1 ) where (x0.cod = x1.schfnrtov_cod 
    ) group by x0.schetfnr_cod ;                             
                   
create view _schetnnakltovs (schet_cod,schfnrtov_cod,st_schet,st_nnakl) as 
  select x0.schetfnr_cod ,x0.cod ,(x0.kol * x0.cena ) ,sum(x1.summa 
    ) from schfnrtov x0 ,outer(nnakltov x1 ) 
    where (x0.cod = x1.schfnrtov_cod ) group by x0.schetfnr_cod 
    ,x0.cod ,3 ;                                       
create view _schetnnmindat (schet_cod,mindat,summa) as 
  select x0.schetfnr_cod ,min(x0.dat ) ,sum(x1.summa ) from nnakl 
    x0 ,outer(nnakltov x1 ) where (x0.cod = x1.nnakl_cod 
    ) group by x0.schetfnr_cod ;                             
    
create view _schetopls (schet_cod,summa) as 
  select x0.schet_cod ,sum(x0.summa ) from schetopl x0 
    group by x0.schet_cod ;                                  
                        
create view _schfnrtovfin (cod,schetfnr_cod,tovar_cod,printnam,kol,cena,usr) as 
  select x0.cod ,x0.schetfnr_cod ,x0.tovar_cod ,x0.printnam ,x0.kol 
    ,x0.cena ,x0.usr from schfnrtov x0 ;             
                                               
create view _schfnrtovfinccc (schetfnr_cod,tovar_cod,kol,cenawpdv,pdv,cena) as 
  select x1.schetfnr_cod ,x1.tovar_cod ,x1.kol ,cenawithoutpdv(x2.cod 
    ,x1.cena ,x0.finnaklr_dat ),(x1.cena - cenawithoutpdv(x2.cod 
    ,x1.cena ,x0.finnaklr_dat )) ,x1.cena from schetfnr 
    x0 ,schfnrtov x1 ,tovar x2 where ((x0.cod 
    = x1.schetfnr_cod ) AND (x1.tovar_cod = x2.cod ) ) ;     
                                       
create view _schfnrtovfins (schetfnr_cod,summa) as 
  select x0.schetfnr_cod ,sum((x0.kol * x0.cena ) ) from _schfnrtovfin 
    x0 group by x0.schetfnr_cod ;                         
create view _sot (cod,fio,sot,matotv,datborn,gorod_cod,index,ulica,dom,kv,phone,email,prim,login) as 
  select x0.cod ,x0.nam ,x0.sot ,x0.matotv ,x0.datreg ,x0.gorod_cod 
    ,x0.index ,x0.ulica ,x0.dom ,x0.kv ,x0.phone_boss ,x0.email 
    ,x0.prim ,x0.login from klient x0 where (x0.sot = 
    '*' ) ;                  
create view _tovarostatokfin (finoperp_cod,doc_cod,naklp_cod,sklad_cod,tovar_cod,ei_cod,dat_pokupki,tovar_nam,kol,ei_nam,cena,isnds) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x1.ei_cod ,x0.dat_pokupki ,x1.nam ,(x0.kol - kolfintovrforp(x0.cod 
    )) ,x2.nam ,x0.cena ,x1.isnds from finoperp x0 ,tovar 
    x1 ,ei x2 where (((x0.tovar_cod = x1.cod ) AND (x1.ei_cod 
    = x2.cod ) ) AND ((x0.kol - kolfintovrforp(x0.cod 
    )) > 0.00 ) ) ;         
create view _tovarostatokfins (sklad_cod,tovar_cod,ei_cod,dat_pokupki,tovar_nam,kol,ei_nam,cena,isnds) as 
  select x0.sklad_cod ,x0.tovar_cod ,x0.ei_cod ,x0.dat_pokupki 
    ,x0.tovar_nam ,sum(x0.kol ) ,x0.ei_nam ,x0.cena ,x0.isnds 
    from _tovarostatokfin x0 group by x0.sklad_cod ,x0.tovar_cod 
    ,x0.ei_cod ,x0.dat_pokupki ,x0.tovar_nam ,x0.ei_nam ,x0.cena 
    ,x0.isnds ;        
create view _tovostfinonly (finoperp_cod,doc_cod,naklp_cod,sklad_cod,tovar_cod,dat_pokupki,kol,cena) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x0.dat_pokupki ,(x0.kol - kolfintovrforp(x0.cod 
    )) ,x0.cena from finoperp x0 ;                   
                           
create view _tovostmatonly (matoperp_cod,docp_cod,naklp_cod,sklad_cod,tovar_cod,dat_pokupki,sernum,kol,cena,cenad) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x0.dat_pokupki ,x0.sernum ,(x0.kol - kolmattovrforp(x0.cod 
    )) ,x0.cena ,x0.cenad from matoperp x0 ;       
create view _postpol (cod,nam,balans,urlico,nds,post,datreg,lgota_cod,numcard,gorod_cod,index,ulica,dom,kv,pgorod_cod,pindex,pulica,pdom,pkv,phone_boss,phone_buh,phone_o,fax,email,boss_f,boss_i,boss_o,boss_i2,boss_o2,boss_i3,boss_o3,boss_born,boss_sex,cont_fio,cont_dol,cont_p_r,cont_p_d,zkpo,inn,ns,bank_nam,bank_mfo,bank_schet,sot_cod,prim) as 
  select x0.cod ,x0.nam ,x0.balans ,x0.urlico ,x0.nds ,x0.post 
    ,x0.datreg ,x0.lgota_cod ,x0.numcard ,x0.gorod_cod ,x0.index 
    ,x0.ulica ,x0.dom ,x0.kv ,x0.pgorod_cod ,x0.pindex ,x0.pulica 
    ,x0.pdom ,x0.pkv ,x0.phone_boss ,x0.phone_buh ,x0.phone_o 
    ,x0.fax ,x0.email ,x0.boss_f ,x0.boss_i ,x0.boss_o ,x0.boss_i2 
    ,x0.boss_o2 ,x0.boss_i3 ,x0.boss_o3 ,x0.boss_born ,x0.boss_sex 
    ,x0.cont_fio ,x0.cont_dol ,x0.cont_p_r ,x0.cont_p_d ,x0.zkpo 
    ,x0.inn ,x0.ns ,x0.bank_nam ,x0.bank_mfo ,x0.bank_schet ,
    x0.sot_cod ,x0.prim from klient x0 where (x0.sot 
    IS NULL ) ;                                              
        
create view _naklrsmk (naklr_cod,sklad_cod,operacia_cod,klient_cod,num,dat,prim1,summa,summad,kol) as 
  select x0.cod ,x0.sklad_cod ,x0.operacia_cod ,x0.klient_cod 
    ,x0.num ,x0.dat ,x0.prim1 ,sum((x1.kol * x1.cena ) ) ,sum((x1.kol 
    * x1.cenad ) ) ,sum(x1.kol ) from naklr x0 ,outer(naklrtov 
    x1 ) where (x0.cod = x1.naklr_cod ) group by x0.cod ,x0.sklad_cod 
    ,x0.operacia_cod ,x0.klient_cod ,x0.num ,x0.dat ,x0.prim1 
    ;         
create view _schetotgmindat (schet_cod,mindat,kol) as 
  select x0.schetfnr_cod ,min(x0.datotg ) ,sum(x0.kol ) from matoperr 
    x0 where ((x0.datotg IS NOT NULL ) AND (x0.schetfnr_cod IS 
    NOT NULL ) ) group by x0.schetfnr_cod ;                  
    
create view _schfnrmattovkol (schet_cod,kol) as 
  select x0.cod ,((select nulltozero(sum(x1.kol ) )from 
    schfnrtov x1 where ((x1.schetfnr_cod = x0.cod ) AND 
    (x1.cod != ALL (select x2.schfnrtov_cod from schfnrtovt 
    x2 ) ) ) ) + (select nulltozero(sum(x3.kol ) )from 
    schfnrtovt x3 where ((x3.schetfnr_cod = x0.cod ) 
    AND (x3.kol IS NOT NULL ) ) ) ) from schetfnr x0 
    ;                         
create view _schetsmk (schet_cod,klient_cod,snum,sdat,prim1,prim2,nnum,ndat,summa,kol) as 
  select x0.cod ,x0.klient_cod ,x0.schet_num ,x0.schet_dat ,x0.prim1 
    ,x0.prim2 ,x0.finnaklr_num ,x0.finnaklr_dat ,sum((x1.kol 
    * x1.cena ) ) ,x2.kol from schetfnr x0 ,outer(schfnrtov 
    x1 ) ,_schfnrmattovkol x2 where ((x0.cod = x1.schetfnr_cod 
    ) AND (x0.cod = x2.schet_cod ) ) group by x0.cod ,x0.klient_cod 
    ,x0.schet_num ,x0.schet_dat ,x0.prim1 ,x0.prim2 ,x0.finnaklr_num 
    ,x0.finnaklr_dat ,x2.kol ;                               
                             
create view _tovarostatokfinsk (finoperp_cod,doc_cod,naklp_cod,sklad_cod,tovar_cod,ei_cod,dat_pokupki,tovar_nam,kol,ei_nam,cena,isnds,sklad_nam) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x1.ei_cod ,x0.dat_pokupki ,x1.nam ,(x0.kol - kolfintovrforp(x0.cod 
    )) ,x2.nam ,x0.cena ,x1.isnds ,x3.nam from finoperp 
    x0 ,tovar x1 ,ei x2 ,sklad x3 where 
    ((((x0.tovar_cod = x1.cod ) AND (x1.ei_cod = x2.cod ) ) AND 
    (x0.sklad_cod = x3.cod ) ) AND ((x0.kol - kolfintovrforp(x0.cod 
    )) > 0.00 ) ) ;  
create view _tovarostatokmatsk (matoperp_cod,docp_cod,naklp_cod,sklad_cod,tovar_cod,ei_cod,dat_pokupki,tovar_nam,sernum,kol,ei_nam,cena,cenad,isnds,sklad_nam) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x1.ei_cod ,x0.dat_pokupki ,x1.nam ,x0.sernum ,(x0.kol - 
    kolmattovrforp(x0.cod )) ,x2.nam ,x0.cena ,x0.cenad 
    ,x1.isnds ,x3.nam from matoperp x0 ,tovar 
    x1 ,ei x2 ,sklad x3 where ((((x0.tovar_cod 
    = x1.cod ) AND (x1.ei_cod = x2.cod ) ) AND (x0.sklad_cod 
    = x3.cod ) ) AND ((x0.kol - kolmattovrforp(x0.cod 
    )) > 0.00 ) ) ;                               
create view _vpfs (cod,num,dat,skladr_cod,skladp_cod,prim1,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.skladr_cod ,x0.skladp_cod 
    ,x0.prim1 ,sum((x1.kol * x1.cena ) ) ,0 from vp x0 
    ,outer(finoperp x1 ) where ((x0.tip = 'F' ) AND (x0.cod 
    = x1.doc_cod ) ) group by x0.cod ,x0.num ,x0.dat ,x0.skladr_cod 
    ,x0.skladp_cod ,x0.prim1 ,8 ;                    
create view _vpms (cod,num,dat,skladr_cod,skladp_cod,prim1,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.skladr_cod ,x0.skladp_cod 
    ,x0.prim1 ,sum((x1.kol * x1.cena ) ) ,sum((x1.kol * x1.cenad 
    ) ) from vp x0 ,outer(matoperp x1 ) where 
    ((x0.tip = 'M' ) AND (x0.cod = x1.doc_cod ) ) group by x0.cod 
    ,x0.num ,x0.dat ,x0.skladr_cod ,x0.skladp_cod ,x0.prim1 ; 
                                                             
        
create view _naklrmatoperp (naklr_cod,summa1,summa2) as 
  select distinct x0.naklr_cod ,sum((x1.kol * x2.cena ) ) ,sum((x1.kol 
    * x2.cenad ) ) from naklrtov x0 ,matoperr 
    x1 ,matoperp x2 where ((x0.cod = x1.doc_cod ) AND 
    (x1.matoperp_cod = x2.cod ) ) group by x0.naklr_cod ;    
              
create view _schets2 (cod,num,dat,klient_cod,summa) as 
  select x0.cod ,x0.schet_num ,x0.schet_dat ,x0.klient_cod ,sum((x1.kol 
    * x1.cena ) ) from schetfnr x0 ,schfnrtov 
    x1 where (x0.cod = x1.schetfnr_cod ) group by x0.cod ,x0.schet_num 
    ,x0.schet_dat ,x0.klient_cod ;                           
      
create view _schetmatoperp (schet_cod,summa1,summa2) as 
  select distinct x0.schetfnr_cod ,sum((x0.kol * x1.cena ) ) ,
    sum((x0.kol * x1.cenad ) ) from matoperr x0 ,matoperp 
    x1 where ((x0.matoperp_cod = x1.cod ) AND (x0.schetfnr_cod 
    IS NOT NULL ) ) group by x0.schetfnr_cod ;               
           
create view _tovostmatsklg (matoperp_cod,docp_cod,naklp_cod,sklad_cod,tovar_cod,ei_cod,dat_pokupki,tovar_nam,sernum,kol,ei_nam,cena,cenad,isnds,sklad_nam,dat_gar,gs) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x1.ei_cod ,x0.dat_pokupki ,x1.nam ,x0.sernum ,(x0.kol - 
    kolmattovrforp(x0.cod )) ,x2.nam ,x0.cena ,x0.cenad 
    ,x1.isnds ,x3.nam ,x0.dat_gar ,x1.gs from matoperp 
    x0 ,tovar x1 ,ei x2 ,sklad x3 where 
    ((((x0.tovar_cod = x1.cod ) AND (x1.ei_cod = x2.cod ) ) AND 
    (x0.sklad_cod = x3.cod ) ) AND ((x0.kol - kolmattovrforp(x0.cod 
    )) > 0.00 ) ) ;     
create view _whomathtov (matoperp_cod,docp_cod,naklp_cod,sklad_cod,tovar_cod,dat_pokupki,sernum,kolrez,kol,cenawithpdv,cenad) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x0.dat_pokupki ,x0.sernum ,kolmattovrforpr(x0.cod 
    ),(x0.kol - kolmattovrforp(x0.cod )) ,cenawithpdv(x0.tovar_cod 
    ,x0.cena ,x0.dat_pokupki ),x0.cenad from matoperp 
    x0 ;                                      
create view _naklrshead (cod,klient_cod,num,dat_dolga,summa) as 
  select x0.cod ,x0.klient_cod ,x0.num ,x0.dat_dolga ,(sum((x1.kol 
    * x1.cena ) ) + sum((x1.kol * x1.cenad ) ) ) from naklr 
    x0 ,naklrtov x1 where (x0.cod = x1.naklr_cod ) group 
    by x0.cod ,x0.klient_cod ,x0.num ,x0.dat_dolga ;       
create view _schet (cod,num,dat,operacia_cod,klient_cod,lgota_proc,prim1,prim2,dat_dolga,usr) as 
  select x0.cod ,x0.schet_num ,x0.schet_dat ,x0.operacia_cod ,
    x0.klient_cod ,x0.lgota_proc ,x0.prim1 ,x0.prim2 ,x0.dat_dolga 
    ,x0.usr from schetfnr x0 ;                       
                                     
create view _schetoplmaxdat (schet_cod,dat,summa) as 
  select x0.schet_cod ,max(x0.dat ) ,sum(x0.summa ) from schetopl 
    x0 group by x0.schet_cod ;                               
    
create view _schetoplmindat (schet_cod,dat,summa) as 
  select x0.schet_cod ,min(x0.dat ) ,sum(x0.summa ) from schetopl 
    x0 group by x0.schet_cod ;                               
    
create view _schets (cod,summa) as 
  select x0.schetfnr_cod ,sum((x0.kol * x0.cena ) ) from schfnrtov 
    x0 group by x0.schetfnr_cod ;                            
                     
create view _schetshead (cod,klient_cod,num,dat_dolga,summa) as 
  select x0.cod ,x0.klient_cod ,x0.schet_num ,x0.dat_dolga ,sum((x1.kol 
    * x1.cena ) ) from schetfnr x0 ,schfnrtov 
    x1 where (x0.cod = x1.schetfnr_cod ) group by x0.cod ,x0.klient_cod 
    ,x0.schet_num ,x0.dat_dolga ;                    
create view _schfnrtovt (cod,schetfnr_cod,schfnrtov_cod,tovar_cod,printnam,kol,cena,usr) as 
  select x0.cod ,x0.schetfnr_cod ,x0.schfnrtov_cod ,x0.tovar_cod 
    ,x1.printnam ,x0.kol ,x0.cena ,x0.usr from schfnrtovt 
    x0 ,schfnrtov x1 where (x0.schfnrtov_cod = x1.cod 
    ) ;                               
create view _naklrms2 (cod,num,dat,operacia_cod,klient_cod,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.operacia_cod ,x0.klient_cod 
    ,sum((x2.kol * x1.cena ) ) ,sum((x2.kol * x1.cenad ) ) from 
    naklr x0 ,naklrtov x1 ,matoperr x2 
    where ((x0.cod = x1.naklr_cod ) AND (x1.cod = x2.doc_cod 
    ) ) group by x0.cod ,x0.num ,x0.dat ,x0.operacia_cod ,x0.klient_cod 
    ;                                                    
create view _naklropls (naklr_cod,summa1,summa2) as 
  select x0.naklr_cod ,sum(x0.summa ) ,sum(x0.summad ) from naklropl 
    x0 group by x0.naklr_cod ;                             
create view _naklrotgmindat (naklr_cod,mindat,kol) as 
  select x0.naklr_cod ,min(x1.datotg ) ,sum(x1.kol ) from naklrtov 
    x0 ,matoperr x1 where ((x0.cod = x1.doc_cod ) AND 
    (x1.datotg IS NOT NULL ) ) group by x0.naklr_cod ;       
       
create view _naklrs (cod,summa1,summa2,summaall) as 
  select x0.naklr_cod ,sum((x0.kol * x0.cena ) ) ,sum((x0.kol 
    * x0.cenad ) ) ,(sum((x0.kol * x0.cena ) ) + sum((x0.kol 
    * x0.cenad ) ) ) from naklrtov x0 group by x0.naklr_cod 
    ;            
create view _tovarostatokmat (matoperp_cod,docp_cod,naklp_cod,sklad_cod,tovar_cod,ei_cod,dat_pokupki,tovar_nam,sernum,dat_gar,kol,ei_nam,cena,cenad,isnds) as 
  select x0.cod ,x0.doc_cod ,x0.naklp_cod ,x0.sklad_cod ,x0.tovar_cod 
    ,x1.ei_cod ,x0.dat_pokupki ,x1.nam ,x0.sernum ,x0.dat_gar 
    ,(x0.kol - kolmattovrforp(x0.cod )) ,x2.nam ,x0.cena 
    ,x0.cenad ,x1.isnds from matoperp x0 ,tovar 
    x1 ,ei x2 where (((x0.tovar_cod = x1.cod ) AND (x1.ei_cod 
    = x2.cod ) ) AND ((x0.kol - kolmattovrforp(x0.cod 
    )) > 0.00 ) ) ;                  
create view _naklpms (cod,num,dat,kurs,sklad_cod,operacia_cod,klient_cod,summa1,summa2) as 
  select x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ,sum((x1.kol * x1.cena ) ) ,sum((x1.kol * 
    x1.cenad ) ) from naklp x0 ,outer(matoperp 
    x1 ) where ((x0.tip = 'M' ) AND (x0.cod = x1.doc_cod ) ) group 
    by x0.cod ,x0.num ,x0.dat ,x0.kurs ,x0.sklad_cod ,x0.operacia_cod 
    ,x0.klient_cod ;               
create view _naklpzaimgashsum (naklp_cod,sumgash) as 
  select distinct x0.master_cod ,(sum((x1.kol * x1.cena ) ) + 
    (sum((x1.kol * x1.cenad ) ) * 10.0000 ) ) from zaimlink 
    x0 ,matoperr x1 where (x0.slave_cod = x1.doc_cod 
    ) group by x0.master_cod ;                               
                      
create view _naklpzaimoplsum (naklp_cod,sumopl) as 
  select distinct x0.naklp_cod ,(sum(x0.summa ) + (sum(x0.summad 
    ) * 10.00 ) ) from naklpopl x0 group by x0.naklp_cod 
    ;      
create view _naklpzaimtovsum (cod,num,dat,klient_cod,operacia_cod,sumtov) as 
  select distinct x0.cod ,x0.num ,x0.dat ,x0.klient_cod ,x0.operacia_cod 
    ,(sum((x1.kol * x1.cena ) ) + (sum((x1.kol * x1.cenad ) ) 
    * 10.0000 ) ) from naklp x0 ,matoperp x1 
    ,stt x2 where ((x0.cod = x1.naklp_cod ) AND (x0.operacia_cod 
    = x2.zaimfrom ) ) group by x0.cod ,x0.num ,x0.dat ,x0.klient_cod 
    ,x0.operacia_cod ;                     
create view _naklrzaimgashsum (naklr_cod,sumgash) as 
  select distinct x0.master_cod ,(sum((x1.kol * x1.cena ) ) + 
    (sum((x1.kol * x1.cenad ) ) * 10.0000 ) ) from zaimlink 
    x0 ,matoperp x1 where (x0.slave_cod = x1.doc_cod 
    ) group by x0.master_cod ;                               
                      
create view _naklrzaimoplsum (naklr_cod,sumopl) as 
  select distinct x0.naklr_cod ,(sum(x0.summa ) + (sum(x0.summad 
    ) * 10.00 ) ) from naklropl x0 group by x0.naklr_cod 
    ;      
create view _naklrzaimtovsum (cod,num,dat,klient_cod,operacia_cod,sumtov) as 
  select distinct x0.cod ,x0.num ,x0.dat ,x0.klient_cod ,x0.operacia_cod 
    ,(sum((x2.kol * x2.cena ) ) + (sum((x2.kol * x2.cenad ) ) 
    * 10.0000 ) ) from naklr x0 ,naklrtov x1 
    ,matoperr x2 ,stt x3 where (((x0.cod = x1.naklr_cod 
    ) AND (x1.cod = x2.doc_cod ) ) AND (x0.operacia_cod = x3.zaimto 
    ) ) group by x0.cod ,x0.num ,x0.dat ,x0.klient_cod ,x0.operacia_cod 
    ;                                   
create view _naklroplmindat (naklr_cod,mindat,summa,summad,summaall,cnt) as 
  select x0.naklr_cod ,min(x0.dat ) ,sum(x0.summa ) ,sum(x0.summad 
    ) ,(sum(x0.summa ) + sum(x0.summad ) ) ,count(*) from naklropl 
    x0 group by x0.naklr_cod ;        
create view _prodmatwffp (schet_cod,finpoksum,kursprihoda) as 
  select distinct x0.schetfnr_cod ,sum((x0.kol * cenawithpdv(x1.tovar_cod 
    ,x1.cena ,x2.dat )) ) ,kurs_prihoda(x2.dat )from 
    finoperr x0 ,finoperp x1 ,_schetoplmaxdat 
    x2 where ((x0.finoperp_cod = x1.cod ) AND (x0.schetfnr_cod 
    = x2.schet_cod ) ) group by x0.schetfnr_cod ,3 ;         
                                                         
create view _prodmatwffptov (schet_cod,doc_cod,tovar_cod,finpoksum,kursprihoda) as 
  select distinct x0.schetfnr_cod ,x0.doc_cod ,x1.tovar_cod ,sum((x0.kol 
    * cenawithpdv(x1.tovar_cod ,x1.cena ,x2.dat )) ) 
    ,kurs_prihoda(x2.dat )from finoperr x0 ,finoperp 
    x1 ,_schetoplmaxdat x2 where ((x0.finoperp_cod = 
    x1.cod ) AND (x0.schetfnr_cod = x2.schet_cod ) ) group by 
    x0.schetfnr_cod ,x0.doc_cod ,x1.tovar_cod ,5 ;           
                                              
create view _prodmatwfmp (schet_cod,matpoksum,matpoksumd) as 
  select distinct x0.schetfnr_cod ,sum((x0.kol * x1.cena ) ) ,
    sum((x0.kol * x1.cenad ) ) from matoperr x0 ,matoperp 
    x1 where ((x0.matoperp_cod = x1.cod ) AND (x0.schetfnr_cod 
    IS NOT NULL ) ) group by x0.schetfnr_cod ;               
      
create view _naklpgargashsum (naklp_cod,sumgash) as 
  select distinct x0.master_cod ,(sum((x1.kol * x1.cena ) ) + 
    (sum((x1.kol * x1.cenad ) ) * 10.0000 ) ) from garlink 
    x0 ,matoperr x1 where (x0.slave_cod = x1.doc_cod 
    ) group by x0.master_cod ;                               
                        
create view _naklpgaroplsum (naklp_cod,sumopl) as 
  select distinct x0.naklp_cod ,(sum(x0.summa ) + (sum(x0.summad 
    ) * 10.00 ) ) from naklpopl x0 group by x0.naklp_cod 
    ;       
create view _naklpgartovsum (cod,num,dat,klient_cod,operacia_cod,sumtov) as 
  select distinct x0.cod ,x0.num ,x0.dat ,x0.klient_cod ,x0.operacia_cod 
    ,(sum((x1.kol * x1.cena ) ) + (sum((x1.kol * x1.cenad ) ) 
    * 10.0000 ) ) from naklp x0 ,matoperp x1 
    ,stt x2 where ((x0.cod = x1.naklp_cod ) AND (x0.operacia_cod 
    IN (x2.gklp1 ,x2.gklp2 )) ) group by x0.cod ,x0.num ,x0.dat 
    ,x0.klient_cod ,x0.operacia_cod ;            
create view _naklrgargashsum (naklr_cod,sumgash) as 
  select distinct x0.master_cod ,(sum((x1.kol * x1.cena ) ) + 
    (sum((x1.kol * x1.cenad ) ) * 10.0000 ) ) from garlink 
    x0 ,matoperp x1 where (x0.slave_cod = x1.doc_cod 
    ) group by x0.master_cod ;                               
                        
create view _naklrgaroplsum (naklr_cod,sumopl) as 
  select distinct x0.naklr_cod ,(sum(x0.summa ) + (sum(x0.summad 
    ) * 10.00 ) ) from naklropl x0 group by x0.naklr_cod 
    ;       
create view _naklrgartovsum (cod,num,dat,klient_cod,operacia_cod,sumtov) as 
  select distinct x0.cod ,x0.num ,x0.dat ,x0.klient_cod ,x0.operacia_cod 
    ,(sum((x2.kol * x2.cena ) ) + (sum((x2.kol * x2.cenad ) ) 
    * 10.0000 ) ) from naklr x0 ,naklrtov x1 
    ,matoperr x2 ,stt x3 where (((x0.cod = x1.naklr_cod 
    ) AND (x1.cod = x2.doc_cod ) ) AND (x0.operacia_cod IN (x3.gpsr1 
    ,x3.gpsr2 )) ) group by x0.cod ,x0.num ,x0.dat ,x0.klient_cod 
    ,x0.operacia_cod ;                        
create view _prodmatwfmptovt (schet_cod,schfnrtov_cod,matpoksum,matpoksumd) as 
  select distinct x0.schetfnr_cod ,x0.schfnrtov_cod ,sum((x1.kol 
    * x2.cena ) ) ,sum((x1.kol * x2.cenad ) ) from schfnrtovt 
    x0 ,matoperr x1 ,matoperp x2 where ((x0.cod 
    = x1.doc_cod ) AND (x1.matoperp_cod = x2.cod ) ) group by 
    x0.schetfnr_cod ,x0.schfnrtov_cod ;           
create view _prodmatwfmptov (schet_cod,doc_cod,tovar_cod,matpoksum,matpoksumd) as 
  select distinct x0.schetfnr_cod ,x0.doc_cod ,x1.tovar_cod ,sum((x0.kol 
    * x1.cena ) ) ,sum((x0.kol * x1.cenad ) ) from matoperr 
    x0 ,matoperp x1 where ((x0.matoperp_cod = x1.cod 
    ) AND (x0.schetfnr_cod IS NOT NULL ) ) group by x0.schetfnr_cod 
    ,x0.doc_cod ,x1.tovar_cod ;        

create trigger naklp_del delete on naklp referencing 
    old as post
    for each row
        (
        execute procedure t_codes_doc_del(post.cod ));
    

create trigger naklp_ins insert on naklp
    before
        (
        execute procedure t_codes_doc_ins());

create trigger naklp_upd1 update of dat on naklp 
    referencing new as post
    for each row
        (
        execute procedure t_naklp_upd1(post.cod ,post.dat 
    ,post.tip ));

create trigger naklp_upd2 update of sklad_cod on naklp 
    referencing new as post
    for each row
        (
        execute procedure t_naklp_upd2(post.cod ,post.sklad_cod 
    ,post.tip ));

create trigger finoperp_upd1 update on finoperp 
    referencing new as post
    for each row
        (
        execute procedure t_finoperp_upd1(post.cod ));
    

create trigger naklrtov_del delete on naklrtov 
    referencing old as post
    for each row
        (
        execute procedure t_codes_doc_del(post.cod ));
    

create trigger naklrtov_ins insert on naklrtov
    
    before
        (
        execute procedure t_codes_doc_ins());

create trigger naklrtov_upd1 update of kol on naklrtov 
    referencing new as post
    for each row
        (
        execute procedure t_naklrtov_upd1(post.cod ,
    post.kol ));

create trigger "slon2".naklrtov_upd2 update of cena,cenad on 
    naklrtov referencing new as post
    for each row
        (
        execute procedure t_naklrtov_upd2(post.cod ,
    post.cena ,post.cenad ));

create trigger schfnrtov_del delete on schfnrtov 
    referencing old as post
    for each row
        (
        execute procedure t_codes_doc_del(post.cod ));
    

create trigger schfnrtov_ins insert on schfnrtov
    
    before
        (
        execute procedure t_codes_doc_ins());

create trigger schfnrtov_upd1 update of kol on schfnrtov 
    referencing new as post
    for each row
        (
        execute procedure t_schfnrtov_upd1(post.cod 
    ,post.kol ));

create trigger schfnrtov_upd2 update of cena on schfnrtov 
    referencing new as post
    for each row
        (
        execute procedure t_schfnrtov_upd2(post.cod 
    ,post.cena ));

create trigger schfnrtovt_del delete on schfnrtovt 
    referencing old as post
    for each row
        (
        execute procedure t_codes_doc_del(post.cod ));
    

create trigger schfnrtovt_ins insert on schfnrtovt
    
    before
        (
        execute procedure t_codes_doc_ins());

create trigger schfnrtovt_upd2 update of cena on schfnrtovt 
    referencing new as post
    for each row
        (
        execute procedure t_schfnrtovt_upd2(post.cod 
    ,post.cena ));

create trigger schetopl_del delete on schetopl 
    referencing old as post
    for each row
        (
        execute procedure t_codes_sofnr_del(post.cod 
    ));

create trigger schetopl_ins insert on schetopl
    
    before
        (
        execute procedure t_codes_sofnr_ins());

create trigger schetopl_upd1 update of dat,summa on 
    schetopl referencing new as post
    for each row
        (
        execute procedure t_schetopl_upd1(post.cod ));
    

create trigger vp_del delete on vp referencing 
    old as post
    for each row
        (
        execute procedure t_codes_doc_del(post.cod ));
    

create trigger vp_ins insert on vp
    before
        (
        execute procedure t_codes_doc_ins());

create trigger vp_upd1 update of dat on vp referencing 
    new as post
    for each row
        (
        execute procedure t_vp_upd1(post.cod ,post.dat 
    ,post.tip ));

create trigger "slon2".matoperp_upd1 update of doc_cod,naklp_cod,
    dat_pokupki,sklad_cod,tovar_cod,sernum,kol on matoperp 
    referencing new as post
    for each row
        (
        execute procedure t_matoperp_upd1(post.cod ));
    

create trigger matoperr_ins insert on matoperr 
    referencing new as post
    for each row
        (
        execute procedure t_matoperr_kol(post.cod ,post.matoperp_cod 
    ,post.doc_cod ));

create trigger matoperr_upd1 update of kol on matoperr 
    referencing new as post
    for each row
        (
        execute procedure t_matoperr_kol(post.cod ,post.matoperp_cod 
    ,post.doc_cod ));

create trigger schetfnr_del delete on schetfnr 
    referencing old as post
    for each row
        (
        execute procedure t_codes_sofnr_del(post.cod 
    ));

create trigger schetfnr_ins insert on schetfnr
    
    before
        (
        execute procedure t_codes_sofnr_ins());

create trigger schetfnr_upd1 update of finnaklr_num,
    finnaklr_dat,sklad_cod on schetfnr referencing new 
    as post
    for each row
        (
        execute procedure t_schetfnr_upd1(post.cod ,
    post.finnaklr_num ,post.finnaklr_dat ,post.sklad_cod ));

create trigger finoperr_ins insert on finoperr 
    referencing new as post
    for each row
        (
        execute procedure t_finoperr_kol(post.finoperp_cod 
    ,post.doc_cod ));

create trigger finoperr_upd1 update of kol on finoperr 
    referencing new as post
    for each row
        (
        execute procedure t_finoperr_kol(post.finoperp_cod 
    ,post.doc_cod ));

create trigger naklr_del delete on naklr referencing 
    old as post
    for each row
        (
        execute procedure t_codes_doc_del(post.cod ));
    

create trigger naklr_ins insert on naklr
    before
        (
        execute procedure t_codes_doc_ins());

